local L = LibStub("AceLocale-3.0"):GetLocale("AspectOfTheHunter")

AddOnName, AOTH = ...;



local CLASS_RARE       = L["RARE_PET"]     ;
local CLASS_RARE_ELITE = L["RARE_ELITE_PET"];
local CLASS_ELITE      = L["ELITE_PET"]     ;
local CLASS_STABLE_MASTER = L["STABLE_MASTER"];
--local CLASS_NORMAL     = L["NORMAL_PET"];
local CLASS_BOSS       = L["BOSS"]      ;
local CLASS_WORLD_BOSS = L["WORLD_BOSS"];

local TENACITY   = "Tenacity";
local CUNNING    = "Cunning";
local FEROCITY   = "Ferocity";

AOTH.specSkills = {

    ["Tenacity"] = {264662, 264735},
    ["Cunning"] =  {264656, 53271 },
    ["Ferocity"] = {264663, 264667},

}

local NOT_EXOTIC = false;
local IS_EXOTIC  = true;

-- FAMILY SKILLS
local ACID_BITE          = 263863;
local ACID_SPIT          = 263446;
local AGILE_REFLEXES     = 160011;
local ANCIENT_HIDE       = 279399;
local ANKLE_CRACK        = 50433 ;
local BLOOD_BOLT         = 288962;
local BLOOD_OF_THE_RHINO = 280069;
local BLOOD_SCREECH      = 24423 ;
local BRISTLE            = 263869;
local BULWARK            = 279410;
local BURROW_ATTACK      = 93433 ;
local CALCIFIED_CARAPACE = 279254;
local CATLIKE_REFLEXES   = 263892;
local CHIJI_TRANQUILITY  = 344350;
local DEADLY_STING       = 160060;
local DEFENSE_MATRIX     = 263868;
local DRAGONS_GUILE      = 263887;
local DUNE_STRIDER       = 280151;
local DUST_CLOUD         = 50285 ;
local ETERNAL_GUARDIAN   = 267922;
local FEAST              = 159953;
local FEATHER_FLURRY     = 263916;
local FLEETHOOF          = 341117;
local FROST_BREATH       = 54644 ;
local FROSTSTORM_BREATH  = 92380 ;
local FURIOUS_BITE       = 263840;
local GNAW               = 263856;
local GORE               = 263861;
local GRIEVOUS_BITE      = 279362;
local GRUESOME_BITE      = 160018;
local GRUFF              = 263921;
local HARDEN_CARAPACE    = 90339 ;
local HARDY              = 341115;
local INFECTED_BITE      = 263853
local LOCKJAW            = 263423;
local MOLTEN_HIDE        = 159788;
local MONSTROUS_BITE     = 54680 ;
local NATURES_GRACE      = 344352;
local NETHER_ENERGY      = 344349;
local NIUZAO_FORTITUDE   = 264023;
local OBSIDIAN_SKIN      = 263867;
local PIN                = 50245 ;
local PLAY               = 90347 ;
local PRIMAL_AGILITY     = 160044;
local PROWL              = 24450 ;
local PETRIFYING_GAZE    = 263841;
local RAVAGE             = 263857;
local REST               = 94019 ;
local SAVAGE_REND        = 263854;
local SCALE_SHIELD       = 263865;
local SERENITY_DUST      = 344353;
local SERPENTS_SWIFTNES  = 263904;
local SHELL_SHIELD       = 26064 ;
local SHIMMERING_SHALE   = 279259;
local SILVERBACK         = 263939;
local SOLID_SHELL        = 160063;
local SOOTHING_WATER     = 344346;
local SPIRIT_PULSE       = 344351 ;
local SPIRIT_MEND       = 90361;
local SPIRIT_WALK        = 90328 ;
local SPORE_CLOUD        = 344347;
local STONE_ARMOR        = 160049;
local SURFACE_TROT       = 126311;
local SWARM_OF_FLIES     = 279336;
local TALON_REND         = 263852;
local TENDON_RIP         = 160065;
local THICK_FUR          = 263934;
local THICK_HIDE         = 160057;
local TOXIC_STING        = 263858;
local TRICK              = 94022 ;
local TRAMPLE            = 341118;
local UPDRAFT            = 160007;
local WARP_TIME          = 35346 ;
local WEB_SPRAY          = 160067;
local WINGED_AGILITY     = 264360;
local SONIC_SCREECH        = 344348;

-- COMMON SKILLS

local BITE = 17253;
local SMACK = 49966;
local CLAW = 16827;

-- PET FAMILIES
local BASILISK_SKILLS      = {PETRIFYING_GAZE                            }; -- BITE
local BAT_SKILLS           = {SONIC_SCREECH                                }; -- BITE
local BEAR_SKILLS          = {THICK_FUR        , REST                    }; -- CLAW
local BEETLE_SKILLS        = {HARDEN_CARAPACE                            }; -- BITE
local BIRD_OF_PREY_SKILLS = {TALON_REND       , TRICK                   }; -- CLAW
local BLOOD_BEAST_SKILLS   = {BLOOD_BOLT                                 }; -- BITE
local BOAR_SKILLS          = {BRISTLE                                    }; -- BITE
local CARRION_BIRD_SKILLS  = {BLOOD_SCREECH                              }; -- BITE
local CAT_SKILLS           = {CATLIKE_REFLEXES , PROWL                   }; -- CLAW
local CHIMAERAS_SKILLS     = {FROST_BREATH     , FROSTSTORM_BREATH       }; -- BITE
local CLEFTHOOVE_SKILLS    = {THICK_HIDE       , BLOOD_OF_THE_RHINO      }; -- SMACK
local COREHOUND_SKILLS     = {OBSIDIAN_SKIN    , MOLTEN_HIDE             }; -- BITE
local CRAB_SKILLS          = {PIN                                        }; -- CLAW
local CRANE_SKILLS         = {CHIJI_TRANQUILITY, TRICK                   }; -- SMACK
local CROCOLISK_SKILLS     = {ANKLE_CRACK                                }; -- BITE
local COURSER_SKILLS       = {FLEETHOOF}
local DEVILSAUR_SKILLS     = {MONSTROUS_BITE   , FEAST                   }; -- BITE
local DIREHORN_SKILLS      = {GORE                                       }; -- BITE
local DOGS_SKILLS          = {LOCKJAW                                    }; -- BITE
local DRAGONHAWKS_SKILLS   = {DRAGONS_GUILE                              }; -- BITE
local FEATHERMANE_SKILLS  = {FEATHER_FLURRY   , UPDRAFT                 }; -- BITE
local FOX_SKILLS           = {AGILE_REFLEXES   , PLAY                    }; -- BITE
local GRUFFHORN_SKILLS     = {GRUFF                                      }; -- SMACK
local GORILLA_SKILLS       = {SILVERBACK                                 }; -- SMACK
local HYDRA_SKILLS         = {ACID_BITE                                  }; -- BITE
local HYENA_SKILLS         = {INFECTED_BITE                              }; -- BITE
local KROLUSK_SKILLS       = {BULWARK          , CALCIFIED_CARAPACE      }; -- BITE
local LIZARD_SKILLS        = {GRIEVOUS_BITE                              }; -- BITE
local MECHANICAL_SKILLS    = {DEFENSE_MATRIX                             }; -- BITE
local MONKEY_SKILLS        = {PRIMAL_AGILITY                             }; -- SMACK
local MOTH_SKILLS          = {SERENITY_DUST                              }; -- SMACK
local OXEN_SKILLS          = {NIUZAO_FORTITUDE                           }; -- SMACK
local PTERRORDAXE_SKILLS   = {ANCIENT_HIDE     , UPDRAFT                 }; -- BITE
local QUILLEN_SKILLS       = {STONE_ARMOR      , ETERNAL_GUARDIAN        }; -- BITE
local RAPTOR_SKILLS        = {SAVAGE_REND                                }; -- CLAW
local RAVAGER_SKILLS       = {RAVAGE                                     }; -- BITE
local RAY_SKILLS           = {NETHER_ENERGY                               }; -- BITE
local RIVERBEAST_SKILLS    = {GRUESOME_BITE                              }; -- BITE
local RODENT_SKILLS        = {GNAW             , REST                    }; -- CLAW
local SCALEHIDE_SKILLS     = {SCALE_SHIELD                               }; -- SMACK
local SCORPID_SKILLS       = {DEADLY_STING                               }; -- CLAW
local SERPENT_SKILLS       = {SERPENTS_SWIFTNES                          }; -- BITE
local SHALE_SPIDER_SKILLS  = {SOLID_SHELL      , SHIMMERING_SHALE        }; -- BITE
local SILITHID_SKILLS      = {TENDON_RIP       , DUNE_STRIDER            }; -- CLAW
local SPIDER_SKILLS        = {WEB_SPRAY                                  }; -- BITE
local SPIRIT_BEAST_SKILLS  = {SPIRIT_PULSE, SPIRIT_MEND, SPIRIT_WALK}; -- CLAW
local SPOREBATS_SKILLS     = {SPORE_CLOUD                                }; -- SMACK
local STAG_SKILLS          = {NATURES_GRACE                              }; -- SMACK
local TALLSTRIDER_SKILLS   = {DUST_CLOUD                                 }; -- CLAW
local TOAD_SKILLS          = {SWARM_OF_FLIES                             }; -- SMACK
local TURTLE_SKILLS        = {SHELL_SHIELD                               }; -- BITE
local WARP_STALKERS_SKILLS = {WARP_TIME                                  }; -- BITE
local WASP_SKILLS          = {TOXIC_STING                                }; -- SMACK
local WATER_STRIDER_SKILLS = {SOOTHING_WATER   , SURFACE_TROT            }; -- BITE
local WIND_SERPENTS_SKILLS = {WINGED_AGILITY                             }; -- BITE
local WOLF_SKILLS          = {FURIOUS_BITE                               }; -- BITE
local WORMS_SKILLS         = {ACID_SPIT        , BURROW_ATTACK           }; -- BITE




AOTH.families = {
{"Aqiri"        ,CUNNING ,IS_EXOTIC },
{"Basilisk"     ,CUNNING ,NOT_EXOTIC},
{"Bat"          ,FEROCITY,NOT_EXOTIC},
{"Bear"         ,TENACITY,NOT_EXOTIC},
{"Beetle"       ,TENACITY,NOT_EXOTIC},
{"Bird of Prey" ,CUNNING ,NOT_EXOTIC},
{"Blood Beast"  ,TENACITY,NOT_EXOTIC},
{"Boar"         ,CUNNING ,NOT_EXOTIC},
{"Camel"        ,CUNNING ,NOT_EXOTIC},
{"Carapid"      ,TENACITY,IS_EXOTIC },
{"Carrion Bird" ,FEROCITY,NOT_EXOTIC},
{"Cat"          ,FEROCITY,NOT_EXOTIC},
{"Chimaera"     ,FEROCITY,IS_EXOTIC },
{"Clefthoof"    ,FEROCITY,IS_EXOTIC },
{"Core Hound"   ,FEROCITY,IS_EXOTIC },
{"Courser"      ,FEROCITY,NOT_EXOTIC},
{"Crab"         ,TENACITY,NOT_EXOTIC},
{"Crane"        ,TENACITY,NOT_EXOTIC},
{"Crocolisk"    ,FEROCITY,NOT_EXOTIC},
{"Devilsaur"    ,FEROCITY,IS_EXOTIC },
{"Direhorn"     ,TENACITY,NOT_EXOTIC},
{"Dragonhawk"   ,TENACITY,NOT_EXOTIC},
{"Feathermane"  ,TENACITY,NOT_EXOTIC},
{"Fox"          ,CUNNING ,NOT_EXOTIC},
{"Gorilla"      ,FEROCITY,NOT_EXOTIC},
{"Gruffhorn"    ,CUNNING ,NOT_EXOTIC},
{"Hound"        ,CUNNING ,NOT_EXOTIC},
{"Hydra"        ,TENACITY,NOT_EXOTIC},
{"Hyena"        ,CUNNING ,NOT_EXOTIC},
{"Lizard"       ,TENACITY,NOT_EXOTIC},
{"Mammoth"      ,TENACITY,NOT_EXOTIC},
{"Mechanical"   ,CUNNING ,NOT_EXOTIC},
{"Monkey"       ,CUNNING ,NOT_EXOTIC},
{"Moth"         ,CUNNING ,NOT_EXOTIC},
{"Oxen"         ,TENACITY,NOT_EXOTIC},
{"Pterrordax"   ,CUNNING ,IS_EXOTIC },
{"Raptor"       ,CUNNING ,NOT_EXOTIC},
{"Ravager"      ,FEROCITY,NOT_EXOTIC},
{"Ray"          ,FEROCITY,NOT_EXOTIC},
{"Riverbeast"   ,TENACITY,NOT_EXOTIC},
{"Rodent"       ,CUNNING ,NOT_EXOTIC},
{"Scalehide"    ,FEROCITY,NOT_EXOTIC},
{"Scorpid"      ,FEROCITY,NOT_EXOTIC},
{"Serpent"      ,CUNNING ,NOT_EXOTIC},
{"Shale Beast"  ,CUNNING ,IS_EXOTIC },
{"Spider"       ,FEROCITY,NOT_EXOTIC},
{"Spirit Beast" ,TENACITY,IS_EXOTIC },
{"Sporebat"     ,CUNNING ,NOT_EXOTIC},
{"Stag"         ,TENACITY,NOT_EXOTIC},
{"Stone Hound"  ,TENACITY,IS_EXOTIC },
{"Tallstrider"  ,FEROCITY,NOT_EXOTIC},
{"Toad"         ,TENACITY,NOT_EXOTIC},
{"Turtle"       ,TENACITY,NOT_EXOTIC},
{"Warp Stalker" ,CUNNING ,NOT_EXOTIC},
{"Wasp"         ,FEROCITY,NOT_EXOTIC},
{"Water Strider",CUNNING ,IS_EXOTIC },
{"Wind Serpent",FEROCITY,NOT_EXOTIC },
{"Wolf"         ,FEROCITY,NOT_EXOTIC},
{"Worm"         ,TENACITY,IS_EXOTIC },
--{"Unclassifide" ,"n"     ,NOT_EXOTIC}

 }


AOTH.famSkills = {

    ["Basilisk"     ] = BASILISK_SKILLS,
    ["Bat"          ] = BAT_SKILLS,
    ["Bear"         ] = BEAR_SKILLS,
    ["Beetle"       ] = BEETLE_SKILLS,
    ["Bird of Prey" ] = BIRD_OF_PREY_SKILLS,
    ["Blood Beast"  ] = BLOOD_BEAST_SKILLS,
    ["Boar"         ] = BOAR_SKILLS,
    ["Carrion Bird" ] = CARRION_BIRD_SKILLS,
    ["Cat"          ] = CAT_SKILLS,
    ["Chimaera"     ] = CHIMAERAS_SKILLS,
    ["Clefthoof"    ] = CLEFTHOOVE_SKILLS,
    ["Core Hound"   ] = COREHOUND_SKILLS,
    ["Crab"         ] = CRAB_SKILLS,
    ["Crane"        ] = CRANE_SKILLS,
    ["Crocolisk"    ] = CROCOLISK_SKILLS,
    ["Courser"      ] = COURSER_SKILLS,
    ["Devilsaur"    ] = DEVILSAUR_SKILLS,
    ["Direhorn"     ] = DIREHORN_SKILLS,
    ["Hound"        ] = DOGS_SKILLS,
    ["Dragonhawk"   ] = DRAGONHAWKS_SKILLS,
    ["Feathermane"  ] = FEATHERMANE_SKILLS,
    ["Fox"          ] = FOX_SKILLS,
    ["Gruffhorn"    ] = GRUFFHORN_SKILLS,
    ["Gorilla"      ] = GORILLA_SKILLS,
    ["Hydra"        ] = HYDRA_SKILLS,
    ["Hyena"        ] = HYENA_SKILLS,
    ["Carapid"      ] = KROLUSK_SKILLS,
    ["Lizard"       ] = LIZARD_SKILLS,
    ["Mechanical"   ] = MECHANICAL_SKILLS,
    ["Monkey"       ] = MONKEY_SKILLS,
    ["Moth"         ] = MOTH_SKILLS,
    ["Oxen"         ] = OXEN_SKILLS,
    ["Pterrordax"   ] = PTERRORDAXE_SKILLS,
    ["Stone Hound"  ] = QUILLEN_SKILLS,
    ["Raptor"       ] = RAPTOR_SKILLS,
    ["Ravager"      ] = RAVAGER_SKILLS,
    ["Ray"          ] = RAY_SKILLS,
    ["Riverbeast"   ] = RIVERBEAST_SKILLS,
    ["Rodent"       ] = RODENT_SKILLS,
    ["Scalehide"    ] = SCALEHIDE_SKILLS,
    ["Scorpid"      ] = SCORPID_SKILLS,
    ["Serpent"      ] = SERPENT_SKILLS,
    ["Shale Beast"  ] = SHALE_SPIDER_SKILLS,
    ["Aqiri"        ] = SILITHID_SKILLS,
    ["Spider"       ] = SPIDER_SKILLS,
    ["Spirit Beast" ] = SPIRIT_BEAST_SKILLS,
    ["Sporebat"     ] = SPOREBATS_SKILLS,
    ["Stag"         ] = STAG_SKILLS,
    ["Tallstrider"  ] = TALLSTRIDER_SKILLS,
    ["Toad"         ] = TOAD_SKILLS,
    ["Turtle"       ] = TURTLE_SKILLS,
    ["Warp Stalker" ] = WARP_STALKERS_SKILLS,
    ["Wasp"         ] = WASP_SKILLS,
    ["Water Strider"] = WATER_STRIDER_SKILLS,
    ["Wind Serpent" ] = WIND_SERPENTS_SKILLS,
    ["Wolf"         ] = WOLF_SKILLS,
    ["Worm"         ] = WORMS_SKILLS,
}




--[[
TODO: add mech rares,add elites 


AOTH.test = {
  {["zone_name"] = "Loch Modan", [ "zoneID" ] = 48, [ "name" ] = "Gosh-Haldir <The Clutch Mother>",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Loch Modan. Spawns on what used to be the crocolisk island in the southern part of the dried-up loch.", ["class" ] = CLASS_RARE, ["family"] = {  6  , "Crocolisk"          } , ["familySkills" ] = CROCOLISK_SKILLS          ,["displayID"] = 32813 ,["id"] = 2476  ,["coords"] = {{52.8,57.8},{53,55.8},{53,56.8},{53.2,55.4},{53.6,54.2},{53.8,55},{54,53.4},{54,56.4},{54,56.6},{54,58},{54.2,59},{54.6,56.4},{54.6,57},{55.2,54.2},{55.4,53},{55.4,55.2},{55.6,53.4},{55.6,54.8},{55.6,55.8},{56,53.6},{56.4,51.8} } },
  {["zone_name"] = "Wetlands", [ "zoneID" ] = 56, [ "name" ] = "Razormaw Matriarch",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Wetlands.", ["class" ] = CLASS_RARE, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 11316 ,["id"] = 1140  ,["coords"] = {{69.8,29.2} } },
  {["zone_name"] = "Redridge Mountains", [ "zoneID" ] = 49, [ "name" ] = "Chatter",["maxlevel" ] =30, [ "minlevel" ] =7, ["info" ] ="Located in Redridge Mountains. Chatter is located east of Lakeshire, south-east of Redridge Canyons. On the zone map it's a bit south-west of the crossroads.", ["class" ] = CLASS_RARE, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 37620 ,["id"] = 616  ,["coords"] = {{36.4,33.8},{36.8,36.2},{37.4,34.2},{37.4,35.2},{37.4,36.6},{37.8,34.4},{37.8,34.8},{38,33.4},{38.2,35.8},{38.6,36.6},{38.8,34.4},{39,36.4} } },
  {["zone_name"] = "Wetlands", [ "zoneID" ] = 56, [ "name" ] = "Leech Widow",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Wetlands.", ["class" ] = CLASS_RARE, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 283 ,["id"] = 1112  ,["coords"] = {{46.8,63.4},{46.8,63.6} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Scale Belly",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Crystalvein Mine, The Cape of Stranglethorn. Located at the back of the mine.", ["class" ] = CLASS_RARE, ["family"] = {  130  , "Basilisk"          } , ["familySkills" ] = BASILISK_SKILLS          ,["displayID"] = 45945 ,["id"] = 1552  ,["coords"] = {{67.8,25.2},{68,25.6} } },
  {["zone_name"] = "Dun Morogh", [ "zoneID" ] = 27, [ "name" ] = "Bjarn",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Dun Morogh.", ["class" ] = CLASS_RARE, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70185 ,["id"] = 1130  ,["coords"] = {{66.2,59.8},{66.4,58.8},{67.2,58},{67.4,58.6},{67.8,58.4},{67.8,58.8},{69.2,55.8},{69.6,56.4},{69.8,56.8},{69.8,58.6} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Broken Tooth",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_RARE, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 21192 ,["id"] = 2850  ,["coords"] = {{22.4,60.8},{22.6,60},{22.8,60.6},{23,61.6} } },
  {["zone_name"] = "Darkshore", [ "zoneID" ] = 62, [ "name" ] = "Shadowclaw",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Darkshore. Used to be a Black Striped Cat.", ["class" ] = CLASS_RARE, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 37555 ,["id"] = 2175  ,["coords"] = {{41.2,36.4},{41.2,36.6},{41.6,36} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Zaricotl",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_RARE, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 37577 ,["id"] = 2931  ,["coords"] = {{55,43.2},{55.4,44.4},{55.4,44.6},{55.4,45.8},{55.8,42.6},{56.4,43.8},{56.4,44.8},{56.6,43.4},{56.6,44} } },
  {["zone_name"] = "Darkshore", [ "zoneID" ] = 62, [ "name" ] = "Strider Clutchmother",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Darkshore.", ["class" ] = CLASS_RARE, ["family"] = {  12  , "Tallstrider"          } , ["familySkills" ] = TALLSTRIDER_SKILLS          ,["displayID"] = 38 ,["id"] = 2172  ,["coords"] = {{40.8,48.4},{40.8,48.6} } },
  {["zone_name"] = "Duskwood", [ "zoneID" ] = 47, [ "name" ] = "Naraxis",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Duskwood. Appears in a cave in the mountains that form the eastern border of the zone. The cave can be seen on the zone map, in an area roughly north-east of Tranquil Gardens Cemetery.", ["class" ] = CLASS_RARE, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 963 ,["id"] = 574  ,["coords"] = {{86.4,48},{86.6,49} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Barnabus",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_RARE, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9372 ,["id"] = 2753  ,["coords"] = {{39.4,58.2},{39.4,59.4},{39.4,60.2},{39.8,59},{40.4,60},{40.6,60.2},{40.8,58.8},{41.2,58.2} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Vultros",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall. Vultros can appear a one of five places around the farmsteads of northern Westfall: (i) south of the Jansen Stead; (ii) south-east of Furlbrow's Pumpkin Farm; (iii) around the road between Furlbrow's Pumpkin Farm and the Molsen Farm; (iv) east of the Molsen Farm; and (v) just south-east of Saldean's Farm.", ["class" ] = CLASS_RARE, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 507 ,["id"] = 462  ,["coords"] = {{48.4,33},{49,28},{49,28.6},{49,32.2},{49,33.4},{49,33.6},{49,35.2},{49.2,26.8},{49.4,26.4},{49.8,32.4},{50.2,28.2},{50.2,33},{50.4,28.8},{54.2,24.2},{54.2,25},{54.4,25.8},{54.6,24.6},{55.2,35},{55.4,23.6},{55.6,35.6},{56,34.4},{56.2,33.4},{56.4,20.8},{56.4,35.2},{56.6,35.4},{56.6,35.6},{56.8,34},{57.2,19.4},{57.4,19.8},{57.6,19.4},{57.8,20.6},{58,18},{58,20.2} } },
  {["zone_name"] = "Dun Morogh", [ "zoneID" ] = 27, [ "name" ] = "Timber",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Dun Morogh.", ["class" ] = CLASS_RARE, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 10278 ,["id"] = 1132  ,["coords"] = {{66,33.6},{66,37.2},{66.8,37.8},{67.2,35.6},{67.4,34},{67.4,35.4},{67.6,35},{67.6,35.8},{67.8,33.8},{67.8,37.4},{69,34.4},{69.6,38},{70,34.8} } },
  {["zone_name"] = "Duskwood", [ "zoneID" ] = 47, [ "name" ] = "Lupos",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Darkened Bank, Duskwood. Wanders an area a bit south of the river, but north of Brightwood Grove.", ["class" ] = CLASS_RARE, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 10278 ,["id"] = 521  ,["coords"] = {{58.8,18.6},{59,20},{59.8,21},{60,22},{60.2,18.8},{60.2,22.8},{60.4,20},{60.6,21.2},{60.8,19.6},{63.8,19.4},{64.4,21.8},{64.8,20.6},{65,20},{65.2,18.2},{65.2,22},{65.4,19.4},{65.6,17.8},{65.6,19.6},{66,21.6},{66.2,20.8},{66.4,19.4},{66.6,19},{69,24.2},{69,25.2},{69.2,25.6},{69.4,22.8},{69.6,22.6},{69.8,25},{70,24.4},{70.4,25.6},{70.6,25},{70.8,22.2},{70.8,23.8},{71,22.8},{71.6,23} } },

}
]]
AOTH.test = {
  { ["zone_name"] = "Westfall"                      , [ "zoneID" ] = 52   , [ "name" ] = "Vultros"                     ,["maxlevel" ] =62      , [ "minlevel" ] =15    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 507   ,["id"] = 462    ,["coords"] = {{ 48.4  , 33    },{49,28},{49,28.6},{49,32.2},{49,33.4},{49,33.6},{49,35.2},{49.2,26.8},{49.4,26.4},{49.8,32.4},{50.2,28.2},{50.2,33},{50.4,28.8},{54.2,24.2},{54.2,25},{54.4,25.8},{54.6,24.6},{55.2,35},{55.4,23.6},{55.6,35.6},{56,34.4},{56.2,33.4},{56.4,20.8},{56.4,35.2},{56.6,35.4},{56.6,35.6},{56.8,34},{57.2,19.4},{57.4,19.8},{57.6,19.4},{57.8,20.6},{58,18},{58,20.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Mother Fang"                 ,["maxlevel" ] =62      , [ "minlevel" ] =12    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 36505 ,["id"] = 471    ,["coords"] = {{ 61    , 47    },{61.4,48},{61.6,47.4},{61.8,47.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Duskwood"                      , [ "zoneID" ] = 47   , [ "name" ] = "Lupos"                       ,["maxlevel" ] =62      , [ "minlevel" ] =22    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 10278 ,["id"] = 521    ,["coords"] = {{ 58.8  , 18.6  },{59,20},{59.8,21},{60,22},{60.2,18.8},{60.2,22.8},{60.4,20},{60.6,21.2},{60.8,19.6},{63.8,19.4},{64.4,21.8},{64.8,20.6},{65,20},{65.2,18.2},{65.2,22},{65.4,19.4},{65.6,17.8},{65.6,19.6},{66,21.6},{66.2,20.8},{66.4,19.4},{66.6,19},{69,24.2},{69,25.2},{69.2,25.6},{69.4,22.8},{69.6,22.6},{69.8,25},{70,24.4},{70.4,25.6},{70.6,25},{70.8,22.2},{70.8,23.8},{71,22.8},{71.6,23}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Duskwood"                      , [ "zoneID" ] = 47   , [ "name" ] = "Naraxis"                     ,["maxlevel" ] =62      , [ "minlevel" ] =23    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 963   ,["id"] = 574    ,["coords"] = {{ 86.4  , 48    },{86.6,49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Redridge Mountains"            , [ "zoneID" ] = 49   , [ "name" ] = "Chatter"                     ,["maxlevel" ] =62      , [ "minlevel" ] =21    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 37620 ,["id"] = 616    ,["coords"] = {{ 36.4  , 33.8  },{36.8,36.2},{37.4,34.2},{37.4,35.2},{37.4,36.6},{37.8,34.4},{37.8,34.8},{38,33.4},{38.2,35.8},{38.6,36.6},{38.8,34.4},{39,36.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Wetlands"                      , [ "zoneID" ] = 56   , [ "name" ] = "Leech Widow"                 ,["maxlevel" ] =62      , [ "minlevel" ] =24    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 283   ,["id"] = 1112   ,["coords"] = {{ 46.8  , 63.4  },{46.8,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Dun Morogh"                    , [ "zoneID" ] = 27   , [ "name" ] = "Bjarn"                       ,["maxlevel" ] =62      , [ "minlevel" ] =16    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70185 ,["id"] = 1130   ,["coords"] = {{ 66.2  , 59.8  },{66.4,58.8},{67.2,58},{67.4,58.6},{67.8,58.4},{67.8,58.8},{69.2,55.8},{69.6,56.4},{69.8,56.8},{69.8,58.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "New Tinkertown"                , [ "zoneID" ] = 30   , [ "name" ] = "Timber"                      ,["maxlevel" ] =62      , [ "minlevel" ] =5     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 10278 ,["id"] = 1132   ,["coords"] = {{ 66    , 33.6  },{66,37.2},{66.8,37.8},{67.2,35.6},{67.4,34},{67.4,35.4},{67.6,35},{67.6,35.8},{67.8,33.8},{67.8,37.4},{69,34.4},{69.6,38},{70,34.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Wetlands"                      , [ "zoneID" ] = 56   , [ "name" ] = "Razormaw Matriarch"          ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 11316 ,["id"] = 1140   ,["coords"] = {{ 69.8  , 29.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "The Cape of Stranglethorn"     , [ "zoneID" ] = 210  , [ "name" ] = "Scale Belly"                 ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 45945 ,["id"] = 1552   ,["coords"] = {{ 67.8  , 25.2  },{68,25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Strider Clutchmother"        ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 12  , "Tallstrider"   } , ["familySkills" ] = TALLSTRIDER_SKILLS   ,["displayID"] = 38    ,["id"] = 2172   ,["coords"] = {{ 40.8  , 48.4  },{40.8,48.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Shadowclaw"                  ,["maxlevel" ] =62      , [ "minlevel" ] =27    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37555 ,["id"] = 2175   ,["coords"] = {{ 41.2  , 36.4  },{41.2,36.6},{41.6,36}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Gosh-Haldir"                 ,["maxlevel" ] =62      , [ "minlevel" ] =20    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 32813 ,["id"] = 2476   ,["coords"] = {{ 52.8  , 57.8  },{53,55.8},{53,56.8},{53.2,55.4},{53.6,54.2},{53.8,55},{54,53.4},{54,56.4},{54,56.6},{54,58},{54.2,59},{54.6,56.4},{54.6,57},{55.2,54.2},{55.4,53},{55.4,55.2},{55.6,53.4},{55.6,54.8},{55.6,55.8},{56,53.6},{56.4,51.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Barnabus"                    ,["maxlevel" ] =62      , [ "minlevel" ] =55    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9372  ,["id"] = 2753   ,["coords"] = {{ 39.4  , 58.2  },{39.4,59.4},{39.4,60.2},{39.8,59},{40.4,60},{40.6,60.2},{40.8,58.8},{41.2,58.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Broken Tooth"                ,["maxlevel" ] =62      , [ "minlevel" ] =47    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 21192 ,["id"] = 2850   ,["coords"] = {{ 22.4  , 60.8  },{22.6,60},{22.8,60.6},{23,61.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Zaricotl"                    ,["maxlevel" ] =62      , [ "minlevel" ] =45    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 37577 ,["id"] = 2931   ,["coords"] = {{ 55    , 43.2  },{55.4,44.4},{55.4,44.6},{55.4,45.8},{55.8,42.6},{56.4,43.8},{56.4,44.8},{56.6,43.4},{56.6,44}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Mulgore"                       , [ "zoneID" ] = 7    , [ "name" ] = "Arra'chea"                   ,["maxlevel" ] =62      , [ "minlevel" ] =6     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 10916 ,["id"] = 3058   ,["coords"] = {{ 48    , 68.6  },{48.2,68.2},{48.6,67.8},{48.6,69.6},{49,69},{50.4,66.6},{50.4,68.4},{51,69},{51.2,66},{51.4,65.2},{51.6,65.4},{51.8,68.4},{52.4,63.8},{53.2,62.2},{53.4,61.4},{53.6,62.2},{53.8,69},{54.6,68},{54.8,62.4},{54.8,70},{55,68.6},{56.2,63.2},{56.2,70},{56.8,63.4},{57,65.8},{57.2,66.8},{57.8,67.6},{57.8,69}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Mulgore"                       , [ "zoneID" ] = 7    , [ "name" ] = "Mazzranache"                 ,["maxlevel" ] =62      , [ "minlevel" ] =15    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 12  , "Tallstrider"   } , ["familySkills" ] = TALLSTRIDER_SKILLS   ,["displayID"] = 1961  ,["id"] = 3068   ,["coords"] = {{ 42.4  , 45.4  },{42.8,46.2},{43.6,41},{44.4,47.4},{45,46.4},{45.2,47.6},{45.4,47.4},{45.6,47.2},{46.8,46.8},{47.2,40.6},{47.2,46.2},{47.6,46.4},{48.8,43.4},{49.6,43.6},{50,42.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Southern Barrens"              , [ "zoneID" ] = 199  , [ "name" ] = "Silithid Harvester"          ,["maxlevel" ] =62      , [ "minlevel" ] =35    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 37581 ,["id"] = 3253   ,["coords"] = {{ 41.2  , 67    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Gesharahan"                  ,["maxlevel" ] =62      , [ "minlevel" ] =21    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 1397  ,["id"] = 3398   ,["coords"] = {{ 40    , 74.6  },{40.4,74.2},{40.6,74.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Stormwind City"                , [ "zoneID" ] = 84   , [ "name" ] = "Sewer Beast"                 ,["maxlevel" ] =50      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 2850  ,["id"] = 3581   ,["coords"] = {{ 48.4  , 61.8  },{52.2,64.2},{54,68.2},{54.2,64.8},{54.2,68.6},{54.4,70.8},{54.6,65.6},{54.8,67.4},{54.8,67.6},{54.8,69.4},{55,70.6},{55.6,65},{56,72.8},{56.2,74.2},{56.2,76.6},{56.6,64.6},{57,75},{57.2,76.2},{57.6,73.4},{57.8,77.6},{58,41.2},{58.4,79.2},{59,43},{59.4,45.2},{59.8,44.2},{60.4,45.4},{60.4,72.2},{61.2,47.2},{61.4,47.6},{61.8,48.8},{62,51},{62.2,49.8},{62.6,50.6},{62.8,51.8},{63.6,49},{64.4,60.4},{65,65.4},{65.6,50.8},{65.6,64.6},{66,61.2},{66.4,64.2},{66.6,58.4},{66.6,61},{66.8,58.6},{67,55},{67.2,52.6},{67.4,54.2},{67.4,62},{67.4,62.6},{67.6,62.8},{67.8,62.2},{67.8,64},{67.8,66},{68.2,53.2},{68.6,53.4},{68.8,50.4},{68.8,50.6},{68.8,64.2},{69,65.4},{69.4,51.6},{69.4,63.4},{69.6,49.2},{69.8,50},{70,50.8},{70.2,65.8},{70.6,68},{71,48.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Pridewing Patriarch"         ,["maxlevel" ] =120     , [ "minlevel" ] =28    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 35655 ,["id"] = 4015   ,["coords"] = {{ 55    , 45    },{55.2,44.4},{55.4,46.4},{55.6,44.4},{55.6,44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Krkk'kx"                     ,["maxlevel" ] =62      , [ "minlevel" ] =45    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"         } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 37583 ,["id"] = 4132   ,["coords"] = {{ 69.8  , 85.6  },{70,85.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Darkmist Widow"              ,["maxlevel" ] =62      , [ "minlevel" ] =37    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 17814 ,["id"] = 4380   ,["coords"] = {{ 33.4  , 22.8  },{33.6,22.4},{33.6,22.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Antilus the Soarer"          ,["maxlevel" ] =62      , [ "minlevel" ] =42    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 10889 ,["id"] = 5347   ,["coords"] = {{ 53.4  , 68.8  },{53.6,70.8},{53.8,67.6},{53.8,70.4},{54,66.4},{54,71.6},{54.4,65.2},{54.4,67},{54.4,68.8},{54.6,65},{54.6,68.4},{54.6,73.6},{54.8,69},{55,65.8},{55.2,66.6},{55.2,70.8},{55.2,71.6},{55.4,70.2},{55.6,69.4},{55.6,69.8},{55.8,72.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Arash-ethis"                 ,["maxlevel" ] =62      , [ "minlevel" ] =38    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 7569  ,["id"] = 5349   ,["coords"] = {{ 37.4  , 22    },{37.8,23.4},{38,24},{38.4,21.6},{38.8,24.2},{38.8,24.6},{39,20.4},{39.4,20.6},{39.8,20.2},{39.8,21},{40.2,24.6},{40.4,22.4},{40.8,24.6},{41,22.6},{41.4,24}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Qirot"                       ,["maxlevel" ] =62      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 11142 ,["id"] = 5350   ,["coords"] = {{ 73.4  , 64    },{73.6,64},{76.4,61.2},{76.6,61.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Old Grizzlegut"              ,["maxlevel" ] =62      , [ "minlevel" ] =37    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 706   ,["id"] = 5352   ,["coords"] = {{ 55.4  , 61.2  },{55.4,62},{55.8,59.8},{55.8,62.4},{56,57.6},{56,58.6},{56.2,60.8},{56.2,62.8},{56.6,62.6},{57,58.2},{57.2,62.2},{57.6,58.8},{57.6,62.6},{58,58},{58,62.4},{58.6,62.4},{58.8,59},{59,62.6},{59.2,61},{59.6,60.2},{60,59.4},{60,60.8},{60.8,60.4},{60.8,62},{61,62.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Snarler"                     ,["maxlevel" ] =62      , [ "minlevel" ] =54    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 780   ,["id"] = 5356   ,["coords"] = {{ 75.2  , 36.4  },{75.4,36.8},{75.6,36.8},{76,38.6},{76.4,38.2},{76.6,38.8},{77.8,37.8},{78.6,38},{79.4,39.2},{81.2,38.6},{81.4,39.8},{82,39.4},{82.2,39.8},{83.4,38.8},{84,38.2},{84.6,38}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Mulgore"                       , [ "zoneID" ] = 7    , [ "name" ] = "The Rake"                    ,["maxlevel" ] =62      , [ "minlevel" ] =13    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 1973  ,["id"] = 5807   ,["coords"] = {{ 49.6  , 22    },{49.8,25},{50,23.2},{50.4,26.2},{50.6,26.6},{50.8,21.6},{51,28.4},{51.2,21.4},{51.8,21.4},{52.6,20.4},{52.6,20.6},{53.4,19.4},{53.4,29.6},{53.8,19.2},{54.4,20.2},{54.4,20.8},{54.6,20.8},{55.4,24},{55.4,24.6},{55.6,24.4},{55.8,25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Durotar"                       , [ "zoneID" ] = 1    , [ "name" ] = "Death Flayer"                ,["maxlevel" ] =62      , [ "minlevel" ] =16    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 2491  ,["id"] = 5823   ,["coords"] = {{ 34.4  , 44.6  },{34.8,43.4},{35,44.2},{35.4,45.2},{35.4,46},{35.6,45.6},{36.4,44.4},{36.4,44.6},{36.6,44.4},{37,44.6},{37.2,45.8},{37.2,47.6},{37.4,46.8},{37.8,47.8},{38,44.6},{38.2,44.2},{38.4,43.4},{38.4,46.8},{38.6,44},{38.6,44.6},{38.8,48.6},{39,46.4},{39.2,46.6},{39.6,45.2},{39.6,45.6},{39.8,44}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Humar the Pridelord"         ,["maxlevel" ] =62      , [ "minlevel" ] =21    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 4424  ,["id"] = 5828   ,["coords"] = {{ 67.2  , 64    },{67.4,64.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Southern Barrens"              , [ "zoneID" ] = 199  , [ "name" ] = "Snort the Heckler"           ,["maxlevel" ] =62      , [ "minlevel" ] =34    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         } , ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 34324 ,["id"] = 5829   ,["coords"] = {{ 45.4  , 43.4  },{45.4,43.6},{45.6,43.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Swiftmane"                   ,["maxlevel" ] =62      , [ "minlevel" ] =20    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 6084  ,["id"] = 5831   ,["coords"] = {{ 63.2  , 63.4  },{64.8,60.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Southern Barrens"              , [ "zoneID" ] = 199  , [ "name" ] = "Thunderstomp"                ,["maxlevel" ] =62      , [ "minlevel" ] =34    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 37778 ,["id"] = 5832   ,["coords"] = {{ 44.4  , 77.4  },{44.4,77.6},{44.4,80},{44.6,77.4},{44.6,80.2},{46.2,79},{46.4,78.2},{48.2,74.4},{48.2,74.6},{49.8,79.2},{49.8,80.2},{49.8,80.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Southern Barrens"              , [ "zoneID" ] = 199  , [ "name" ] = "Azzere the Skyblade"         ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 2702  ,["id"] = 5834   ,["coords"] = {{ 42.2  , 53.4  },{42.2,54},{42.4,54.8},{42.8,53.6},{43,54.6},{43,56.2},{43.4,56.6},{43.6,57.4},{43.6,58.2},{43.8,54.8},{44,56},{44.2,59},{44.6,56.2},{45,58.8},{46,57.4},{46.2,55.2},{46.2,57.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Takk the Leaper"             ,["maxlevel" ] =62      , [ "minlevel" ] =24    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 1337  ,["id"] = 5842   ,["coords"] = {{ 63.4  , 36    },{63.4,36.6},{63.6,35.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 10   , [ "name" ] = "Dishu"                       ,["maxlevel" ] =62      , [ "minlevel" ] =25    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 1043  ,["id"] = 5865   ,["coords"] = {{ 45.2  , 52.8  },{45.4,33},{48.8,51.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Sorrow Wing"                 ,["maxlevel" ] =62      , [ "minlevel" ] =27    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 11012 ,["id"] = 5928   ,["coords"] = {{ 50.2  , 41.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Ironeye the Invincible"      ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 46055 ,["id"] = 5935   ,["coords"] = {{ 61.2  , 67    },{61.2,67.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Vile Sting"                  ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 10988 ,["id"] = 5937   ,["coords"] = {{ 5.4   , 42    },{5.6,42.6},{6,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "Ravasaur Matriarch"          ,["maxlevel" ] =62      , [ "minlevel" ] =45    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 11319 ,["id"] = 6581   ,["coords"] = {{ 60.8  , 72.8  },{66.4,67}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "Clutchmother Zavas"          ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 11084 ,["id"] = 6582   ,["coords"] = {{ 76.8  , 52.4  },{78.6,47.8},{80.2,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "Gruff"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 37587 ,["id"] = 6583   ,["coords"] = {{ 31.8  , 78.2  },{32,78.6},{33,79.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "King Mosh"                   ,["maxlevel" ] =62      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5305  ,["id"] = 6584   ,["coords"] = {{ 29    , 36.4  },{29,36.8},{29.2,47.4},{29.4,42.4},{29.4,46},{29.6,45.8},{29.8,37},{30,35.6},{30,44.4},{30.2,45.4},{30.2,46.8},{30.8,31.8},{31.2,29.4},{31.4,30},{31.4,36.6},{32,30.4},{32,31},{32.6,30.4},{32.6,36.6},{32.8,31},{33.4,28.4},{33.4,29.4},{33.4,35.6},{33.8,37.2},{34.4,38},{35.2,35.8},{35.2,36.8},{35.2,37.6},{35.2,39},{35.4,35.2},{35.6,35.8},{36.2,37},{36.4,30.6},{36.4,35.4},{36.8,32.2},{36.8,34.8},{37,31.4},{37,33.8},{37.4,30.2},{37.6,31}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Un'Goro Crater"                , [ "zoneID" ] = 78   , [ "name" ] = "Uhk'loc"                     ,["maxlevel" ] =62      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       } , ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 8129  ,["id"] = 6585   ,["coords"] = {{ 62.8  , 18.4  },{63,18.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Azshara"                       , [ "zoneID" ] = 76   , [ "name" ] = "Antilos"                     ,["maxlevel" ] =62      , [ "minlevel" ] =31    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 3212  ,["id"] = 6648   ,["coords"] = {{ 44.4  , 26.4  },{44.4,26.6},{44.4,27.6},{44.6,26.4},{44.8,27.2},{44.8,28}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Soriid the Devourer"         ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 14521 ,["id"] = 8204   ,["coords"] = {{ 53.4  , 67.8  },{53.4,70.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Haarka the Ravenous"         ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15439 ,["id"] = 8205   ,["coords"] = {{ 58.2  , 23.4  },{60.2,27.8},{60.6,21.6},{60.8,25.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Emberwing"                   ,["maxlevel" ] =62      , [ "minlevel" ] =44    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 34048 ,["id"] = 8207   ,["coords"] = {{ 44.4  , 40.4  },{44.4,40.6},{44.6,40.4},{44.6,40.6},{48.2,45.4},{48.2,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tanaris"                      , [ "zoneID" ] = 71   , [ "name" ] = "Murderous Blisterpaw"        ,["maxlevel" ] ="???"   , [ "minlevel" ] ="???" , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         } , ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 1534  ,["id"] = 8208   ,["coords"] = {{ 47.4  , 25.2  },{47.6,25.8},{47.8,30},{48,27},{48.6,31.6},{49,31.4},{49.6,31.8},{50,32.6},{51.2,32.6},{51.6,32},{52.4,32.8},{53.4,32.2},{53.4,32.8},{54,32.4},{54.4,32.6},{55,33.4},{55,33.8},{55.4,36.6},{56.4,36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "The Hinterlands"               , [ "zoneID" ] = 26   , [ "name" ] = "Old Cliff Jumper"            ,["maxlevel" ] =62      , [ "minlevel" ] =36    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11414 ,["id"] = 8211   ,["coords"] = {{ 13.2  , 53.8  },{13.6,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "The Hinterlands"               , [ "zoneID" ] = 26   , [ "name" ] = "Ironback"                    ,["maxlevel" ] =62      , [ "minlevel" ] =32    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 37770 ,["id"] = 8213   ,["coords"] = {{ 79.4  , 56.6  },{80.2,56.4},{80.2,58.2},{80.4,57},{80.6,56.2},{81,55.4},{81,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Rekk'tilac"                  ,["maxlevel" ] =62      , [ "minlevel" ] =56    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 37685 ,["id"] = 8277   ,["coords"] = {{ 29.2  , 67.8  },{30.2,68.6},{30.4,70.2},{30.4,71},{30.4,71.8},{30.6,69.8},{30.6,71.2},{30.6,72.2},{31.2,69.4},{31.6,72},{31.8,73.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Spiteflayer"                 ,["maxlevel" ] =62      , [ "minlevel" ] =61    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 37536 ,["id"] = 8299   ,["coords"] = {{ 59.4  , 35.4  },{59.4,36.6},{59.4,38.2},{59.6,36.8},{59.6,38.2},{59.8,35.2},{60,34.2},{60,38.8},{60.4,33.2},{60.6,33.2},{60.8,40},{61.4,40.6},{61.6,32.6},{61.8,32.4},{62,36.6},{62,40.2},{62.4,41},{63.2,40.2},{63.4,33},{63.4,33.6},{63.6,33},{63.6,40.6},{64,33.6},{64,39.4},{64,39.6},{64.4,38},{64.6,33.6},{64.6,36},{64.6,37.2},{64.6,39.4},{64.8,35.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Ravage"                      ,["maxlevel" ] =62      , [ "minlevel" ] =53    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         } , ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 34324 ,["id"] = 8300   ,["coords"] = {{ 49    , 34.4  },{49,35.4},{49.4,36.2},{49.6,34.4},{49.6,35.6},{49.8,35}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Clack the Reaver"            ,["maxlevel" ] =62      , [ "minlevel" ] =52    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 15433 ,["id"] = 8301   ,["coords"] = {{ 47.2  , 13.8  },{47.2,14.6},{47.6,14.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Deatheye"                    ,["maxlevel" ] =62      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 46053 ,["id"] = 8302   ,["coords"] = {{ 51.2  , 27.2  },{51.6,25.6},{52.2,27.8},{52.4,27.4},{52.4,29},{52.6,27.8},{53.2,26.8},{53.4,26.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Blasted Lands"                 , [ "zoneID" ] = 17   , [ "name" ] = "Grunter"                     ,["maxlevel" ] =62      , [ "minlevel" ] =53    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 24741 ,["id"] = 8303   ,["coords"] = {{ 54.4  , 39.4  },{54.4,39.8},{54.8,39},{55.2,38.4},{55.4,40.2},{55.6,39.4},{55.6,40}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Azshara"                       , [ "zoneID" ] = 76   , [ "name" ] = "The Evalcharr"               ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 37569 ,["id"] = 8660   ,["coords"] = {{ 13.8  , 50.6  },{14.4,50.4},{14.4,57.4},{14.4,57.6},{14.6,57.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Deathmaw"                    ,["maxlevel" ] =62      , [ "minlevel" ] =59    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 37671 ,["id"] = 10077  ,["coords"] = {{ 62.8  , 31.4  },{63.2,32.2},{63.4,32.6},{67.4,54.6},{68.4,55.2},{70,56.2},{70.2,56.8},{70.6,31.2},{70.8,29.8},{72.2,59},{73,51.6},{73.6,51.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Rak'shiri"                   ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 10054 ,["id"] = 10200  ,["coords"] = {{ 46.8  , 19.4  },{47,19.6},{47.4,18.2},{47.8,18.8},{48.4,17.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Bayne"                       ,["maxlevel" ] =62      , [ "minlevel" ] =6     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 37773 ,["id"] = 10356  ,["coords"] = {{ 45.4  , 48.8  },{45.8,48.4},{45.8,48.6},{46,49.6},{46.6,50.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Ressan the Needler"          ,["maxlevel" ] =62      , [ "minlevel" ] =8     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 24  , "Bat"           } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 16053 ,["id"] = 10357  ,["coords"] = {{ 52.2  , 56.4  },{53.2,56.4},{53.4,57.4},{53.4,57.8},{53.6,57.4},{53.6,58},{53.6,58.6},{54.2,56.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Sri'skulk"                   ,["maxlevel" ] =62      , [ "minlevel" ] =12    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 22185 ,["id"] = 10359  ,["coords"] = {{ 84.4  , 49.2  },{84.4,49.6},{84.6,49.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Ashenvale"                     , [ "zoneID" ] = 63   , [ "name" ] = "Mist Howler"                 ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 165   ,["id"] = 10644  ,["coords"] = {{ 25.2  , 26.8  },{26.2,15.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Sian-Rotam"                  ,["maxlevel" ] =62      , [ "minlevel" ] =52    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 10114 ,["id"] = 10741  ,["coords"] = {{ 45.8  , 17.4  },{45.8,17.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Ashenvale"                     , [ "zoneID" ] = 63   , [ "name" ] = "Ursol'lok"                   ,["maxlevel" ] =62      , [ "minlevel" ] =28    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70188 ,["id"] = 12037  ,["coords"] = {{ 89.4  , 46.4  },{89.4,46.6},{89.4,47.6},{89.6,46.4},{89.6,46.6},{92.8,45.4},{92.8,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Gorefang"                    ,["maxlevel" ] =62      , [ "minlevel" ] =15    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11413 ,["id"] = 12431  ,["coords"] = {{ 56    , 23    },{56.2,25.2},{56.4,24.4},{56.6,24},{56.8,23.2},{57.2,16},{57.4,15.4},{57.4,17.4},{57.8,16.2},{57.8,16.8},{58,15.2},{58.6,15},{58.6,16},{60,9},{60.2,9.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Krethis the Shadowspinner"   ,["maxlevel" ] =62      , [ "minlevel" ] =21    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 22185 ,["id"] = 12433  ,["coords"] = {{ 34.6  , 15.6  },{34.6,17.6},{35.2,15.2},{35.4,14.2},{35.4,16.8},{35.6,17.4},{35.6,18.2},{36.2,15.2},{36.2,15.6},{36.4,14},{36.6,16},{36.6,17},{36.8,14.4},{37,14.6},{37.4,17.6},{37.6,17.4},{37.8,16.2},{38.4,14.2},{38.4,14.8},{38.6,14.2},{38.6,14.6},{38.6,16}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Araga"                       ,["maxlevel" ] =62      , [ "minlevel" ] =31    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37735 ,["id"] = 14222  ,["coords"] = {{ 44.2  , 54    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Cranky Benj"                 ,["maxlevel" ] =62      , [ "minlevel" ] =32    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 21240 ,["id"] = 14223  ,["coords"] = {{ 56.6  , 61.6  },{57.2,61.2},{57.4,60},{58,59},{58,60.8},{58.4,59.6},{59.2,58.6},{59.4,58.4},{59.8,58.4},{60.2,57},{60.4,55.2},{60.4,56.4},{60.6,47.4},{60.6,55.2},{60.6,56.4},{60.8,50.8},{60.8,52},{60.8,52.8},{60.8,54},{61,47.8},{61.2,45.4},{61.4,41.6},{61.4,43},{61.4,44.4},{61.6,42},{61.6,43},{61.6,43.6},{61.6,48},{62.2,40.4},{62.8,39.2},{63,39.8},{63,40.8},{64,38.6},{64.6,37.2},{65.4,36},{65.8,36.4},{67.2,34.8},{68.4,30.6},{68.6,32.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Desolace"                      , [ "zoneID" ] = 66   , [ "name" ] = "Hissperak"                   ,["maxlevel" ] =62      , [ "minlevel" ] =39    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 45445 ,["id"] = 14227  ,["coords"] = {{ 41.8  , 47.2  },{42.4,45.8},{42.6,46.6},{43,42.6},{43,61.2},{43,61.8},{43.4,41.8},{43.8,61},{46.2,53},{46.4,54},{51.4,47.6},{51.4,48.8},{51.6,48.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Desolace"                      , [ "zoneID" ] = 66   , [ "name" ] = "Giggler"                     ,["maxlevel" ] =62      , [ "minlevel" ] =32    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         } , ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 2714  ,["id"] = 14228  ,["coords"] = {{ 57.4  , 8.4   },{57.4,10},{58,9},{58.6,18.4},{59,17.2},{60,25.4},{60.2,24},{60.8,24.6},{61,24.2},{61,25.6},{63,34.2},{63,34.8},{63.8,19.6},{64.2,19.4},{64.2,33.6},{66,24.2},{66.2,25},{66.4,25.8},{66.6,25.2},{66.6,26.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Dart"                        ,["maxlevel" ] =62      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 788   ,["id"] = 14232  ,["coords"] = {{ 46.8  , 17.4  },{47,18.2},{47.2,18.6},{47.4,15},{47.4,16.2},{47.4,20},{47.8,19.2},{48.2,14.2},{48.4,15.2},{48.4,15.8},{48.4,16.6},{49,17.2},{49,18},{49,18.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Ripscale"                    ,["maxlevel" ] =62      , [ "minlevel" ] =47    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 37748 ,["id"] = 14233  ,["coords"] = {{ 37.6  , 49.2  },{37.6,50.6},{37.8,50.4},{41.8,55.2},{42.2,55.8},{42.6,54.6},{43.6,50.8},{43.8,50},{47.4,54.4},{47.4,54.6},{47.4,55.6},{47.6,54.4},{47.6,54.6},{47.6,55.8},{49,57.6},{49.2,57.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Hayoc"                       ,["maxlevel" ] =62      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 2703  ,["id"] = 14234  ,["coords"] = {{ 47.4  , 61.4  },{47.4,61.6},{47.6,61.4},{47.6,61.6},{47.8,63.2},{48.4,59.8},{48.6,60.4},{48.6,60.8},{48.6,61.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Oozeworm"                    ,["maxlevel" ] =62      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 12336 ,["id"] = 14237  ,["coords"] = {{ 36.4  , 62.4  },{37,62.4},{37,62.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Shanda the Spinner"          ,["maxlevel" ] =62      , [ "minlevel" ] =22    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 34437 ,["id"] = 14266  ,["coords"] = {{ 61.4  , 73.4  },{61.4,73.6},{61.6,74.4},{61.6,74.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Lord Condar"                 ,["maxlevel" ] =62      , [ "minlevel" ] =22    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 25868 ,["id"] = 14268  ,["coords"] = {{ 66.2  , 71.2  },{66.2,73.2},{67.4,76},{68.8,75},{69,73.8},{70.8,73.4},{70.8,74.4},{70.8,75},{70.8,75.6},{71,72.2},{72,71},{72.2,72.4},{72.2,72.6},{73,71},{73,72.2},{73.2,72.6},{73.6,71.2},{73.8,71.6},{74.2,65.8},{74.2,68.6},{74.4,70},{74.6,68.8},{74.8,66.2},{74.8,67.2},{74.8,67.6},{74.8,73.6},{75,71.2},{75.4,73},{75.8,63},{75.8,73},{76,73.8},{76.2,62},{77,74},{77.2,73.4},{77.6,74},{77.8,64.6},{78,67.6},{78,70.2},{78,73},{78,76},{78.2,64.4},{78.2,68.8},{78.2,71.2},{78.2,71.8},{78.2,74.6},{78.4,67},{78.6,64.4},{78.6,64.6},{78.6,68.8},{78.6,70.2},{78.6,71.2},{78.8,67.6},{78.8,72.4},{79,63},{79,67},{79.2,66}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Creepthess"                  ,["maxlevel" ] =62      , [ "minlevel" ] =22    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 37738 ,["id"] = 14279  ,["coords"] = {{ 43.4  , 75.2  },{43.6,74.8},{43.8,74.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Big Samras"                  ,["maxlevel" ] =62      , [ "minlevel" ] =43    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70189 ,["id"] = 14280  ,["coords"] = {{ 63.4  , 52.6  },{63.6,52.4},{63.6,52.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Death Howl"                  ,["maxlevel" ] =62      , [ "minlevel" ] =42    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 36341 ,["id"] = 14339  ,["coords"] = {{ 48.2  , 74.4  },{48.2,74.8},{48.4,73.4},{48.6,75},{53.4,85.6},{53.8,84.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Olm the Wise"                ,["maxlevel" ] =62      , [ "minlevel" ] =58    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 37568 ,["id"] = 14343  ,["coords"] = {{ 54.4  , 26.4  },{54.4,26.8},{54.6,27.2},{54.8,23.2},{55.2,24},{56.2,23.6},{56.4,23.4},{56.6,23.2},{56.6,23.6},{57,18.4},{57.4,19.4},{57.4,19.6},{57.8,19.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Mongress"                    ,["maxlevel" ] =62      , [ "minlevel" ] =44    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70186 ,["id"] = 14344  ,["coords"] = {{ 43.4  , 75.8  },{43.6,75.6},{46.8,82}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Teldrassil"                    , [ "zoneID" ] = 57   , [ "name" ] = "Duskstalker"                 ,["maxlevel" ] =62      , [ "minlevel" ] =12    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37558 ,["id"] = 14430  ,["coords"] = {{ 52.2  , 67.4  },{52.2,67.6},{54,66.6},{54.2,66.2},{57,66.4},{57.4,66.6},{57.6,66.4},{57.6,66.8},{59.4,64.4},{59.4,65.6},{59.6,65.2},{59.6,65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Gretheer"                    ,["maxlevel" ] =62      , [ "minlevel" ] =44    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 1104  ,["id"] = 14472  ,["coords"] = {{ 35.6  , 38    }, {35.8, 39.6}, {36, 38.8}, {36.4, 42}, {36.6, 38}, {36.6, 39.4}, {36.6, 39.8}, {44.4, 51}, {44.6, 49}, {45.2, 50.2}, {45.2, 51.4}, {45.2, 51.6}, {45.6, 50.4}, {51.6, 56.2}, {52.2, 55.2}, {53, 54.6}, {53, 55.8}, {64, 57.6}, {64.4, 58.6}, {64.6, 58}, {64.6, 58.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Lapress"                     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 37593 ,["id"] = 14473  ,["coords"] = {{ 55.4  , 71    }, {56, 74.4}, {57.2, 75}, {57.6, 76}, {58.6, 66.8}, {60.8, 68.8}, {61.6, 66}, {63, 73.4}, {63, 74.4}, {63.6, 82}, {65.6, 75.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Zora"                        ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 37548 ,["id"] = 14474  ,["coords"] = {{ 27    , 62    }, {32, 55.8}, {33.8, 53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Rex Ashil"                   ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 37579 ,["id"] = 14475  ,["coords"] = {{ 51    , 23    }, {51.4, 26.6}, {51.6, 26.6}, {51.8, 23.8}, {51.8, 25.6}, {52, 24.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Krellack"                    ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 6068  ,["id"] = 14476  ,["coords"] = {{ 62.4  , 18.4  }, {62.4, 18.6}, {62.8, 18.8}, {64.4, 39}, {64.4, 39.8}, {64.6, 39.8}, {64.8, 39.4}, {67.2, 29.2}, {67.4, 29.8}, {67.8, 29.4}, {69.2, 36.8}, {69.8, 37.4}, {69.8, 37.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Grubthor"                    ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 14523 ,["id"] = 14477  ,["coords"] = {{ 34    , 73.2  }, {34.4, 71}, {34.6, 72.4}, {34.6, 72.8}, {35.2, 71}, {41, 65.8}, {41.2, 64.4}, {41.2, 64.8}, {48.8, 71.4}, {48.8, 72}, {49.2, 72.6}, {49.4, 63.8}, {49.6, 71}, {49.6, 72.4}, {50, 62.8}, {50.2, 61.4}, {50.2, 63.8}, {50.8, 62.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "The Cape of Stranglethorn"     , [ "zoneID" ] = 210  , [ "name" ] = "Kurmokk"                     ,["maxlevel" ] =62      , [ "minlevel" ] =35    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       } , ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 3188  ,["id"] = 14491  ,["coords"] = {{ 48    , 58    },{48.2,57.4},{49.4,56.6},{49.6,56.4},{50.6,55.6},{50.8,55},{51,54.4},{51.4,53.4},{51.8,53.8},{52.2,53.2},{52.8,53.2},{53.6,53.2},{54.4,52.2},{54.8,51.8},{55.4,51.2},{55.6,51.2},{56.2,50.2},{56.2,52.8},{57.2,49.2},{58,47.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Goretooth"                   ,["maxlevel" ] =82      , [ "minlevel" ] =82    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 20763 ,["id"] = 17144  ,["coords"] = {{ 41.4  , 41.4  },{44,47},{44.8,40.4},{58.2,27.8},{74.6,76},{75.8,75.6},{76,79.6},{76,80.8},{76.2,78}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Desolace"                      , [ "zoneID" ] = 66   , [ "name" ] = "Crusty"                      ,["maxlevel" ] =62      , [ "minlevel" ] =39    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 27692 ,["id"] = 18241  ,["coords"] = {{ 34.4  , 21.6  },{34.4,23.4},{34.4,24},{34.6,20.8},{34.6,22.4},{34.6,23.2},{34.6,24.4},{35,20},{35.2,25.4},{35.8,24},{36,20.4},{36,25.2},{36.2,22.4},{36.4,23.4},{37,19.8},{37.2,20.8},{37.6,20.2},{38,20.8},{38.4,19},{39,18.2},{39.6,18},{41.2,18.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Zangarmarsh"                   , [ "zoneID" ] = 102  , [ "name" ] = "Marticar"                    ,["maxlevel" ] =82      , [ "minlevel" ] =70    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 126 , "Water Strider" } , ["familySkills" ] = WATER_STRIDER_SKILLS ,["displayID"] = 45045 ,["id"] = 18680  ,["coords"] = {{ 9.8   , 52.2  },{10.8,47.2},{10.8,55.2},{11,50.4},{11.2,46.4},{13.4,45.4},{14,44.6},{14.6,44.6},{14.8,44.4},{15,40.4},{15,43.4},{16,38.2},{16.8,36.2},{17.6,34.6},{37.8,38.4},{38.8,33.8},{40.4,33.6},{41.4,33.2},{42.2,33.6},{42.6,34.4},{43,34.6},{43.6,34.8},{44.6,34.2},{47,32},{47.4,30.6},{47.8,30},{50,30.8},{52.4,32.4},{52.8,33},{54,33},{54.8,33.8},{70.2,39.8},{70.4,37.4},{73.6,36.2},{73.8,46.6},{75.8,48.4},{77,51.4},{78.8,53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Netherstorm"                   , [ "zoneID" ] = 109  , [ "name" ] = "Nuramoc"                     ,["maxlevel" ] =82      , [ "minlevel" ] =82    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 19913 ,["id"] = 20932  ,["coords"] = {{ 23.2  , 78.8  },{24.8,80.2},{26.8,81.4},{33,32},{34.2,20.8},{34.4,25},{34.4,27.6},{35,26},{35.2,19.6},{35.4,24.8},{35.6,24.4},{35.6,78},{38.4,78.4},{39.4,77.8},{40.4,77.2},{44.2,71.8},{54.2,59.8},{57.2,60.2},{63.6,58.8},{65.6,58.2},{67.6,60.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Borean Tundra"                 , [ "zoneID" ] = 114  , [ "name" ] = "Icehorn"                     ,["maxlevel" ] =82      , [ "minlevel" ] =70    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 26286 ,["id"] = 32361  ,["coords"] = {{ 80.4  , 46    },{80.6,46.2},{81.2,31.6},{81.4,31.4},{81.6,32},{84.6,46.8},{85.4,34.4},{85.6,34.4},{85.8,34.6},{88.2,39.6},{88.4,39.4},{88.6,39.8},{91.4,32.4},{91.4,32.6},{91.6,32.4},{91.6,32.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Zul'Drak"                      , [ "zoneID" ] = 121  , [ "name" ] = "Terror Spinner"              ,["maxlevel" ] =82      , [ "minlevel" ] =72    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 27683 ,["id"] = 32475  ,["coords"] = {{ 52.6  , 32    },{53.2,31.4},{61.2,36.4},{61.2,36.6},{71.4,23.2},{71.4,23.8},{71.4,28.4},{71.4,29},{71.6,23.4},{71.6,24.2},{71.6,28.8},{71.8,24.6},{72,28.4},{74,66},{74.4,66.6},{74.6,66.4},{75.2,66.6},{77.2,42.2},{77.2,42.8},{77.8,42.8},{81.4,34.4},{81.4,34.6},{81.6,34.4},{82,35}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Sholazar Basin"                , [ "zoneID" ] = 119  , [ "name" ] = "Aotona"                      ,["maxlevel" ] =82      , [ "minlevel" ] =72    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 27975 ,["id"] = 32481  ,["coords"] = {{ 54.8  , 51.8  }, {57.0, 65.0}, {52.6, 72.2}, {44.4, 69.8}, {41.6, 68}, {40.6, 58.6}, {43.2, 52.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Sholazar Basin"                , [ "zoneID" ] = 119  , [ "name" ] = "King Krush"                  ,["maxlevel" ] =82      , [ "minlevel" ] =73    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 28052 ,["id"] = 32485  ,["coords"] = {{ 48.6  , 41.8  }, {58.0, 82.6}, {33.2, 32.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Sholazar Basin"                , [ "zoneID" ] = 119  , [ "name" ] = "Loque'nahak"                 ,["maxlevel" ] =82      , [ "minlevel" ] =73    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 28010 ,["id"] = 32517  ,["coords"] = {{ 58.80 , 22.01 }, {36.00, 30.00}, {31.00, 66.00}, {21.8, 70.6}, {51.2, 81.4}, {67.00, 78.8}, {71.4, 71.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }, } ,
  { ["zone_name"] = "Zul'Drak"                      , [ "zoneID" ] = 121  , [ "name" ] = "Gondria"                     ,["maxlevel" ] =82      , [ "minlevel" ] =67    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 28871 ,["id"] = 33776  ,["coords"] = {{ 61    , 63.4  },{61.4,61.6},{61.6,62.6},{63.2,42.8},{63.6,43.2},{67.4,77.6},{67.6,77.8},{67.8,77.4},{69.4,48.4},{69.6,48.2},{77.2,70},{77.6,70}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "The Storm Peaks"               , [ "zoneID" ] = 120  , [ "name" ] = "Skoll"                       ,["maxlevel" ] =82      , [ "minlevel" ] =82    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 29673 ,["id"] = 35189  ,["coords"] = {{ 27.8  , 50.4  },{27.8,50.8},{30.2,64.4},{30.2,64.6},{46.2,64.4},{46.2,64.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Grizzly Hills"                 , [ "zoneID" ] = 116  , [ "name" ] = "Arcturis"                    ,["maxlevel" ] =82      , [ "minlevel" ] =73    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 31094 ,["id"] = 38453  ,["coords"] = {{ 31    , 55.8  },{31.2,55.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Scorpitar"                   ,["maxlevel" ] =62      , [ "minlevel" ] =53    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 31351 ,["id"] = 39183  ,["coords"] = {{ 49.4  , 58.4  },{49.4,58.8},{49.6,58.4},{49.6,58.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Slaverjaw"                   ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         } , ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 31352 ,["id"] = 39185  ,["coords"] = {{ 40    , 67.8  },{40.2,67.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Hellgazer"                   ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 45946 ,["id"] = 39186  ,["coords"] = {{ 40.8  , 41.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Ashtail"                     ,["maxlevel" ] =62      , [ "minlevel" ] =25    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 50  , "Fox"           } , ["familySkills" ] = FOX_SKILLS           ,["displayID"] = 30239 ,["id"] = 45380  ,["coords"] = {{ 66.6  , 40    },{67.6,42.8},{68.4,37.8},{68.8,36},{68.8,38.2},{69.6,42},{70,37.4},{70,37.6},{70.4,35.6},{70.6,36.2},{70.8,36.8},{71,42.8},{72.2,37},{72.4,36.2},{72.4,42.2},{72.8,42.2},{73,35.4},{73,36},{73,43.4},{73.2,36.6},{73.2,44.6},{73.6,42.8},{73.6,44},{73.8,36.4},{74,34},{74.2,44.8},{74.6,43.8},{75.2,42.6},{76.2,42.8},{76.2,43.8},{76.4,38.4},{76.4,42.4},{76.6,35},{77,36.8},{77,39},{77.6,41.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Loch Modan"                    , [ "zoneID" ] = 48   , [ "name" ] = "Nix"                         ,["maxlevel" ] =62      , [ "minlevel" ] =22    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 18723 ,["id"] = 45402  ,["coords"] = {{ 50.4  , 37.8  },{50.8,36},{50.8,37.4},{51.2,37.8},{51.2,40.6},{51.8,41},{52.2,36},{52.2,40.4},{52.2,41.6},{52.4,34.8},{52.6,41.2},{53,33.8},{53.2,35},{53.2,42.2},{53.8,35.2},{53.8,41},{53.8,43.2},{54.6,41},{55.4,34.6},{55.4,35.8},{55.4,40.2},{55.4,42},{55.6,35.4},{55.8,39},{55.8,41.8},{55.8,42.6},{56,37},{56.8,38.2},{56.8,41.6},{57,36.8},{57.2,34.2},{57.4,34.8},{57.4,35.8},{57.4,38.6},{57.4,40},{57.4,42.6},{57.6,36},{57.6,38},{57.6,42.6},{57.8,40.2},{57.8,40.6},{57.8,42.2},{58.2,36.6},{58.4,38.6},{58.8,39.8},{58.8,41.6},{59,39},{59.4,40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Ainamiss the Hive Queen"     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 37549 ,["id"] = 47386  ,["coords"] = {{ 32.4  , 48.6  },{33,48.8},{33.8,46},{34,45.4},{35,44.6},{35.4,44.4},{36.4,42.4},{36.4,42.6},{36.6,42.4},{36.6,42.6},{36.8,43.8},{36.8,46.6},{36.8,47.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Harakiss the Infestor"       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15657 ,["id"] = 47387  ,["coords"] = {{ 50.4  , 72.4  },{50.4,72.8},{50.6,72.2},{50.6,72.6},{52.4,65.4},{52.4,65.8},{52.6,65.4},{52.6,65.6},{52.8,70.6},{53,70.4},{55.6,64.4},{55.8,64.6},{56.2,68.8},{56.4,68.4},{56.6,68.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Deepholm"                      , [ "zoneID" ] = 207  , [ "name" ] = "Jadefang"                    ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 55  , "Shale Beast"  } , ["familySkills" ] = SHALE_SPIDER_SKILLS  ,["displayID"] = 36636 ,["id"] = 49822  ,["coords"] = {{ 61.2  , 22.4  },{61.2,22.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Abyssal Depths"                , [ "zoneID" ] = 204  , [ "name" ] = "Ghostcrawler"                ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] = L["Ghostcrawler_info"      ] , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 37396 ,["id"] = 50051  ,["coords"] = {{ 12.8  , 82.6  },{15,77.4},{15,87.4},{19,77.4},{20,58},{20.4,68.4},{22,65},{24.2,71.8},{24.4,80.4},{26,81.4},{28.2,82.2},{31.2,78},{31.4,80.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Mount Hyjal"                   , [ "zoneID" ] = 198  , [ "name" ] = "Terrorpene"                  ,["maxlevel" ] =92      , [ "minlevel" ] =91    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 37282 ,["id"] = 50058  ,["coords"] = {{ 52.2  , 83.2  },{53.8,82},{54.2,80},{55.6,76.2},{56,75.4},{56.8,75.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Twilight Highlands"            , [ "zoneID" ] = 241  , [ "name" ] = "Karoma"                      ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 36726 ,["id"] = 50138  ,["coords"] = {{ 49.2  , 74.2  },{49.4,75},{49.8,75.4},{53.8,53.2},{54,54},{54.2,76.2},{54.6,75},{54.6,75.6},{58.2,63.6},{58.4,63.4},{58.6,63.2},{58.8,64},{59.2,43.4},{59.4,44},{59.6,43.4},{59.6,44},{65.4,60.2},{65.4,60.6},{65.6,60.2},{65.6,60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 36728 ,["id"] = 50154  ,["coords"] = {{ 44.4  , 10.4  },{44.4,11},{44.4,21.8},{44.4,22.6},{44.6,10.8},{44.8,10},{44.8,22.2},{47.4,18.2},{47.6,18.6},{48.2,18.4},{50,23.8},{50.2,19.6},{50.4,21},{50.6,20.6},{50.8,20.2},{50.8,23.8},{53.4,18.6},{53.4,19.6},{53.6,19.6},{53.8,19.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Twilight Highlands"            , [ "zoneID" ] = 241  , [ "name" ] = "Sambas"                      ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37352 ,["id"] = 50159  ,["coords"] = {{ 38.2  , 53    },{42.6,38.6},{68.8,25.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Deathknell"                    , [ "zoneID" ] = 465  , [ "name" ] = "Fangor"                      ,["maxlevel" ] =62      , [ "minlevel" ] =5     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 24  , "Bat"           } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 46665 ,["id"] = 50328  ,["coords"] = {{ 60.8  , 77.8  },{61.4,76.8},{61.6,79.6},{62.8,80.6},{64,80},{65,81.4},{65.2,79.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Kree"                        ,["maxlevel" ] =62      , [ "minlevel" ] =23    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 24  , "Bat"           } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 34130 ,["id"] = 50330  ,["coords"] = {{ 60.2  , 6.8   },{60.4,6},{60.6,6.6},{60.6,7.8},{60.8,6.4},{61.6,6.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Alitus"                      ,["maxlevel" ] =62      , [ "minlevel" ] =27    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 26255 ,["id"] = 50335  ,["coords"] = {{ 46    , 66.2  },{46.4,66.8},{46.8,66.8},{47,66.2},{47.4,68.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Cackle"                      ,["maxlevel" ] =62      , [ "minlevel" ] =40    , ["info" ] = L["Cackle_info"            ] , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 46227 ,["id"] = 50337  ,["coords"] = {{ 21    , 87.6  },{21.4,86.6},{21.6,88.6},{21.8,86.2},{22.2,87},{22.2,87.8},{22.6,86.8},{22.6,87.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Heronis"                     ,["maxlevel" ] =62      , [ "minlevel" ] =40    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 33004 ,["id"] = 50342  ,["coords"] = {{ 39.4  , 28.6  },{40,28.2},{40.2,28.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Quall"                       ,["maxlevel" ] =62      , [ "minlevel" ] =24    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 46988 ,["id"] = 50343  ,["coords"] = {{ 59.6  , 64    },{60,63.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Alit"                        ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 21133 ,["id"] = 50345  ,["coords"] = {{ 31    , 71.8  },{31.8,71.4},{31.8,72.2},{32,73},{32.6,72.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Ronak"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 17093 ,["id"] = 50346  ,["coords"] = {{ 59.4  , 42.6  },{59.6,42.4},{59.8,42.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Norissis"                    ,["maxlevel" ] =62      , [ "minlevel" ] =60    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 17092 ,["id"] = 50348  ,["coords"] = {{ 59.4  , 23.8  },{59.6,24}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Manas"                       ,["maxlevel" ] =62      , [ "minlevel" ] =53    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 30  , "Dragonhawk"    } , ["familySkills" ] = DRAGONHAWKS_SKILLS   ,["displayID"] = 45200 ,["id"] = 50353  ,["coords"] = {{ 64    , 80    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Sunwing"                     ,["maxlevel" ] =62      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 30  , "Dragonhawk"    } , ["familySkills" ] = DRAGONHAWKS_SKILLS   ,["displayID"] = 45201 ,["id"] = 50357  ,["coords"] = {{ 8.4   , 54.6  },{9,54.4},{9,54.6},{9.4,52.4},{9.4,53.4},{9.6,55},{9.8,54.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Ornat"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 34  , "Ray"           } , ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 20596 ,["id"] = 50361  ,["coords"] = {{ 50.4  , 60.2  },{50.4,60.6},{50.6,59.4},{50.6,60.4},{50.6,60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Blackbog the Fang"           ,["maxlevel" ] =62      , [ "minlevel" ] =56    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 34  , "Ray"           } , ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 20596 ,["id"] = 50362  ,["coords"] = {{ 34.8  , 59.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Karapax"                     ,["maxlevel" ] =62      , [ "minlevel" ] =55    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20067 ,["id"] = 50370  ,["coords"] = {{ 57    , 14.4  }, {57, 14.6}, {57.6, 14.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Spinecrawl"                  ,["maxlevel" ] =62      , [ "minlevel" ] =56    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20297 ,["id"] = 50724  ,["coords"] = {{ 60.4  , 22    },{60.6,22.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Azelisk"                     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20309 ,["id"] = 50725  ,["coords"] = {{ 71.8  , 23    },{72.8,22.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Kalixx"                      ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 46250 ,["id"] = 50726  ,["coords"] = {{ 32    , 35.2  },{32,35.6},{32.4,34.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Strix the Barbed"            ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20834 ,["id"] = 50727  ,["coords"] = {{ 93.4  , 80.6  },{94.4,81.6},{94.6,81.4},{94.6,81.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Deathstrike"                 ,["maxlevel" ] =62      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20308 ,["id"] = 50728  ,["coords"] = {{ 69.4  , 53.6  },{70,53.6},{70.2,53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Venomspine"                  ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 20297 ,["id"] = 50730  ,["coords"] = {{ 5.2   , 38.6  },{5.4,38.4},{5.6,38.6},{5.8,38.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Needlefang"                  ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 17062 ,["id"] = 50731  ,["coords"] = {{ 50.4  , 72.4  },{50.6,72.2},{50.8,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Blinkeye the Rattler"        ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 4435  ,["id"] = 50735  ,["coords"] = {{ 51.4  , 16.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Acroniss"                    ,["maxlevel" ] =62      , [ "minlevel" ] =55    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 46985 ,["id"] = 50737  ,["coords"] = {{ 73.6  , 16    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Shimmerscale"                ,["maxlevel" ] =62      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 25009 ,["id"] = 50738  ,["coords"] = {{ 55.4  , 54.6  },{55.6,54},{55.6,54.6},{55.8,52.6},{56.6,54.6},{56.8,54.2},{57.2,52},{57.4,52.8},{57.6,54},{57.8,52.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Kaxx"                        ,["maxlevel" ] =62      , [ "minlevel" ] =48    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 1561  ,["id"] = 50741  ,["coords"] = {{ 37.4  , 56    },{37.6,56}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Qem"                         ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 46982 ,["id"] = 50742  ,["coords"] = {{ 43.8  , 17.6  }, {44, 17.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Manax"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 46983 ,["id"] = 50743  ,["coords"] = {{ 67.2  , 66.4  }, {67.2, 66.6}, {67.8, 66.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Qu'rik"                      ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 46981 ,["id"] = 50744  ,["coords"] = {{ 54.4  , 26.4  }, {54.6, 26.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Losaj"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15658 ,["id"] = 50745  ,["coords"] = {{ 42.2  , 55.8  }, {42.2, 57}, {42.6, 56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Bornix the Burrower"         ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15656 ,["id"] = 50746  ,["coords"] = {{ 62.6  , 89.4  }, {63.6, 88.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Ahn'Qiraj: The Fallen Kingdom" , [ "zoneID" ] = 327  , [ "name" ] = "Tix"                         ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] = L["NO FURTHER INFO YET..."]  , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15334 ,["id"] = 50747  ,["coords"] = {{ 60.4  , 6.2   },{60.8,6.4},{60.8,6.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Nyaj"                        ,["maxlevel" ] =62      , [ "minlevel" ] =48    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 481   ,["id"] = 50748  ,["coords"] = {{ 44    , 40.4  },{44,40.6},{44.6,40.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Tarantis"                    ,["maxlevel" ] =62      , [ "minlevel" ] =9     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 2537  ,["id"] = 50752  ,["coords"] = {{ 65.2  , 64.6  },{65.4,64.2},{65.8,65},{66.4,63},{66.4,63.6},{66.6,63.2},{67.2,63.8},{67.6,63.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Iriss the Widow"             ,["maxlevel" ] =62      , [ "minlevel" ] =26    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 42742 ,["id"] = 50759  ,["coords"] = {{ 54.4  , 74.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Shadowstalker"               ,["maxlevel" ] =62      , [ "minlevel" ] =6     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 67596 ,["id"] = 50763  ,["coords"] = {{ 38    , 52    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Paraliss"                    ,["maxlevel" ] =62      , [ "minlevel" ] =37    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46518 ,["id"] = 50764  ,["coords"] = {{ 38    , 74.4  },{38.4,74.8},{38.8,74.8},{39,74.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Miasmiss"                    ,["maxlevel" ] =62      , [ "minlevel" ] =22    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 27683 ,["id"] = 50765  ,["coords"] = {{ 37    , 68.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Zorn"                        ,["maxlevel" ] =62      , [ "minlevel" ] =39    , ["info" ] = L["Zorn_info"              ] , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46232 ,["id"] = 50770  ,["coords"] = {{ 21.6  , 15.4  },{22,14}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Likk the Hunter"             ,["maxlevel" ] =62      , [ "minlevel" ] =42    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46518 ,["id"] = 50775  ,["coords"] = {{ 11.6  , 70.2  },{12.2,71.6},{12.4,71.4},{12.8,72.2},{13,71.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Needle"                      ,["maxlevel" ] =62      , [ "minlevel" ] =47    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 18041 ,["id"] = 50777  ,["coords"] = {{ 51    , 34.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Ironweb"                     ,["maxlevel" ] =62      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 42742 ,["id"] = 50778  ,["coords"] = {{ 51.2  , 70.2  },{51.2,70.8},{51.4,69.4},{51.6,69.6},{51.8,69.2},{52.2,68.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Sporeggon"                   ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 33  , "Sporebat"      } , ["familySkills" ] = SPOREBATS_SKILLS     ,["displayID"] = 18029 ,["id"] = 50779  ,["coords"] = {{ 39.4  , 55.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Anith"                       ,["maxlevel" ] =62      , [ "minlevel" ] =44    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 47124 ,["id"] = 50784  ,["coords"] = {{ 32.2  , 31    },{32.6,30.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Skyshadow"                   ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 46995 ,["id"] = 50785  ,["coords"] = {{ 93.8  , 57.4  },{94,58.2},{94.2,58.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Sparkwing"                   ,["maxlevel" ] =62      , [ "minlevel" ] =31    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 46990 ,["id"] = 50786  ,["coords"] = {{ 58.8  , 86.4  },{59,86.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Quetzl"                      ,["maxlevel" ] =62      , [ "minlevel" ] =52    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 46996 ,["id"] = 50788  ,["coords"] = {{ 66.8  , 83.4  },{66.8,83.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Ionis"                       ,["maxlevel" ] =62      , [ "minlevel" ] =56    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 47120 ,["id"] = 50790  ,["coords"] = {{ 39    , 34    },{39.2,33.2},{39.4,34.6},{39.8,33},{39.8,35.2},{40,34.4},{40.4,35.6},{40.6,35.2},{40.8,35.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Chiaa"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 46278 ,["id"] = 50792  ,["coords"] = {{ 35.2  , 26.2  },{35.4,26.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Yukiko"                      ,["maxlevel" ] =62      , [ "minlevel" ] =57    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 47126 ,["id"] = 50797  ,["coords"] = {{ 69.2  , 66.4  },{69.4,67.4},{69.4,67.8},{69.8,67.4},{69.8,67.6},{70,65.8},{70.4,64.8},{70.6,66.2},{70.8,65}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Bonechewer"                  ,["maxlevel" ] =62      , [ "minlevel" ] =9     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 37992 ,["id"] = 50803  ,["coords"] = {{ 31.2  , 46.4  },{31.8,46.4},{32.2,47.2},{32.6,46.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Ripwing"                     ,["maxlevel" ] =62      , [ "minlevel" ] =33    , ["info" ] = L["Ripwing_info"           ] , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 10827 ,["id"] = 50804  ,["coords"] = {{ 35.4  , 61.8  },{35.4,62.8},{35.6,61.6},{36,63.4},{36.2,63.8},{36.4,61.2},{36.6,61},{36.6,61.6},{36.8,62.6},{37.2,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Catal"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46277 ,["id"] = 50807  ,["coords"] = {{ 63.6  , 54.2  },{64,52},{64,54.8},{64.4,53},{64.6,53.4},{64.6,54.8},{65,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Heress"                      ,["maxlevel" ] =62      , [ "minlevel" ] =41    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46740 ,["id"] = 50809  ,["coords"] = {{ 34.8  , 52.4  },{34.8,53.8},{35.2,53.2},{35.8,52.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Favored of Isiset"           ,["maxlevel" ] =62      , [ "minlevel" ] =51    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 20347 ,["id"] = 50810  ,["coords"] = {{ 73.2  , 53    },{74.2,52},{74.4,51.4},{75,53.2},{75.4,51.8},{75.4,53.6},{75.6,52.2},{75.6,53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Arae"                        ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46229 ,["id"] = 50812  ,["coords"] = {{ 49.4  , 65.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Fene-mal"                    ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46516 ,["id"] = 50813  ,["coords"] = {{ 49.6  , 43.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Corpsefeeder"                ,["maxlevel" ] =62      , [ "minlevel" ] =29    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 23481 ,["id"] = 50814  ,["coords"] = {{ 49.2  , 68.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Skarr"                       ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 19607 ,["id"] = 50815  ,["coords"] = {{ 33    , 52.2  },{33.2,52.6},{33.6,52.2},{33.6,52.6},{36.8,34.8},{37.4,35.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "The Dark Prowler"            ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 26618 ,["id"] = 50818  ,["coords"] = {{ 33    , 55    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Iceclaw"                     ,["maxlevel" ] =62      , [ "minlevel" ] =54    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 9951  ,["id"] = 50819  ,["coords"] = {{ 52    , 18.4  },{52,18.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Feras"                       ,["maxlevel" ] =62      , [ "minlevel" ] =38    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 46987 ,["id"] = 50825  ,["coords"] = {{ 76    , 91.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Duskcoat"                    ,["maxlevel" ] =62      , [ "minlevel" ] =42    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 38913 ,["id"] = 50833  ,["coords"] = {{ 39.4  , 31.6  },{39.6,31.8},{39.8,31.4},{40.6,31}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Kash"                        ,["maxlevel" ] =62      , [ "minlevel" ] =55    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 46575 ,["id"] = 50837  ,["coords"] = {{ 78.2  , 27.2  },{78.2,29.6},{79,27.6},{79,28.8},{79.4,26.8},{79.4,29.8},{79.4,30.8},{79.6,27.4},{79.6,28.2},{79.6,28.6},{80.2,29.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Tabbs"                       ,["maxlevel" ] =62      , [ "minlevel" ] =48    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 46251 ,["id"] = 50838  ,["coords"] = {{ 58.2  , 60.4  },{58.4,60.6},{58.6,60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Chromehound"                 ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 45  , "Core Hound"    } , ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 29539 ,["id"] = 50839  ,["coords"] = {{ 35.6  , 60.8  },{36,49.6},{37.2,66},{37.6,66.6},{38.2,44.6},{38.8,42.6},{40.4,40.2},{40.6,40.2},{40.8,73.2},{41.6,73.2},{42.4,74.8},{43,76},{43.2,76.6},{43.6,36},{44.2,36.6},{44.4,76.6},{44.6,37.6},{44.6,75},{45,36},{45.4,76.4},{46.4,35},{46.4,78.8},{46.8,77.6},{47.4,36},{48,78.6},{48.8,35},{50,35.2},{50.6,78.6},{51,35.6},{54.4,35.8},{54.6,76.2},{55.2,35.6},{56.2,76},{57,36.4},{57.2,36.8},{57.8,38},{58,38.6},{59.6,41.4},{61,43.4},{62,44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Magmagan"                    ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 45  , "Core Hound"    } , ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 12168 ,["id"] = 50842  ,["coords"] = {{ 28.4  , 33    },{28.8,32.4},{28.8,33},{29,33.6},{29,34.8},{29.2,31.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Burning Steppes"               , [ "zoneID" ] = 36   , [ "name" ] = "Jaxx the Rabid"              ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         } , ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 79025 ,["id"] = 50855  ,["coords"] = {{ 47    , 24.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Snark"                       ,["maxlevel" ] =62      , [ "minlevel" ] =49    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         } , ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 31352 ,["id"] = 50856  ,["coords"] = {{ 37.8  , 84    },{39.2,84},{39.4,84.6},{39.6,84.4},{39.6,84.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Dustwing"                    ,["maxlevel" ] =62      , [ "minlevel" ] =22    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 37  , "Moth"          } , ["familySkills" ] = MOTH_SKILLS          ,["displayID"] = 46551 ,["id"] = 50858  ,["coords"] = {{ 27.8  , 83.6  },{28.4,83.4},{28.6,83.4},{28.6,83.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Thicket"                     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 37  , "Moth"          } , ["familySkills" ] = MOTH_SKILLS          ,["displayID"] = 46831 ,["id"] = 50864  ,["coords"] = {{ 59.4  , 6.8   },{59.6,6.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Saurix"                      ,["maxlevel" ] =62      , [ "minlevel" ] =27    , ["info" ] = L["Saurix_info"            ] , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 21825 ,["id"] = 50865  ,["coords"] = {{ 41.8  , 34.4  },{41.8,35.6},{42,34.6},{42.8,36.2},{43.2,34.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Tenok"                       ,["maxlevel" ] =62      , [ "minlevel" ] =31    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 19733 ,["id"] = 50874  ,["coords"] = {{ 44.4  , 49.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Nychus"                      ,["maxlevel" ] =62      , [ "minlevel" ] =59    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 46287 ,["id"] = 50875  ,["coords"] = {{ 34    , 70.4  },{34.4,71.2},{34.6,70.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Avis"                        ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 1746  ,["id"] = 50876  ,["coords"] = {{ 70.6  , 18.6  },{71.2,17.8},{71.4,16.8},{71.6,19.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Chupacabros"                 ,["maxlevel" ] =62      , [ "minlevel" ] =61    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 19743 ,["id"] = 50882  ,["coords"] = {{ 27    , 61    },{27.4,61.6},{27.4,63},{27.6,61},{27.6,62},{27.6,62.8},{27.8,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Dustflight the Cowardly"     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 12  , "Tallstrider"   } , ["familySkills" ] = TALLSTRIDER_SKILLS   ,["displayID"] = 21268 ,["id"] = 50884  ,["coords"] = {{ 44.8  , 55.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Seawing"                     ,["maxlevel" ] =62      , [ "minlevel" ] =48    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 12  , "Tallstrider"   } , ["familySkills" ] = TALLSTRIDER_SKILLS   ,["displayID"] = 21268 ,["id"] = 50886  ,["coords"] = {{ 80.2  , 16.2  },{81.8,17},{82.4,17.6},{85,24.2},{85.4,22.2},{85.6,21.8},{85.8,23.2},{85.8,25},{86,23.8},{87.2,24.6},{87.6,30.4},{88,26.6},{88.4,31},{88.6,27.6},{88.8,29.8},{88.8,31.2},{88.8,33},{89,28.8},{89,33.6},{89.2,31.6},{89.4,27.2},{89.4,35.8},{90,35.2},{90.4,36.8},{90.4,38.8},{90.6,39.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Boros"                       ,["maxlevel" ] =62      , [ "minlevel" ] =40    , ["info" ] = L["Boros_info"             ] , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46235 ,["id"] = 50891  ,["coords"] = {{ 47.4  , 33.8  },{48,34.4},{48.2,36.6},{48.4,35.2},{48.4,35.6},{48.6,34.4},{48.6,35},{48.6,35.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Cyn"                         ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 25857 ,["id"] = 50892  ,["coords"] = {{ 55.2  , 40.4  },{55.2,40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Volux"                       ,["maxlevel" ] =62      , [ "minlevel" ] =33    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46998 ,["id"] = 50895  ,["coords"] = {{ 39.8  , 46    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Ffexk the Dunestalker"       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46980 ,["id"] = 50897  ,["coords"] = {{ 32.2  , 53    }, {32.8, 53.8}, {33, 53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Teromak"                     ,["maxlevel" ] =62      , [ "minlevel" ] =42    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46235 ,["id"] = 50901  ,["coords"] = {{ 41.8  , 43.4  },{42,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Orlix the Swamplord"         ,["maxlevel" ] =62      , [ "minlevel" ] =58    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 37856 ,["id"] = 50903  ,["coords"] = {{ 16    , 36    },{16.8,35.2},{16.8,35.6},{17.2,38.6},{17.4,37.2},{17.4,38.4},{17.6,37.6},{17.6,39.2},{17.8,36.2},{17.8,37.2},{18.6,35.4},{18.6,38.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Cida"                        ,["maxlevel" ] =62      , [ "minlevel" ] =49    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 46830 ,["id"] = 50905  ,["coords"] = {{ 45    , 31.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Mutilax"                     ,["maxlevel" ] =62      , [ "minlevel" ] =47    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 37857 ,["id"] = 50906  ,["coords"] = {{ 52.2  , 27.2  },{52.4,26.4},{52.4,28.2},{52.6,27.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Nighthowl"                   ,["maxlevel" ] =9       , [ "minlevel" ] =9     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 46667 ,["id"] = 50908  ,["coords"] = {{ 42.4  , 28.4  },{42.4,28.8},{42.6,28.6},{42.8,28.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Snort"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 46520 ,["id"] = 50915  ,["coords"] = {{ 57.4  , 80    },{57.6,79.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Lamepaw the Whimperer"       ,["maxlevel" ] =62      , [ "minlevel" ] =11    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 46543 ,["id"] = 50916  ,["coords"] = {{ 51.4  , 62.4  },{51.4,63.4},{51.4,63.6},{52,62.2},{52,63.6},{52.2,62.8},{52.6,63.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Warg"                        ,["maxlevel" ] =62      , [ "minlevel" ] =45    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 35394 ,["id"] = 50922  ,["coords"] = {{ 56    , 62.6  },{56.4,61.6},{56.6,63.6},{57,61.8},{57,63.4},{57.2,60.6},{58,61.8},{58.2,61.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Grovepaw"                    ,["maxlevel" ] =62      , [ "minlevel" ] =45    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9569  ,["id"] = 50925  ,["coords"] = {{ 38.2  , 72.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Grizzled Ben"                ,["maxlevel" ] =62      , [ "minlevel" ] =10    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70199 ,["id"] = 50926  ,["coords"] = {{ 27.4  , 67.4  },{27.4,67.8},{27.4,69.2},{27.6,67},{28.6,66.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Little Bjorn"                ,["maxlevel" ] =62      , [ "minlevel" ] =22    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 46552 ,["id"] = 50929  ,["coords"] = {{ 34.6  , 78.8  },{35,78.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Hibernus the Sleeper"        ,["maxlevel" ] =62      , [ "minlevel" ] =6     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70192 ,["id"] = 50930  ,["coords"] = {{ 46.8  , 69.2  },{47.4,70.2},{47.6,70.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Mange"                       ,["maxlevel" ] =62      , [ "minlevel" ] =52    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70191 ,["id"] = 50931  ,["coords"] = {{ 65.6  , 56.6  },{66,55.4},{66.2,55.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Hamhide"                     ,["maxlevel" ] =62      , [ "minlevel" ] =44    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 6122  ,["id"] = 50937  ,["coords"] = {{ 43    , 34.4  },{43.2,35.6},{43.6,35.2},{43.6,36}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Swee"                        ,["maxlevel" ] =62      , [ "minlevel" ] =32    , ["info" ] = L["Swee_info"              ] , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 20814 ,["id"] = 50940  ,["coords"] = {{ 55.6  , 57.6  },{56.2,56.8},{56.4,56.4},{56.6,56.2},{56.6,56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Snoot the Rooter"            ,["maxlevel" ] =62      , [ "minlevel" ] =9     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 1208  ,["id"] = 50942  ,["coords"] = {{ 67.8  , 82.2  },{69.2,77},{69.2,78.2},{69.2,79.4},{69.4,79.6},{69.6,78.8},{69.6,79.6},{69.8,77.4},{69.8,78},{70.6,79.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Scruff"                      ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 4714  ,["id"] = 50945  ,["coords"] = {{ 29.4  , 43.4  },{29.4,44},{29.4,44.6},{29.6,44.4},{29.6,44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Hogzilla"                    ,["maxlevel" ] =62      , [ "minlevel" ] =42    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 2450  ,["id"] = 50946  ,["coords"] = {{ 21.2  , 78.8  },{22.2,77.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Varah"                       ,["maxlevel" ] =62      , [ "minlevel" ] =56    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 46532 ,["id"] = 50947  ,["coords"] = {{ 11.6  , 28    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Crystalback"                 ,["maxlevel" ] =62      , [ "minlevel" ] =47    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 46566 ,["id"] = 50948  ,["coords"] = {{ 64.4  , 46.2  },{65,45.6},{65.2,45},{65.4,46.6},{65.8,47.6},{66,45.2},{66,46.2},{66,47.2},{66.4,44.4},{66.8,43.8},{66.8,46.6},{67,45.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Finn's Gambit"               ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 4714  ,["id"] = 50949  ,["coords"] = {{ 64    , 46.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Barnacle Jim"                ,["maxlevel" ] =62      , [ "minlevel" ] =48    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 46994 ,["id"] = 50952  ,["coords"] = {{ 41    , 36.2  },{41,36.8},{41.6,36.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Carcinak"                    ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 46558 ,["id"] = 50955  ,["coords"] = {{ 46.6  , 76.6  },{46.8,76}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Hugeclaw"                    ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 46285 ,["id"] = 50957  ,["coords"] = {{ 53.8  , 43.4  },{54,43.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Karkin"                      ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 88834 ,["id"] = 50959  ,["coords"] = {{ 33    , 52.2  },{33.4,53},{33.6,52.2},{36.8,34.8},{37.6,35.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Wetlands"                      , [ "zoneID" ] = 56   , [ "name" ] = "Chops"                       ,["maxlevel" ] =61      , [ "minlevel" ] =59    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 46230 ,["id"] = 50964  ,["coords"] = {{ 57.2  , 9     },{57.4,8.4},{57.8,7.2},{57.8,8.4},{58,8.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Craw the Ravager"            ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 32807 ,["id"] = 50967  ,["coords"] = {{ 51.8  , 87.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Goldenback"                  ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       } , ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 5245  ,["id"] = 50986  ,["coords"] = {{ 82.2  , 79.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Gal'dorak"                   ,["maxlevel" ] =62      , [ "minlevel" ] =43    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 26267 ,["id"] = 50993  ,["coords"] = {{ 35.4  , 48.4  },{35.4,49},{35.6,48.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Bruiser"                     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 28648 ,["id"] = 50995  ,["coords"] = {{ 65.4  , 41.6  },{65.8,42.8},{66,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Bornak the Gorer"            ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 26295 ,["id"] = 50997  ,["coords"] = {{ 59.2  , 16.4  },{59.4,17},{59.6,17.4},{59.8,17.6},{62.2,24.4},{62.4,24.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Blackshell the Impenetrable" ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 46248 ,["id"] = 51000  ,["coords"] = {{ 70.2  , 29.6  },{71.8,28},{72.2,27.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "Venomclaw"                   ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 15423 ,["id"] = 51001  ,["coords"] = {{ 81.4  , 95.8  },{81.8,96}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Scorpoxx"                    ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 15336 ,["id"] = 51002  ,["coords"] = {{ 17.8  , 38.4  },{18.4,38.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Toxx"                        ,["maxlevel" ] =62      , [ "minlevel" ] =53    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 46984 ,["id"] = 51004  ,["coords"] = {{ 42.4  , 17.2  }, {42.4, 18.2}, {42.6, 17.4}, {42.8, 16.2}, {42.8, 18.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Serkett"                     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 46252 ,["id"] = 51007  ,["coords"] = {{ 26.4  , 38.4  },{26.4,38.6},{26.6,38.6},{26.8,38},{27.6,38}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Thousand Needles"              , [ "zoneID" ] = 64   , [ "name" ] = "The Barbed Horror"           ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 20912 ,["id"] = 51008  ,["coords"] = {{ 71.2  , 94.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Snips"                       ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 46248 ,["id"] = 51010  ,["coords"] = {{ 35    , 52    },{36.2,53}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Terrapis"                    ,["maxlevel" ] =62      , [ "minlevel" ] =9     , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 7837  ,["id"] = 51014  ,["coords"] = {{ 50.6  , 87.2  },{51.2,88},{51.6,87.8},{53.4,87.8},{53.8,86.8},{53.8,87.8},{55.2,86.6},{55.8,85.8},{56.2,85.4},{57,85.2},{58.4,83.8},{58.8,83},{59.2,83.8},{59.6,83},{60.4,82.2},{60.8,82.4},{62,82.4},{62.6,82.4},{63.4,83.4},{63.6,83.2},{63.6,83.6},{66,84.4},{66.4,84.6},{66.8,85},{67.4,84.4},{68,85.4},{68.6,84.6},{70.2,85.4},{71,85.4},{72,84.4},{72.2,85.4},{73,85.2},{73.2,85.8},{74,84.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Gezan"                       ,["maxlevel" ] =62      , [ "minlevel" ] =59    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 20142 ,["id"] = 51017  ,["coords"] = {{ 52.4  , 31.4  },{52.4,31.6},{52.6,31.4},{52.6,31.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Zormus"                      ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 19996 ,["id"] = 51018  ,["coords"] = {{ 51.4  , 34.2  },{51.6,34.6},{51.8,34.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Badlands"                      , [ "zoneID" ] = 15   , [ "name" ] = "Vorticus"                    ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 20910 ,["id"] = 51021  ,["coords"] = {{ 21.8  , 37.4  },{23.2,37.2},{23.2,37.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Chordix"                     ,["maxlevel" ] =62      , [ "minlevel" ] =31    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 37540 ,["id"] = 51022  ,["coords"] = {{ 56.2  , 54.4  },{56.2,54.6},{56.8,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Dilennaa"                    ,["maxlevel" ] =62      , [ "minlevel" ] =42    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 12335 ,["id"] = 51025  ,["coords"] = {{ 42.2  , 47.4  },{42.2,48.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Gnath"                       ,["maxlevel" ] =62      , [ "minlevel" ] =21    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 46569 ,["id"] = 51026  ,["coords"] = {{ 49.2  , 29.4  },{49.6,29.6},{50,29.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Spirocula"                   ,["maxlevel" ] =62      , [ "minlevel" ] =44    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 46534 ,["id"] = 51027  ,["coords"] = {{ 74.2  , 58.4  },{74.2,58.8},{74.6,58.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "The Deep Tunneler"           ,["maxlevel" ] =62      , [ "minlevel" ] =53    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 37551 ,["id"] = 51028  ,["coords"] = {{ 50.6  , 72.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Parasitus"                   ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 23998 ,["id"] = 51029  ,["coords"] = {{ 61.6  , 72.4  },{62,73.4},{62,73.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Tracker"                     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 46741 ,["id"] = 51031  ,["coords"] = {{ 62.2  , 47.6  },{62.4,47.4},{62.6,47.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Silverpine Forest"             , [ "zoneID" ] = 21   , [ "name" ] = "Lost Gilnean Wardog"         ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 33998 ,["id"] = 51037  ,["coords"] = {{ 57.2  , 42.4  },{57.6,41.6},{58.4,41},{59,41},{59,42},{60,40.8},{60,41.6},{60.2,40.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Snuffles"                    ,["maxlevel" ] =61      , [ "minlevel" ] =27    , ["info" ] = L["Snuffles_info"          ] , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 30222 ,["id"] = 51040  ,["coords"] = {{ 25.2  , 27.6  },{25.4,27.2},{26,27.2},{26.2,27.6},{26.8,27.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Bleakheart"                  ,["maxlevel" ] =62      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 46517 ,["id"] = 51042  ,["coords"] = {{ 71.8  , 45.4  },{71.8,45.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tirisfal Glades"               , [ "zoneID" ] = 18   , [ "name" ] = "Plague"                      ,["maxlevel" ] =15      , [ "minlevel" ] =12    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 46668 ,["id"] = 51044  ,["coords"] = {{ 57.8  , 33    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Winterspring"                  , [ "zoneID" ] = 83   , [ "name" ] = "Arcanus"                     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 24906 ,["id"] = 51045  ,["coords"] = {{ 48    , 59.4  },{48,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Fidonis"                     ,["maxlevel" ] =62      , [ "minlevel" ] =49    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 46517 ,["id"] = 51046  ,["coords"] = {{ 38.4  , 52.8  },{38.6,52.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Rexxus"                      ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 35356 ,["id"] = 51048  ,["coords"] = {{ 39.4  , 50.6  },{39.8,53},{40.2,50.2},{40.4,49.4},{40.4,50.6},{40.6,49.2},{41,49.6},{41.4,50.6},{42,49.8},{42.8,47.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Swamp of Sorrows"              , [ "zoneID" ] = 51   , [ "name" ] = "Gib the Banana-Hoarder"      ,["maxlevel" ] =62      , [ "minlevel" ] =52    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 51  , "Monkey"        } , ["familySkills" ] = MONKEY_SKILLS        ,["displayID"] = 46574 ,["id"] = 51052  ,["coords"] = {{ 16.4  , 47.2  },{16.6,47.2},{16.6,47.6},{17.6,47.2},{17.8,48}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Eastern Plaguelands"           , [ "zoneID" ] = 23   , [ "name" ] = "Quirix"                      ,["maxlevel" ] =62      , [ "minlevel" ] =47    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 37580 ,["id"] = 51053  ,["coords"] = {{ 23.6  , 78.4  },{23.8,78.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Weevil"                      ,["maxlevel" ] =62      , [ "minlevel" ] =27    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 34898 ,["id"] = 51057  ,["coords"] = {{ 45.4  , 52.4  },{45.4,52.8},{45.6,52.4},{45.6,53.2},{45.6,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Western Plaguelands"           , [ "zoneID" ] = 22   , [ "name" ] = "Aphis"                       ,["maxlevel" ] =62      , [ "minlevel" ] =50    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 34900 ,["id"] = 51058  ,["coords"] = {{ 62.4  , 35.2  },{62.4,35.6},{62.6,35.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Roth-Salam"                  ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 15339 ,["id"] = 51061  ,["coords"] = {{ 50.2  , 84.4  },{50.2,84.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Stonetalon Mountains"          , [ "zoneID" ] = 65   , [ "name" ] = "Khep-Re"                     ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 46225 ,["id"] = 51062  ,["coords"] = {{ 74.6  , 73.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Phalanax"                    ,["maxlevel" ] =62      , [ "minlevel" ] =36    , ["info" ] = L["Phalanax_info"          ] , ["class" ] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 46226 ,["id"] = 51063  ,["coords"] = {{ 47.8  , 82.2  },{48.6,81.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Searing Gorge"                 , [ "zoneID" ] = 32   , [ "name" ] = "Crystalfang"                 ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 55  , "Shale Beast"  } , ["familySkills" ] = SHALE_SPIDER_SKILLS  ,["displayID"] = 33863 ,["id"] = 51066  ,["coords"] = {{ 33.2  , 19.6  },{33.4,18.8},{33.6,19.2},{34,20}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Arathi Highlands"              , [ "zoneID" ] = 14   , [ "name" ] = "Glint"                       ,["maxlevel" ] =62      , [ "minlevel" ] =33    , ["info" ] = L["Glint_info"             ] , ["class" ] = CLASS_RARE       , ["family"] = { 55  , "Shale Beast"  } , ["familySkills" ] = SHALE_SPIDER_SKILLS  ,["displayID"] = 36634 ,["id"] = 51067  ,["coords"] = {{ 29.4  , 59.6  },{29.6,59.4},{30,61},{30,61.6},{30.2,60.4},{30.4,63.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Dustwallow Marsh"              , [ "zoneID" ] = 70   , [ "name" ] = "Scintillex"                  ,["maxlevel" ] =62      , [ "minlevel" ] =62    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 55  , "Shale Beast"  } , ["familySkills" ] = SHALE_SPIDER_SKILLS  ,["displayID"] = 46290 ,["id"] = 51069  ,["coords"] = {{ 55.8  , 85.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Hillsbrad Foothills"           , [ "zoneID" ] = 25   , [ "name" ] = "Lopex"                       ,["maxlevel" ] =62      , [ "minlevel" ] =35    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 50  , "Fox"           } , ["familySkills" ] = FOX_SKILLS           ,["displayID"] = 40191 ,["id"] = 51076  ,["coords"] = {{ 68.8  , 56    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Elwynn Forest"                 , [ "zoneID" ] = 37   , [ "name" ] = "Bushtail"                    ,["maxlevel" ] =62      , [ "minlevel" ] =14    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 50  , "Fox"           } , ["familySkills" ] = FOX_SKILLS           ,["displayID"] = 30254 ,["id"] = 51077  ,["coords"] = {{ 81.6  , 85.2  },{82.4,84},{83,82.8},{83,84.4},{83,85.4},{83,85.8},{83.8,85}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37360 ,["id"] = 51401  ,["coords"] = {{ 44.2  , 10.8  },{44.6,21.4},{47.4,19},{50.2,23.8},{50.4,20.2},{50.6,19.6},{50.6,24},{53.2,19.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37362 ,["id"] = 51402  ,["coords"] = {{ 44.4  , 10.4  },{44.4,10.6},{44.4,22},{44.6,10.2},{44.6,21.8},{50.8,20.2},{53.2,19.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel" ] ="???"   , [ "minlevel" ] ="???" , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37359 ,["id"] = 51403  ,["coords"] = {{ 47.8  , 18.2  },{51,20.4},{53.4,19}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 249  , [ "name" ] = "Madexx"                      ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37361 ,["id"] = 51404  ,["coords"] = {{ 44.4  , 10.2  },{44.4,10.8},{44.6,10.6},{44.6,22.8},{44.8,10},{44.8,21.6},{47.4,18.4},{47.6,17.6},{47.6,18.8},{50,20.6},{50,24},{50.4,19.8},{50.6,23.8},{51,19.6},{53.2,19.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Northern Stranglethorn"        , [ "zoneID" ] = 50   , [ "name" ] = "Tsul'Kalu"                   ,["maxlevel" ] =62      , [ "minlevel" ] =31    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       } , ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 10133 ,["id"] = 51661  ,["coords"] = {{ 47    , 32    },{47.2,31.2},{47.2,33.4},{47.6,31.4},{47.6,31.6},{47.6,33.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Northern Stranglethorn"        , [ "zoneID" ] = 50   , [ "name" ] = "Mahamba"                     ,["maxlevel" ] =62      , [ "minlevel" ] =28    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 37613 ,["id"] = 51662  ,["coords"] = {{ 53.4  , 30.2  },{54,31},{54.2,30.2},{54.2,31.6},{54.4,29.2},{54.6,29},{54.6,30},{55,30.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Northern Stranglethorn"        , [ "zoneID" ] = 50   , [ "name" ] = "Pogeyan"                     ,["maxlevel" ] =62      , [ "minlevel" ] =32    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 37615 ,["id"] = 51663  ,["coords"] = {{ 36.2  , 29.2  },{36.4,28.2},{36.4,29.6},{36.6,29.2},{37,28.4},{37,29.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Redridge Mountains"            , [ "zoneID" ] = 49   , [ "name" ] = "Chitter"                     ,["maxlevel" ] =62      , [ "minlevel" ] =30    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 909   ,["id"] = 52146  ,["coords"] = {{ 63.2  , 66.6  },{63.4,65.2},{63.4,66},{63.6,66},{63.8,65.2},{64.2,64.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Mount Hyjal"                   , [ "zoneID" ] = 198  , [ "name" ] = "Ankha"                       ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 38748 ,["id"] = 54318  ,["coords"] = {{ 27.4  , 51.2  },{27.6,51.2},{28,52},{28.8,52.2},{29.6,52},{30,51.4},{30.6,51.4},{32.4,51.4},{33.2,52},{33.2,52.6},{33.8,52.4},{34.4,53.2},{34.6,53.4},{34.8,53.8},{35,54.6},{35.6,54.6},{36,53.8},{37,54},{38,54.2},{38.4,54.6},{39.2,54.8},{39.4,54.2},{39.6,54.8},{40.4,53.4},{40.4,53.6},{41.2,54}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Mount Hyjal"                   , [ "zoneID" ] = 198  , [ "name" ] = "Magria"                      ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 38749 ,["id"] = 54319  ,["coords"] = {{ 27.4  , 51.4  },{27.6,51.4},{28.4,52},{29,52.4},{29.4,52.6},{29.6,52.6},{30,51.6},{30.4,51.4},{31.2,51.2},{32.4,51.4},{32.6,51.2},{33,52.4},{33.4,52.6},{33.6,52.4},{34.4,53.2},{34.6,53},{34.8,54},{35.2,54.6},{35.6,54.8},{36.4,54.2},{36.6,54.6},{37.2,54},{37.8,54.2},{38.2,54.6},{38.8,55},{39,54.4},{39.6,53.8},{40.2,53.2},{40.6,53.2},{40.8,54},{41.2,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Mount Hyjal"                   , [ "zoneID" ] = 198  , [ "name" ] = "Ban'thalos"                  ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 38634 ,["id"] = 54320  ,["coords"] = {{ 25.8  , 61.2  },{25.8,61.8},{26,65.2},{26.2,62.8},{26.4,60},{27,59.8},{27,63.4},{27.2,64.2},{27.6,60.2},{27.8,62.6},{28,61},{28,62.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Solix"                       ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38780 ,["id"] = 54321  ,["coords"] = {{ 60.2  , 58.6  },{60.4,60.2},{60.6,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Deth'tilac"                  ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38424 ,["id"] = 54322  ,["coords"] = {{ 68    , 71.4  },{68,72.2},{68.8,71.2},{69.4,69.8},{73,58},{73.2,59.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Kirix"                       ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38453 ,["id"] = 54323  ,["coords"] = {{ 26.6  , 66.4  },{27,62},{28,61.6},{29,73},{29.8,55.2},{30.2,58},{30.4,56.8},{31.2,57.4},{31.6,56.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Skitterflame"                ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38779 ,["id"] = 54324  ,["coords"] = {{ 18.6  , 52.6  },{19.4,47.4},{19.4,48.4},{19.4,48.8},{19.6,48.4},{19.8,49},{20,50.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Molten Front"                  , [ "zoneID" ] = 338  , [ "name" ] = "Anthriss"                    ,["maxlevel" ] =122     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 38426 ,["id"] = 54338  ,["coords"] = {{ 52.6  , 41.2  },{53.8,39.6},{54.2,39.2},{54.6,38.8},{54.6,41.8},{54.8,38.4},{54.8,39.6},{54.8,41},{55.6,38.4},{56.6,41.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Prince Lakma"                ,["maxlevel" ] =87      , [ "minlevel" ] =87    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 39009 ,["id"] = 54533  ,["coords"] = {{ 47.6  , 74.6  },{48,78.4},{48.2,78.8},{48.6,79}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Vale of Eternal Blossoms"      , [ "zoneID" ] = 390  , [ "name" ] = "Bloodtip"                    ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 36513 ,["id"] = 58474  ,["coords"] = {{ 27    , 14.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Vale of Eternal Blossoms"      , [ "zoneID" ] = 390  , [ "name" ] = "Wulon"                       ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 128 , "Stone Hound"        } , ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 43097 ,["id"] = 63510  ,["coords"] = {{ 45.2  , 76.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Rockhoof"                    ,["maxlevel" ] =102     , [ "minlevel" ] =97    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 53607 ,["id"] = 72606  ,["coords"] = {{ 52.8  , 50.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Timeless Isle"                 , [ "zoneID" ] = 554  , [ "name" ] = "Emerald Gander"              ,["maxlevel" ] =92      , [ "minlevel" ] =91    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 125 , "Crane"         } , ["familySkills" ] = CRANE_SKILLS         ,["displayID"] = 51264 ,["id"] = 73158  ,["coords"] = {{ 29.4  , 50.2  },{29.4,50.6},{29.6,50.2},{29.8,45.4},{29.8,61.4},{29.8,66},{30,62.6},{30.2,58},{30.4,43.6},{30.4,50.6},{30.4,58.6},{30.4,61.6},{30.4,64.8},{30.4,66.8},{30.6,43.4},{30.6,44},{30.6,52.4},{30.6,58.4},{30.6,62.2},{30.8,45.2},{30.8,50},{30.8,50.6},{31,66},{31.2,62.6},{31.2,66.6},{31.2,79.4},{31.4,65.2},{31.4,79.8},{31.6,40},{31.6,62.4},{31.6,66.8},{31.6,79.4},{31.8,66},{32,52.6},{32,79.8},{32.2,48.8},{32.2,80.6},{32.6,49.2},{32.6,49.6},{33,48.2},{33.2,39.4},{36.2,39.4},{36.2,40.4},{36.2,40.6},{36.4,83.8},{36.6,40.4},{36.6,83.8},{37.6,41.6},{38.2,41.4},{38.6,41.4},{39.2,43.4},{39.2,68},{39.6,67.6},{39.6,68.6},{40,39.4},{40.2,40.2},{40.2,43.6},{40.4,40.8},{40.4,43.4},{40.6,43.8},{40.8,39.2},{40.8,40.4},{40.8,42.4},{41,40.6},{41.4,42.8},{42.2,70.2},{42.2,70.8},{42.4,66.8},{42.4,68},{42.8,67},{42.8,70},{42.8,70.6},{43.4,55.2},{44.2,61},{44.2,61.8},{44.4,54},{44.4,55},{44.6,55},{44.6,61.4},{44.8,53.2},{44.8,53.6}                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Timeless Isle"                 , [ "zoneID" ] = 554  , [ "name" ] = "Ironfur Steelhorn"           ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 157 , "Oxen"          } , ["familySkills" ] = OXEN_SKILLS          ,["displayID"] = 51284 ,["id"] = 73160  ,["coords"] = {{ 27.8  , 51.2  },{27.8,60},{28.2,40.2},{28.2,59},{28.6,47.4},{29.2,43},{29.2,44.4},{29.4,71.4},{29.4,72},{29.6,45.8},{29.8,70},{30.8,47.4},{30.8,70.8},{31.2,57.6},{31.6,43.2},{31.6,58.8},{31.8,58.4},{32.2,44.8},{33.2,38.6},{33.4,61.2},{33.6,37.2},{33.6,62.2},{34.2,71},{34.8,72},{35.2,41.8},{35.4,67.4},{36,67},{36,70.6},{39.4,38.4},{41.6,39.6},{43.8,43.8},{44.6,43.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Timeless Isle"                 , [ "zoneID" ] = 554  , [ "name" ] = "Great Turtle Furyshell"      ,["maxlevel" ] =92      , [ "minlevel" ] =91    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 51127 ,["id"] = 73161  ,["coords"] = {{ 20.6  , 43.2  },{21,44.4},{21.4,64.6},{21.4,66.2},{22,42.6},{22,44.2},{22,61.6},{22.2,53.6},{22.2,61.4},{22.2,67.8},{22.4,45.8},{22.4,53},{22.4,65.2},{22.4,66.2},{22.4,67.2},{22.6,53.4},{22.6,53.8},{22.6,65.4},{22.6,66.4},{22.6,66.8},{23,47.4},{23.2,63.2},{23.2,63.6},{23.2,68.4},{23.2,69.8},{23.4,49},{23.4,49.6},{23.4,60.6},{23.6,47.6},{23.6,49.8},{23.6,53.4},{23.6,59.8},{23.6,62.8},{23.8,54},{23.8,59.2},{24.2,49},{24.2,70},{24.4,57.8},{24.6,57.4},{24.6,57.6},{24.6,59.6},{25,58.6},{25.4,50.4},{25.4,52.4},{25.4,53},{25.4,55.8},{25.6,56},{25.6,57.8},{25.8,54.4},{25.8,57.4},{25.8,58.6},{25.8,71.6},{26,50.4},{26.2,50.8},{26.6,72.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Killmaw"                     ,["maxlevel" ] =102     , [ "minlevel" ] =95    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 55523 ,["id"] = 74206  ,["coords"] = {{ 40.6  , 44.6  },{40.8,44.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Veloss"                      ,["maxlevel" ] =102     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 33  , "Sporebat"      } , ["familySkills" ] = SPOREBATS_SKILLS     ,["displayID"] = 53360 ,["id"] = 75482  ,["coords"] = {{ 21.4  , 20.8  },{21.6,21.6},{21.8,21}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Mother Araneae"              ,["maxlevel" ] =102     , [ "minlevel" ] =95    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 17180 ,["id"] = 76473  ,["coords"] = {{ 53.4  , 78.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Coldtusk"                    ,["maxlevel" ] =102     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 52652 ,["id"] = 76914  ,["coords"] = {{ 54    , 68.2  },{54.2,67.4},{54.2,68.8},{54.4,69.6},{54.8,70},{55,71.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Amaukwa"                     ,["maxlevel" ] =102     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 60896 ,["id"] = 77140  ,["coords"] = {{ 29.2  , 30.8  },{29.4,29.8},{29.6,32.2},{30,29.6},{30.4,29},{31,32.2},{31.2,28.6},{31.4,28.4},{31.4,32.6},{31.6,32.4},{32,33},{32.2,28},{32.6,28},{32.6,33.2},{33.2,33.6},{33.6,33.8},{34.2,28.2},{34.2,28.6},{35.2,29},{35.4,35},{36,29.2},{36,35.4},{36.2,35.6},{36.6,35.8},{37.2,29.6},{37.6,29.6},{38.2,36.6},{38.8,36.6},{40.4,35.4},{40.4,35.8},{41,34.6},{41.2,30.8},{41.4,31.6},{41.4,32.8},{41.6,32.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Coldstomp the Griever"       ,["maxlevel" ] =102     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 52404 ,["id"] = 77513  ,["coords"] = {{ 25.4  , 55    },{25.6,55},{26.2,56.4},{26.2,56.6},{26.6,55.6},{26.8,55.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Giantbane"                   ,["maxlevel" ] =102     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 53946 ,["id"] = 77519  ,["coords"] = {{ 57    , 38    },{57.4,37.4},{57.6,37},{57.6,37.6},{58.4,31.6},{58.4,35.4},{58.4,35.6},{58.6,33.6},{58.6,34.6},{58.6,35.6},{58.8,33.4},{59.4,31.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Hen-Mother Hami"             ,["maxlevel" ] =102     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 58713 ,["id"] = 77626  ,["coords"] = {{ 75.4  , 50.8  },{75.6,51.6},{75.8,50.4},{76.2,50.8},{76.6,50.4},{77.2,51.6},{77.4,51.2},{77.6,51.8},{78,50.4},{78.4,50.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Taladorantula"               ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 54564 ,["id"] = 77634  ,["coords"] = {{ 58.8  , 87.6  },{59,87.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Hammertooth"                 ,["maxlevel" ] =102     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 52415 ,["id"] = 77715  ,["coords"] = {{ 60.2  , 47.8  },{60.6,47.4},{60.8,48.4},{61,46},{61.2,45.2},{61.4,44.4},{61.4,49.2},{61.6,48.6},{62,46},{62.2,47.2},{62.4,44.4},{62.4,45.4},{62.4,48},{62.8,44.2},{62.8,45.2},{63.6,43.6},{63.6,45},{64,43.2},{64.6,45.2},{65.2,43}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Glimmerwing"                 ,["maxlevel" ] =102     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 37  , "Moth"          } , ["familySkills" ] = MOTH_SKILLS          ,["displayID"] = 59748 ,["id"] = 77719  ,["coords"] = {{ 30.4  , 64.2  },{30.4,65},{30.6,64.6},{31.4,63.6},{32.2,63.6},{32.2,65.6},{32.4,63.4},{32.4,65.2},{32.6,63.2},{32.6,65},{32.8,62.4},{33.2,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Ra'kahn"                     ,["maxlevel" ] =102     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 59725 ,["id"] = 77741  ,["coords"] = {{ 59.4  , 59.4  },{59.4,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Klikixx"                     ,["maxlevel" ] =102     , [ "minlevel" ] =97    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46518 ,["id"] = 78872  ,["coords"] = {{ 66.8  , 85.4  },{66.8,85.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "No'losh"                     ,["maxlevel" ] =102     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 126 , "Water Strider" } , ["familySkills" ] = WATER_STRIDER_SKILLS ,["displayID"] = 18194 ,["id"] = 79334  ,["coords"] = {{ 85.8  , 29.2  },{86,29.6},{86.4,30.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Hypnocroak"                  ,["maxlevel" ] =102     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 291 , "Toad"          } , ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 55232 ,["id"] = 79524  ,["coords"] = {{ 37.4  , 48.8  },{37.6,49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Gaz'orda"                    ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55460 ,["id"] = 80122  ,["coords"] = {{ 43.4  , 77.6  },{43.6,77.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Chillfang"                   ,["maxlevel" ] =102     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 24  , "Bat"           } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 55721 ,["id"] = 80242  ,["coords"] = {{ 41.2  , 68.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Gennadian"                   ,["maxlevel" ] =102     , [ "minlevel" ] =97    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55763 ,["id"] = 80471  ,["coords"] = {{ 67.4  , 80.4  },{67.4,80.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Varasha"                     ,["maxlevel" ] =102     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 58892 ,["id"] = 82050  ,["coords"] = {{ 29.4  , 41.4  },{29.4,41.6},{29.6,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Darktalon"                   ,["maxlevel" ] =102     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 59726 ,["id"] = 82411  ,["coords"] = {{ 49.4  , 41.8  },{49.6,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Jabberjaw"                   ,["maxlevel" ] =102     , [ "minlevel" ] =95    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 55133 ,["id"] = 82616  ,["coords"] = {{ 48.2  , 24.2  },{48.4,23.4},{48.4,24.6},{48.6,23.6},{48.6,24.6},{48.8,23.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Frostfire Ridge"               , [ "zoneID" ] = 525  , [ "name" ] = "Slogtusk the Corpse-Eater"   ,["maxlevel" ] =102     , [ "minlevel" ] =101   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 57263 ,["id"] = 82617  ,["coords"] = {{ 44.6  , 15.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Greatfeather"                ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 60416 ,["id"] = 82758  ,["coords"] = {{ 66.8  , 51.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Gnarlhoof the Rabid"         ,["maxlevel" ] =102     , [ "minlevel" ] =101   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 53744 ,["id"] = 82778  ,["coords"] = {{ 66.6  , 56.4  },{66.6,56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Grizzlemaw"                  ,["maxlevel" ] =102     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 57383 ,["id"] = 82912  ,["coords"] = {{ 89.4  , 72.4  },{89.4,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Flinthide"                   ,["maxlevel" ] =102     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 57735 ,["id"] = 83483  ,["coords"] = {{ 69.8  , 41.4  },{69.8,42}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Hive Queen Skrikka"          ,["maxlevel" ] =101     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 57771 ,["id"] = 83522  ,["coords"] = {{ 52.2  , 70.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Shadowmoon Valley"             , [ "zoneID" ] = 539  , [ "name" ] = "Insha'tar"                   ,["maxlevel" ] =102     , [ "minlevel" ] =95    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 57801 ,["id"] = 83553  ,["coords"] = {{ 57.4  , 48.4  },{57.4,48.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Tura'aka"                    ,["maxlevel" ] =102     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 56062 ,["id"] = 83591  ,["coords"] = {{ 65    , 39.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Stonespite"                  ,["maxlevel" ] =102     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 58506 ,["id"] = 84805  ,["coords"] = {{ 33.4  , 22    },{33.6,22}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Blightglow"                  ,["maxlevel" ] =102     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 33  , "Sporebat"      } , ["familySkills" ] = SPOREBATS_SKILLS     ,["displayID"] = 52740 ,["id"] = 84856  ,["coords"] = {{ 64.2  , 65.2  },{64.4,65.6},{64.8,66.4},{65,67},{65.2,67.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Sunderthorn"                 ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 58569 ,["id"] = 84912  ,["coords"] = {{ 58.4  , 45.2  },{58.6,45}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Spires of Arak"                , [ "zoneID" ] = 542  , [ "name" ] = "Jiasska the Sporegorger"     ,["maxlevel" ] =102     , [ "minlevel" ] =99    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55723 ,["id"] = 84955  ,["coords"] = {{ 56.4  , 94.4  },{56.4,94.6},{56.6,94.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Berthora"                    ,["maxlevel" ] =102     , [ "minlevel" ] =99    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 59205 ,["id"] = 85907  ,["coords"] = {{ 39.4  , 74.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Riptar"                      ,["maxlevel" ] =102     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 59579 ,["id"] = 85970  ,["coords"] = {{ 37.4  , 81.4  },{37.6,81.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Venolasix"                   ,["maxlevel" ] =102     , [ "minlevel" ] =94    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 61588 ,["id"] = 86266  ,["coords"] = {{ 63.4  , 30.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Stompalupagus"               ,["maxlevel" ] =102     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 57735 ,["id"] = 86520  ,["coords"] = {{ 53.8  , 73.2  },{53.8,73.6},{54.2,72.4},{54.4,71.4},{54.6,71.6},{55,71}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Ashran"                        , [ "zoneID" ] = 588  , [ "name" ] = "Gibby"                       ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 51  , "Monkey"        } , ["familySkills" ] = MONKEY_SKILLS        ,["displayID"] = 46574 ,["id"] = 87362  ,["coords"] = {{ 47.4  , 69    },{47.6,28.4},{47.8,30.2},{48.4,58.8},{49.8,36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Pit Beast"                   ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 290 , "Pterrordax"    } , ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 48084 ,["id"] = 88208  ,["coords"] = {{ 58    , 18.6  },{58.2,18.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Mogamago"                    ,["maxlevel" ] =102     , [ "minlevel" ] =94    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 55211 ,["id"] = 88586  ,["coords"] = {{ 61.4  , 39.2  },{61.6,39.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Daggerbeak"                  ,["maxlevel" ] =110     , [ "minlevel" ] =99    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 64535 ,["id"] = 90057  ,["coords"] = {{ 51    , 31.4  },{51,31.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "Skystormer"                  ,["maxlevel" ] ="???"   , [ "minlevel" ] ="???" , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 12589 ,["id"] = 90816  ,["coords"] = {{ 53.6  , 64.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Pridelord Meowl"             ,["maxlevel" ] =110     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 69191 ,["id"] = 90901  ,["coords"] = {{ 56    , 29    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Broodlord Ixkor"             ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 58756 ,["id"] = 92429  ,["coords"] = {{ 57.6  , 67.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Bloodstalker Alpha"          ,["maxlevel" ] =110     , [ "minlevel" ] =99    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 71540 ,["id"] = 92599  ,["coords"] = {{ 40.0  , 38.6  }, {38.2, 42.8}, {39.0, 44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Rendrak"                     ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 24  , "Bat"           } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 63197 ,["id"] = 92627  ,["coords"] = {{ 37.2  , 68.6  },{37.8,67},{38.8,77},{39,74.8},{39.2,69},{39.2,70.4},{39.2,71},{39.4,72},{39.4,74},{39.8,75.4},{39.8,76.4},{39.8,76.6},{40.2,74},{40.4,71.4},{40.6,71.6},{40.8,73.2},{41.2,74.2},{41.2,77},{41.4,75.2},{41.6,74.4},{41.6,76.2},{42,70.4},{42,70.8},{42.4,71.8},{42.4,73.4},{42.4,77.6},{42.6,71.8},{42.6,76.4},{42.8,74},{43,70.4},{43,71.4},{43,73.4},{43,75.4},{43.2,76.6},{43.4,79.2},{43.6,72.4},{43.6,74},{43.6,77},{43.8,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "The Goreclaw"                ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 63223 ,["id"] = 92694  ,["coords"] = {{ 34.4  , 72.4  },{34.4,72.6},{34.6,72.4},{34.6,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Steelsnout"                  ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 64723 ,["id"] = 92887  ,["coords"] = {{ 65.4  , 36.4  },{65.4,36.8},{65.6,36.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Magwia"                      ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 61301 ,["id"] = 93002  ,["coords"] = {{ 52.2  , 65.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Tanaan Jungle"                 , [ "zoneID" ] = 534  , [ "name" ] = "Shadowthrash"                ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 21371 ,["id"] = 93236  ,["coords"] = {{ 49.6  , 61    },{49.8,61.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Majestic Elderhorn"          ,["maxlevel" ] =110     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 64893 ,["id"] = 96410  ,["coords"] = {{ 45.2  , 25.8  },{45.4,30.2},{45.8,30.4},{46.4,30.8},{46.6,31.4},{47,33.6},{47.2,32.4},{47.4,33},{47.6,32.8},{47.8,30.4},{47.8,32},{48.4,25.2},{48.6,25.2},{49.2,29}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Arru"                        ,["maxlevel" ] =110     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 20827 ,["id"] = 97220  ,["coords"] = {{ 48.8  , 50    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Crawshuk the Hungry"         ,["maxlevel" ] =110     , [ "minlevel" ] =101   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 65258 ,["id"] = 97345  ,["coords"] = {{ 48.4  , 40.4  },{48.4,40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Bristlemaul"                 ,["maxlevel" ] =110     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 51827 ,["id"] = 97449  ,["coords"] = {{ 38    , 45.4  },{38,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Wraithtalon"                 ,["maxlevel" ] =110     , [ "minlevel" ] =99    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 65235 ,["id"] = 97504  ,["coords"] = {{ 66.6  , 37.6  },{66.8,36.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Tamed Coralback"             ,["maxlevel" ] =110     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 70524 ,["id"] = 97928  ,["coords"] = {{ 43    , 10.4  },{43.4,10.8},{43.8,10},{44,11.2},{44.2,12.2},{44.4,12.6},{45.4,12.4},{45.4,12.6},{45.8,12.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Slumber"                     ,["maxlevel" ] =110     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 37737 ,["id"] = 98890  ,["coords"] = {{ 41.4  , 31.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Thunder Totem"                 , [ "zoneID" ] = 652  , [ "name" ] = "Sekhan"                      ,["maxlevel" ] =110     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 64387 ,["id"] = 101077 ,["coords"] = {{ 36    , 8     },{36.2,6.2},{36.4,7},{36.8,7.2},{36.8,12.8},{37,6.4},{37,8.2},{37.2,4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Well-Fed Bear"               ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 68383 ,["id"] = 103785 ,["coords"] = {{ 49.2  , 46.8  },{59.6,66.8},{60.2,66.4},{60.6,66.2},{69,59.4},{69,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Baconlisk"                   ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 66850 ,["id"] = 103787 ,["coords"] = {{ 24.4  , 49.6  },{24.6,49.4},{24.8,49.8},{38.8,29.6},{39,29.4},{75.8,50.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Shadowquill"                 ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 64536 ,["id"] = 103841 ,["coords"] = {{ 16.2  , 25.4  },{16.4,26.4},{16.4,26.8},{16.8,26.4},{17,26.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Rauren"                      ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 69191 ,["id"] = 105547 ,["coords"] = {{ 23.4  , 26    },{23.8,25.4},{23.8,25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Starbuck"                    ,["maxlevel" ] =110     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 70116 ,["id"] = 107487 ,["coords"] = {{ 54.6  , 29.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Grimrot"                     ,["maxlevel" ] =60      , [ "minlevel" ] =60    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70193 ,["id"] = 107595 ,["coords"] = {{ 38.2  , 45.4  },{38.2,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Felwood"                       , [ "zoneID" ] = 77   , [ "name" ] = "Grimrot"                     ,["maxlevel" ] =60      , [ "minlevel" ] =57    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70194 ,["id"] = 107596 ,["coords"] = {{ 38.2  , 45.4  },{38.2,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "The Hinterlands"               , [ "zoneID" ] = 26   , [ "name" ] = "Ol' Muddle"                  ,["maxlevel" ] =60      , [ "minlevel" ] =36    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 70190 ,["id"] = 107617 ,["coords"] = {{ 42.6  , 61.8  },{42.8,59.4},{42.8,62.6},{43,61.4},{43,63.8},{43.2,60},{44,55.2},{44,59.6},{44.4,64.6},{44.6,53.6},{47,56.2},{48.8,59.2},{49.2,57.2},{49.8,57.2},{51,55.6},{51.2,53.8},{51.2,59},{52.4,51},{54.2,45.4},{54.2,45.8},{54.8,46.2},{56,46},{58,46.6},{58.2,53.2},{59,48.8},{61,50.4},{62,54},{62.6,47.6},{62.8,45},{63.2,54.2},{63.4,42.4},{64,54.6},{64.2,41.2},{64.4,42.2},{64.6,42},{64.8,57.2},{65.4,58.4},{67.8,47},{67.8,57.4},{68.2,48},{69.4,50.6},{70.2,51.2},{71.6,50.2},{71.8,51.8},{72.2,50.6},{72.8,49.2},{72.8,50},{74,54.6},{75.8,51.8},{76.8,49.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Pinchshank"                  ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 699   ,["id"] = 107846 ,["coords"] = {{ 66.4  , 67.2  },{66.4,67.6},{66.6,66.4},{66.6,67.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Myonix"                      ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 71536 ,["id"] = 110340 ,["coords"] = {{ 40.4  , 33.4  },{40.8,32.4},{40.8,32.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Bahagar"                     ,["maxlevel" ] =110     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 71578 ,["id"] = 110562 ,["coords"] = {{ 45.2  , 87.4  },{45.2,88 },{45.4,88.6},{45.6,88.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Tideclaw"                    ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 70524 ,["id"] = 110824 ,["coords"] = {{ 18.4  , 61    },{18.6,60.2},{18.6,61}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Anax"                        ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 291 , "Toad"          } , ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 55080 ,["id"] = 111197 ,["coords"] = {{ 33.4  , 51    },{33.4,51.6},{33.6,51.4},{33.6,51.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Bulvinkel"                   ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 70876 ,["id"] = 111463 ,["coords"] = {{ 73.8  , 84.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Maia the White"              ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 68526 ,["id"] = 112497 ,["coords"] = {{ 24.4  , 35.2  },{24.6,35 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }, } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Sinister Leyrunner"          ,["maxlevel" ] =110     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 69430 ,["id"] = 112636 ,["coords"] = {{ 50.4  , 52    },{50.6,52}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Devious Sunrunner"           ,["maxlevel" ] =110     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 72132 ,["id"] = 112637 ,["coords"] = {{ 50.4  , 52    },{50.6,52.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Mar'tura"                    ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 44781 ,["id"] = 112802 ,["coords"] = {{ 13.4  , 53.4  },{13.4,53.6},{13.6,53.4},{13.6,53.6},{13.8,52.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Suramar"                       , [ "zoneID" ] = 680  , [ "name" ] = "Pashya"                      ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 67421 ,["id"] = 113694 ,["coords"] = {{ 60.2  , 40.8  },{62 ,46.8},{62.4,52.2},{62.4,52.8},{62.6,53.2},{64.2,47.4},{64.2,48},{66.2,53.4},{66.2,53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }, } ,
  { ["zone_name"] = "Duskwood"                      , [ "zoneID" ] = 47   , [ "name" ] = "Lightning Paw"               ,["maxlevel" ] =60      , [ "minlevel" ] =25    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 46  , "Spirit Beast"  } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 74736 ,["id"] = 118244 ,["coords"] = {{ 23    , 39    } , {23 , 29}, {30 , 41},{16 , 54},{16 , 60}, {23 , 76} ,                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Umbra'jin"                   ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 83645 ,["id"] = 122004 ,["coords"] = {{ 71.2  , 32.4  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Overstuffed Saurolisk"       ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 77980 ,["id"] = 124375 ,["coords"] = {{ 62    , 65    }, {62.4, 64.4}, {62.6, 64.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Kal'draxa"                   ,["maxlevel" ] =120     , [ "minlevel" ] =118   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 290 , "Pterrordax"    } , ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 80333 ,["id"] = 124397 ,["coords"] = {{ 52.8  , 13.2  }, {52.8, 13.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Infected Direhorn"           ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 74268 ,["id"] = 124399 ,["coords"] = {{ 24.4  , 78    }, {24.6, 77.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Krubbs"                      ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 50962 ,["id"] = 125214 ,["coords"] = {{ 75.8  , 36    }, {76, 36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Ancient Jawbreaker"          ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 78396 ,["id"] = 125250 ,["coords"] = {{ 67.4  , 29.4  }, {67.4, 29.6}, {67.6, 29.4}, {67.8, 29.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Quillrat Matriarch"          ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 127 , "Rodent"        } , ["familySkills" ] = RODENT_SKILLS        ,["displayID"] = 43647 ,["id"] = 125453 ,["coords"] = {{ 66.4  , 42.4  }, {66.4, 42.6}, {66.6, 42.4}, {66.6, 42.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Bajiatha"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 78750 ,["id"] = 126142 ,["coords"] = {{ 42    , 60.6  }, {42.4, 60.4}, {42.6, 60.4}, {42.8, 60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Kandak"                      ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 79019 ,["id"] = 126637 ,["coords"] = {{ 68.6  , 48.4  }, {68.6, 48.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Venomjaw"                    ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 40269 ,["id"] = 126926 ,["coords"] = {{ 29.2  , 50.4  }, {29.4, 50.6}, {29.6, 50.8}, {29.8, 50.4}, {29.8, 51.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Mugg"                        ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 81866 ,["id"] = 127290 ,["coords"] = {{ 58.4  , 14.8  }, {58.8, 14.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Barbthorn Queen"             ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 85629 ,["id"] = 127333 ,["coords"] = {{ 59    , 17    }, {59, 17.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Vicemaul"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 21936 ,["id"] = 127651 ,["coords"] = {{ 72.8  , 60.4  }, {72.8, 60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Scaleclaw Broodmother"       ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 79365 ,["id"] = 127776 ,["coords"] = {{ 44.4  , 80.2  }, {44.4, 80.6}, {44.6, 80.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Scrounger Patriarch"         ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 83648 ,["id"] = 127873 ,["coords"] = {{ 57.4  , 9.4   }, {57.4, 9.6}, {57.6, 8.2}, {58.2, 9.2}, {58.4, 9.8}, {58.6, 9.4}, {58.6, 9.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Torraske the Eternal"        ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 79702 ,["id"] = 127939 ,["coords"] = {{ 46.4  , 65.2  }, {46.6, 65.2}, {46.8, 65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Bloodbulge"                  ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 296 , "Blood Beast"   } , ["familySkills" ] = BLOOD_BEAST_SKILLS   ,["displayID"] = 83539 ,["id"] = 128699 ,["coords"] = {{ 59.4  , 18.4  }, {59.6, 18.6}, {59.8, 18.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Queen Tzxi'kik"              ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 80307 ,["id"] = 128974 ,["coords"] = {{ 57.4  , 67.8  }, {57.6, 67.6}, {57.8, 67.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "King Kooba"                  ,["maxlevel" ] =120     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 9   , "Gorilla"       } , ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 80326 ,["id"] = 129005 ,["coords"] = {{ 53.2  , 42.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Jumbo Sandsnapper"           ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 80500 ,["id"] = 129283 ,["coords"] = {{ 37.4  , 84.4  }, {37.4, 84.8}, {37.6, 84.4}, {37.6, 84.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Bloated Krolusk"             ,["maxlevel" ] =120     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 292 , "Carapid"       } , ["familySkills" ] = KROLUSK_SKILLS       ,["displayID"] = 80618 ,["id"] = 129476 ,["coords"] = {{ 48.8  , 50.6  }, {49, 50}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Beshol"                      ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 37738 ,["id"] = 129805 ,["coords"] = {{ 50.4  , 30    }, {50.6, 30}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Gorehorn"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 80884 ,["id"] = 129835 ,["coords"] = {{ 57    , 44.2  }, {57.2, 44.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Talon"                       ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 81102 ,["id"] = 129950 ,["coords"] = {{ 31.8  , 41    }, {32.2, 40}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Gahz'ralka"                  ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 58892 ,["id"] = 129954 ,["coords"] = {{ 64.2  , 32.8  }, {64.4, 32.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Nevermore"                   ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 80965 ,["id"] = 130138 ,["coords"] = {{ 60    , 45.4  }, {60, 45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Vathikur"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 81189 ,["id"] = 130401 ,["coords"] = {{ 57.2  , 73.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Ashmane"                     ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 25  , "Hyena"         } , ["familySkills" ] = HYENA_SKILLS         ,["displayID"] = 49064 ,["id"] = 130439 ,["coords"] = {{ 54.6  , 15.2  }, {54.6, 15.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Hivemother Kraxi"            ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 81233 ,["id"] = 130443 ,["coords"] = {{ 53.6  , 53.4  }, {53.6, 53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Broodmother Razora"          ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 81342 ,["id"] = 130508 ,["coords"] = {{ 83.2  , 44.4  }, {83.4, 44.8}, {83.6, 44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Lei-zhi"                     ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 128 , "Stone Hound"        } , ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 42065 ,["id"] = 131233 ,["coords"] = {{ 58.8  , 74.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Merianae"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 82052 ,["id"] = 131252 ,["coords"] = {{ 43.2  , 16.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Pack Leader Asenya"          ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 68526 ,["id"] = 131262 ,["coords"] = {{ 39    , 15.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Kulett the Ornery"           ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 47803 ,["id"] = 131520 ,["coords"] = {{ 48    , 22.2  }, {48.2, 22.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Tambano"                     ,["maxlevel" ] =120     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 44916 ,["id"] = 131687 ,["coords"] = {{ 77.4  , 11.2  }, {77.6, 10.2}, {77.6, 11}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Bramblewing"                 ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 290 , "Pterrordax"    } , ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 76655 ,["id"] = 131718 ,["coords"] = {{ 66.4  , 32.4  }, {66.4, 32.6}, {66.6, 32.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Bashmu"                      ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55832 ,["id"] = 132068 ,["coords"] = {{ 34.2  , 30.6  }, {34.4, 30.2}, {34.6, 30.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Foxhollow Skyterror"         ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 82239 ,["id"] = 132127 ,["coords"] = {{ 60    , 22.6  }, {60.2, 22.2}, {60.6, 22}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Fowlmouth"                   ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 82292 ,["id"] = 132211 ,["coords"] = {{ 90.2  , 77.2  }, {90.2, 77.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Kiboku"                      ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 77474 ,["id"] = 132244 ,["coords"] = {{ 75.4  , 35.8  }, {75.6, 36}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Bilefang Mother"             ,["maxlevel" ] =120     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 34168 ,["id"] = 132319 ,["coords"] = {{ 35.2  , 33    }, {35.6, 32.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Tempestria"                  ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 82869 ,["id"] = 133356 ,["coords"] = {{ 60.6  , 17.4  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Juba the Scarred"            ,["maxlevel" ] =120     , [ "minlevel" ] =113   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47819 ,["id"] = 133527 ,["coords"] = {{ 27.4  , 34.2  }, {28, 34.2}, {28.2, 33.4}, {28.2, 35}, {28.6, 33.4}, {28.6, 33.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Lo'kuno"                     ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 82989 ,["id"] = 133539 ,["coords"] = {{ 77.4  , 44.4  }, {77.4, 45.2}, {77.4, 45.6}, {77.6, 44.4}, {77.6, 45.2}, {77.6, 45.6}, {78.6, 44.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Zanxib"                      ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 83646 ,["id"] = 133812 ,["coords"] = {{ 38.4  , 71.4  }, {38.4, 71.6}, {38.8, 71.4}, {38.8, 71.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Warcrawler Karkithiss"       ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 292 , "Carapid"       } , ["familySkills" ] = KROLUSK_SKILLS       ,["displayID"] = 79721 ,["id"] = 133842 ,["coords"] = {{ 44    , 25.4  }, {44, 25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "First Mate Swainbeak"        ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 80412 ,["id"] = 133843 ,["coords"] = {{ 41.2  , 24.2  }, {41.2, 24.6}, {41.6, 24}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Vukuba"                      ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 27  , "Wind Serpent"  } , ["familySkills" ] = WIND_SERPENTS_SKILLS ,["displayID"] = 4065  ,["id"] = 134048 ,["coords"] = {{ 62    , 46.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Murderbeak"                  ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 55918 ,["id"] = 134782 ,["coords"] = {{ 60.6  , 66.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Ak'tar"                      ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 290 , "Pterrordax"    } , ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 76667 ,["id"] = 135852 ,["coords"] = {{ 50.2  , 81.6  }, {50.4, 81.4}, {50.6, 81.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Crushtacean"                 ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 83864 ,["id"] = 136183 ,["coords"] = {{ 51.4  , 55.4  }, {51.4, 55.6}, {51.6, 55.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Enraged Krolusk"             ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 292 , "Carapid"       } , ["familySkills" ] = KROLUSK_SKILLS       ,["displayID"] = 75589 ,["id"] = 136335 ,["coords"] = {{ 61.8  , 37.4  }, {61.8, 37.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Scorpox"                     ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 37539 ,["id"] = 136336 ,["coords"] = {{ 32.8  , 65.2  }, {32.8, 65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Jungleweb Hunter"            ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 1104  ,["id"] = 136341 ,["coords"] = {{ 60.4  , 17.4  }, {60.4, 17.8}, {60.6, 17.4}, {60.6, 17.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Bloodwing Bonepicker"        ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 3248  ,["id"] = 136393 ,["coords"] = {{ 56    , 53.4  }, {56, 53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Broodmother"                 ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 85021 ,["id"] = 137025 ,["coords"] = {{ 29.2  , 69.4  }, {29.2, 69.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Honey-Coated Slitherer"      ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78242 ,["id"] = 137183 ,["coords"] = {{ 64.2  , 19.4  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "King Clickyclack"            ,["maxlevel" ] =120     , [ "minlevel" ] =113   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 85438 ,["id"] = 137681 ,["coords"] = {{ 38.2  , 41.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Arclight"                    ,["maxlevel" ] =120     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 85538 ,["id"] = 137824 ,["coords"] = {{ 29.2  , 68.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Avalanche"                   ,["maxlevel" ] =120     , [ "minlevel" ] =113   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 85539 ,["id"] = 137825 ,["coords"] = {{ 43.8  , 88.2  }, {43.8, 88.6}, {44.4, 85.4}, {44.4, 85.6}, {44.4, 87.2}, {44.6, 86.4}, {44.6, 86.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "Gorged Boar"                 ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 55858 ,["id"] = 138675 ,["coords"] = {{ 27.8  , 25.4  }, {28, 26}, {28.6, 25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Nestmother Acada"            ,["maxlevel" ] =120     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 507   ,["id"] = 138963 ,["coords"] = {{ 43.4  , 45    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Blackthorne"                 ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 66132 ,["id"] = 139145 ,["coords"] = {{ 85.2  , 73.4  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Gulliver"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 78151 ,["id"] = 139233 ,["coords"] = {{ 57.4  , 56    }, {57.8, 56}, {57.8, 56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Tort Jaw"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 42658 ,["id"] = 139235 ,["coords"] = {{ 70.4  , 55.4  }, {70.4, 55.6}, {70.6, 55.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Ranja"                       ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 913   ,["id"] = 139278 ,["coords"] = {{ 68.2  , 63.4  }, {68.2, 63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Sythian the Swift"           ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 45092 ,["id"] = 139280 ,["coords"] = {{ 66.2  , 14    }, {66.4, 13.4}, {66.4, 14.6}, {66.6, 14.6}, {66.8, 13.4}, {66.8, 13.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Shiverscale the Toxic"       ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78240 ,["id"] = 139285 ,["coords"] = {{ 55    , 32.4  }, {55, 32.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Tiragarde Sound"               , [ "zoneID" ] = 895  , [ "name" ] = "Maison the Portable"         ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 75380 ,["id"] = 139290 ,["coords"] = {{ 58.2  , 50.2  }, {58.2, 50.6}, {58.4, 49.4}, {58.6, 49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Pinku'shon"                  ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 86218 ,["id"] = 139298 ,["coords"] = {{ 38.2  , 51    }, {38.2, 51.6}, {38.6, 51}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Deepfang"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 71540 ,["id"] = 139385 ,["coords"] = {{ 52.8  , 51.4  }, {52.8, 51.6}, {53, 50.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Sandfang"                    ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78242 ,["id"] = 139988 ,["coords"] = {{ 73.4  , 60.4  }, {73.4, 60.6}, {73.6, 60.4}, {73.6, 60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Croaker"                     ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 291 , "Toad"          } , ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 55080 ,["id"] = 140938 ,["coords"] = {{ 62.4  , 33.4  }, {62.4, 33.6}, {62.8, 32.8}, {62.8, 33.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Kickers"                     ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 129 , "Gruffhorn"          } , ["familySkills" ] = GRUFFHORN_SKILLS          ,["displayID"] = 82209 ,["id"] = 141029 ,["coords"] = {{ 31.2  , 61.8  }, {31.2, 62.6}, {31.4, 61.4}, {31.6, 61.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Osca the Bloodied"           ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 87178 ,["id"] = 141239 ,["coords"] = {{ 41.8  , 62.4  }, {42, 63}, {42, 63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Stormsong Valley"              , [ "zoneID" ] = 942  , [ "name" ] = "Whirlwing"                   ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 85524 ,["id"] = 142088 ,["coords"] = {{ 46.8  , 42.2  }, {46.8, 42.6}, {47, 41.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Redridge Mountains"            , [ "zoneID" ] = 49   , [ "name" ] = "Gnollfeaster"                ,["maxlevel" ] =120     , [ "minlevel" ] =17    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 8014  ,["id"] = 147222 ,["coords"] = {{ 24.4  , 70.4  },{24.4,70.6},{24.6,70.4},{24.6,70.6},{25,69.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "N'chala the Egg Thief"       ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 83648 ,["id"] = 149147 ,["coords"] = {{ 69.2  , 35.2  }, {69.4, 35.8}, {69.4, 36.8}, {69.4, 37.8}, {69.6, 36.4}, {69.6, 36.6}, {69.6, 37.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Glimmerspine"                ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 89029 ,["id"] = 149654 ,["coords"] = {{ 43.4  , 19.8  },{43.6,19.4},{43.6,19.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Shadowclaw"                  ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 89243 ,["id"] = 149663 ,["coords"] = {{ 39.8  , 32.4  },{39.8,32.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Mechagon"                      , [ "zoneID" ] = 1462 , [ "name" ] = "Bonepicker"                  ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 77483 ,["id"] = 152001 ,["coords"] = {{ 65.4  , 23.4  },{65.4,23.6},{65.4,24.8},{65.4,25.6},{65.6,23.4},{65.6,24},{65.6,24.6},{65.6,25.6},{65.8,22.4},{65.8,26.6},{66.6,23.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Soundless"                   ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 34  , "Ray"           } , ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 92542 ,["id"] = 152290 ,["coords"] = {{ 53.6  , 41.4  }, {54.4, 50}, {57.4, 51.4}, {58,41.8, }, {60, 47.8}, {62.4, 59.4}, {64.4, 51.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Deepglider"                  ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 34  , "Ray"           } , ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 90735 ,["id"] = 152291 ,["coords"] = {{ 52.2  , 52.8  }, {52.2, 54.4}, {52.2, 54.6}, {52.4, 42.4}, {52.4, 44}, {52.4, 52.4}, {52.6, 43.2}, {52.8, 44}, {53, 55}, {53.2, 42.2}, {53.2, 52}, {53.2, 52.8}, {53.2, 53.6}, {53.2, 56}, {53.6, 40}, {53.6, 41.4}, {53.6, 43.2}, {53.6, 44.2}, {53.6, 51.8}, {53.6, 53.2}, {53.6, 53.6}, {53.6, 54.6}, {54, 44.6}, {54.8, 52.4}, {55, 42.4}, {55.2, 42.6}, {55.6, 41.4}, {56.2, 44.8}, {56.2, 48.4}, {56.2, 51.6}, {56.4, 42.2}, {56.4, 42.8}, {56.4, 43.8}, {56.4, 48.8}, {56.4, 50.4}, {56.4, 51.4}, {56.4, 52.8}, {56.6, 42.4}, {56.6, 42.6}, {56.6, 44.4}, {56.8, 41.4}, {56.8, 44.8}, {56.8, 45.8}, {56.8, 47.8}, {56.8, 54.4}, {57, 47.4}, {57.2, 49.4}, {57.2, 49.8}, {57.2, 52.2}, {57.2, 52.6}, {57.4, 51.2}, {57.6, 49.4}, {57.6, 52.2}, {57.8, 50.4}, {58.2, 41.2}, {58.2, 55.6}, {58.4, 51.4}, {58.4, 53.2}, {58.4, 54.4}, {58.4, 54.8}, {58.6, 51.8}, {59, 48}, {59, 54}, {59, 56}, {59.2, 48.8}, {59.2, 51.4}, {59.2, 55.2}, {59.4, 52.6}, {59.6, 48}, {59.6, 52.8}, {59.6, 55.4}, {59.6, 56.6}, {59.8, 49.6}, {59.8, 51.2}, {59.8, 52.4}, {60, 48.8}, {60.2, 47.2}, {60.4, 55.8}, {60.6, 48.8}, {60.6, 51.2}, {60.6, 51.8}, {60.6, 55.4}, {60.8, 47.2}, {60.8, 49.6}, {61, 48.4}, {61, 52.8}, {61.8, 48}                        }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Siltstalker the Packmother"  ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90766 ,["id"] = 152359 ,["coords"] = {{ 71.6  , 54.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Toxigore the Alpha"          ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90767 ,["id"] = 152360 ,["coords"] = {{ 64.4  , 47.2  }, {64.6, 46.6}, {64.8, 46.4}, {65.4, 50.4}, {65.4, 50.6}, {65.6, 50.2}, {67.4, 47}, {68.2, 46.4}, {68.4, 46.8}, {69.2, 45.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Banescale the Packfather"    ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90768 ,["id"] = 152361 ,["coords"] = {{ 71    , 54.4  }, {72, 54}, {73.2, 53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Iridescent Glimmershell"     ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 90947 ,["id"] = 152448 ,["coords"] = {{ 40.2  , 49.4  }, {40.4, 48.4}, {40.4, 49.6}, {40.6, 48.4}, {40.6, 48.6}, {42.4, 47.8}, {42.8, 47.4}, {42.8, 47.8}, {43.4, 54.8}, {43.6, 48}, {43.6, 54.2}, {44.4, 55.4}, {44.4, 55.6}, {44.6, 55.4}, {45.4, 47}, {45.4, 47.6}, {45.4, 56}, {45.6, 47.2}, {45.6, 47.6}, {45.6, 55.8}, {46, 54.4}, {46, 54.6}, {46.6, 52.4}, {46.8, 52.6}, {47, 55.4}, {47.2, 56}, {49.4, 51.4}, {49.6, 51.4}, {56.2, 57}, {58.8, 40.8}, {61.6, 42.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Needlespine"                 ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91027 ,["id"] = 152465 ,["coords"] = {{ 39.4  , 27.4  }, {39.4, 28.2}, {39.6, 27.4}, {39.6, 28.2}, {46, 25.2}, {46, 25.6}, {46.8, 30.2}, {47, 30.8}, {48.4, 17}, {48.6, 17.4}, {48.6, 17.6}, {50.2, 19.2}, {50.4, 19.6}, {50.6, 19.2}, {56.4, 8.8}, {56.6, 8.6}, {56.8, 8}, {70.2, 24.4}, {70.4, 24.6}, {70.6, 24.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Shassera"                    ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 74318 ,["id"] = 152552 ,["coords"] = {{ 62.6  , 8.4   }, {62.8, 8.8}, {63.2, 7.4}, {64.2, 7.2}, {64.4, 5.4}, {64.4, 6}, {64.6, 5.4}, {64.6, 5.6}, {65.6, 5.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Garnetscale"                 ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 50760 ,["id"] = 152553 ,["coords"] = {{ 31.4  , 35.4  }, {31.4, 35.6}, {31.6, 35.4}, {31.6, 35.6}, {32.2, 36.6}, {32.4, 33.4}, {32.4, 33.6}, {32.6, 33.4}, {32.6, 33.8}, {35.4, 45.2}, {35.8, 45.6}, {36.2, 45.2}, {36.4, 39}, {36.4, 44.2}, {36.6, 39.4}, {36.6, 40.8}, {36.6, 45.2}, {36.8, 41.6}, {37.4, 40.2}, {37.4, 47.4}, {37.4, 47.6}, {37.6, 39.4}, {37.6, 40.4}, {37.6, 40.6}, {37.6, 47.4}, {37.6, 47.6}, {38.4, 43}, {38.8, 43.4}, {39, 43.6}, {39.4, 42.2}, {39.6, 42.2}, {39.6, 42.6}, {39.6, 43.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Chasm-Haunter"               ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78240 ,["id"] = 152556 ,["coords"] = {{ 49    , 88.4  }, {49.2, 88.6}, {49.6, 88}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }, } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Sandclaw Stoneshell"         ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 75368 ,["id"] = 152795 ,["coords"] = {{ 51.8  , 51.4  }, {51.8, 51.6}, {51.8, 52.6}, {56, 44}, {63.4, 47.2}, {63.6, 47.2}, {63.8, 48.2}, {63.8, 48.6}, {64.2, 54.8}, {65.2, 41.6}, {65.4, 41}, {68.4, 32.4}, {68.4, 32.8}, {68.6, 32.8}, {73.4, 45.6}, {73.6, 45.4}, {73.6, 45.6}, {74.4, 31}, {74.4, 44}, {74.6, 31.2}, {74.6, 44}, {76.2, 52}, {78.4, 32.2}, {78.6, 31.8}, {78.6, 32.6}, {79.4, 38.6}, {79.6, 38.6}, {79.8, 27.4}, {79.8, 27.6}, {80.4, 38.2}, {80.6, 42}, {81, 41.4}, {81.2, 40}, {82.8, 41.8}, {84.2, 40.4}, {84.4, 40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }, } ,
  { ["zone_name"] = "Mechagon"                      , [ "zoneID" ] = 1462 , [ "name" ] = "Scrapclaw"                   ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91409 ,["id"] = 155583 ,["coords"] = {{ 81.4  , 76.2  },{81.4,77},{82,76.4},{82.2,77.4},{82.2,77.6},{82.6,77},{82.6,77.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Vision of Stormwind"           , [ "zoneID" ] = 1470 , [ "name" ] = "Sewer Beastling"             ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 74885 ,["id"] = 160341 ,["coords"] = {{ 54.8  , 56.4  },{56.2,65.4},{59,63.2},{59.2,61.2},{59.6,58.8},{59.8,62.6},{60,58.2},{60,60.2},{60,60.8},{60,61.6},{60.4,42.8},{61,56.8},{61,58.4},{61,60.8},{61,62},{61.2,50},{61.2,60},{61.4,51},{61.4,51.8},{61.4,52.8},{61.4,59.2},{61.6,50.4},{61.6,57.4},{61.6,58.4},{61.6,59.4},{61.8,54.4},{61.8,55.4},{62,53},{62,55.8},{62,60.2},{62.2,51},{62.2,61.6},{62.4,52},{62.4,61},{62.6,50.4},{62.6,50.6},{62.6,55.2},{62.8,52},{62.8,53},{62.8,59.4},{63,60},{63.2,47.8},{63.4,61.2},{63.6,49.2},{63.8,50.2},{64.2,66.6},{64.4,51.2},{64.4,51.8},{64.4,60.4},{64.4,60.6},{64.6,51.8},{64.6,60.4},{64.8,50.8},{64.8,60.8},{65,52.6},{65,61.8},{65.2,65},{65.4,63},{65.6,64.2},{66.2,61},{66.2,62.4},{66.2,62.6},{66.4,52.2},{66.4,52.6},{66.4,59.4},{66.4,60},{66.6,52.8},{66.8,54.4},{66.8,56.6},{66.8,58.2},{66.8,59.2},{66.8,60.8},{67,50.8},{67,51.8},{67,56.4},{67,62.2},{67.2,60.4},{67.2,65.2},{67.4,54.8},{67.4,63},{67.4,64.2},{67.4,65.8},{67.6,52.2},{67.6,58.2},{67.6,59.2},{67.6,60.4},{67.8,54.4},{67.8,54.6},{67.8,56},{67.8,61.8},{68,51.2},{68,52.6},{68,64},{68.2,65.4},{68.2,66},{68.4,49.8},{68.4,60.8},{68.6,52.4},{68.6,53.2},{68.6,62.6},{68.8,53.8},{68.8,62.4},{69,60.2},{69.2,67.6},{69.6,53},{69.6,62.8},{70.2,61.8}}, } ,
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 1527 , [ "name" ] = "Skikx'traz"                  ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 91809 ,["id"] = 162140 ,["coords"] = {{ 23.4  , 62.2  },{23.4,62.6},{23.8,62.6},{24,62.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }, } ,
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 1527 , [ "name" ] = "Qho"                         ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 92904 ,["id"] = 162142 ,["coords"] = {{ 37.2  , 59.4  },{37.4,60.2},{37.4,60.6},{37.6,59.4},{37.6,60.2},{37.6,60.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Uldum"                         , [ "zoneID" ] = 1527 , [ "name" ] = "Corpse Eater"                ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 91811 ,["id"] = 162147 ,["coords"] = {{ 30.8  , 49.4  },{30.8,49.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }, } ,
  { ["zone_name"] = "Northern Barrens"              , [ "zoneID" ] = 11   , [ "name" ] = "Trigore the Lasher"          ,["maxlevel" ] ="???"   , [ "minlevel" ] ="???" , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 1092  ,["id"] = 3652   ,["coords"] = {{ 60.4  , 38.6  },{60.4,40.6},{60.6,40.8},{61,41.6},{61.6,41.2},{62,38.8},{62.2,42},{62.4,37.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }, } ,
  { ["zone_name"] = "Feralas"                       , [ "zoneID" ] = 69   , [ "name" ] = "The Razza"                   ,["maxlevel" ] ="???"   , [ "minlevel" ] ="???" , ["info" ] =   ""                         , ["class" ] = CLASS_RARE       , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 37571 ,["id"] = 11497  ,["coords"] = {{ 84.5  , 49.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, } ,
  { ["zone_name"] = "Sethekk Halls"                  , [ "zoneID" ] = 259  , [ "name" ] = "Anzu"                        ,["maxlevel" ] =72      , [ "minlevel" ] =72    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 21492 ,["id"] = 23035  ,["coords"] = {{ 32.6  , 54.5  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Karazhan"                      , [ "zoneID" ] = 350  , [ "name" ] = "Shadikith the Glider"        ,["maxlevel" ] =73      , [ "minlevel" ] =73    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 24  , "Bat"           } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 16053 ,["id"] = 16180  ,["coords"] = {{ 59.6  , 28.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Isle Of Giants"                  , [ "zoneID" ] = 507  , [ "name" ] = "Oondasta"                    ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 47257 ,["id"] = 69161  ,["coords"] = {{ 49.9  , 54    },{50.6,54.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }  } ,
  { ["zone_name"] = "Orgrimmar Raid"                 , [ "zoneID" ] = 559  , [ "name" ] = "Thok the Bloodthirsty"       ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 51144 ,["id"] = 71529  ,["coords"] = {{ 51.3  , 82.1  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Throne Of Thunder"               , [ "zoneID" ] = 511  , [ "name" ] = "Ji-Kun"                      ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 46675 ,["id"] = 69712  ,["coords"] = {{ 49.3  , 41.5  },{49.7,41.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }  } ,
  { ["zone_name"] = "Blackwing Lair"                 , [ "zoneID" ] = 1560 , [ "name" ] = "Chromaggus"                  ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 45  , "Core Hound"     } , ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 14367 ,["id"] = 14020  ,["coords"] = {{ 39.4  , 72.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Molten Core"                    , [ "zoneID" ] = 232  , [ "name" ] = "Magmadar"                    ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 45  , "Core Hound"     } , ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 10193 ,["id"] = 11982  ,["coords"] = {{ 69.4  , 23.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Drak Tharon Keep"                , [ "zoneID" ] = 160  , [ "name" ] = "King Dred"                    ,["maxlevel" ] =82      , [ "minlevel" ] =65    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5240  ,["id"] = 27483  ,["coords"] = {{ 61.2  , 86.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Maraudon"                      , [ "zoneID" ] = 281  , [ "name" ] = "Rotgrip"                     ,["maxlevel" ] =62      , [ "minlevel" ] =36    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 6   , "Crocolisk"     } , ["familySkills" ] = CROCOLISK_SKILLS     ,["displayID"] = 13589 ,["id"] = 13596  ,["coords"] = {{ 41.3  , 81.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Throne Of Thunder"               , [ "zoneID" ] = 509  , [ "name" ] = "Horridon"                    ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47325 ,["id"] = 68476  ,["coords"] = {{ 26.2  , 78.2  },{26.8,78.7}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }  } ,
  { ["zone_name"] = "Karazhan"                      , [ "zoneID" ] = 350  , [ "name" ] = "Rokad the Ravager"           ,["maxlevel" ] =73      , [ "minlevel" ] =73    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 16054 ,["id"] = 16181  ,["coords"] = {{ 59.6  , 28.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Blackwing Descent"              , [ "zoneID" ] = 286  , [ "name" ] = "Chimaeron"                   ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 33308 ,["id"] = 43296  ,["coords"] = {{ 24.5  , 70.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "The Underbog"                   , [ "zoneID" ] = 262  , [ "name" ] = "Ghaz'an"                     ,["maxlevel" ] =82      , [ "minlevel" ] =64    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 17528 ,["id"] = 18105  ,["coords"] = {{ 78.6  , 28.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Blackrock Depths"               , [ "zoneID" ] = 243  , [ "name" ] = "Verek"                       ,["maxlevel" ] =61      , [ "minlevel" ] =51    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 9019  ,["id"] = 9042   ,["coords"] = {{ 60.2  , 65.9  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Zul Farrak"                     , [ "zoneID" ] = 219  , [ "name" ] = "Gahz'rilla"                  ,["maxlevel" ] =61      , [ "minlevel" ] =45    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 7271  ,["id"] = 7273   ,["coords"] = {{ 28    , 38.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Ruins of AhnQiraj"               , [ "zoneID" ] = 247  , [ "name" ] = "Buruthe Gorger"              ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15654 ,["id"] = 15370  ,["coords"] = {{ 69.7  , 62    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Ruins of AhnQiraj"               , [ "zoneID" ] = 247  , [ "name" ] = "Kurinnaxx"                   ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 15742 ,["id"] = 15348  ,["coords"] = {{ 56.3  , 35.7  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Blackrock Spire"                , [ "zoneID" ] = 251  , [ "name" ] = "Crystal Fang"                ,["maxlevel" ] =62      , [ "minlevel" ] =58    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 9755  ,["id"] = 10376  ,["coords"] = {{ 61.1  , 74    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Blackrock Spire"                , [ "zoneID" ] = 251  , [ "name" ] = "Mother Smolderweb"           ,["maxlevel" ] =62      , [ "minlevel" ] =57    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 36506 ,["id"] = 10596  ,["coords"] = {{ 60.1  , 75    },{62,74.1}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }  } ,
  { ["zone_name"] = "The Underbog"                   , [ "zoneID" ] = 262  , [ "name" ] = "The Black Stalker"           ,["maxlevel" ] =82      , [ "minlevel" ] =64    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 126 , "Water Strider"  } , ["familySkills" ] = WATER_STRIDER_SKILLS ,["displayID"] = 18194 ,["id"] = 17882  ,["coords"] = {{ 24.7  , 45.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Ruins of AhnQiraj"               , [ "zoneID" ] = 247  , [ "name" ] = "Ayamiss the Hunter"          ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 15431 ,["id"] = 15369  ,["coords"] = {{ 61.6  , 90.5  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Blackrock Spire"                , [ "zoneID" ] = 254  , [ "name" ] = "Gizrulthe Slavener"          ,["maxlevel" ] =62      , [ "minlevel" ] =57    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9564  ,["id"] = 10268  ,["coords"] = {{ 37.7  , 83.4  },{39.4,79.3}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      }  } ,
  { ["zone_name"] = "Blackrock Spire"                , [ "zoneID" ] = 254  , [ "name" ] = "Halycon"                     ,["maxlevel" ] =62      , [ "minlevel" ] =57    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 9567  ,["id"] = 10220  ,["coords"] = {{ 37.7  , 83.4  },{37.9,84}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }  } ,
  { ["zone_name"] = "Wailing Caverns"                , [ "zoneID" ] = 279  , [ "name" ] = "Kresh"                       ,["maxlevel" ] =62      , [ "minlevel" ] =19    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 5126  ,["id"] = 3653   ,["coords"] = {{ 38.5  , 36    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Elderspawn Nalaada"          ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78243 ,["id"] = 152555 ,["coords"] = {{ 51.4  , 75.2  } ,{51.8,75.2},{52,75.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Shiz'narasz the Consumer"    ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 91870 ,["id"] = 153658 ,["coords"] = {{ 37.4  , 14.2  } ,{37.4,14.6},{37.8,14.6},{38,14.2},{38.4,9.4},{38.4,9.6},{38.4,17},{38.6,9.6},{38.6,10.8},{38.6,16.4},{38.6,17.4},{38.6,17.6},{38.8,9.2},{39.6,16.6},{40.4,12},{40.4,15.2},{40.4,15.6},{40.6,15.4},{40.6,15.6},{40.8,11.6},{41,11.2},{41.6,15.6},{41.8,15.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "ScaleMatriarch Zodia"        ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90033 ,["id"] = 152542 ,["coords"] = {{ 28.8  , 46.4  } ,{28.8,46.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "ScaleMatriarch Gratinax"     ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90035 ,["id"] = 152548 ,["coords"] = {{ 35    , 41.6  } ,{35.4,41.2},{35.6,41}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "ScaleMatriarch Vynara"       ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90034 ,["id"] = 152545 ,["coords"] = {{ 27.4  , 37    } ,{27.6,37}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Qroshekx"                    ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 82490 ,["id"] = 132578 ,["coords"] = {{ 57.2  , 12.4  } ,{57.2,13.2},{57.2,13.6},{57.6,13.4},{58,15},{58.2,12.2},{58.2,13.6},{58.6,14.6},{59,12},{59,12.6},{59.2,11.4},{59.6,12},{59.6,13.2},{60.8,14},{61.6,13.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Ssinkrix"                    ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 82491 ,["id"] = 132580 ,["coords"] = {{ 53    , 79.2  } ,{53.2,79.6},{54.4,78},{54.4,79.2},{54.4,79.6},{54.4,81},{54.6,79.4},{54.6,79.6},{55.8,77.8},{55.8,80}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Xaarshej"                    ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 82492 ,["id"] = 132584 ,["coords"] = {{ 29.4  , 34.2  } ,{29.4,35},{29.4,35.6},{29.6,34},{29.6,35},{29.6,35.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Darkshore"                     , [ "zoneID" ] = 62   , [ "name" ] = "Alash'anir"                  ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 89749 ,["id"] = 148787 ,["coords"] = {{ 56.4  , 30.8  } ,{56.6,30.4},{56.6,30.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Thousand Needles"               , [ "zoneID" ] = 64   , [ "name" ] = "Rrakk"                       ,["maxlevel" ] =63      , [ "minlevel" ] =63    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 24  , "Bat"           } , ["familySkills" ] = BAT_SKILLS           ,["displayID"] = 46999 ,["id"] = 50329  ,["coords"] = {{ 89    , 40.4  } ,{90,39.8},{90.4,38.4},{90.4,38.8},{90.6,39.4},{90.6,39.8},{90.8,38.2},{90.8,40.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Arathi Highlands"               , [ "zoneID" ] = 14   , [ "name" ] = "Skullripper"                 ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 61297 ,["id"] = 142437 ,["coords"] = {{ 56.2  , 46.6  } ,{56.4,44.2},{56.4,45.4},{56.4,46.2},{56.8,44.2},{56.8,45},{56.8,46},{56.8,46.6},{57,43.4},{57.6,44.4},{57.6,45},{57.6,45.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Arathi Highlands"               , [ "zoneID" ] = 14   , [ "name" ] = "Venomarus"                   ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46232 ,["id"] = 142438 ,["coords"] = {{ 56.2  , 54.6  } ,{56.4,53.4},{56.4,54},{57,53.4},{57,54.6},{57.2,54},{57.6,53.4},{57.6,53.8},{57.6,54.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Arathi Highlands"               , [ "zoneID" ] = 14   , [ "name" ] = "Plaguefeather"               ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 54845 ,["id"] = 142435 ,["coords"] = {{ 35.2  , 64.8  } ,{35.4,61.4},{35.4,62.4},{35.4,62.8},{35.4,64},{35.6,63.4},{35.8,61.4},{35.8,62.4},{35.8,64.2},{36.2,64.8},{36.6,61.4},{36.8,62.4},{36.8,65.2},{37,65.6},{37.2,63.4},{37.2,66.6},{37.4,64},{37.6,63.4},{37.6,64.2},{37.6,64.6},{37.8,65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Razorfen Kraul"                 , [ "zoneID" ] = 301  , [ "name" ] = "Enormous Bullfrog"           ,["maxlevel" ] =61      , [ "minlevel" ] =32    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 291 , "Toad"          } , ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 52785 ,["id"] = 75590  ,["coords"] = {{ 35.4  , 62.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Searing Gorge"                  , [ "zoneID" ] = 32   , [ "name" ] = "Slavermaw"                   ,["maxlevel" ] =63      , [ "minlevel" ] =63    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5240  ,["id"] = 50846  ,["coords"] = {{ 57    , 25.6  } ,{57.2,23.8},{57.8,24.4},{58.2,22.4},{58.4,23.2},{58.8,23.4},{59,25.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Isle of Thunder"                 , [ "zoneID" ] = 504  , [ "name" ] = "Goda"                        ,["maxlevel" ] =93      , [ "minlevel" ] =93    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 47809 ,["id"] = 69998  ,["coords"] = {{ 53.6  , 53    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Frostfire Ridge"                , [ "zoneID" ] = 525  , [ "name" ] = "Canyon Icemother"            ,["maxlevel" ] =103     , [ "minlevel" ] =93    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 49096 ,["id"] = 71721  ,["coords"] = {{ 33.8  , 23    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Spires of Arak"                  , [ "zoneID" ] = 542  , [ "name" ] = "Echidna"                     ,["maxlevel" ] =103     , [ "minlevel" ] =99    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55712 ,["id"] = 80372  ,["coords"] = {{ 69.2  , 53.8  } ,{69.4,53},{69.6,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Deathtalon"                  ,["maxlevel" ] =103     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 64266 ,["id"] = 95053  ,["coords"] = {{ 23    , 40.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Keravnos"                    ,["maxlevel" ] =103     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55718 ,["id"] = 80398  ,["coords"] = {{ 39.8  , 82.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Vileclaw"                    ,["maxlevel" ] =103     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 61300 ,["id"] = 88951  ,["coords"] = {{ 37.2  , 39    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Mu'gra"                      ,["maxlevel" ] =103     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 61301 ,["id"] = 87666  ,["coords"] = {{ 34    , 51.6  } ,{34.2,51.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Direhoof"                    ,["maxlevel" ] =103     , [ "minlevel" ] =101   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 56848 ,["id"] = 86729  ,["coords"] = {{ 60.2  , 38.4  } ,{60.2,38.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Thek'talon"                  ,["maxlevel" ] =103     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 61652 ,["id"] = 86750  ,["coords"] = {{ 49.4  , 38    } ,{49.4,38.8},{49.6,38.6},{50,38},{50.2,37},{50.4,40},{50.6,40.2},{50.8,38},{51,36.8},{51.4,40.6},{51.8,39.4},{52,40.2},{52.2,35.6},{53,35.8},{53,39.4},{53,39.6},{53.4,35},{53.8,39},{54.2,34.8},{54.8,34.6},{55,33.4},{55,33.8},{55.2,38},{55.4,37},{55.8,33.6},{55.8,38.2},{56,33.4},{56.4,36.8},{56.8,36.4},{56.8,36.6},{57.2,31.8},{57.4,31.4},{57.8,35.8},{58,35.4},{58.2,30.6},{58.4,30.4},{58.8,34.8},{59,34},{59.4,29.8},{59.8,29.2},{60,32.8},{60.2,32},{60.4,28.4},{60.8,27.2},{60.8,27.8},{60.8,32.2},{61,25.2},{61,31.4},{61.2,22.8},{61.4,22.4},{61.6,22.2},{61.6,31},{61.8,22.6},{62.2,30.2},{62.6,22.8},{63,29.6},{63.2,24.6},{63.2,29.2},{63.4,24.4},{63.6,24.4},{63.6,24.6},{63.8,28.8},{64,28.2},{64.2,29.6},{64.4,26.2},{64.4,26.8},{64.6,27.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Aogexon"                     ,["maxlevel" ] =103     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 59928 ,["id"] = 86774  ,["coords"] = {{ 51.4  , 16    } ,{51.6,16}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Nakk the Thunderer"          ,["maxlevel" ] =103     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 61219 ,["id"] = 50990  ,["coords"] = {{ 50    , 34.2  } ,{54.4,35.6},{55,35.4},{55.2,35.8},{60.2,32},{60.8,31.8},{62.4,14.8},{62.4,15.8},{62.6,18},{64.4,20}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Bergruu"                     ,["maxlevel" ] =103     , [ "minlevel" ] =101   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 58621 ,["id"] = 86732  ,["coords"] = {{ 61    , 12.2  } ,{61.2,12.6},{61.8,12.8},{62.2,17.2},{62.4,14.4},{62.4,15.8},{62.4,17.6},{62.6,17.8},{63.4,19.8},{63.6,19.4},{63.6,19.6},{64.6,20},{65.2,21.4},{65.6,22.2},{65.8,24.6},{66,24.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Xelganak"                    ,["maxlevel" ] =103     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 61274 ,["id"] = 86835  ,["coords"] = {{ 41.4  , 44.8  } ,{41.6,44.4},{41.6,45}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Lernaea"                     ,["maxlevel" ] =103     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55710 ,["id"] = 80370  ,["coords"] = {{ 51.8  , 89.4  } ,{52,89.8},{52.6,90}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Tsavo'ka"                    ,["maxlevel" ] =93      , [ "minlevel" ] =93    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 51132 ,["id"] = 72808  ,["coords"] = {{ 54    , 42.4  } ,{54.2,42.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Bufo"                        ,["maxlevel" ] =93      , [ "minlevel" ] =93    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 291 , "Toad"          } , ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 48112 ,["id"] = 72775  ,["coords"] = {{ 62    , 76.4  } ,{62.2,76.8},{63.4,73},{63.6,72.4},{63.6,72.6},{64.8,74.2},{64.8,74.6},{65.2,69.2},{65.2,69.6},{65.2,70.6},{65.6,69.8},{66.4,67.2},{66.6,65.4},{66.8,66.6},{67,65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Monstrous Spineclaw"         ,["maxlevel" ] =93      , [ "minlevel" ] =93    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 51146 ,["id"] = 73166  ,["coords"] = {{ 17.4  , 52.4  } ,{17.4,52.6},{17.4,72.6},{17.8,72},{18.2,54.6},{18.2,75.2},{18.6,64},{18.8,54},{18.8,54.6},{18.8,57.8},{18.8,58.8},{19,75.6},{20.2,77},{20.4,48},{20.6,47.6},{20.6,70.8},{20.6,77.6},{21,36.2},{21,77.4},{21.2,46.8},{21.2,64.2},{21.4,32.6},{21.4,63.2},{21.6,35.8},{22.2,31},{22.6,30.8},{23.2,34.4},{23.2,35},{23.4,28.4},{23.4,35.8},{23.6,28.2},{23.6,28.6},{23.8,35.2},{23.8,36.8},{24.2,75},{25,74.8},{25.4,74.4},{25.6,74.6},{26.2,73.4},{27,75.2},{27.2,74.4},{27.4,79.8},{27.6,74.2},{28,79.6},{28.2,81.2},{30.6,31.2},{35.4,87},{36.4,86.2},{38,86},{38.6,87.2},{40.2,90.6},{40.4,90.2},{40.8,90.8},{44.8,89.2},{44.8,89.6},{45.6,90.4},{52.2,86.6},{61.6,83.2},{63.2,79.8},{65.4,77.8},{65.6,77.4},{65.6,78},{67.2,77.6},{67.8,78.2},{68,74.2},{68.2,77},{68.8,74.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Stormfeather"                ,["maxlevel" ] =112     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 65235 ,["id"] = 109594 ,["coords"] = {{ 51    , 58    } ,{51.2,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Ala'washte"                  ,["maxlevel" ] =112     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 26  , "Bird of Prey"  } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 68615 ,["id"] = 104481 ,["coords"] = {{ 28.2  , 52.8  } ,{28.4,53.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "BrokenShore"                   , [ "zoneID" ] = 646  , [ "name" ] = "Somber Dawn"                 ,["maxlevel" ] =112     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 76109 ,["id"] = 121112 ,["coords"] = {{ 27    , 60.2  } ,{27,61},{27.4,61.8},{27.8,56.8},{27.8,58.6},{27.8,62.4},{28,57.6},{28,60.4},{28.4,61.2},{28.6,55.6},{28.8,61.6},{29,59.6},{29.2,59.4},{29.2,61.4},{29.6,55.4},{29.6,58.6},{29.8,57.2},{29.8,58.2},{30.2,55.8},{30.8,60.8},{31,55.6},{31,59.2},{31.4,60},{31.6,55.4},{31.6,60.6},{31.8,59.4},{32.2,59.8},{32.4,56.4},{32.4,56.8},{32.6,56.4},{32.6,59},{32.8,57.2},{33,60},{33.2,58},{33.6,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Gorebeak"                    ,["maxlevel" ] =110     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 31979 ,["id"] = 92117  ,["coords"] = {{ 59.4  , 76.4  } ,{59.4,77},{59.6,77.4},{59.6,77.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Golanar"                     ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 76904 ,["id"] = 129027 ,["coords"] = {{ 57.4  , 6.4   } ,{57.4,6.6},{57.6,6.4},{58.2,7},{58.4,7.6},{58.6,7.4},{59.2,8.4},{59.4,8.6},{59.6,8.2},{59.6,8.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }  } ,
  { ["zone_name"] = "Krokuun"                       , [ "zoneID" ] = 830  , [ "name" ] = "Naroua"                      ,["maxlevel" ] =112     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 78926 ,["id"] = 126419 ,["coords"] = {{ 70.4  , 34    } ,{70.6,33.8},{70.8,33},{71,32.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Mac'Aree"                      , [ "zoneID" ] = 882  , [ "name" ] = "Sabuul"                      ,["maxlevel" ] =112     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 79156 ,["id"] = 126898 ,["coords"] = {{ 43    , 47.4  } ,{43.4,48.2},{43.4,48.6},{43.4,49.6},{43.8,46.8},{43.8,48.4},{43.8,49},{44,49.6},{44,50.8},{44.6,49.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Mac'Aree"                      , [ "zoneID" ] = 882  , [ "name" ] = "Umbraliss"                   ,["maxlevel" ] =112     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 32  , "Warp Stalker"  } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 76479 ,["id"] = 126885 ,["coords"] = {{ 34    , 37.8  } ,{34.4,37.4},{34.4,38.6},{34.6,37.2},{34.6,38.6},{34.8,36.4},{34.8,37.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Stormsong Valley"               , [ "zoneID" ] = 942  , [ "name" ] = "Beehemoth"                   ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 83359 ,["id"] = 134147 ,["coords"] = {{ 66.2  , 74.4  } ,{66.2,74.8},{66.6,74.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Vale of Eternal Blossoms"         , [ "zoneID" ] = 1530 , [ "name" ] = "Stormhowl"                   ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 44449 ,["id"] = 157279 ,["coords"] = {{ 23.4  , 76.4  } ,{23.4,77},{23.4,77.6},{23.6,77},{23.6,77.6},{24,76.4},{25,76.2},{25,76.6},{25.4,75.4},{25.8,75.6},{26.4,73.4},{26.4,74.4},{26.4,74.6},{26.6,74.6},{27,73},{27,74},{27.2,71.4},{27.2,72.4},{27.6,72.2},{27.6,72.6},{27.6,73.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Vale of Eternal Blossoms"         , [ "zoneID" ] = 1530 , [ "name" ] = "Jade Watcher"                ,["maxlevel" ] =122     , [ "minlevel" ] =122   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 128 , "Stone Hound"        } , ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 45362 ,["id"] = 157290 ,["coords"] = {{ 26.4  , 10.4  } ,{26.8,10.4},{26.8,11},{27,11.6},{27.4,12.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "The Underrot"                   , [ "zoneID" ] = 1041 , [ "name" ] = "Rotmaw"                      ,["maxlevel" ] =122     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 57548 ,["id"] = 139194 ,["coords"] = {{ 64.8  , 29    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Arathi Highlands"               , [ "zoneID" ] = 14   , [ "name" ] = "Plaguefeather"               ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 7   , "Carrion Bird"  } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 54845 ,["id"] = 142361 ,["coords"] = {{ 67.4  , 40.2  } ,{68.6,33.4},{70,35.4},{71,31.2},{72.2,41.2},{72.6,31.6},{72.6,40.6},{73.4,36.2},{73.8,36.4},{74.2,41.4},{74.4,33},{74.4,34.6},{74.8,33},{75.2,32.2},{75.4,28.6},{75.4,30.4},{75.4,31.2},{75.6,30.8},{75.6,31.6},{75.6,32.6},{75.8,28.4},{76.4,29.2},{76.4,30.2},{76.6,29.4},{76.8,30.8},{77.2,30.2},{77.2,31.6},{77.6,29.2},{77.6,29.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Caverndark Terror"           ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91024 ,["id"] = 152464 ,["coords"] = {{ 42.24 , 13.51 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1500 , [ "name" ] = "Caverndark Terror"           ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91024 ,["id"] = 152464 ,["coords"] = {{ 35.17 , 38.51 }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Ashran"                        , [ "zoneID" ] = 588  , [ "name" ] = "Goregore"                    ,["maxlevel" ] ="????"  , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_RARE_ELITE , ["family"] = { 5   , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 52698 ,["id"] = 84893  ,["coords"] = {{ 34.4  , 53.2  } ,{34.6,53.2},{35.8,53.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Chitterspine Deeplurker"     ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91021 ,["id"] = 152463 ,["coords"] = {{ 71    , 24.6  } ,{71.4,24.2},{71.6,24}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Glimmershell Hulk"           ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 90871 ,["id"] = 152426 ,["coords"] = {{ 40.2  , 49.2  } ,{40.4,48.4},{40.6,49},{42.4,47.8},{42.6,47.4},{42.8,47.8},{43.4,55},{43.6,54.2},{44.4,55.4},{44.4,55.6},{44.6,55.4},{45.4,47},{45.4,47.8},{45.4,55.8},{45.6,47.2},{45.6,47.6},{45.6,55.8},{46,54.4},{46,54.6},{46.8,52.6},{46.8,55.8},{47,51.6},{47,55.4},{49.4,51.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Chitterspine Guillotine"     ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 91021 ,["id"] = 153814 ,["coords"] = {{ 34.8  , 11.4  } ,{35.8,9.6},{36.2,13.6},{36.4,13.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Braxicus"                    ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 90948 ,["id"] = 153026 ,["coords"] = {{ 43.4  , 55.2  } ,{43.4,55.6},{43.6,55.4},{43.6,55.6},{44.2,54.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Siltridge Marauder"          ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90033 ,["id"] = 152541 ,["coords"] = {{ 30.4  , 48.4  } ,{30.4,48.6},{30.8,48.4},{30.8,48.6},{31.2,45.4},{31.2,45.8},{31.4,46.6},{31.6,45.6},{31.6,47.2},{31.8,45.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Stonemaw Devourer"           ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90035 ,["id"] = 152546 ,["coords"] = {{ 34.4  , 42.2  } ,{34.4,42.6},{35,42},{35.2,40.8},{35.2,42.6},{35.4,40.4},{35.6,40.6},{35.8,40},{36.2,39.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Voidscale Trenchstalker"     ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90034 ,["id"] = 152544 ,["coords"] = {{ 27.2  , 42    } ,{28.2,38.4},{28.4,37.2},{28.4,38.6},{28.4,39.6},{28.6,38.4},{28.6,39.2},{28.6,39.6},{28.8,36.6},{29,36.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "ScaleLord Theronar"          ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 90035 ,["id"] = 153801 ,["coords"] = {{ 35.4  , 12.6  } ,{35.6,12.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Colossal SkyRay"             ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 34  , "Ray"           } , ["familySkills" ] = RAY_SKILLS           ,["displayID"] = 92544 ,["id"] = 150467 ,["coords"] = {{ 41.4  , 49.2  } ,{44,53.4},{44.2,54.6},{45.4,55.6},{46,58.6},{46,59.6},{46.2,35.4},{46.4,55},{46.8,59.4},{47,54},{47.2,49.2},{47.2,50.6},{48,59.8},{48.8,54.8},{49.6,54},{50.4,57.4},{50.6,57.6},{51.2,57.4},{51.8,52.8},{51.8,56},{52.2,57.4},{52.6,56.6},{53,55.8},{53.4,55.4},{53.6,55},{54.4,53.6},{54.6,53.6},{54.8,52.8},{55.6,53.2},{56.8,54},{57.6,54.6},{58.4,52.4},{58.4,53.2},{58.4,53.6},{58.6,52.4},{58.6,53.4},{58.6,53.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Deepcoil Constrictor"        ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 74317 ,["id"] = 152551 ,["coords"] = {{ 68.2  , 18.6  } ,{68.4,19.8},{68.4,21.4},{69.2,20.4},{69.2,20.6},{69.2,22.6},{69.4,18.4},{69.4,18.6},{69.4,22.2},{69.6,18.4},{69.6,19.2},{69.6,19.6},{69.8,21.4},{69.8,21.6},{70,22.6},{70.6,19.4},{70.6,19.8},{70.6,22.2},{70.8,20.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Voltscale Guardian"          ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 91862 ,["id"] = 153654 ,["coords"] = {{ 36.8  , 11.4  } ,{37,14.4},{37,15.2},{37.2,16},{37.8,6.4},{37.8,14.4},{38,7},{38.2,18.4},{38.2,18.6},{38.4,8.2},{38.6,8.4},{39,9.4},{39,9.6},{39.4,10.6},{39.6,10.4},{39.8,10.8},{41.2,17.2},{41.4,16.4},{42,17.2},{43,16.2},{43.4,16.6},{43.6,16.4},{43.6,16.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Snapdragon Vicejaw"          ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90764 ,["id"] = 154752 ,["coords"] = {{ 64.6  , 49.4  } ,{64.8,49.6},{67,48.2},{67.6,48.8},{69.4,51},{69.6,51},{70,51.6},{70.4,50.2},{70.6,50.4},{70.6,50.6},{71.4,48.6},{71.6,48.8},{72,49.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Snapdragon Terrormaw"        ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90764 ,["id"] = 152358 ,["coords"] = {{ 67    , 50.2  } ,{67,50.6},{67.4,47.2},{68,47.4},{68.2,47.6},{68.4,45.4},{68.4,46},{68.6,45.8},{69,47.8},{69.2,47},{69.4,49.4},{69.4,49.6},{69.4,51},{69.4,51.8},{69.6,47.8},{69.6,51.6},{69.6,53.4},{69.8,49.2},{69.8,51.4},{70.4,50},{70.4,54},{70.6,50},{70.6,50.6},{71,54.4},{71.2,48.4},{71.4,49},{71.4,54.6},{71.6,48.8},{71.6,49.6},{71.6,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nazjatar"                      , [ "zoneID" ] = 1355 , [ "name" ] = "Snapdragon Matriarch"        ,["maxlevel" ] =121     , [ "minlevel" ] =121   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 90768 ,["id"] = 154422 ,["coords"] = {{ 68.2  , 50.6  } ,{68.4,50.4},{68.6,50.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Utgarde Pinnacle"               , [ "zoneID" ] = 136  , [ "name" ] = "Bloodthirsty TundraWolf"     ,["maxlevel" ] =81      , [ "minlevel" ] =66    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 22089 ,["id"] = 26672  ,["coords"] = {{ 50    , 50    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Lord Skwol"                  ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 800   ,["id"] = 117672 ,["coords"] = {{ 27    , 74.4  } ,{27 ,74.6},{45,41.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }  } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "The Dukeof Fathoms"          ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 62    ,["id"] = 117663 ,["coords"] = {{ 25.4  , 75.6  } ,{25.6,76 },{27,75 },{43.8,42.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Silithus"                      , [ "zoneID" ] = 81   , [ "name" ] = "Deathclasp"                  ,["maxlevel" ] =61      , [ "minlevel" ] =43    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 15327 ,["id"] = 15196  ,["coords"] = {{ 48.2  , 80.6  } ,{48.4,80.4},{48.6,80.4},{49.2,81},{49.4,81.6},{49.4,82.6},{49.6,81.4},{49.6,82}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Dustwallow Marsh"               , [ "zoneID" ] = 70   , [ "name" ] = "Strashaz Hydra"              ,["maxlevel" ] =61      , [ "minlevel" ] =59    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 2423  ,["id"] = 4374   ,["coords"] = {{ 69    , 19.2  } ,{69,19.6},{69.2,15.4},{69.8,17.8},{70.2,20.4},{70.6,20.6},{70.8,20.2},{71,18.4},{71,21.8},{71.2,15.6},{71.8,18.4},{71.8,18.6},{72.8,18.4},{73.4,18.6},{74,18.6},{74.2,16.6},{74.4,15.8},{74.4,17.6},{75,17.8},{75.6,18.4},{75.8,18.6},{76.4,19.8},{76.4,22.2},{76.6,21.2},{76.6,22}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Icecrown"                      , [ "zoneID" ] = 118  , [ "name" ] = "Grimkor's Hound"             ,["maxlevel" ] =80      , [ "minlevel" ] =78    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 52  , "Hound"           } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 27790 ,["id"] = 32163  ,["coords"] = {{ 45.4  , 46    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Northern Stranglethorn"         , [ "zoneID" ] = 50   , [ "name" ] = "CrystalSpine Matriarch"      ,["maxlevel" ] =120     , [ "minlevel" ] =59    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 45467 ,["id"] = 130598 ,["coords"] = {{ 11.4  , 31    } ,{12,30.4},{12,30.6},{12.6,29.8},{11.4,31}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Nagrand"                       , [ "zoneID" ] = 107  , [ "name" ] = "Brokentoe"                   ,["maxlevel" ] =81      , [ "minlevel" ] =65    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 19797 ,["id"] = 18398  ,["coords"] = {{ 43.4  , 20.4  } ,{43.4,20.6},{43.6,20.4},{43.6,20.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Terokkar Forest"                , [ "zoneID" ] = 108  , [ "name" ] = "Deathskitter"                ,["maxlevel" ] =80      , [ "minlevel" ] =74    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 18923 ,["id"] = 18647  ,["coords"] = {{ 53    , 59.8  } ,{53,61.2},{53.4,58.2},{53.4,58.6},{53.4,61.8},{53.4,64.4},{53.4,64.6},{53.6,57.2},{53.6,58.2},{53.6,58.6},{53.6,62.4},{53.6,62.6},{53.8,61.2},{53.8,63.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Terokkar Forest"                , [ "zoneID" ] = 108  , [ "name" ] = "Gezzarak the Huntress"       ,["maxlevel" ] =80      , [ "minlevel" ] =71    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 32  , "Warp Stalker"   } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 21371 ,["id"] = 23163  ,["coords"] = {{ 61.4  , 78    } ,{62,74.6},{69.4,74.6},{69.6,74.6},{70,79.4},{70,79.6},{70.2,83.2},{72.2,88.2},{73.4,80.6},{74.8,87.4},{74.8,87.6},{75.2,81.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Shadowmoon Valley (BC)"              , [ "zoneID" ] = 104  , [ "name" ] = "Uvuros"                      ,["maxlevel" ] =80      , [ "minlevel" ] =68    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 45  , "Core Hound"     } , ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 20522 ,["id"] = 21102  ,["coords"] = {{ 54.4  , 49.4  } ,{55,49.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Zul'Aman"                      , [ "zoneID" ] = 333  , [ "name" ] = "Amani Lynx"                  ,["maxlevel" ] =80      , [ "minlevel" ] =68    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 19705 ,["id"] = 52839  ,["coords"] = {{ 90.4  , 52.2  } ,{90.4,53.2},{90.4,53.6},{90.6,52.4},{90.6,52.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Zul'Aman"                      , [ "zoneID" ] = 333  , [ "name" ] = "Amani Bear"                  ,["maxlevel" ] =85      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 22467 ,["id"] = 23584  ,["coords"] = {{ 30.4  , 64    } ,{31.4,63.4},{31.4,63.6},{31.6,63.2},{31.6,63.6},{32,62.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Zul'Aman"                      , [ "zoneID" ] = 333  , [ "name" ] = "Amani Bear Mount"            ,["maxlevel" ] =85      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 22467 ,["id"] = 24217  ,["coords"] = {{ 34    , 74.4  } ,{34,75.2},{34.4,76},{34.4,76.6},{34.6,75.4},{35,76.6},{35.4,76.2},{35.6,76.4},{35.6,76.6},{37.2,76.8},{37.4,76.4},{38,76.8},{38.2,75.2},{38.2,78.6},{38.4,76.2},{38.4,77.6},{38.6,76},{38.6,76.6},{38.6,77.6},{38.8,75},{39.6,76.6},{39.8,76.2},{40.6,76.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Zul'Aman"                      , [ "zoneID" ] = 333  , [ "name" ] = "AmaniElder Lynx"             ,["maxlevel" ] =85      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 19705 ,["id"] = 24530  ,["coords"] = {{ 58.2  , 50.6  } ,{58.4,49.4},{58.4,50},{58.6,49.4},{58.8,50.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Zul'Aman"                      , [ "zoneID" ] = 333  , [ "name" ] = "Amani Lynx"                  ,["maxlevel" ] =85      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 19705 ,["id"] = 24043  ,["coords"] = {{ 68.4  , 16.4  } ,{68.4,17},{68.4,17.6},{68.6,16.4},{68.6,16.6},{69,15.4},{69.6,15},{72.4,14.4},{72.4,14.6},{72.6,14.4},{73,14.8},{73.6,15},{74.4,15.6},{75.6,17.4},{76,18.4},{76.2,19.4},{76.2,19.6},{76.2,20.6},{76.4,21.6},{76.6,20.4},{76.6,21.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Zul'Aman"                      , [ "zoneID" ] = 333  , [ "name" ] = "Amani Dragonhawk"            ,["maxlevel" ] =85      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 30  , "Dragonhawk"    } , ["familySkills" ] = DRAGONHAWKS_SKILLS   ,["displayID"] = 37573 ,["id"] = 23834  ,["coords"] = {{ 45    , 90.4  } ,{45.4,90.6},{46.4,90.4},{46.4,90.8},{46.6,90.8},{47.4,90.4},{47.6,90.6},{47.8,90.4},{48.6,90.6},{49.2,90.2},{49.4,89.4},{49.6,89.4},{49.6,89.6},{52.6,83.4},{52.8,83.6},{53.8,83.4},{54,83.6},{54.6,83.4},{55.4,84},{55.6,83.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Grizzly Hills"                  , [ "zoneID" ] = 116  , [ "name" ] = "Goremaw"                     ,["maxlevel" ] =80      , [ "minlevel" ] =70    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 24708 ,["id"] = 27578  ,["coords"] = {{ 86.8  , 26.8  } ,{87,26.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Desolace"                      , [ "zoneID" ] = 66   , [ "name" ] = "Enraged Kodo"                ,["maxlevel" ] =60      , [ "minlevel" ] =31    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 1241  ,["id"] = 36094  ,["coords"] = {{ 57.4  , 58.6  } ,{58,58.8},{58.2,58.4},{58.4,55.4},{58.4,55.8},{58.4,59.6},{58.6,55.4},{58.6,55.8},{58.6,58.4},{58.6,58.6},{59.4,57.4},{60.2,57.4},{60.2,57.6},{60.2,59.8},{60.4,55.4},{60.4,56},{60.6,55.8},{60.6,57.4},{61,55.2},{61.4,58.2},{61.6,55.6},{61.6,62},{61.8,57.4},{61.8,57.8},{61.8,58.6},{62.4,54.2},{62.4,54.6},{62.6,54.4},{62.6,54.6},{62.6,56},{63.4,52.6},{64,56.2},{64,57.2},{64.2,57.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Redridge Mountains"             , [ "zoneID" ] = 49   , [ "name" ] = "Blackrock Battle Worg"       ,["maxlevel" ] =60      , [ "minlevel" ] =17    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 780   ,["id"] = 43340  ,["coords"] = {{ 44.4  , 37.8  } ,{45.8,38.6},{46.8,40.4},{47.4,37.6},{47.6,36.4},{48,37.8},{48.2,39.6},{48.4,37.4},{48.8,37.4},{49.2,38},{49.2,39},{49.6,38.4},{49.6,38.6},{50.4,40.2},{50.4,40.6},{50.6,38.8},{51.4,39.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Tanaris"                       , [ "zoneID" ] = 71   , [ "name" ] = "Sarinexx"                    ,["maxlevel" ] =60      , [ "minlevel" ] =40    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 25089 ,["id"] = 39149  ,["coords"] = {{ 51.4  , 28.4  } ,{51.6,28.2},{51.6,28.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "The Hinterlands"                , [ "zoneID" ] = 26   , [ "name" ] = "Shadra"                      ,["maxlevel" ] =60      , [ "minlevel" ] =37    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 33275 ,["id"] = 43007  ,["coords"] = {{ 34.2  , 69.8  } ,{34.2,70.8},{34.4,69.4},{34.6,69.4},{34.6,69.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Devilsaur"                   ,["maxlevel" ] =60      , [ "minlevel" ] =45    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5239  ,["id"] = 6498   ,["coords"] = {{ 32.6  , 37.4  } ,{32.8,40},{33.2,38.4},{34.6,30.8},{36.2,36},{37.4,41.8},{37.4,43.6},{38.2,44.4},{40,59.6},{42,62.6},{42.8,61.6},{44,78.8},{44.2,66},{45,77.8},{46.2,64.8},{46.4,63.6},{57.6,69.6},{59,74.4},{59.2,71.6},{59.4,70.8},{59.8,71.8},{60.2,61.4},{61.4,64},{61.8,68},{64.8,31.8},{69.2,57.4},{70.2,26.2},{70.2,26.6},{73.8,37.6},{75.4,43},{75.8,40.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Ironhide Devilsaur"          ,["maxlevel" ] =60      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5238  ,["id"] = 6499   ,["coords"] = {{ 31    , 58.8  } ,{33,42.6},{33.4,38.8},{33.6,37},{33.6,39},{34.4,38},{35.6,29.4},{35.6,30.2},{35.8,30.6},{36.4,34.6},{37.2,40.6},{37.4,41.8},{37.8,45},{38,44.2},{38.4,47.4},{39.8,46},{44.4,67.4},{44.6,71.8},{45.2,65.2},{45.2,68.2},{45.2,70.2},{45.8,69},{46,74.6},{48.2,62.2},{58.6,69.8},{61.2,56.6},{61.6,52.8},{61.6,61.4},{62,68.2},{69.8,30.8},{70.2,26.6},{70.4,30.4},{70.6,27.2},{70.6,27.8},{70.8,29.4},{73.8,38},{74.4,41.2},{75.2,41.4},{75.4,43.2},{75.6,43},{75.6,43.8},{75.8,42.2},{76.8,45}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Tyrant Devilsaur"            ,["maxlevel" ] =60      , [ "minlevel" ] =42    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5240  ,["id"] = 6500   ,["coords"] = {{ 32.4  , 37.2  } ,{34,28.6},{34.2,37.6},{35.6,30.4},{35.6,30.6},{35.6,36.4},{35.6,37.6},{35.6,40.4},{35.8,35.2},{36,31.8},{38.4,44.2},{39.2,52.2},{39.4,59.2},{39.8,46},{44.8,77},{59.8,65.4},{60.4,63.6},{61.2,63},{66.2,33},{70.2,26.4},{70.2,26.6},{70.6,27.6},{71.2,29.4},{71.4,30.8},{74.4,42},{74.4,43.4},{75.2,41.2},{75.4,43},{75.4,43.6},{75.4,46},{75.8,42.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Devilsaur Queen"             ,["maxlevel" ] =60      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 5305  ,["id"] = 38346  ,["coords"] = {{ 34.4  , 81.2  } ,{34.6,81.2},{35,81.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Spiked Stegodon"             ,["maxlevel" ] =60      , [ "minlevel" ] =44    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 5288  ,["id"] = 6503   ,["coords"] = {{ 25.4  , 54    } ,{25.6,53.8},{25.6,59.2},{26.8,67.2},{28,64.6},{28.4,58},{28.4,58.6},{28.6,58.8},{28.6,68.4},{28.8,63.8},{29.8,77.2},{30,66},{30,72.4},{30.2,61.2},{32,69.2},{33.4,78.2},{36,74.2},{37.2,67},{37.2,67.6},{41,72},{41,72.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Plated Stegodon"             ,["maxlevel" ] =61      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 5287  ,["id"] = 6502   ,["coords"] = {{ 25.6  , 59.2  } ,{26.6,55.4},{26.6,66.8},{26.8,56},{28.2,58.6},{28.4,58.4},{28.4,64.2},{28.8,58.6},{29.4,61},{29.8,64.6},{30,72.6},{30.2,72.4},{31.8,63.8},{31.8,69.2},{32,74.8},{32.8,74.4},{33.6,66.4},{33.8,61.2},{33.8,61.6},{33.8,77.6},{35.4,64},{35.8,69.2},{37.4,77},{38.8,69.4},{39.4,57.8},{39.4,62.4},{39.4,63.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Stegodon"                    ,["maxlevel" ] =61      , [ "minlevel" ] =46    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 5241  ,["id"] = 6501   ,["coords"] = {{ 25.6  , 53.8  } ,{26.4,66.4},{26.6,56.2},{27,64.6},{28.2,58.8},{28.4,58.4},{28.4,63.8},{29.8,66},{30,61.2},{30,72.6},{30.2,61.8},{30.2,72},{30.6,64},{31.8,69.6},{32,74.6},{32.2,74.4},{33.6,66.4},{33.8,72.6},{33.8,77.2},{35.4,64.8},{35.6,69.4},{36.8,71.6},{37,77.6},{37.2,61.2},{37.4,61.6},{37.4,67.2},{38.6,68.6},{41,71.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Thunderstomp Stegodon"       ,["maxlevel" ] =61      , [ "minlevel" ] =49    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 5289  ,["id"] = 6504   ,["coords"] = {{ 25.8  , 53.4  } ,{27,67.4},{29.8,61.6},{31.2,63.8},{32,74.6},{37.4,61.4},{40.8,77.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Un'Goro Crater"                 , [ "zoneID" ] = 78   , [ "name" ] = "Gorishi Fledgling Colossus"  ,["maxlevel" ] =62      , [ "minlevel" ] =43    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 41  , "Aqiri"      } , ["familySkills" ] = SILITHID_SKILLS      ,["displayID"] = 31045 ,["id"] = 38305  ,["coords"] = {{ 46.6  , 86.8  } ,{47.4,86.4},{47.6,86.4},{47.6,86.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Halls of Origination"            , [ "zoneID" ] = 279  , [ "name" ] = "Venomous Skitterer"          ,["maxlevel" ] =90      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 37241 ,["id"] = 39440  ,["coords"] = {{ 79.6  , 49.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Halls of Origination"            , [ "zoneID" ] = 279  , [ "name" ] = "Blistering Scarab"           ,["maxlevel" ] =90      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 34900 ,["id"] = 40310  ,["coords"] = {{ 76.4  , 49.4  } ,{76.4,49.6},{76.6,49.6},{77,49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "The Bastion of Twilight"          , [ "zoneID" ] = 294  , [ "name" ] = "Lava Scarab"                 ,["maxlevel" ] =85      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 53  , "Beetle"        } , ["familySkills" ] = BEETLE_SKILLS        ,["displayID"] = 86670 ,["id"] = 47079  ,["coords"] = {{ 52    , 45    } ,{52,47.8},{52.6,46.4},{52.8,44},{54.2,41.8},{54.4,45.2},{55.4,39},{55.4,44.4},{55.4,45.6},{55.4,46.8},{55.4,47.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Molten Front"                   , [ "zoneID" ] = 338  , [ "name" ] = "Lost Emberspit Scorpion"     ,["maxlevel" ] =120     , [ "minlevel" ] =86    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 38123 ,["id"] = 123636 ,["coords"] = {{ 42.6  , 45.2  } ,{42.6,49.6},{43.4,46.4},{43.4,48.4},{44.6,49.6},{50.8,52.2},{50.8,55},{51.6,51.2},{51.6,53.6},{52,55},{53,49.6},{53,55.8},{53,57.8},{53.6,55.2},{54.2,54},{54.2,55.6},{54.4,52.6},{54.4,57.6},{56.4,49.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "The Jade Forest"                 , [ "zoneID" ] = 371  , [ "name" ] = "Rakira"                      ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 43104 ,["id"] = 66622  ,["coords"] = {{ 56    , 74.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "The Jade Forest"                 , [ "zoneID" ] = 371  , [ "name" ] = "Savage"                      ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 40719 ,["id"] = 50850  ,["coords"] = {{ 35.8  , 57.4  } ,{35.8,57.8},{36.6,45},{37.4,63.4},{37.6,51.8},{43.2,37.2},{44.6,39},{46,37},{46.2,38.8},{46.4,36},{46.8,35.2},{47,29.8},{47,32.8},{47.8,29},{49,29.4},{51.2,30.8},{52.8,30.8},{53,24.6},{53.2,24},{54.6,28.2},{54.8,38.2},{55.4,29},{55.8,32.2},{56,32.6},{56.6,34},{56.8,30.2},{57,37.8},{57.2,35.4},{57.4,35.6},{57.4,37.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "The Jade Forest"                 , [ "zoneID" ] = 371  , [ "name" ] = "Ruukti"                      ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 45258 ,["id"] = 66633  ,["coords"] = {{ 62.2  , 74.6  } ,{62.4,74.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "The Jade Forest"                 , [ "zoneID" ] = 371  , [ "name" ] = "Ro'shen"                     ,["maxlevel" ] =90      , [ "minlevel" ] =84    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 44486 ,["id"] = 66617  ,["coords"] = {{ 65.2  , 78.6  } ,{65.4,78.4},{65.6,78.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "The Jade Forest"                 , [ "zoneID" ] = 371  , [ "name" ] = "Hutia"                       ,["maxlevel" ] =90      , [ "minlevel" ] =81    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 46  , "Spirit Beast"   } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 47777 ,["id"] = 69946  ,["coords"] = {{ 48.2  , 27.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "The Jade Forest"                 , [ "zoneID" ] = 371  , [ "name" ] = "Sungraze Behemoth"           ,["maxlevel" ] =90      , [ "minlevel" ] =80    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 45087 ,["id"] = 58895  ,["coords"] = {{ 27.4  , 59.6  } ,{27.6,59.4},{27.6,59.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "The Jade Forest"                 , [ "zoneID" ] = 371  , [ "name" ] = "Glimmer"                     ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 126 , "Water Strider"  } , ["familySkills" ] = WATER_STRIDER_SKILLS ,["displayID"] = 42271 ,["id"] = 50859  ,["coords"] = {{ 38.2  , 73    } ,{39.6,67}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "The Jade Forest"                 , [ "zoneID" ] = 371  , [ "name" ] = "Chibee"                      ,["maxlevel" ] =90      , [ "minlevel" ] =80    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 43342 ,["id"] = 59756  ,["coords"] = {{ 46.6  , 70.8  } ,{47.2,68.2},{47.6,67.8},{48.6,71.8},{48.8,69.4},{48.8,70.6},{48.8,72.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Valley of the Four Winds"          , [ "zoneID" ] = 376  , [ "name" ] = "Patrannache"                 ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 125 , "Crane"         } , ["familySkills" ] = CRANE_SKILLS         ,["displayID"] = 39729 ,["id"] = 50885  ,["coords"] = {{ 20.6  , 47.8  } ,{21.6,58},{57.6,70}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Valley of the Four Winds"          , [ "zoneID" ] = 376  , [ "name" ] = "Degu"                        ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 46  , "Spirit Beast"   } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 47778 ,["id"] = 69947  ,["coords"] = {{ 41.4  , 78    } ,{42,77.8},{42.2,77.4},{43.2,77},{43.8,77},{45.2,76.8},{45.8,76.6},{46.2,76.4},{46.6,76.4},{46.8,76.6},{48.2,76.6},{48.6,76.8},{49.2,77.6},{50,77.8},{50.2,77.4},{50.6,77.6},{50.8,77.2},{51.8,77.6},{52,77.4},{52.8,77.2},{53,77.8},{53.6,77.4},{53.8,77.6},{54.6,77},{55.6,76.8},{56,77.8},{57.2,77},{57.4,77.6},{58,77.2},{59.2,77},{59.8,76.6},{60.4,76.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Valley of the Four Winds"          , [ "zoneID" ] = 376  , [ "name" ] = "Mothallus"                   ,["maxlevel" ] =92      , [ "minlevel" ] =84    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 37  , "Moth"          } , ["familySkills" ] = MOTH_SKILLS          ,["displayID"] = 44770 ,["id"] = 57421  ,["coords"] = {{ 64.4  , 57.8  } ,{64.6,57.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Valley of the Four Winds"          , [ "zoneID" ] = 376  , [ "name" ] = "Darkhide"                    ,["maxlevel" ] =92      , [ "minlevel" ] =83    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 44478 ,["id"] = 58435  ,["coords"] = {{ 26    , 75.4  } ,{26,75.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Vale of Eternal Blossoms"         , [ "zoneID" ] = 390  , [ "name" ] = "Portent"                     ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 128 , "Stone Hound"        } , ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 45427 ,["id"] = 50843  ,["coords"] = {{ 13.6  , 37.4  } ,{14.4,46.8},{15,40.2},{17.6,53},{50,32.6},{63.2,64.8},{65.8,60},{68,44.8},{68,58.2},{70,22},{71,22},{78.2,25.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Kun-Lai Summit"                 , [ "zoneID" ] = 379  , [ "name" ] = "Enraged Mushan"              ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 156 , "Scalehide"     } , ["familySkills" ] = SCALEHIDE_SKILLS     ,["displayID"] = 41539 ,["id"] = 60623  ,["coords"] = {{ 66.4  , 77.2  } ,{66.4,77.6},{66.8,76.4},{66.8,76.8},{66.8,78.8},{67.2,78.4},{67.8,76.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Kun-Lai Summit"                 , [ "zoneID" ] = 379  , [ "name" ] = "Furious Gruffhorn"                ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 129 , "Gruffhorn"          } , ["familySkills" ] = GRUFFHORN_SKILLS          ,["displayID"] = 41073 ,["id"] = 60668  ,["coords"] = {{ 53.4  , 65.4  } ,{53.4,65.6},{53.6,65.4},{53.6,65.6},{53.8,64.4},{54.6,65},{54.6,65.8},{55.2,64.2},{55.6,63.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Kun-Lai Summit"                 , [ "zoneID" ] = 379  , [ "name" ] = "King Spineclaw"              ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 45167 ,["id"] = 66472  ,["coords"] = {{ 44    , 20.8  } ,{44.2,23.8},{45.6,20.4},{48.6,18.8},{51.8,18.8},{53.2,19.8},{55.2,21.4},{56.8,21.6},{58.4,21.4},{58.4,21.6},{58.6,21.4},{58.6,21.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Kun-Lai Summit"                 , [ "zoneID" ] = 379  , [ "name" ] = "Stompy"                      ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 129 , "Gruffhorn"          } , ["familySkills" ] = GRUFFHORN_SKILLS          ,["displayID"] = 40022 ,["id"] = 50998  ,["coords"] = {{ 38    , 49    } ,{39.2,54.8},{39.8,47.8},{42,45.6},{43,53.2},{44.8,48.6},{45.2,47.6},{45.4,45.8},{46.6,48.2},{49.2,58.2},{50.4,58.6},{50.8,59},{51.6,56.6},{51.6,60.2},{52.6,54.8},{54.4,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Kun-Lai Summit"                 , [ "zoneID" ] = 379  , [ "name" ] = "Gumi"                        ,["maxlevel" ] =90      , [ "minlevel" ] =82    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 46  , "Spirit Beast"   } , ["familySkills" ] = SPIRIT_BEAST_SKILLS  ,["displayID"] = 47776 ,["id"] = 69943  ,["coords"] = {{ 54.2  , 57.6  } ,{54.4,57.4},{54.6,57.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Kun-Lai Summit"                 , [ "zoneID" ] = 379  , [ "name" ] = "Bristlespine"                ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 127 , "Rodent"        } , ["familySkills" ] = RODENT_SKILLS        ,["displayID"] = 41004 ,["id"] = 50944  ,["coords"] = {{ 45.2  , 81.6  } ,{48.4,85.2},{53,85.8},{62,84.6},{64.4,86.4},{65.4,81.4},{65.8,85.2},{66,79},{73.2,70.8},{73.6,53.4},{74,70},{74.6,68}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Kun-Lai Summit"                 , [ "zoneID" ] = 379  , [ "name" ] = "Zhing"                       ,["maxlevel" ] =91      , [ "minlevel" ] =88    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 129 , "Gruffhorn"          } , ["familySkills" ] = GRUFFHORN_SKILLS          ,["displayID"] = 45163 ,["id"] = 66464  ,["coords"] = {{ 39    , 52.4  } ,{39,55.6},{39.2,54.4},{39.2,54.8},{39.4,53.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Townlong Steppes"               , [ "zoneID" ] = 388  , [ "name" ] = "Rockhide the Immovable"      ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 45464 ,["id"] = 51013  ,["coords"] = {{ 53.8  , 73.6  } ,{61.4,78.2},{65.4,62.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Krasarang Wilds"                , [ "zoneID" ] = 418  , [ "name" ] = "Bloodtooth"                  ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 45487 ,["id"] = 50854  ,["coords"] = {{ 14.8  , 45.6  } ,{46.2,62.6},{48,59.8},{48.8,53.2},{50.2,65.6},{51.6,67.2},{54.2,49.2},{56.4,44},{57,45},{67.2,36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Krasarang Wilds"                , [ "zoneID" ] = 418  , [ "name" ] = "Bombyx"                      ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 46461 ,["id"] = 67820  ,["coords"] = {{ 31    , 43.6  } ,{31.6,45},{31.8,46},{32,47.4},{32,47.6},{32.6,48},{34.2,45.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Krasarang Wilds"                , [ "zoneID" ] = 418  , [ "name" ] = "Venerable Viseclaw"          ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 45334 ,["id"] = 66748  ,["coords"] = {{ 10.2  , 44.6  } ,{10.8,44.2},{11,45.8},{11.2,46.8},{11.4,45.4},{11.4,47.6},{11.6,45},{11.6,47.4},{11.8,48.6},{12,48.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Krasarang Wilds"                , [ "zoneID" ] = 418  , [ "name" ] = "Elder Viseclaw"              ,["maxlevel" ] =90      , [ "minlevel" ] =81    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 45058 ,["id"] = 61091  ,["coords"] = {{ 41    , 62.8  } ,{47.8,54.2},{53.8,45},{55.4,44},{55.8,44},{56.2,46.8},{56.2,47.6},{56.4,46.4},{56.6,46.2},{56.8,49.6},{57,46.8},{58.2,43},{58.6,43.8},{60.2,40.6},{60.8,40.4},{61.4,39.2},{61.8,39.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Krasarang Wilds"                , [ "zoneID" ] = 418  , [ "name" ] = "Feverbite"                   ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 40321 ,["id"] = 58883  ,["coords"] = {{ 18.2  , 41.6  } ,{18.4,45.4},{18.4,45.6},{18.6,45.2},{18.6,45.6},{19.4,44.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Krasarang Wilds"                , [ "zoneID" ] = 418  , [ "name" ] = "Elder Seadragon"             ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 44784 ,["id"] = 58940  ,["coords"] = {{ 70.4  , 34.2  } ,{70.6,33.8},{71.4,33.2},{71.6,33.2},{73.8,31.2},{74,31.8},{74.2,29.8},{74.6,32.6},{75,29.4},{77.6,27.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Krasarang Wilds"                , [ "zoneID" ] = 418  , [ "name" ] = "Snapclaw"                    ,["maxlevel" ] =92      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 45062 ,["id"] = 60401  ,["coords"] = {{ 73.4  , 38.2  } ,{73.6,38.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Dread Wastes"                   , [ "zoneID" ] = 422  , [ "name" ] = "Hexapos"                     ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 126 , "Water Strider"  } , ["familySkills" ] = WATER_STRIDER_SKILLS ,["displayID"] = 20917 ,["id"] = 50960  ,["coords"] = {{ 30    , 53.8  } ,{32.6,23.4},{33.6,23.6},{36,24.8},{40,52.6},{42,25.2},{42.8,51.6},{43.6,52.2},{44.2,53},{44.2,53.6},{50,65},{55,66.6},{56,66.6},{56.6,66.2},{59.2,22.2},{60.4,22.2},{60.6,22.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Dread Wastes"                   , [ "zoneID" ] = 422  , [ "name" ] = "Dread Matriarch"             ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 44486 ,["id"] = 66187  ,["coords"] = {{ 55    , 63.4  } ,{55.4,63.6},{55.8,63.8},{59.4,39.8},{60.2,38},{66.4,41.8},{66.8,42.4},{66.8,43.8},{66.8,44.6},{67,43.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Dread Wastes"                   , [ "zoneID" ] = 422  , [ "name" ] = "Pengsong"                    ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 157 , "Oxen"          } , ["familySkills" ] = OXEN_SKILLS          ,["displayID"] = 45242 ,["id"] = 66587  ,["coords"] = {{ 51.4  , 69    } ,{51.4,71.6},{51.6,69.4},{51.6,71.4},{51.8,70.2},{51.8,71.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Dread Wastes"                   , [ "zoneID" ] = 422  , [ "name" ] = "Ik'thik Amberstinger"        ,["maxlevel" ] =90      , [ "minlevel" ] =84    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 43143 ,["id"] = 63728  ,["coords"] = {{ 58    , 71.4  } ,{58,71.6},{58.4,76.4},{58.4,76.6},{58.6,76.2},{58.8,73.2},{60.8,65.6},{60.8,70.4},{61,65.2},{61,68.4},{61,69},{61,71},{61,71.6},{61.2,73.4},{61.2,73.8},{61.4,63.4},{61.4,63.6},{61.6,63.4},{61.6,63.6},{61.6,70.4},{61.6,73.8},{61.8,70.8},{62.4,68.4},{62.8,68.4},{63,68.6},{64,70.6},{64.2,70.4},{64.4,67.2},{64.4,67.6},{64.6,66.4},{64.6,67.2},{64.6,67.6},{64.6,70.6},{65,69.6},{65.2,69.4},{66.2,66.4},{66.2,66.8},{66.2,67.6},{66.6,66.4},{66.8,66.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Dread Wastes"                   , [ "zoneID" ] = 422  , [ "name" ] = "Ik'thik Terrorclaw"          ,["maxlevel" ] =90      , [ "minlevel" ] =84    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 20  , "Scorpid"       } , ["familySkills" ] = SCORPID_SKILLS       ,["displayID"] = 43143 ,["id"] = 65632  ,["coords"] = {{ 57.4  , 46.2  },{57.8,46.4},{58,46.8},{61.4,47.6},{61.8,47.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }  } ,
  { ["zone_name"] = "Mount Hyjal"                    , [ "zoneID" ] = 198  , [ "name" ] = "Smolderos the Carbonizer"    ,["maxlevel" ] =90      , [ "minlevel" ] =86    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 45  , "Core Hound"     } , ["familySkills" ] = COREHOUND_SKILLS     ,["displayID"] = 10193 ,["id"] = 39348  ,["coords"] = {{ 77.6  , 63    } ,{77.6,64.2},{78.6,64.2},{79,64.8},{80,62.6},{80,65},{81,65},{83.8,64.4},{84.4,62.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Crypt of Forgotten Kings"         , [ "zoneID" ] = 481  , [ "name" ] = "Guardian of Sacrifice"        ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 128 , "Stone Hound"        } , ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 41233 ,["id"] = 71491  ,["coords"] = {{ 39.4  , 38    } ,{39.4,43},{39.6,37.8},{39.6,43.4},{40,36.6},{40.4,44.4},{40.6,44.4},{41.4,44.6},{47.4,62.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Crypt of Forgotten Kings"         , [ "zoneID" ] = 481  , [ "name" ] = "Quilen Watcher"              ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 128 , "Stone Hound"        } , ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 46049 ,["id"] = 62254  ,["coords"] = {{ 61.6  , 83.2  } ,{62.2,80.4},{62.4,81},{62.4,81.4},{62.4,82.2},{62.4,85.4},{63,85.6},{63.2,83.6},{63.2,84.2},{63.2,85},{63.4,80.2},{63.4,80.4},{63.4,81.4},{63.4,82},{63.4,82.4},{63.4,82.8},{63.4,83.4},{63.4,84.6},{63.6,81.8},{63.8,82.6},{64,80.8},{64,84.2},{64,85},{64,85.8},{64.2,80.2},{64.2,80.4},{64.2,81.4},{64.2,81.8},{64.2,84},{64.4,82.6},{64.4,84.8},{64.6,80.4},{64.6,81.4},{64.6,81.8},{64.6,84.2},{64.8,80.2},{64.8,81.4},{64.8,82.2},{64.8,83},{64.8,84.8},{65,82.6},{65,84},{65.4,84.6},{65.4,85.8},{65.6,80.2},{65.6,81.2},{65.6,82},{65.6,82.6},{65.6,83},{65.6,84.4},{65.6,84.8},{65.8,86},{66,80.4},{66.6,83},{66.6,83.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Crypt of Forgotten Kings"         , [ "zoneID" ] = 481  , [ "name" ] = "Quilen Statue"               ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 128 , "Stone Hound"        } , ["familySkills" ] = QUILLEN_SKILLS       ,["displayID"] = 42157 ,["id"] = 61565  ,["coords"] = {{ 58.8  , 86.2  } ,{58.8,86.6},{59.8,87},{63.4,81},{64,80.4},{64,80.6},{64,88},{67.6,87.8},{69.6,85}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Dragonblight"                  , [ "zoneID" ] = 115  , [ "name" ] = "Hulking Jormungar"           ,["maxlevel" ] =81      , [ "minlevel" ] =63    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 42  , "Worm"          } , ["familySkills" ] = WORMS_SKILLS         ,["displayID"] = 24564 ,["id"] = 26293  ,["coords"] = {{ 58    , 22.4  } ,{58.2,22.6},{58.2,25.6},{58.4,24.2},{58.4,25.4},{58.6,24.4},{58.6,25},{58.8,21},{58.8,22.8},{59.2,21.6},{59.6,22.8},{59.6,24.2},{59.6,26.6},{60.4,26.4},{60.6,27.2},{60.8,28.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Isle of Thunder"                 , [ "zoneID" ] = 504  , [ "name" ] = "Bloodrender Devilsaur"       ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 47249 ,["id"] = 69148  ,["coords"] = {{ 49.6  , 49.6  } ,{49.8,48.8},{50.2,51},{50.4,47.4},{50.4,47.6},{50.6,51.4},{50.6,52},{50.8,47.2},{50.8,47.6},{51.4,46.2},{51.6,45.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Isle of Thunder"                 , [ "zoneID" ] = 504  , [ "name" ] = "Kroshik"                     ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 47355 ,["id"] = 69218  ,["coords"] = {{ 48.6  , 80.2  } ,{49.2,81.4},{49.2,81.6},{49.4,79.4},{50.2,78.6},{50.2,83.2},{50.4,78.4},{51,78.4},{51.2,83},{51.4,78.6},{51.6,78.6},{51.8,78.4},{52.2,82.8},{52.6,82.6},{53,82.2},{53.4,77.6},{54,78.2},{54.4,79},{54.4,79.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Isle of Thunder"                 , [ "zoneID" ] = 504  , [ "name" ] = "Kroshik"                     ,["maxlevel" ] =90      , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 47355 ,["id"] = 70226  ,["coords"] = {{ 55    , 87.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Isle of Thunder"                 , [ "zoneID" ] = 504  , [ "name" ] = "Adolescent Direhorn"         ,["maxlevel" ] =92      , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47805 ,["id"] = 67576  ,["coords"] = {{ 48.4  , 41.4  } ,{48.4,41.6},{48.8,41},{48.8,41.6},{50,34},{50.4,36.2},{50.6,32.8},{50.6,36.2},{50.8,33.6},{51.4,37.6},{51.6,37.4},{51.6,37.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Isle of Thunder"                 , [ "zoneID" ] = 504  , [ "name" ] = "Zandalari Battlebeast"       ,["maxlevel" ] =9999    , [ "minlevel" ] =9999  , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47660 ,["id"] = 69795  ,["coords"] = {{ 49.6  , 49.2  } ,{50,50.2},{50.4,47.4},{50.4,47.6},{50.4,51.2},{50.6,47.2},{50.8,47.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Isle of Thunder"                 , [ "zoneID" ] = 504  , [ "name" ] = "Defiant Direhorn"            ,["maxlevel" ] =9999    , [ "minlevel" ] =9999  , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47660 ,["id"] = 69277  ,["coords"] = {{ 45.2  , 33.8  } ,{51.4,33.8},{51.6,33.6},{51.8,32.8},{51.8,35.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Kil'uun"                     ,["maxlevel" ] =102     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 7   , "Carrion Bird"   } , ["familySkills" ] = CARRION_BIRD_SKILLS  ,["displayID"] = 58718 ,["id"] = 77430  ,["coords"] = {{ 66    , 33.4  } ,{66,34},{66.2,31.2},{66.2,34.6},{66.4,28.8},{66.4,32},{66.6,32.6},{66.6,35.4},{66.6,36},{66.8,28.6},{66.8,29.8},{67,28.2},{67,34.4},{67.2,30.8},{67.4,37},{67.6,37.2},{67.8,28},{68.4,27.2},{68.8,27.6},{69.2,25.8},{69.2,27.2},{69.2,37},{69.4,25.4},{69.6,26.2},{69.6,26.8},{69.6,37.2},{70,29},{70,37.8},{70.2,25},{70.8,38},{71,24.6},{71.2,24.2},{71.4,36.6},{71.6,36.6},{71.8,24},{71.8,28.6},{72,36},{72.2,35.4},{72.4,24.6},{72.6,24.4},{72.6,25},{72.6,35},{72.6,35.8},{72.8,29.8},{73,26},{73,29},{73,31.4},{73,32.4},{73,33.2},{73.2,26.6},{73.2,27.8},{73.2,33.8},{73.6,28}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Grom'kar Warbeast"           ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 61679 ,["id"] = 85537  ,["coords"] = {{ 74    , 8.4   } ,{74,8.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }  } ,
  { ["zone_name"] = "Talador"                       , [ "zoneID" ] = 535  , [ "name" ] = "Hilaani"                     ,["maxlevel" ] =102     , [ "minlevel" ] =97    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 52749 ,["id"] = 77431  ,["coords"] = {{ 66.4  , 64.8  } ,{66.6,65.2},{66.6,65.6},{66.8,64.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "The Storm Peaks"                 , [ "zoneID" ] = 120  , [ "name" ] = "Oloh"                        ,["maxlevel" ] =81      , [ "minlevel" ] =79    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 27042 ,["id"] = 30456  ,["coords"] = {{ 65.4  , 60    } ,{65.6,60}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Shadowmoon Valley"              , [ "zoneID" ] = 539  , [ "name" ] = "Shadowmoon Packleader"       ,["maxlevel" ] =100     , [ "minlevel" ] =95    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 56156 ,["id"] = 82307  ,["coords"] = {{ 39.4  , 65.6  } ,{39.8,66},{40.2,60.4},{40.2,61.2},{40.2,64.2},{40.4,59.2},{40.4,61.8},{40.4,62.6},{40.6,62.6},{40.6,63.6},{40.8,59.4},{40.8,60.4},{41.2,61},{41.4,61.6},{41.6,61.8},{42,61.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Shadowmoon Valley"              , [ "zoneID" ] = 539  , [ "name" ] = "Maa'run"                     ,["maxlevel" ] =102     , [ "minlevel" ] =93    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 53222 ,["id"] = 76442  ,["coords"] = {{ 51.8  , 54    } ,{52,54.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Shadowmoon Valley"              , [ "zoneID" ] = 539  , [ "name" ] = "Kliaa"                       ,["maxlevel" ] =102     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 61634 ,["id"] = 76438  ,["coords"] = {{ 24.4  , 36.4  } ,{24.4,36.6},{24.6,36.4},{24.6,36.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Frostfire Ridge"                , [ "zoneID" ] = 525  , [ "name" ] = "Blazing Pyreclaw"            ,["maxlevel" ] =100     , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 54957 ,["id"] = 80241  ,["coords"] = {{ 42    , 65.8  } ,{42.4,65.2},{42.8,64.8},{43.2,67.4},{43.6,65.6},{44.2,66.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Frostfire Ridge"                , [ "zoneID" ] = 525  , [ "name" ] = "Ironwing Flamespitter"       ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 58013 ,["id"] = 86373  ,["coords"] = {{ 82    , 58    } ,{82.4,56.8},{82.6,56.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Frostfire Ridge"                , [ "zoneID" ] = 525  , [ "name" ] = "Chilltongue"                 ,["maxlevel" ] =100     , [ "minlevel" ] =95    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 53817 ,["id"] = 76477  ,["coords"] = {{ 65.8  , 65.4  } ,{65.8,65.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Frostfire Ridge"                , [ "zoneID" ] = 525  , [ "name" ] = "Icemaw Matriarch"            ,["maxlevel" ] =100     , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 55671 ,["id"] = 80321  ,["coords"] = {{ 38.8  , 55.6  } ,{39,55},{39.6,55.2},{39.8,57.6},{40,57.2},{40.2,56.2},{41.4,57.4},{41.4,57.8},{41.8,58.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Frostfire Ridge"                , [ "zoneID" ] = 525  , [ "name" ] = "Nok-Karosh"                  ,["maxlevel" ] =100     , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 61674 ,["id"] = 81001  ,["coords"] = {{ 13    , 50.4  } ,{13.2,50.6},{13.6,51}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Frostfire Ridge"                , [ "zoneID" ] = 525  , [ "name" ] = "Garn Nighthowl"              ,["maxlevel" ] =100     , [ "minlevel" ] =90    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 61675 ,["id"] = 81000  ,["coords"] = {{ 11.6  , 47.8  } ,{12,49.6},{12.4,45.2},{12.6,48.2},{12.8,52.8},{13,50.4},{13.2,50.6},{13.2,55.2},{13.6,51},{13.8,49.6},{13.8,55},{13.8,55.8},{14,52},{14.6,56.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Roardan the Sky Terror"      ,["maxlevel" ] =100     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 58290 ,["id"] = 77093  ,["coords"] = {{ 50.8  , 67.4  } ,{50.8,67.6},{51.2,65.6},{53,63},{60.8,66.4},{61.4,61.6},{61.6,61.4},{61.6,61.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Charl Doomwing"              ,["maxlevel" ] =100     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 56432 ,["id"] = 81548  ,["coords"] = {{ 45.2  , 51.6  } ,{45.4,49},{45.6,50},{46,46.8},{47.8,46.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Iron Banshee"                ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 59913 ,["id"] = 85184  ,["coords"] = {{ 47.6  , 30.8  } ,{47.8,21.2},{48.2,30.4},{48.4,22.4},{48.6,22},{48.6,30.2},{48.8,23.6},{49.2,22.6},{49.4,27.8},{49.8,23.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Khargax the Devourer"        ,["maxlevel" ] =100     , [ "minlevel" ] =92    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 56429 ,["id"] = 81537  ,["coords"] = {{ 50.4  , 66.4  } ,{50.8,66},{51.4,65.4},{51.4,66.8},{51.6,65.4},{51.6,67.2},{52.2,67.6},{52.4,65.8},{52.6,65.2},{52.6,65.8},{52.6,67.8},{53,66.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Gorgrond"                      , [ "zoneID" ] = 543  , [ "name" ] = "Typhon Broodmother"          ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55454 ,["id"] = 89031  ,["coords"] = {{ 76    , 40    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Spires of Arak"                  , [ "zoneID" ] = 542  , [ "name" ] = "Dread Raven"                 ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 59369 ,["id"] = 84083  ,["coords"] = {{ 58.4  , 8.4   } ,{59.4,8.4},{59.4,8.6},{59.6,8.4},{59.6,8.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Spires of Arak"                  , [ "zoneID" ] = 542  , [ "name" ] = "Dread Raven"                 ,["maxlevel" ] =100     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 54715 ,["id"] = 80589  ,["coords"] = {{ 55    , 60    } ,{55.6,60.4},{57.6,63.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Spires of Arak"                  , [ "zoneID" ] = 542  , [ "name" ] = "Dread Raven"                 ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 59369 ,["id"] = 94495  ,["coords"] = {{ 58.4  , 8.4   } ,{59.4,8.4},{59.4,8.6},{59.6,8.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }  } ,
  { ["zone_name"] = "Spires of Arak"                  , [ "zoneID" ] = 542  , [ "name" ] = "Brood Mother Xylax"          ,["maxlevel" ] =100     , [ "minlevel" ] =96    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 58756 ,["id"] = 86455  ,["coords"] = {{ 30.4  , 30.4  } ,{30.6,29.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Spires of Arak"                  , [ "zoneID" ] = 542  , [ "name" ] = "Venombarb"                   ,["maxlevel" ] =102     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 55095 ,["id"] = 82646  ,["coords"] = {{ 61    , 19    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Spires of Arak"                  , [ "zoneID" ] = 542  , [ "name" ] = "Spineslicer"                 ,["maxlevel" ] =102     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 31  , "Ravager"       } , ["familySkills" ] = RAVAGER_SKILLS       ,["displayID"] = 56020 ,["id"] = 82632  ,["coords"] = {{ 53.2  , 69.4  } ,{53.2,69.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Spires of Arak"                  , [ "zoneID" ] = 542  , [ "name" ] = "Rukhmar"                     ,["maxlevel" ] =9999    , [ "minlevel" ] =9999  , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 59089 ,["id"] = 83746  ,["coords"] = {{ 34.4  , 31.4  } ,{34.4,36.2},{34.4,36.6},{34.6,31.4},{35,38.6},{36.8,39.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Keravnos Scout"              ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55722 ,["id"] = 80403  ,["coords"] = {{ 9.8   , 54.8  } ,{12.2,56.6},{12.6,57},{12.8,56.4},{14,56.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Fel Raven"                   ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 64266 ,["id"] = 95328  ,["coords"] = {{ 33.6  , 60.2  } ,{34.2,62.6},{34.8,64.4},{35.6,54.6},{35.8,64.6},{37.2,53.6},{38.4,61.8},{39,62.2},{39.8,59.4},{41.8,62.6},{44,52.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Diresnout Felboar"           ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 51  , "Monkey"        } , ["familySkills" ] = MONKEY_SKILLS        ,["displayID"] = 64854 ,["id"] = 89689  ,["coords"] = {{ 45.2  , 60.4  } ,{45.6,60.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Reassigned Warbeast"         ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 53311 ,["id"] = 108181 ,["coords"] = {{ 38.8  , 41.8  } ,{39.2,41.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Fathomless Mauler"           ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 64628 ,["id"] = 93226  ,["coords"] = {{ 43    , 87.4  } ,{43.2,85.6},{43.4,83},{43.4,85.4},{43.6,85.4},{43.6,85.6},{46.4,89},{46.4,89.6},{47.2,88.4},{47.2,88.6},{47.6,88.4},{47.6,89.4},{49.4,91},{49.8,89.2},{49.8,91.6},{50,91},{50.4,90.4},{50.6,91.8},{55.4,93},{55.4,93.8},{55.6,93.6},{55.8,92.4},{55.8,92.8},{56.6,92},{63.4,89.8},{63.4,90.6},{63.6,90.4},{63.6,90.6},{64,91.6},{67.4,87},{67.4,87.6},{67.6,87.4},{67.6,87.6},{67.8,88.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Keravnos Monitor"            ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55723 ,["id"] = 80404  ,["coords"] = {{ 38.4  , 81.2  } ,{38.4,82},{38.6,80.8},{38.8,82.4},{38.8,82.6},{40,82.2},{40.2,83.6},{40.4,81.2},{40.4,82.8},{40.6,81.2},{40.6,82.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Ancient Matriarch"           ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 63400 ,["id"] = 93010  ,["coords"] = {{ 60.6  , 92.4  } ,{60.6,92.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Keravnos Wanderer"           ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55723 ,["id"] = 80453  ,["coords"] = {{ 39.2  , 83    } ,{39.2,83.6},{39.4,80.6},{39.4,81.8},{39.6,82.6},{39.8,81.4},{39.8,81.6},{39.8,84},{40.6,83},{40.6,84.4},{40.8,81.2},{40.8,81.8},{41.8,81.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Tanaan Jungle"                  , [ "zoneID" ] = 534  , [ "name" ] = "Keravnos Broodmother"        ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55460 ,["id"] = 80405  ,["coords"] = {{ 39.4  , 83    } ,{39.6,82.2},{39.6,82.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Leatherhide Earthshaker"     ,["maxlevel" ] = "????" , [ "minlevel" ] ="????", ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 58621 ,["id"] = 85031  ,["coords"] = {{ 55.6  , 11.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Direbeak Windroc"            ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 61646 ,["id"] = 86748  ,["coords"] = {{ 52.4  , 39    } ,{52.6,39},{56.8,34},{56.8,36.2},{57,37.6},{57.8,35},{58.4,30},{58.6,30},{60.8,24.2},{60.8,33}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Ironhide Bull"               ,["maxlevel" ] =100     , [ "minlevel" ] =98    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 60083 ,["id"] = 86731  ,["coords"] = {{ 51.4  , 39.4  } ,{51.4,39.8},{51.6,36.4},{51.6,39.4},{51.6,39.8},{51.8,37},{52.2,38.2},{52.6,37.4},{52.8,38},{54,36.4},{54,36.8},{54.2,34.4},{54.2,34.6},{55.4,36.2},{55.4,36.6},{55.6,36.4},{55.6,36.6},{56.2,33.6},{56.4,33.2},{57.4,30.4},{57.4,33},{57.8,29.8},{58,29.4},{58,33.4},{58.2,33.6},{58.4,35},{58.4,35.6},{58.6,35.2},{58.6,35.6},{58.8,28.4},{59,29},{59.2,32.2},{59.2,32.6},{59.4,33.8},{59.6,33.4},{59.6,33.6},{60.4,13},{60.4,20.4},{60.4,20.6},{60.4,26.4},{60.4,26.8},{60.4,28.4},{60.4,28.8},{60.4,31.2},{60.4,31.6},{60.6,13.2},{60.6,20.4},{60.6,20.6},{60.6,27},{60.6,28.4},{60.6,31},{60.8,29.6},{61,21.6},{61.2,25.4},{61.4,17.4},{61.4,17.8},{61.4,19.2},{61.4,25.6},{61.4,29},{61.4,32.2},{61.4,32.6},{61.6,14.8},{61.6,17.2},{61.6,18.4},{61.6,25.4},{61.6,29},{61.6,32.4},{61.8,14.4},{61.8,15.6},{62,26},{62.2,30},{62.2,33},{62.4,19.4},{62.4,19.6},{62.4,23.6},{62.4,26.6},{62.6,17.2},{62.6,17.6},{62.6,19.4},{62.6,19.6},{62.6,26.4},{62.6,26.8},{62.8,24},{62.8,25.2},{62.8,28.6},{63,15.4},{63,15.6},{63,28},{63,30.6},{63.2,13.6},{63.2,30.2},{63.4,13.4},{63.6,13},{63.6,13.8},{63.6,29},{64,28.2},{64.2,20.2},{64.4,20.6},{64.6,20.8},{65,19.4},{65,19.6}                                               }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Lernaean Scout"              ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55820 ,["id"] = 80543  ,["coords"] = {{ 49    , 79    } ,{51.4,80.2},{51.8,81.2},{61.6,12.4},{62,13.4},{62.2,13.6},{63,10.4},{63.2,11.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Vicious Razorclaw"           ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 61299 ,["id"] = 88956  ,["coords"] = {{ 36.2  , 39.6  } ,{36.2,43.4},{36.4,39},{36.4,43.6},{36.6,43.6},{36.8,40.4},{36.8,40.6},{37.4,38.4},{37.4,39.2},{37.4,41.6},{37.4,42.8},{37.6,39.4},{37.6,41.4},{37.8,37.4},{37.8,38},{37.8,40.2},{37.8,41.6},{38.8,38.2},{39,40.6},{39.2,39.2},{39.4,39.8},{39.8,39.4},{41,47},{41.2,47.6},{42.2,44},{42.4,43},{42.6,43}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Lernaean Broodmother"        ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55459 ,["id"] = 80541  ,["coords"] = {{ 51.8  , 89.4  } ,{52.2,90.2},{53.2,84.4},{63.2,10.4},{63.2,10.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Lernaean Monitor"            ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 68  , "Hydra"         } , ["familySkills" ] = HYDRA_SKILLS         ,["displayID"] = 55819 ,["id"] = 80542  ,["coords"] = {{ 50    , 82.2  } ,{50.2,82.6},{52,89.2},{52.4,81},{52.8,81},{61.4,10.4},{61.4,10.8},{61.6,10.4},{61.6,11},{62.6,10}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Wetland Trampler"            ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 150 , "Riverbeast"    } , ["familySkills" ] = RIVERBEAST_SKILLS    ,["displayID"] = 55211 ,["id"] = 87021  ,["coords"] = {{ 30.4  , 49.2  } ,{30.6,49.4},{30.6,49.6},{31.4,51.2},{31.8,48.8},{32,47.8},{32.2,50.4},{32.2,50.6},{32.6,51},{33.4,47.6},{33.4,49.2},{33.4,49.6},{33.6,48},{34,46.4},{34.2,48.6},{34.6,48.8},{34.8,49.6},{35,46.4},{35,47.6},{35.2,46.8},{35.4,45.4},{36,44.4},{36,44.6},{36,47.8},{36.2,48.6},{36.4,45.6},{36.4,46.8},{36.6,45.4},{37.4,46.2},{37.4,46.6},{37.4,48.4},{37.4,48.6},{37.6,48.4},{38.2,45.8},{45.2,46}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Thorncoat Buck"              ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 60086 ,["id"] = 86728  ,["coords"] = {{ 51.4  , 43.2  } ,{51.6,43.2},{53,40.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Direfang Alpha"              ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 61302 ,["id"] = 86932  ,["coords"] = {{ 39    , 34.2  } ,{39.2,32.4},{39.4,31.2},{39.6,31.4},{40.2,34},{40.2,34.8},{40.4,30.2},{40.4,31.6},{40.6,30.2},{40.6,31.8},{41.2,31.2},{41.2,32.6},{41.4,34},{42,31.6},{42.6,31.6},{47,33.6},{47,36.4},{47.2,33.4},{47.2,37},{47.8,37},{48.2,35.4},{48.2,35.6},{48.4,33},{48.4,37.6},{48.6,33},{48.6,37.4},{48.6,37.6},{48.8,34.4},{48.8,34.6},{49.2,36.2},{52,42.4},{52.2,42.6},{52.8,41.6},{53,41.4},{53.6,40.8},{53.8,40},{54.2,39.4},{54.8,39.4},{54.8,39.6},{55.8,39.2},{56.4,39.6},{56.8,39.2},{57.8,38},{58.4,38.6},{58.8,38.6},{59,38.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Deadly Gloomstalker"         ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 32  , "Warp Stalker"   } , ["familySkills" ] = WARP_STALKERS_SKILLS ,["displayID"] = 61265 ,["id"] = 86773  ,["coords"] = {{ 42.2  , 26.6  } ,{42.8,28.2},{43,28.8},{43.2,26.4},{43.4,26.8},{45.2,21.6},{45.6,21.6},{46,23.2},{46.2,23.6},{46.2,25.8},{47.2,29.4},{47.6,28.8},{51.2,29},{52,16.4},{52.2,16.6},{52.4,23.4},{52.6,15.8},{52.6,16.6},{52.6,22.4},{52.6,23.2},{52.6,26.2},{52.6,26.8},{53,17.8},{53.2,29.2},{53.6,25.8},{53.6,29.2},{53.8,23.4},{53.8,24.2},{54.4,25.2},{54.6,25.6},{54.8,29.2},{55.2,25.4},{55.4,21.4},{55.4,21.8},{55.6,21.4},{56,25}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nagrand (Draenor)"                       , [ "zoneID" ] = 550  , [ "name" ] = "Venombore Hive Guard"        ,["maxlevel" ] =100     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 61273 ,["id"] = 86834  ,["coords"] = {{ 38.2  , 43    } ,{39.4,36.2},{39.6,36.2},{39.6,36.6},{41,44.4},{41.4,44.6},{41.8,45.4},{42,44.2},{42,45.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Primal Stalker"              ,["maxlevel" ] =90      , [ "minlevel" ] =89    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 51326 ,["id"] = 72805  ,["coords"] = {{ 49    , 58.8  } ,{49.4,58.4},{49.6,58.4},{49.6,58.6},{50.4,56.2},{50.4,56.6},{50.6,56},{52.2,61.6},{52.4,61.2},{52.4,63.4},{52.4,64.4},{52.6,61.4},{52.6,63.8},{52.8,63.4},{55.4,45},{55.6,45},{56,44.4},{57.4,47.2},{57.4,47.6},{57.6,47.6},{57.8,46.8},{59.8,66.2},{59.8,66.8},{61.2,52.6},{61.4,52.4},{61.6,52.6},{62.4,52.4},{62.6,52.6},{62.8,52.2},{63.4,57.6},{63.4,59.2},{63.4,59.6},{63.6,57.8},{63.6,59.2},{63.6,59.6},{63.8,57.4},{64.4,54.6},{64.6,54.4},{64.8,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Brilliant Windfeather"       ,["maxlevel" ] =90      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 125 , "Crane"         } , ["familySkills" ] = CRANE_SKILLS         ,["displayID"] = 51262 ,["id"] = 72762  ,["coords"] = {{ 29.2  , 50.4  } ,{29.4,50.6},{29.6,50.6},{29.8,50.4},{30.2,43.4},{30.2,58.2},{30.2,59.2},{30.4,44},{30.4,61.4},{30.4,62.4},{30.4,62.8},{30.4,65.8},{30.6,43.4},{30.6,49.4},{30.6,50.2},{30.6,51.2},{30.6,62.4},{30.6,62.8},{30.6,65.4},{30.8,43.8},{30.8,66.4},{30.8,66.6},{31.2,51.6},{31.2,52.6},{31.4,39.4},{31.4,40.2},{31.4,79.8},{31.6,39.4},{31.6,40.2},{31.6,79.4},{31.8,40.6},{31.8,62.8},{31.8,66.4},{31.8,66.6},{31.8,79.8},{32.2,48.6},{32.2,52.2},{32.2,80.6},{32.4,48.2},{32.6,48.6},{36.2,40.6},{36.4,39.4},{36.4,40},{36.4,83.4},{36.4,83.6},{36.6,40},{36.6,40.6},{36.8,83.8},{37.8,41.8},{38.4,41.4},{38.6,41.4},{38.6,41.6},{39.2,67.4},{39.4,68},{39.4,68.6},{39.6,67.4},{39.6,68.2},{39.6,68.6},{40.4,40.2},{40.4,42.4},{40.4,43.2},{40.6,39.4},{40.6,39.8},{40.6,42.4},{40.8,40.6},{40.8,43.2},{41,43.6},{42.4,67},{42.4,67.6},{42.4,69.4},{42.4,70},{42.4,70.6},{42.6,67.2},{42.6,67.6},{42.6,69.4},{42.6,70.4},{42.6,70.6},{44.2,61},{44.2,61.8},{44.4,54.4},{44.4,55},{44.6,54.8},{44.6,61.4},{44.8,53.4},{44.8,53.6}                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Ancient Spineclaw"           ,["maxlevel" ] =90      , [ "minlevel" ] =89    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 8   , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 50962 ,["id"] = 72766  ,["coords"] = {{ 15.6  , 36.8  } ,{16.4,60.6},{17.6,53},{18,75.2},{18.2,54.6},{18.2,58},{18.2,58.6},{18.2,63},{18.2,64.4},{18.8,54.4},{19,55},{19,76.4},{20.2,47.2},{20.4,47.8},{20.6,47.4},{20.6,47.6},{20.8,71.6},{21,63.4},{21,71},{21.2,32.4},{21.2,63.6},{21.4,32.8},{21.4,35.4},{21.4,35.8},{21.6,32.4},{21.6,32.6},{21.6,35.4},{21.8,36},{22.4,30.4},{22.4,30.8},{22.6,30.2},{22.6,30.8},{22.6,35.2},{22.8,35.6},{23.4,27.4},{23.4,28.2},{23.4,28.6},{23.6,27.4},{23.6,28.4},{23.6,28.8},{23.6,35.8},{23.8,34.8},{24.4,74.4},{24.4,74.8},{25.4,74.4},{25.4,74.6},{25.6,74.4},{25.6,74.6},{27.4,74.2},{27.4,74.6},{27.6,74.2},{27.6,80.4},{27.8,74.6},{29.2,84},{30.4,30.8},{30.6,30.4},{30.6,31},{30.8,31.6},{33,85.8},{33.4,85.2},{38.4,87.2},{38.6,86.8},{40.2,90.8},{40.6,90.8},{41,90},{44.8,90.4},{52,86.8},{61.8,83},{62.2,82.4},{62.6,81.8},{66,78.4},{68,77.8},{68.6,74.2},{70.2,70.4},{70.8,63.4}                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Ironfur Great Bull"          ,["maxlevel" ] =90      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 157 , "Oxen"          } , ["familySkills" ] = OXEN_SKILLS          ,["displayID"] = 51283 ,["id"] = 72844  ,["coords"] = {{ 27.2  , 39.6  } ,{27.4,60.4},{28,39.4},{28,46.2},{28,49},{28,59.4},{28.2,40.4},{28.4,41},{28.4,46.8},{28.4,48},{28.4,50.4},{28.8,43},{28.8,59.2},{29.2,39.6},{29.2,44.4},{29.2,70.2},{29.6,43.4},{29.6,70},{29.8,71.4},{30,44.2},{30.2,47.6},{30.2,69.4},{30.4,47.4},{30.6,48},{30.6,49.4},{30.8,68.2},{30.8,70.8},{31.4,69.2},{31.6,43.8},{32,44.6},{32,59.4},{32.2,58.2},{32.8,62},{33.2,63},{33.4,38.6},{33.6,38.6},{33.8,61.4},{33.8,68},{34.2,37.2},{34.2,38.4},{34.2,70.6},{34.4,66.8},{34.6,69.8},{34.8,40.8},{34.8,68.2},{35,43},{35,71},{35.8,70.2},{36,67.6},{36.2,66.8},{37.2,43.4},{37.2,44},{37.6,42.4},{37.6,42.8},{37.8,36.6},{37.8,44.2},{40.8,65.2},{41,37.6},{41,65.8},{41.4,39.4},{43.2,55.2},{43.4,55.6},{43.6,51.6},{43.6,54.8},{44,55.8},{44.2,52.6},{44.2,54.2},{44.4,58.4},{44.6,43.4},{44.8,52.6},{44.8,58.4},{45,51.8},{45,56.6},{45.2,45.6},{45.6,63.2},{46.2,63.6},{46.8,63},{47.2,61.6}                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Gulp Frog"                   ,["maxlevel" ] =90      , [ "minlevel" ] =89    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 291 , "Toad"          } , ["familySkills" ] = TOAD_SKILLS          ,["displayID"] = 51346 ,["id"] = 72777  ,["coords"] = {{ 59.8  , 70.6  } ,{60.4,72.4},{60.8,71.4},{61,72.2},{61.4,72.6},{61.4,74.4},{61.4,74.6},{61.6,72.4},{61.6,74.4},{61.6,74.6},{62,79.6},{62.2,77.2},{62.2,77.6},{62.4,60.8},{62.4,73.4},{62.4,75.6},{62.6,74.2},{62.6,77.6},{63,72.4},{63,72.8},{63,80.8},{63.2,76.6},{63.4,75.4},{63.4,75.6},{63.6,75.2},{63.6,77.6},{63.8,77},{64,72.2},{64,72.6},{64,76.2},{64.2,73.8},{64.6,76.4},{65,71},{65,73.6},{65.2,64.4},{65.2,64.6},{65.2,67.4},{65.2,67.8},{65.2,71.6},{65.2,73.2},{65.2,78.2},{65.4,66.4},{65.4,68.6},{65.4,70.4},{65.6,66.4},{65.6,74},{65.8,68.8},{66,67.2},{66,69.8},{66,72.2},{66,72.6},{66.4,64.4},{66.4,64.6},{66.4,68},{66.4,71.4},{66.6,65},{66.6,67.8},{66.6,68.6},{66.6,76.4},{66.8,66.2},{66.8,70},{67,66.6},{67,71.4},{67,71.6},{67.6,69.8},{67.8,70.8},{70.2,70.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Elder Great Turtle"          ,["maxlevel" ] =90      , [ "minlevel" ] =85    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 51125 ,["id"] = 72765  ,["coords"] = {{ 16.2  , 37    } ,{16.2,48.4},{16.4,35.8},{16.4,48.6},{16.6,48.8},{16.6,49.6},{16.8,36.4},{17,37},{17.2,37.6},{17.2,47.6},{17.4,38.8},{17.4,46.8},{17.6,37.2},{17.8,46},{18,38.4},{18.2,30.6},{18.2,63.6},{18.6,30.2},{18.8,39},{18.8,62.4},{19,29.4},{19,54.2},{19,54.6},{19,64},{19.2,31},{19.2,32.4},{19.2,63.4},{19.4,56},{19.4,65.2},{19.6,31.8},{19.6,39.8},{19.6,54},{19.6,55.6},{19.6,65},{19.8,54.8},{19.8,57},{20,30.2},{20,63.2},{20,63.6},{20.2,65.8},{20.4,30.8},{20.6,56},{20.8,64},{21,31.4},{21,54.4},{21,54.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Timeless Isle"                  , [ "zoneID" ] = 554  , [ "name" ] = "Great Turtle"                ,["maxlevel" ] =90      , [ "minlevel" ] =89    , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 51128 ,["id"] = 72764  ,["coords"] = {{ 20.6  , 42.6  } ,{21,42.4},{21,44.8},{21.6,43.8},{21.6,44.6},{22,42.4},{22,42.6},{22,46},{22,61.6},{22.2,53.6},{22.2,61.4},{22.4,46.6},{22.4,53},{22.4,65},{22.4,65.6},{22.4,67.2},{22.4,67.8},{22.6,53.8},{22.6,65.4},{22.6,65.6},{22.6,67.2},{22.6,68},{22.8,52},{22.8,61.6},{23.2,47},{23.2,57.4},{23.4,47.6},{23.4,49},{23.4,49.6},{23.4,53},{23.4,58},{23.4,58.6},{23.4,60.4},{23.4,60.8},{23.4,62.8},{23.4,63.8},{23.6,48.6},{23.6,49.6},{23.6,53.4},{23.6,63.4},{23.6,63.6},{23.6,67.2},{23.6,68.8},{23.8,48},{23.8,54},{23.8,60.4},{23.8,60.6},{24.2,70},{24.4,57.4},{24.4,57.6},{24.6,57.4},{24.8,58.4},{24.8,59},{24.8,59.6},{25.2,52.2},{25.4,50},{25.4,50.6},{25.4,53},{25.4,56.4},{25.4,72.2},{25.6,50.2},{25.6,58.6},{25.8,50.6},{25.8,57.4},{25.8,57.8},{26,55.4},{26,56.4},{26,71.4},{26,72.8},{26.2,72},{26.6,72.2},{26.6,72.6}                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Blackrock Foundry"              , [ "zoneID" ] = 599  , [ "name" ] = "Faultline"                   ,["maxlevel" ] =9999    , [ "minlevel" ] =9999  , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 43  , "Clefthoof"     } , ["familySkills" ] = CLEFTHOOVE_SKILLS    ,["displayID"] = 53542 ,["id"] = 76946  ,["coords"] = {{ 66.3  , 72.1  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Blackrock Foundry"              , [ "zoneID" ] = 599  , [ "name" ] = "Dreadwing"                   ,["maxlevel" ] =9999    , [ "minlevel" ] =9999  , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 53505 ,["id"] = 76874  ,["coords"] = {{ 66.3  , 72.1  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Upper Blackrock Spire"           , [ "zoneID" ] = 618  , [ "name" ] = "Ironbarb Skyreaver"          ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 38  , "Chimaera"      } , ["familySkills" ] = CHIMAERAS_SKILLS     ,["displayID"] = 59180 ,["id"] = 80098  ,["coords"] = {{ 48.5  , 24.5  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Leytusk"                     ,["maxlevel" ] =110     , [ "minlevel" ] =101   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 51  , "Monkey"        } , ["familySkills" ] = MONKEY_SKILLS        ,["displayID"] = 62708 ,["id"] = 100846 ,["coords"] = {{ 62    , 11.4  } ,{62,11.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "CoveGull"                    ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 71849 ,["id"] = 111570 ,["coords"] = {{ 39.6  , 85.8  } ,{46.8,91.4},{46.8,91.6},{48.4,92},{50.8,75.2},{50.8,76}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Mac the Bear"                ,["maxlevel" ] =110     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 41014 ,["id"] = 109324 ,["coords"] = {{ 53    , 21.4  } ,{53,21.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Resting Dauorbjorn"          ,["maxlevel" ] =110     , [ "minlevel" ] =101   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 41014 ,["id"] = 92735  ,["coords"] = {{ 53    , 21.2  } ,{53.4,22.2},{53.6,22.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Bloodgazer Patriarch"        ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 73913 ,["id"] = 115670 ,["coords"] = {{ 34.4  , 6.4   } ,{34.4,10},{34.6,6.4},{34.8,7.8},{35,6.8},{35,10},{35.2,9},{36,8.6},{36.4,7.4},{36.4,8.2},{36.6,8.2},{36.6,8.6},{37.2,7.4},{37.4,5.4},{37.4,5.6},{37.8,6},{37.8,6.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Bloodgazer Matriarch"        ,["maxlevel" ] =111     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 73920 ,["id"] = 115674 ,["coords"] = {{ 35.4  , 5.4   } ,{35.4,5.6},{35.6,5.4},{35.6,5.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }  } ,
  { ["zone_name"] = "Azsuna"                        , [ "zoneID" ] = 630  , [ "name" ] = "Netherbeak"                  ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 63623 ,["id"] = 16875  ,["coords"] = {{ 42.6  , 21    } ,{43.4,24.6},{43.6,24.4},{43.6,24.6},{43.6,26.2},{43.8,27}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Irewing"                     ,["maxlevel" ] =110     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 66088 ,["id"] = 95762  ,["coords"] = {{ 43.4  , 45    } ,{43.6,44.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Spinesever"                  ,["maxlevel" ] =110     , [ "minlevel" ] =105   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 66850 ,["id"] = 100841 ,["coords"] = {{ 39.2  , 13.4  } ,{39.2,13.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Great Eagle"                 ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 70260 ,["id"] = 108552 ,["coords"] = {{ 26    , 61.4  } ,{27,57.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Rashar"                      ,["maxlevel" ] =110     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 2   , "Cat"           } , ["familySkills" ] = CAT_SKILLS           ,["displayID"] = 62609 ,["id"] = 97454  ,["coords"] = {{ 37.4  , 49.2  } ,{37.6,49}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Snowfeather Patriarch"       ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 73914 ,["id"] = 115669 ,["coords"] = {{ 32.2  , 23.8  } ,{32.4,24.6},{32.8,24},{33.2,25.6},{33.4,22.8},{33.4,25.4},{33.8,25.6},{34,23.6},{34,25.2},{34.2,22.8},{35,22.8},{35.4,21},{35.4,22},{35.6,20},{35.6,21.4},{35.6,22},{35.6,24.2},{35.8,18},{36.4,19.2},{36.8,18.4},{36.8,18.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Morashu"                     ,["maxlevel" ] =110     , [ "minlevel" ] =100   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 151 , "Stag"          } , ["familySkills" ] = STAG_SKILLS          ,["displayID"] = 64256 ,["id"] = 94694  ,["coords"] = {{ 45.4  , 42.4  } ,{45.4,42.6},{45.6,42.4},{45.6,42.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Thornback Spinner"           ,["maxlevel" ] =110     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 3   , "Spider"        } , ["familySkills" ] = SPIDER_SKILLS        ,["displayID"] = 46709 ,["id"] = 97494  ,["coords"] = {{ 41    , 41.6  } ,{41.2,40.6},{41.4,43},{41.6,43.2},{41.8,44},{42.4,42.4},{47.4,37},{47.4,37.8},{48.2,36.4},{48.4,36.8},{48.4,38.4},{48.4,39.4},{48.6,37.4},{48.6,38},{48.8,40},{49,38.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Highmountain"                  , [ "zoneID" ] = 650  , [ "name" ] = "Snowfeather Matriarch"       ,["maxlevel" ] =111     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 73919 ,["id"] = 115673 ,["coords"] = {{ 35    , 22    } ,{35,22.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Stonefang"                   ,["maxlevel" ] =110     , [ "minlevel" ] =103   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 130 , "Basilisk"      } , ["familySkills" ] = BASILISK_SKILLS      ,["displayID"] = 70340 ,["id"] = 107914 ,["coords"] = {{ 46.4  , 60.8  } ,{46.6,60.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Spitefeather"                ,["maxlevel" ] =110     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 70334 ,["id"] = 97124  ,["coords"] = {{ 48.4  , 32.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Direbeak Patriarch"          ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 73916 ,["id"] = 115667 ,["coords"] = {{ 76.4  , 84    } ,{76.6,84},{77.2,82.2},{77.2,82.8},{77.4,80.2},{77.4,81.4},{77.6,79.4},{77.6,79.8},{77.6,80.8},{77.6,82.8},{77.8,72.4},{77.8,72.6},{78,74.2},{78.4,77.4},{78.4,77.6},{78.6,76.8},{78.8,74.4},{78.8,75.2},{78.8,76.2},{79.4,70.4},{79.6,70.2},{80.4,69.2},{80.6,69.4},{80.6,69.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 }  } ,
  { ["zone_name"] = "Stormheim"                     , [ "zoneID" ] = 634  , [ "name" ] = "Direbeak Matriarch"          ,["maxlevel" ] =111     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 73917 ,["id"] = 115671 ,["coords"] = {{ 78.2  , 76.4  } ,{78.2,76.6},{78.6,73.4},{78.6,76.6},{78.8,74.4},{78.8,75.2},{78.8,75.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Hellfire Citadel"               , [ "zoneID" ] = 665  , [ "name" ] = "Fel Raven"                    ,["maxlevel" ] =102     , [ "minlevel" ] =102   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 26  , "Bird of Prey"    } , ["familySkills" ] = BIRD_OF_PREY_SKILLS ,["displayID"] = 62494 ,["id"] = 93952  ,["coords"] = {{ 40.1  , 76.1  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Sharptalon Patriarch"        ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 73915 ,["id"] = 115668 ,["coords"] = {{ 48    , 7.4   } ,{48.8,7.4},{49,8.4},{49.2,9},{49.8,7.4},{50.4,8.2},{50.6,8.4},{50.6,8.6},{51.6,8.4},{51.8,9.2},{53,9.2},{53,9.6},{53.6,9.2},{55,7.8},{55.2,8.8},{55.4,7.4},{55.4,9.6},{55.6,9.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }  } ,
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Sharptalon Matriarch"        ,["maxlevel" ] =111     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 73918 ,["id"] = 115672 ,["coords"] = {{ 48    , 9.4   } ,{48,9.6},{48.6,9.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Val'sharah"                    , [ "zoneID" ] = 641  , [ "name" ] = "Wandering Shellback"         ,["maxlevel" ] =110     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 21  , "Turtle"        } , ["familySkills" ] = TURTLE_SKILLS        ,["displayID"] = 51124 ,["id"] = 111633 ,["coords"] = {{ 45.2  , 57.6  } ,{45.8,65.4},{46.2,65.8},{48,63},{48.2,69.4},{48.8,62.8},{48.8,69.4},{49,69.6},{49.2,66},{49.4,68.4},{49.6,65.2},{49.6,66.6},{49.6,68.4},{49.6,69},{49.6,69.8},{49.8,65.8},{50,71},{50.6,65.4},{50.6,68.2},{50.6,70.2},{50.8,66.8},{51,58},{51.2,58.6},{51.8,64.8},{51.8,66.4},{52,62.8},{52,67.2},{52.2,62.2},{52.4,64.4},{52.6,62.8},{52.6,65.6},{52.8,68.2},{53,68.6},{53.2,64.2},{53.6,67.6},{54.6,68.8},{56.8,69.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Eye of Azshara"                , [ "zoneID" ] = 713  , [ "name" ] = "Varoudnir"                   ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 76531 ,["id"] = 121623 ,["coords"] = {{ 57    , 78.4  } ,{57,80}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "KingK'tal"                   ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 47511 ,["id"] = 123502 ,["coords"] = {{ 68    , 22.2  } ,{68.4,22.8},{68.6,22.2},{68.6,23},{70,22.6},{70.4,22.4},{70.6,22.6},{71.2,21.6},{71.4,21.4},{71.6,20.4},{71.6,21.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Ten'gor"                     ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 47808 ,["id"] = 130713 ,["coords"] = {{ 61.4  , 25.2  } ,{61.8,25.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Xibalan Apex"                ,["maxlevel" ] =120     , [ "minlevel" ] =113   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 81975 ,["id"] = 131632 ,["coords"] = {{ 40.4  , 75.4  } ,{40.6,75.4},{40.8,74.2},{40.8,75.6},{42,74.4},{42,74.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Savagelands Devilsaur"       ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 82974 ,["id"] = 139706 ,["coords"] = {{ 69    , 31.4  } ,{69.6,33.2},{69.6,36.8},{70.2,34.2},{70.4,35},{70.8,35},{71,34.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Pinky"                       ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 76972 ,["id"] = 126732 ,["coords"] = {{ 67.8  , 44.8  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Azuresail the Ancient"       ,["maxlevel" ] =120     , [ "minlevel" ] =115   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 76835 ,["id"] = 135510 ,["coords"] = {{ 67    , 26.4  } ,{67,26.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Kil'Tawan"                   ,["maxlevel" ] =120     , [ "minlevel" ] =115   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47236 ,["id"] = 135508 ,["coords"] = {{ 69    , 30.8  } ,{69.2,30.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Sabertusk Empress"           ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 288 , "Lizard"        } , ["familySkills" ] = LIZARD_SKILLS        ,["displayID"] = 86802 ,["id"] = 129323 ,["coords"] = {{ 46.8  , 56.2  } ,{52.2,47.4},{52.2,47.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Prime Thumpknuckle"          ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 9   , "Gorilla"       } , ["familySkills" ] = GORILLA_SKILLS       ,["displayID"] = 3186  ,["id"] = 136334 ,["coords"] = {{ 47.4  , 34.2  } ,{52.4,44.4},{52.4,45.2},{52.6,45},{52.8,43.4},{52.8,43.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Nol'ixwan"                   ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47819 ,["id"] = 130741 ,["coords"] = {{ 61.4  , 25.4  } ,{61.6,25.2},{61.6,25.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Zuldazar"                      , [ "zoneID" ] = 862  , [ "name" ] = "Ji'arak Broodling"           ,["maxlevel" ] =122     , [ "minlevel" ] =113   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 290 , "Pterrordax"    } , ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 76910 ,["id"] = 132653 ,["coords"] = {{ 69.4  , 33.4  } ,{69.4,33.8},{69.6,33.4},{69.6,33.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Monstrous Pterrordax"        ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 290 , "Pterrordax"    } , ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 82392 ,["id"] = 139493 ,["coords"] = {{ 28.4  , 92.8  } ,{28.4,93.8},{28.8,94}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           }  } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Gruesh"                      ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 39  , "Devilsaur"     } , ["familySkills" ] = DEVILSAUR_SKILLS     ,["displayID"] = 79823 ,["id"] = 128051 ,["coords"] = {{ 48.6  , 24    } ,{48.8,26},{50,21},{51,22.2},{51.2,20.8},{51.4,19.6},{52,23.8},{52.2,23.2},{52.4,19.4},{52.4,19.6},{52.4,21},{52.4,22.4},{52.6,22.2},{52.8,19.4},{53,21},{53.2,23.2},{53.4,17.4},{53.4,18.4},{53.4,19.6},{53.6,17.8},{53.6,18.6},{53.6,19.8},{53.6,21.2},{53.6,22},{54.8,19.8},{55.2,22.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Makatau"                     ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 290 , "Pterrordax"    } , ["familySkills" ] = PTERRORDAXE_SKILLS   ,["displayID"] = 76656 ,["id"] = 143898 ,["coords"] = {{ 23    , 68.6  } ,{23.2,70},{23.2,71.2},{23.2,71.8},{23.2,72.6},{23.6,68.8},{23.6,73},{23.8,69.8},{24,71.4},{24,71.6},{24.4,74.2},{24.4,75},{24.6,69.4},{24.8,72.4},{24.8,72.6},{25,70.6},{25.4,69.8},{25.4,74.8},{25.6,69.8},{25.6,70.8},{25.6,71.8},{25.8,75.2},{26,75.6},{26.2,73.2},{26.4,73.8},{26.6,75.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Zulajin"                     ,["maxlevel" ] =120     , [ "minlevel" ] =112   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 11  , "Raptor"        } , ["familySkills" ] = RAPTOR_SKILLS        ,["displayID"] = 82053 ,["id"] = 134436 ,["coords"] = {{ 25    , 52    } ,{25.8,51.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Nazmir"                        , [ "zoneID" ] = 863  , [ "name" ] = "Tojek"                       ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 138 , "Direhorn"      } , ["familySkills" ] = DIREHORN_SKILLS      ,["displayID"] = 47236 ,["id"] = 136381 ,["coords"] = {{ 26.4  , 65.4  } ,{26.4,65.6},{26.4,66.6},{26.6,65.4},{26.6,65.6},{26.8,67.6},{27,67},{27.6,67.4},{27.6,67.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Vol'dun"                       , [ "zoneID" ] = 864  , [ "name" ] = "Sevriss"                     ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78251 ,["id"] = 136593 ,["coords"] = {{ 39.4  , 59.2  } ,{39.8,59.4},{40.2,59.6},{40.8,58.8},{41.2,59.6},{41.4,58.4},{41.6,58.2},{41.6,58.6},{42.8,58}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   }  } ,
  { ["zone_name"] = "Tiragarde Sound"                , [ "zoneID" ] = 895  , [ "name" ] = "Old Frostclaw"               ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 4   , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 20827 ,["id"] = 128093 ,["coords"] = {{ 79.4  , 65.6  } ,{79.8,65.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Tiragarde Sound"                , [ "zoneID" ] = 895  , [ "name" ] = "Wild Gryphon"                ,["maxlevel" ] =120     , [ "minlevel" ] =111   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 82019 ,["id"] = 129001 ,["coords"] = {{ 43.4  , 23.4  } ,{43.4,23.6},{44,22},{44,23.2},{44.2,19},{44.2,21.2},{44.6,21.2},{44.6,22},{44.8,20.2},{45.2,18.6},{45.2,22.8},{45.8,21.2},{45.8,22.6},{46,17.8},{46.2,20.4},{46.4,18.8},{47,20},{47.6,17.2},{48.8,18.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         }  } ,
  { ["zone_name"] = "Tiragarde Sound"                , [ "zoneID" ] = 895  , [ "name" ] = "Wild Gryphon"                ,["maxlevel" ] =120     , [ "minlevel" ] =120   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 160 , "Feathermane"   } , ["familySkills" ] = FEATHERMANE_SKILLS  ,["displayID"] = 81338 ,["id"] = 140433 ,["coords"] = {{ 42.4  , 22.6  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  { ["zone_name"] = "Tiragarde Sound"                , [ "zoneID" ] = 895  , [ "name" ] = "The Hornet"                  ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 44  , "Wasp"          } , ["familySkills" ] = WASP_SKILLS          ,["displayID"] = 82379 ,["id"] = 137450 ,["coords"] = {{ 47.2  , 18.2  } ,{47.6,18.2}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     }  } ,
  { ["zone_name"] = "Drustvar"                      , [ "zoneID" ] = 896  , [ "name" ] = "The Rime Huntress"           ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 84897 ,["id"] = 136697 ,["coords"] = {{ 42.4  , 43.4  } ,{42.4,43.6},{43,42.6},{43.4,42.4},{43.6,42.2},{44,41.2},{44.4,40.2},{45,39.6},{45.2,39.4}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Stormsong Valley"               , [ "zoneID" ] = 942  , [ "name" ] = "Thundersnout"                ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 51  , "Boar"        } , ["familySkills" ] = MONKEY_SKILLS        ,["displayID"] = 52696 ,["id"] = 135293 ,["coords"] = {{ 40.4  , 71.4  } ,{40.4,71.6},{40.6,71.4},{40.6,71.8}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             }  } ,
  { ["zone_name"] = "Stormsong Valley"               , [ "zoneID" ] = 942  , [ "name" ] = "Razorclaw Alpha"             ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 1   , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 63016 ,["id"] = 136417 ,["coords"] = {{ 28    , 79.4  } ,{28,79.6}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       }  } ,
  { ["zone_name"] = "Temple of Sethraliss"            , [ "zoneID" ] = 1038 , [ "name" ] = "Sand-crusted Striker"         ,["maxlevel" ] =120     , [ "minlevel" ] =110   , ["info" ] =   ""                         , ["class" ] = CLASS_ELITE      , ["family"] = { 35  , "Serpent"       } , ["familySkills" ] = SERPENT_SKILLS       ,["displayID"] = 78247 ,["id"] = 134390 ,["coords"] = {{ 42.9  , 51.2  }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }  } ,
  -- SHADOWLANDS RARES / ELITES
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="The Lonely Matriarch"       ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={126 ,"Water Strider" },["familySkills"]=WATER_STRIDER_SKILLS ,["displayID"]=57556 ,["id"]=167480,["coords"]={{18.2 ,37.6 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Dustwilt Gorger"           ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94200 ,["id"]=163994,["coords"]={{19   ,62.2 },{21.6,61.2},{22.4,59.2},{22.8,61.4}                                                                                                                                                                                                          } },
  {["zone_name"]="The Necrotic Wake"    ,["zoneID"]=1666 ,["name"]="Bonefang"                 ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=94926 ,["id"]=164479,["coords"]={{20.5 ,40.3 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Dustwilt Acidmaw"          ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94204 ,["id"]=163991,["coords"]={{22.6 ,62   },{22.8,61.4}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Dustwilt Scythehorn"       ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94191 ,["id"]=163992,["coords"]={{22.6 ,62   }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Eastern Plaguelands" ,["zoneID"]=23   ,["name"]="Blight-Howl"              ,["maxlevel"]=50,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=6196  ,["id"]=169118,["coords"]={{23   ,66.4 },{23.2,69.2}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Eastern Plaguelands" ,["zoneID"]=23   ,["name"]="Plaguefang"               ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=6196  ,["id"]=169119,["coords"]={{23.4 ,68.4 },{23.6,68.2},{23.6,68.8},{25.2,67.4}                                                                                                                                                                                                          } },
  {["zone_name"]="Revendreth"         ,["zoneID"]=1525 ,["name"]="Nightwidow Horror"         ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={3   ,"Spider"       },["familySkills"]=SPIDER_SKILLS        ,["displayID"]=94408 ,["id"]=159460,["coords"]={{23.8 ,28.6 },{25.4,23.4},{25.6,23.8},{26.4,23.2},{26.8,22.6},{27.2,13},{27.4,11.8},{30.4,25},{30.6,24.8},{37.8,22.4}                                                                                                                                      } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Gladestalker"             ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=62588 ,["id"]=165094,["coords"]={{24.6 ,46.8 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Dustwilt Husk"             ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94205 ,["id"]=172108,["coords"]={{24.6 ,60.6 },{25.4,60.2}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Wounded Forest Guardian"    ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={151 ,"Stag"         },["familySkills"]=STAG_SKILLS          ,["displayID"]=93783 ,["id"]=165093,["coords"]={{25.6 ,52.8 },{29.2,48.2},{30.2,47}                                                                                                                                                                                                                        } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Monstrous Needler"         ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={44  ,"Wasp"         },["familySkills"]=WASP_SKILLS          ,["displayID"]=95689 ,["id"]=170847,["coords"]={{26.4 ,58.4 },{26.4,58.8},{26.6,58.8},{26.8,58.4}                                                                                                                                                                                                          } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Terrified Guardian"        ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={151 ,"Stag"         },["familySkills"]=STAG_SKILLS          ,["displayID"]=93791 ,["id"]=172067,["coords"]={{26.4 ,58.6 },{26.6,58.6},{27.2,57.8},{27.6,59.6},{27.8,56.2},{32,62.2},{33,61}                                                                                                                                                                            } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Mist-Maddened Wader"       ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={125 ,"Crane"        },["familySkills"]=CRANE_SKILLS         ,["displayID"]=95553 ,["id"]=172072,["coords"]={{26.4 ,60.6 },{27.4,61.4},{29.4,61.8}                                                                                                                                                                                                                      } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Unnerved Wader"            ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={125 ,"Crane"        },["familySkills"]=CRANE_SKILLS         ,["displayID"]=95555 ,["id"]=172070,["coords"]={{26.8 ,58.8 },{27.4,57.8},{27.6,56.4},{27.8,59.4},{28,58}                                                                                                                                                                                                  } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Deranged Guardian"         ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={151 ,"Stag"         },["familySkills"]=STAG_SKILLS          ,["displayID"]=93795 ,["id"]=166735,["coords"]={{27.2 ,52.4 },{27.4,56.2},{27.6,56.2},{28,52.6},{28,53.8},{28.8,52.6},{29,55.4},{29.4,55.8}                                                                                                                                                                } },
  {["zone_name"]="Revendreth"         ,["zoneID"]=1525 ,["name"]="Great Granitefur"          ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={128 ,"Stone Hound"   },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=93163 ,["id"]=158978,["coords"]={{27.4 ,22.4 },{30.4,14.6}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="War-gorm"                 ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94193 ,["id"]=170933,["coords"]={{27.4 ,56.2 },{27.6,56}                                                                                                                                                                                                                                    } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Fog-Frenzied Gladestalker" ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=62590 ,["id"]=172071,["coords"]={{27.4 ,60.6 },{28.8,62.4},{28.8,62.8},{30.2,60.6}                                                                                                                                                                                                          } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Frightened Gladestalker"   ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={2   ,"Cat"          },["familySkills"]=CAT_SKILLS           ,["displayID"]=62588 ,["id"]=172069,["coords"]={{27.6 ,59.2 },{27.8,59.6},{30.2,55.6}                                                                                                                                                                                                                      } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Hazebroken Guardian"       ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={151 ,"Stag"         },["familySkills"]=STAG_SKILLS          ,["displayID"]=93787 ,["id"]=172073,["coords"]={{29.2 ,58.8 },{29.2,62.2},{30.2,62.4}                                                                                                                                                                                                                      } },
  {["zone_name"]="Revendreth"         ,["zoneID"]=1525 ,["name"]="Dire Evedweller"           ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={24  ,"Bat"          },["familySkills"]=BAT_SKILLS           ,["displayID"]=92701 ,["id"]=159178,["coords"]={{29.6 ,20.8 },{29.8,20.4},{30,16.2},{30.2,16.8},{31.4,20.8},{31.6,21},{32,25.4},{32.2,25.6},{33.4,21.6},{35.2,23.4},{35.8,19.8}                                                                                                                            } },
  {["zone_name"]="The Maw"             ,["zoneID"]=1543 ,["name"]="Gargantuan Seeker"         ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=92628 ,["id"]=161172,["coords"]={{32.4 ,24.4 },{32.4,25.4},{32.4,25.8},{32.6,26},{33,24.6},{33.4,24.4},{33.8,25}                                                                                                                                                                            } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Flayedwing Fleshripper"    ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=94926 ,["id"]=172390,["coords"]={{33.2 ,75.4 },{34.2,77},{35.2,76.8},{36,77.6},{36.2,76.4}                                                                                                                                                                                                  } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Ragerider Battlehorn"      ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={157 ,"Oxen"         },["familySkills"]=OXEN_SKILLS          ,["displayID"]=96469 ,["id"]=170969,["coords"]={{34   ,76.8 },{35,77},{35,78},{35.8,75.4},{35.8,78.8},{36,78.2},{36.2,76.4},{36.6,78.6},{37,76.8}                                                                                                                                                          } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Chosen Warhound"           ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=70086 ,["id"]=172388,["coords"]={{34   ,80   },{36,76.6},{36,79.2},{36.2,76.4},{36.4,75.4},{36.6,78.4},{36.8,75.6}                                                                                                                                                                          } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Unfallen Warhound"         ,["maxlevel"]=52,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=70086 ,["id"]=157662,["coords"]={{39   ,73.4 },{39.6,73.4},{39.8,74}                                                                                                                                                                                                                        } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Unfallen Warhound"         ,["maxlevel"]=52,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=70086 ,["id"]=157665,["coords"]={{40.4 ,73.6 },{40.6,73.8}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Lumbering Crystalback"     ,["maxlevel"]=52,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={21  ,"Turtle"       },["familySkills"]=TURTLE_SKILLS        ,["displayID"]=94149 ,["id"]=163556,["coords"]={{41.8 ,45   }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Revendreth"         ,["zoneID"]=1525 ,["name"]="TombBurster"              ,["maxlevel"]=58,["minlevel"]=60,["info"]="",["class"]=CLASS_ELITE      ,["family"]={3   ,"Spider"       },["familySkills"]=SPIDER_SKILLS        ,["displayID"]=94408 ,["id"]=155779,["coords"]={{42.8 ,79.2 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Spires of Ascension"  ,["zoneID"]=1693 ,["name"]="Azules"                   ,["maxlevel"]=62,["minlevel"]=62,["info"]="",["class"]=CLASS_RARE       ,["family"]={27  ,"Wind Serpent"  },["familySkills"]=WIND_SERPENTS_SKILLS ,["displayID"]=93471 ,["id"]=163077,["coords"]={{43.6 ,57   }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Corrupted Cloud feather"    ,["maxlevel"]=60,["minlevel"]=52,["info"]="",["class"]=CLASS_RARE       ,["family"]={7   ,"Carrion Bird"  },["familySkills"]=CARRION_BIRD_SKILLS  ,["displayID"]=95115 ,["id"]=158256,["coords"]={{44   ,66   },{44,66.8},{44.8,63.4},{44.8,64.2},{45,66.2},{45.2,67.4},{45.2,68.4},{45.2,68.6},{45.8,66.2},{45.8,67},{46,63.2},{46,65.2},{46.4,64.4},{46.8,63.4},{47.2,66.6},{47.4,66.2},{47.6,64.6},{47.6,66.4},{47.6,66.8},{48,64.4},{48,68.2}            } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Tahonta"                  ,["maxlevel"]=54,["minlevel"]=54,["info"]="",["class"]=CLASS_ELITE      ,["family"]={157 ,"Oxen"         },["familySkills"]=OXEN_SKILLS          ,["displayID"]=96462 ,["id"]=162586,["coords"]={{44.2 ,51   },{44.4,50.4},{44.4,52},{44.6,50.2},{44.6,52}                                                                                                                                                                                                  } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Kala"                     ,["maxlevel"]=52,["minlevel"]=51,["info"]="",["class"]=CLASS_RARE       ,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANE_SKILLS  ,["displayID"]=93463 ,["id"]=158254,["coords"]={{46   ,56.8 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Deifir the Untamed"         ,["maxlevel"]=61,["minlevel"]=61,["info"]="",["class"]=CLASS_ELITE      ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94195 ,["id"]=164238,["coords"]={{46.2 ,21.8 },{46.4,21.4},{46.4,22.6},{46.4,24.2},{46.4,25.2},{46.4,25.6},{46.6,24.4},{46.6,25},{46.6,26.2},{47,27.4},{47.4,21.2},{47.4,28.4},{47.6,28.2},{48,27.4},{48.4,21.2},{48.6,21.4},{49,22},{49,22.6},{49,25.6},{49.4,23.8},{49.4,24.8},{49.6,24.2}} },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Spiritwing Emperor"        ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={37  ,"Moth"         },["familySkills"]=MOTH_SKILLS          ,["displayID"]=93496 ,["id"]=170397,["coords"]={{47.4 ,34.2 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Argentwing Patriarch"      ,["maxlevel"]=50,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANE_SKILLS  ,["displayID"]=93464 ,["id"]=169504,["coords"]={{48   ,50.2 },{49,51.2}                                                                                                                                                                                                                                    } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Basilofos,KingoftheHill"  ,["maxlevel"]=52,["minlevel"]=60,["info"]="",["class"]=CLASS_ELITE      ,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANE_SKILLS  ,["displayID"]=93463 ,["id"]=170659,["coords"]={{48.4 ,50.4 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Gorgebeak"                ,["maxlevel"]=52,["minlevel"]=51,["info"]="",["class"]=CLASS_RARE       ,["family"]={125 ,"Crane"        },["familySkills"]=CRANE_SKILLS         ,["displayID"]=95554 ,["id"]=168240,["coords"]={{49   ,46.8 },{49.2,46.4}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="TrainedHellhound"         ,["maxlevel"]=54,["minlevel"]=52,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=70087 ,["id"]=166592,["coords"]={{49.2 ,45.6 },{49.4,47.2},{49.4,47.8},{49.6,47.2},{50,46.4},{50,47.8},{51.2,46}                                                                                                                                                                            } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Cloudfeather Guardian"     ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_ELITE      ,["family"]={7   ,"Carrion Bird"  },["familySkills"]=CARRION_BIRD_SKILLS  ,["displayID"]=95116 ,["id"]=170932,["coords"]={{49.4 ,58   },{50,59},{50.2,57.8},{50.6,59.6},{50.8,58.4},{50.8,58.8}                                                                                                                                                                                      } },
  {["zone_name"]="Revendreth"         ,["zoneID"]=1525 ,["name"]="SoulstalkerAlpha"         ,["maxlevel"]=58,["minlevel"]=58,["info"]="",["class"]=CLASS_RARE       ,["family"]={128 ,"Stone Hound"   },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=93160 ,["id"]=162990,["coords"]={{49.8 ,74.6 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="OldArdeite"               ,["maxlevel"]=61,["minlevel"]=61,["info"]="",["class"]=CLASS_ELITE      ,["family"]={7   ,"Carrion Bird"  },["familySkills"]=CARRION_BIRD_SKILLS  ,["displayID"]=95115 ,["id"]=164391,["coords"]={{50.2 ,57.6 },{51,57.4},{51,58.6},{51.2,58.4},{51.8,57.8},{52,58.8}                                                                                                                                                                                        } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Baedos"                   ,["maxlevel"]=60,["minlevel"]=51,["info"]="",["class"]=CLASS_ELITE      ,["family"]={21  ,"Turtle"       },["familySkills"]=TURTLE_SKILLS        ,["displayID"]=97288 ,["id"]=160629,["coords"]={{51.2 ,40.6 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Revendreth"         ,["zoneID"]=1525 ,["name"]="Hopecrusher"              ,["maxlevel"]=62,["minlevel"]=62,["info"]="",["class"]=CLASS_RARE_ELITE ,["family"]={128 ,"Stone Hound"   },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=95369 ,["id"]=166679,["coords"]={{51.2 ,51.2 },{51.2,52.2},{51.4,52.8},{51.8,51},{51.8,52}                                                                                                                                                                                                  } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Kala"                     ,["maxlevel"]=51,["minlevel"]=51,["info"]="",["class"]=CLASS_RARE       ,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANE_SKILLS  ,["displayID"]=93463 ,["id"]=158081,["coords"]={{51.2 ,59.4 },{51.4,59.6},{51.8,54.8}                                                                                                                                                                                                                      } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Fortified Dessicator"      ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94190 ,["id"]=173409,["coords"]={{51.4 ,79.8 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Galescreamer Elder"        ,["maxlevel"]=54,["minlevel"]=54,["info"]="",["class"]=CLASS_ELITE       ,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=94913 ,["id"]=168216,["coords"]={{52.2 ,58   },{53,57.2},{53.2,57.8},{53.4,59.8},{53.8,60.2},{53.8,61},{54.4,57},{54.4,58},{54.6,57},{54.6,59}                                                                                                                                              } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Ragewing"                 ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=94922 ,["id"]=165125,["coords"]={{52.8 ,67.6 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Boneweave Rampager"        ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_ELITE       ,["family"]={3   ,"Spider"       },["familySkills"]=SPIDER_SKILLS        ,["displayID"]=94406 ,["id"]=159916,["coords"]={{53.2 ,16.6 },{54,17.8},{54.6,17.6},{55.8,17.4},{55.8,18.6}                                                                                                                                                                                                } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Ravenomous"               ,["maxlevel"]=61,["minlevel"]=61,["info"]="",["class"]=CLASS_ELITE      ,["family"]={44  ,"Wasp"         },["familySkills"]=WASP_SKILLS          ,["displayID"]=92246 ,["id"]=159753,["coords"]={{53.2 ,16.6 },{54,18.4},{54,19.2}                                                                                                                                                                                                                          } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Pesticide"                ,["maxlevel"]=54,["minlevel"]=53,["info"]="",["class"]=CLASS_ELITE      ,["family"]={53  ,"Beetle"       },["familySkills"]=BEETLE_SKILLS        ,["displayID"]=34902 ,["id"]=162767,["coords"]={{53.8 ,61   }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Gormbore"                 ,["maxlevel"]=60,["minlevel"]=61,["info"]="",["class"]=CLASS_ELITE      ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94201 ,["id"]=163370,["coords"]={{53.8 ,75.8 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="The Maw"             ,["zoneID"]=1543 ,["name"]="Dread Soulseeker"          ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=92627 ,["id"]=160784,["coords"]={{54.6 ,58.2 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Nemaeus"                  ,["maxlevel"]=52,["minlevel"]=60,["info"]="",["class"]=CLASS_ELITE      ,["family"]={160 ,"Feathermane"  },["familySkills"]=FEATHERMANE_SKILLS  ,["displayID"]=94634 ,["id"]=161529,["coords"]={{55   ,80.8 },{55.2,80.4}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Sister Chelicerae"         ,["maxlevel"]=62,["minlevel"]=62,["info"]="",["class"]=CLASS_RARE_ELITE ,["family"]={3   ,"Spider"       },["familySkills"]=SPIDER_SKILLS        ,["displayID"]=96755 ,["id"]=159886,["coords"]={{55.2 ,23.4 },{55.4,22.2},{55.6,22.4}                                                                                                                                                                                                                      } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Deathfang"                ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=70087 ,["id"]=171591,["coords"]={{55.2 ,53.4 },{55.2,53.6}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Deathfang"                ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={52  ,"Hound"          },["familySkills"]=DOGS_SKILLS          ,["displayID"]=70087 ,["id"]=171450,["coords"]={{55.2 ,53.4 },{55.4,53.6}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Bloodtusk Ancient"        ,["maxlevel"]=54,["minlevel"]=54,["info"]="",["class"]=CLASS_ELITE      ,["family"]={5   ,"Boar"         },["familySkills"]=BOAR_SKILLS          ,["displayID"]=96310 ,["id"]=168192,["coords"]={{55.2 ,55.6 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Cloudtail"                ,["maxlevel"]=52,["minlevel"]=60,["info"]="",["class"]=CLASS_ELITE      ,["family"]={50  ,"Fox"          },["familySkills"]=FOX_SKILLS           ,["displayID"]=94633 ,["id"]=161530,["coords"]={{55.2 ,80.4 },{55.2,80.6},{56,81.8}                                                                                                                                                                                                                        } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Sigilback"                ,["maxlevel"]=52,["minlevel"]=60,["info"]="",["class"]=CLASS_ELITE      ,["family"]={21  ,"Turtle"       },["familySkills"]=TURTLE_SKILLS        ,["displayID"]=94631 ,["id"]=161527,["coords"]={{55.2 ,80.4 },{55.2,80.6}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Aethon"                   ,["maxlevel"]=52,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE      ,["family"]={299 ,"Courser"      },["familySkills"]=COURSER_SKILLS       ,["displayID"]=94632 ,["id"]=161528,["coords"]={{55.2 ,80.4 },{55.2,80.6}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Darkwing"                 ,["maxlevel"]=52,["minlevel"]=51,["info"]="",["class"]=CLASS_RARE       ,["family"]={7   ,"Carrion Bird"  },["familySkills"]=CARRION_BIRD_SKILLS  ,["displayID"]=95115 ,["id"]=168402,["coords"]={{56   ,48   }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="Gristlebeak"              ,["maxlevel"]=54,["minlevel"]=54,["info"]="",["class"]=CLASS_ELITE      ,["family"]={38  ,"Chimaera"     },["familySkills"]=CHIMAERAS_SKILLS     ,["displayID"]=94882 ,["id"]=162588,["coords"]={{57.4 ,52   },{57.6,51.4},{57.6,51.6}                                                                                                                                                                                                                      } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Egg-TenderLeh'go"         ,["maxlevel"]=56,["minlevel"]=56,["info"]="",["class"]=CLASS_ELITE      ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94204 ,["id"]=167851,["coords"]={{57.8 ,29.6 },{58,29.4}                                                                                                                                                                                                                                    } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="EngorgedBorer"            ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={292 ,"Carapid"      },["familySkills"]=KROLUSK_SKILLS       ,["displayID"]=94197 ,["id"]=170767,["coords"]={{58.4 ,32.2 },{58.4,32.8},{58.4,33.6},{58.4,34.6},{58.6,34.8},{59.2,32},{59.2,35.8},{59.6,35.4},{59.8,31},{60.4,31.8},{60.4,32.8},{60.4,33.8},{60.6,33},{60.8,31},{61.2,29.8},{61.2,33.6},{61.4,29.4},{61.4,32},{61.6,31},{61.6,32},{62.6,30.8},{63,30.4}  } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="TheSlumberingEmperor"     ,["maxlevel"]=54,["minlevel"]=60,["info"]="",["class"]=CLASS_ELITE      ,["family"]={37  ,"Moth"         },["familySkills"]=MOTH_SKILLS          ,["displayID"]=95201 ,["id"]=167721,["coords"]={{59.2 ,46.6 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="Sundancer"                ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE_ELITE ,["family"]={299 ,"Courser"      },["familySkills"]=COURSER_SKILLS       ,["displayID"]=94295 ,["id"]=170439,["coords"]={{59.6 ,95.4 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="The Maw"             ,["zoneID"]=1543 ,["name"]="SkitteringBroodmother"    ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={127 ,"Rodent"       },["familySkills"]=RODENT_SKILLS        ,["displayID"]=96556 ,["id"]=172524,["coords"]={{61.4 ,78.4 },{61.6,78.2}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Bastion"            ,["zoneID"]=1533 ,["name"]="BehemothGlimmerfly"       ,["maxlevel"]=50,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={37  ,"Moth"         },["familySkills"]=MOTH_SKILLS          ,["displayID"]=93498 ,["id"]=169193,["coords"]={{63.2 ,52.4 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Revendreth"         ,["zoneID"]=1525 ,["name"]="Doom"                     ,["maxlevel"]=58,["minlevel"]=57,["info"]="",["class"]=CLASS_RARE       ,["family"]={128 ,"Stone Hound"   },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=95371 ,["id"]=164198,["coords"]={{64.4 ,50.6 },{64.6,52.6},{64.8,48.4},{65.4,48.8},{65.4,50},{65.4,50.8},{65.4,51.8},{65.6,46.6},{65.6,47.8},{65.6,49},{65.6,49.8},{65.6,51.8},{65.8,51},{65.8,53.8}                                                                                        } },
  {["zone_name"]="Revendreth"         ,["zoneID"]=1525 ,["name"]="Justice"                  ,["maxlevel"]=58,["minlevel"]=57,["info"]="",["class"]=CLASS_RARE       ,["family"]={128 ,"Stone Hound"   },["familySkills"]=QUILLEN_SKILLS       ,["displayID"]=95370 ,["id"]=164197,["coords"]={{64.4 ,52.4 },{66.4,52},{66.6,51.8},{67.2,52.6},{67.4,54.2},{67.6,51.8},{69.2,52},{69.6,52}                                                                                                                                                                } },
  {["zone_name"]="Maldraxxus"         ,["zoneID"]=1536 ,["name"]="BloodtuskAncient"         ,["maxlevel"]=54,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={5   ,"Boar"         },["familySkills"]=BOAR_SKILLS          ,["displayID"]=96310 ,["id"]=175162,["coords"]={{67.4 ,49   },{67.6,49.4}                                                                                                                                                                                                                                  } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Dambala"                  ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={35  ,"Serpent"      },["familySkills"]=SERPENT_SKILLS       ,["displayID"]=78246 ,["id"]=166475,["coords"]={{67.8 ,36.2 }                                                                                                                                                                                                                                              } },
  {["zone_name"]="Ardenweald"         ,["zoneID"]=1565 ,["name"]="Dambala"                  ,["maxlevel"]=60,["minlevel"]=60,["info"]="",["class"]=CLASS_RARE       ,["family"]={35  ,"Serpent"      },["familySkills"]=SERPENT_SKILLS       ,["displayID"]=98233 ,["id"]=167848,["coords"]={{68.6 ,65   },{68.6,65.8}                                                                                                                                                                                                                                  } },



  
  --Stable Masters
{["zone_name"] = "Dun Morogh"                ,[ "zoneID" ] =27   ,["name"]="Shelby Stoneflint"               ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9253  ,["id"]=9980   ,["react"]={    1,-1 }	,[ "coords"]= {{ 54    ,51    }}} ,
{["zone_name"] = "Duskwood"                  ,[ "zoneID" ] =47   ,["name"]="Steven Black"                    ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=10062 ,["id"]=10062  ,["react"]={    1,-1 }	,[ "coords"]= {{ 74    ,46.2  }}} ,
{["zone_name"] = "Nazjatar"                  ,[ "zoneID" ] =1355 ,["name"]="Tamer Orami"                     ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=92566 ,["id"]=155941 ,["react"]={    1,-1 }	,[ "coords"]= {{ 39.4  ,55.4  }}} ,
{["zone_name"] = "Nazjatar"                  ,[ "zoneID" ] =1355 ,["name"]="Lily Bopip"                      ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=90579 ,["id"]=151352 ,["react"]={    1,1  }	,[ "coords"]= {{ 47.4  ,62    }}} ,
{["zone_name"] = "Mechagon"                  ,[ "zoneID" ] =1462 ,["name"]="Vera Lonelycog"                  ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=90823 ,["id"]=150629 ,["react"]={    1,1  }	,[ "coords"]= {{ 69.2  ,30.4  }}} ,
{["zone_name"] = "Uldum"                     ,[ "zoneID" ] =1527 ,["name"]="Darwishi"                        ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=35929 ,["id"]=164249 ,["react"]={    1,1  }	,[ "coords"]= {{ 54.6  ,33.8  }}} ,
{["zone_name"] = "Wetlands"                  ,[ "zoneID" ] =56   ,["name"]="Salustred"                       ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9275  ,["id"]=43994  ,["react"]={    1,-1 }	,[ "coords"]= {{ 57.6  ,40.2  }}} ,
{["zone_name"] = "Wetlands"                  ,[ "zoneID" ] =56   ,["name"]="Bethaine Flinthammer"            ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9264  ,["id"]=10046  ,["react"]={    1,-1 }	,[ "coords"]= {{ 10.4  ,59.4  }}} ,
{["zone_name"] = "Elwynn Forest"             ,[ "zoneID" ] =37   ,["name"]="Erma"                            ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9257  ,["id"]=6749   ,["react"]={    1,-1 }	,[ "coords"]= {{ 42.8  ,65.8  }}} ,
{["zone_name"] = "Silverpine Forest"         ,[ "zoneID" ] =21   ,["name"]="Sarah Goode"                     ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9251  ,["id"]=9979   ,["react"]={-   1,1  }	,[ "coords"]= {{ 46    ,42.4  }}} ,
{["zone_name"] = "Silverpine Forest"         ,[ "zoneID" ] =21   ,["name"]="\"Salty\" Rocka"                 ,["maxlevel"]=60  ,["minlevel"]=14  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=34616 ,["id"]=45498  ,["react"]={-   1,1  }	,[ "coords"]= {{ 44.4  ,20.8  }}} ,
{["zone_name"] = "Silithus"                  ,[ "zoneID" ] =81   ,["name"]="Squire Leoren Mal'derath"        ,["maxlevel"]=60  ,["minlevel"]=57  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=15685 ,["id"]=15722  ,["react"]={    1,1  }	,[ "coords"]= {{ 53.2  ,34.4  }}} ,
{["zone_name"] = "Durotar"                   ,[ "zoneID" ] =1    ,["name"]="Shoja'my"                        ,["maxlevel"]=20  ,["minlevel"]=10  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9262  ,["id"]=9987   ,["react"]={-   1,1  }	,[ "coords"]= {{ 52    ,41.8  }}} ,
{["zone_name"] = "Darkshore"                 ,[ "zoneID" ] =62   ,["name"]="Jaelysia"                        ,["maxlevel"]=60  ,["minlevel"]=19  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9294  ,["id"]=10085  ,["react"]={    1,-1 }	,[ "coords"]= {{ 50.4  ,19.2  }}} ,
{["zone_name"] = "Undercity"                 ,[ "zoneID" ] =998  ,["name"]="Anya Maulray"                    ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9273  ,["id"]=10053  ,["react"]={-   1,1  }	,[ "coords"]= {{ 66.8  ,38.6  }}} ,
{["zone_name"] = "Dustwallow Marsh"          ,[ "zoneID" ] =70   ,["name"]="Michael"                         ,["maxlevel"]=60  ,["minlevel"]=49  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9266  ,["id"]=10047  ,["react"]={    1,-1 }	,[ "coords"]= {{ 65.8  ,45.4  }}} ,
{["zone_name"] = "Stormwind City"            ,[ "zoneID" ] =84   ,["name"]="Karin"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33756 ,["id"]=44252  ,["react"]={    1,-1 }	,[ "coords"]= {{ 77.8  ,67.2  }}} ,
{["zone_name"] = "Stormwind City"            ,[ "zoneID" ] =84   ,["name"]="Jenova Stoneshield"              ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=10477 ,["id"]=11069  ,["react"]={    1,-1 }	,[ "coords"]= {{ 67    ,37.4  }}} ,
{["zone_name"] = "Stormwind City"            ,[ "zoneID" ] =84   ,["name"]="Ashlee Umberleaf"                ,["maxlevel"]=110 ,["minlevel"]=110 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=82897 ,["id"]=133408 ,["react"]={    1,nil}	,[ "coords"]= {{ 53.4  ,12.6  }}} ,
{["zone_name"] = "Stormwind City"            ,[ "zoneID" ] =84   ,["name"]="Sylista"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9249  ,["id"]=9977   ,["react"]={    1,nil}	,[ "coords"]= {{ 42.4  ,60.8  }}} ,
{["zone_name"] = "Ironforge"                 ,[ "zoneID" ] =87   ,["name"]="Ulbrek Firehand"                 ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9258  ,["id"]=9984   ,["react"]={    1,nil}	,[ "coords"]= {{ 69.4  ,84    }}} ,
{["zone_name"] = "Blackrock Depths"          ,[ "zoneID" ] =242  ,["name"]="Kasea Angerforge"                ,["maxlevel"]=120 ,["minlevel"]=120 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=88363 ,["id"]=144119 ,["react"]={    1,nil}	,[ "coords"]= {{ 47.6  ,47.2  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Murog"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=35816 ,["id"]=47764  ,["react"]={-   1,1  }	,[ "coords"]= {{ 62.6  ,35.4  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Bezzil"                          ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=34673 ,["id"]=45789  ,["react"]={nil,1    }	,[ "coords"]= {{ 40.8  ,80.4  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Lonto"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=34111 ,["id"]=44788  ,["react"]={-   1,1  }	,[ "coords"]= {{ 39.4  ,49.2  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Xon'cha"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9261  ,["id"]=9988   ,["react"]={nil,1    }	,[ "coords"]= {{ 32.4  ,64.4  }}} ,
{["zone_name"] = "Orgrimmar"                 ,[ "zoneID" ] =85   ,["name"]="Hern Cragfeather"                ,["maxlevel"]=110 ,["minlevel"]=110 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=82725 ,["id"]=133108 ,["react"]={nil,1    }	,[ "coords"]= {{ 38    ,86.8  }}} ,
{["zone_name"] = "Thunder Bluff"             ,[ "zoneID" ] =88   ,["name"]="Bulrug"                          ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9272  ,["id"]=10054  ,["react"]={-   1,1  }	,[ "coords"]= {{ 44.8  ,60.6  }}} ,
{["zone_name"] = "Darnassus"                 ,[ "zoneID" ] =89   ,["name"]="Alassin"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9275  ,["id"]=10056  ,["react"]={    1,nil}	,[ "coords"]= {{ 43.4  ,29.6  }}} ,
{["zone_name"] = "Northern Barrens"          ,[ "zoneID" ] =10   ,["name"]="Reggifuz"                        ,["maxlevel"]=60  ,["minlevel"]=20  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9286  ,["id"]=10063  ,["react"]={    1,1  }	,[ "coords"]= {{ 67.4  ,74.2  }}} ,
{["zone_name"] = "Northern Barrens"          ,[ "zoneID" ] =10   ,["name"]="Sikwa"                           ,["maxlevel"]=60  ,["minlevel"]=19  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9254  ,["id"]=9981   ,["react"]={-   1,1  }	,[ "coords"]= {{ 49    ,57.4  }}} ,
{["zone_name"] = "Northern Barrens"          ,[ "zoneID" ] =10   ,["name"]="Carthok"                         ,["maxlevel"]=60  ,["minlevel"]=21  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=38007 ,["id"]=43988  ,["react"]={-   1,1  }	,[ "coords"]= {{ 56.4  ,39.8  }}} ,
{["zone_name"] = "Northern Barrens"          ,[ "zoneID" ] =10   ,["name"]="Vernon Soursprye"                ,["maxlevel"]=60  ,["minlevel"]=27  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=37699 ,["id"]=43982  ,["react"]={-   1,1  }	,[ "coords"]= {{ 62.4  ,16.8  }}} ,
{["zone_name"] = "Icecrown"                  ,[ "zoneID" ] =118  ,["name"]="Moonbell"                        ,["maxlevel"]=75  ,["minlevel"]=75  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=29739 ,["id"]=35291  ,["react"]={    1,-1 }	,[ "coords"]= {{ 75.8  ,20.2  }}} ,
{["zone_name"] = "Hillsbrad Foothills"       ,[ "zoneID" ] =25   ,["name"]="Ansel Tunsleworth"               ,["maxlevel"]=52  ,["minlevel"]=52  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=36477 ,["id"]=49431  ,["react"]={-   1,1  }	,[ "coords"]= {{ 59.6  ,64.8  }}} ,
{["zone_name"] = "Hillsbrad Foothills"       ,[ "zoneID" ] =25   ,["name"]="Theodore Mont Claire"            ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9279  ,["id"]=10057  ,["react"]={-   1,1  }	,[ "coords"]= {{ 56.8  ,46.8  }}} ,
{["zone_name"] = "Western Plaguelands"       ,[ "zoneID" ] =22   ,["name"]="Lois Henderson"                  ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=35871 ,["id"]=47866  ,["react"]={-   1,1  }	,[ "coords"]= {{ 47.8  ,64    }}} ,
{["zone_name"] = "Badlands"                  ,[ "zoneID" ] =15   ,["name"]="Deedee Dropbolt"                 ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=36005 ,["id"]=48055  ,["react"]={    1,1  }	,[ "coords"]= {{ 65.4  ,36.4  }}} ,
{["zone_name"] = "Northern Stranglethorn"    ,[ "zoneID" ] =50   ,["name"]="Durik"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=3519  ,["id"]=16094  ,["react"]={-   1,1  }	,[ "coords"]= {{ 38    ,51.2  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Vorcha"                          ,["maxlevel"]=60  ,["minlevel"]=20  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33441 ,["id"]=43634  ,["react"]={-   1,1  }	,[ "coords"]= {{ 50.2  ,65.8  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Lursa"                           ,["maxlevel"]=60  ,["minlevel"]=37  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33572 ,["id"]=43617  ,["react"]={-   1,1  }	,[ "coords"]= {{ 12.6  ,33.8  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Maluressian"                     ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9271  ,["id"]=10052  ,["react"]={    1,-1 }	,[ "coords"]= {{ 36.4  ,50.4  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Qeeju"                           ,["maxlevel"]=32  ,["minlevel"]=23  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=14773 ,["id"]=15131  ,["react"]={-   1,1  }	,[ "coords"]= {{ 73.2  ,60.6  }}} ,
{["zone_name"] = "Ashenvale"                 ,[ "zoneID" ] =63   ,["name"]="Drek"                            ,["maxlevel"]=60  ,["minlevel"]=49  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=31438 ,["id"]=43630  ,["react"]={-   1,1  }	,[ "coords"]= {{ 38.6  ,42.4  }}} ,
{["zone_name"] = "Ghostlands"                ,[ "zoneID" ] =95   ,["name"]="Paniar"                          ,["maxlevel"]=60  ,["minlevel"]=22  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16821 ,["id"]=16665  ,["react"]={-   1,1  }	,[ "coords"]= {{ 48.4  ,31.2  }}} ,
{["zone_name"] = "Ghostlands"                ,[ "zoneID" ] =95   ,["name"]="Huntsman Torf Angerhoof"         ,["maxlevel"]=80  ,["minlevel"]=58  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16303 ,["id"]=16586  ,["react"]={-   1,1  }	,[ "coords"]= {{ 54.4  ,41    }}} ,
{["zone_name"] = "Ghostlands"                ,[ "zoneID" ] =95   ,["name"]="Master Sergeant Lorin Thalmerok" ,["maxlevel"]=80  ,["minlevel"]=58  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16367 ,["id"]=16824  ,["react"]={    1,-1 }	,[ "coords"]= {{ 54.4  ,62.6  }}} ,
{["zone_name"] = "Silvermoon City"           ,[ "zoneID" ] =110  ,["name"]="Shalenn"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16751 ,["id"]=16656  ,["react"]={-   1,1  }	,[ "coords"]= {{ 82.8  ,30.8  }}} ,
{["zone_name"] = "Terokkar Forest"           ,[ "zoneID" ] =108  ,["name"]="Leassian"                        ,["maxlevel"]=83  ,["minlevel"]=78  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22730 ,["id"]=24905  ,["react"]={    1,-1 }	,[ "coords"]= {{ 56.8  ,53.8  }}} ,
{["zone_name"] = "Terokkar Forest"           ,[ "zoneID" ] =108  ,["name"]="Trag"                            ,["maxlevel"]=63  ,["minlevel"]=63  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=18415 ,["id"]=18984  ,["react"]={-   1,1  }	,[ "coords"]= {{ 49.4  ,44.6  }}} ,
{["zone_name"] = "Shadowmoon Valley (BC)"         ,[ "zoneID" ] =104  ,["name"]="Crinn Pathfinder"                ,["maxlevel"]=65  ,["minlevel"]=65  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=18777 ,["id"]=19368  ,["react"]={    1,nil}	,[ "coords"]= {{ 37.4  ,56    }}} ,
{["zone_name"] = "Shadowmoon Valley (BC)"         ,[ "zoneID" ] =104  ,["name"]="Gedrah"                          ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=20228 ,["id"]=21336  ,["react"]={nil,1    }	,[ "coords"]= {{ 29.2  ,29.4  }}} ,
{["zone_name"] = "Zangarmarsh"               ,[ "zoneID" ] =102  ,["name"]="Joraal"                          ,["maxlevel"]=80  ,["minlevel"]=65  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17637 ,["id"]=18250  ,["react"]={    1,-1 }	,[ "coords"]= {{ 67.6  ,49.6  }}} ,
{["zone_name"] = "Zangarmarsh"               ,[ "zoneID" ] =102  ,["name"]="Khalan"                          ,["maxlevel"]=81  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17631 ,["id"]=18244  ,["react"]={-   1,1  }	,[ "coords"]= {{ 31.8  ,49.8  }}} ,
{["zone_name"] = "Zangarmarsh"               ,[ "zoneID" ] =102  ,["name"]="Kameel Longstride"               ,["maxlevel"]=81  ,["minlevel"]=61  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17319 ,["id"]=17896  ,["react"]={    1,1  }	,[ "coords"]= {{ 78.8  ,64.2  }}} ,
{["zone_name"] = "Blade's Edge Mountains"    ,[ "zoneID" ] =105  ,["name"]="Lor"                             ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=18915 ,["id"]=19476  ,["react"]={nil,1    }	,[ "coords"]= {{ 53.4  ,53.2  }}} ,
{["zone_name"] = "Netherstorm"               ,[ "zoneID" ] =109  ,["name"]="Liza Cutlerflix"                 ,["maxlevel"]=66  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22780 ,["id"]=24974  ,["react"]={    1,1  }	,[ "coords"]= {{ 32    ,64.8  }}} ,
{["zone_name"] = "Borean Tundra"             ,[ "zoneID" ] =114  ,["name"]="Durkot Wolfbrother"              ,["maxlevel"]=80  ,["minlevel"]=59  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=23502 ,["id"]=26044  ,["react"]={-   1,1  }	,[ "coords"]= {{ 40.2  ,55    }}} ,
{["zone_name"] = "Borean Tundra"             ,[ "zoneID" ] =114  ,["name"]="Toby \"Mother Goose\" Ironbolt"  ,["maxlevel"]=80  ,["minlevel"]=62  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=23957 ,["id"]=26597  ,["react"]={    1,-1 }	,[ "coords"]= {{ 57    ,19    }}} ,
{["zone_name"] = "Borean Tundra"             ,[ "zoneID" ] =114  ,["name"]="Celidh Aletracker"               ,["maxlevel"]=75  ,["minlevel"]=58  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=24298 ,["id"]=27010  ,["react"]={    1,-1 }	,[ "coords"]= {{ 58.4  ,68.4  }}} ,
{["zone_name"] = "Borean Tundra"             ,[ "zoneID" ] =114  ,["name"]="Arthaid"                         ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17217 ,["id"]=16764  ,["react"]={    1,nil}	,[ "coords"]= {{ 59.8  ,24.2  }}} ,
{["zone_name"] = "Feralas"                   ,[ "zoneID" ] =69   ,["name"]="Antarius"                        ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9282  ,["id"]=10059  ,["react"]={    1,-1 }	,[ "coords"]= {{ 46.8  ,45.4  }}} ,
{["zone_name"] = "Feralas"                   ,[ "zoneID" ] =69   ,["name"]="Shyrka Wolfrunner"               ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9260  ,["id"]=9986   ,["react"]={nil,1    }	,[ "coords"]= {{ 74.4  ,43.2  }}} ,
{["zone_name"] = "Felwood"                   ,[ "zoneID" ] =77   ,["name"]="Hurah"                           ,["maxlevel"]=60  ,["minlevel"]=55  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17319 ,["id"]=48216  ,["react"]={    1,1  }	,[ "coords"]= {{ 44.4  ,28.4  }}} ,
{["zone_name"] = "Felwood"                   ,[ "zoneID" ] =77   ,["name"]="Nalesette Wildbringer"           ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=12749 ,["id"]=543    ,["react"]={    1,-1 }	,[ "coords"]= {{ 61.4  ,25.4  }}} ,
{["zone_name"] = "Shattrath City"            ,[ "zoneID" ] =111  ,["name"]="Ilthuril"                        ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=16706 ,["id"]=21517  ,["react"]={    1,1  }	,[ "coords"]= {{ 55.4  ,80.2  }}} ,
{["zone_name"] = "Shattrath City"            ,[ "zoneID" ] =111  ,["name"]="Oruhe"                           ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=17327 ,["id"]=21518  ,["react"]={    1,1  }	,[ "coords"]= {{ 28.4  ,47.4  }}} ,
{["zone_name"] = "Sholazar Basin"            ,[ "zoneID" ] =119  ,["name"]="Hadrius Harlowe"                 ,["maxlevel"]=80  ,["minlevel"]=66  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=25068 ,["id"]=28047  ,["react"]={    1,1  }	,[ "coords"]= {{ 27.2  ,59.4  }}} ,
{["zone_name"] = "Loch Modan"                ,[ "zoneID" ] =48   ,["name"]="Gravin Steelbeard"               ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33596 ,["id"]=43979  ,["react"]={    1,-1 }	,[ "coords"]= {{ 83.8  ,62.4  }}} ,
{["zone_name"] = "Loch Modan"                ,[ "zoneID" ] =48   ,["name"]="Lina Hearthstove"                ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9263  ,["id"]=9989   ,["react"]={    1,-1 }	,[ "coords"]= {{ 34.4  ,48    }}} ,
{["zone_name"] = "Grizzly Hills"             ,[ "zoneID" ] =116  ,["name"]="Craga Ironsting"                 ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26471 ,["id"]=29740  ,["react"]={nil,1    }	,[ "coords"]= {{ 21.6  ,64    }}} ,
{["zone_name"] = "Grizzly Hills"             ,[ "zoneID" ] =116  ,["name"]="Squire Percy"                    ,["maxlevel"]=9   ,["minlevel"]=9   ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=23796 ,["id"]=26377  ,["react"]={    1,nil}	,[ "coords"]= {{ 59    ,26.4  }}} ,
{["zone_name"] = "Grizzly Hills"             ,[ "zoneID" ] =116  ,["name"]="Matthew Ackerman"                ,["maxlevel"]=70  ,["minlevel"]=70  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=24277 ,["id"]=27068  ,["react"]={    1,-1 }	,[ "coords"]= {{ 32.4  ,59.6  }}} ,
{["zone_name"] = "Grizzly Hills"             ,[ "zoneID" ] =116  ,["name"]="Soulok Stormfury"                ,["maxlevel"]=80  ,["minlevel"]=66  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=24184 ,["id"]=26944  ,["react"]={-   1,1  }	,[ "coords"]= {{ 65    ,47.8  }}} ,
{["zone_name"] = "Blasted Lands"             ,[ "zoneID" ] =17   ,["name"]="Gina Gellar"                     ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33812 ,["id"]=44330  ,["react"]={    1,-1 }	,[ "coords"]= {{ 60.2  ,16    }}} ,
{["zone_name"] = "Blasted Lands"             ,[ "zoneID" ] =17   ,["name"]="Willard C. Bennington"           ,["maxlevel"]=63  ,["minlevel"]=63  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33808 ,["id"]=44335  ,["react"]={    1,-1 }	,[ "coords"]= {{ 46    ,85.4  }}} ,
{["zone_name"] = "Blasted Lands"             ,[ "zoneID" ] =17   ,["name"]="Kroff"                           ,["maxlevel"]=65  ,["minlevel"]=65  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33822 ,["id"]=44310  ,["react"]={-   1,1  }	,[ "coords"]= {{ 41.4  ,12.8  }}} ,
{["zone_name"] = "Westfall"                  ,[ "zoneID" ] =52   ,["name"]="Kirk Maxwell"                    ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9265  ,["id"]=10045  ,["react"]={    1,-1 }	,[ "coords"]= {{ 53    ,53    }}} ,
{["zone_name"] = "Desolace"                  ,[ "zoneID" ] =66   ,["name"]="Shelgrayn"                       ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=10567 ,["id"]=11104  ,["react"]={    1,-1 }	,[ "coords"]= {{ 65.4  ,7.8   }}} ,
{["zone_name"] = "Desolace"                  ,[ "zoneID" ] =66   ,["name"]="Fina Stillgrove"                 ,["maxlevel"]=60  ,["minlevel"]=35  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33562 ,["id"]=43877  ,["react"]={    1,1  }	,[ "coords"]= {{ 57    ,49.4  }}} ,
{["zone_name"] = "Stonetalon Mountains"      ,[ "zoneID" ] =65   ,["name"]="Adrius"                          ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9282  ,["id"]=43021  ,["react"]={    1,-1 }	,[ "coords"]= {{ 58.4  ,56.6  }}} ,
{["zone_name"] = "Dalaran"                   ,[ "zoneID" ] =125  ,["name"]="Tassia Whisperglen"              ,["maxlevel"]=75  ,["minlevel"]=75  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=25607 ,["id"]=28690  ,["react"]={    1,1  }	,[ "coords"]= {{ 59.4  ,37.4  }}} ,
{["zone_name"] = "Redridge Mountains"        ,[ "zoneID" ] =49   ,["name"]="Penny"                           ,["maxlevel"]=30  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9255  ,["id"]=9982   ,["react"]={    1,-1 }	,[ "coords"]= {{ 26.2  ,43    }}} ,
{["zone_name"] = "Tanaris"                   ,[ "zoneID" ] =71   ,["name"]="Laziphus"                        ,["maxlevel"]=60  ,["minlevel"]=50  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9259  ,["id"]=9985   ,["react"]={    1,1  }	,[ "coords"]= {{ 52.6  ,27.4  }}} ,
{["zone_name"] = "Arathi Highlands"          ,[ "zoneID" ] =14   ,["name"]="Emily Jackson"                   ,["maxlevel"]=60  ,["minlevel"]=32  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33685 ,["id"]=44123  ,["react"]={    1,-1 }	,[ "coords"]= {{ 40    ,49    }}} ,
{["zone_name"] = "Arathi Highlands"          ,[ "zoneID" ] =14   ,["name"]="Tharlidun"                       ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9250  ,["id"]=9976   ,["react"]={-   1,1  }	,[ "coords"]= {{ 69    ,34    }}} ,
{["zone_name"] = "The Hinterlands"           ,[ "zoneID" ] =26   ,["name"]="Huntsman Markhor"                ,["maxlevel"]=45  ,["minlevel"]=45  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=28263 ,["id"]=14741  ,["react"]={-   1,1  }	,[ "coords"]= {{ 79    ,79.4  }}} ,
{["zone_name"] = "The Hinterlands"           ,[ "zoneID" ] =26   ,["name"]="Roslyn Paxton"                   ,["maxlevel"]=60  ,["minlevel"]=30  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33502 ,["id"]=43766  ,["react"]={-   1,1  }	,[ "coords"]= {{ 31.8  ,57.4  }}} ,
{["zone_name"] = "The Hinterlands"           ,[ "zoneID" ] =26   ,["name"]="Tathan Thunderstone"             ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33504 ,["id"]=43770  ,["react"]={    1,-1 }	,[ "coords"]= {{ 66.4  ,45    }}} ,
{["zone_name"] = "The Hinterlands"           ,[ "zoneID" ] =26   ,["name"]="Killium Bouldertoe"              ,["maxlevel"]=60  ,["minlevel"]=36  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9283  ,["id"]=10061  ,["react"]={    1,-1 }	,[ "coords"]= {{ 14.4  ,45.2  }}} ,
{["zone_name"] = "Southern Barrens"          ,[ "zoneID" ] =199  ,["name"]="Munada"                          ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33801 ,["id"]=44349  ,["react"]={-   1,1  }	,[ "coords"]= {{ 39.2  ,19.8  }}} ,
{["zone_name"] = "Southern Barrens"          ,[ "zoneID" ] =199  ,["name"]="Werner Eastbrook"                ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33798 ,["id"]=44347  ,["react"]={    1,-1 }	,[ "coords"]= {{ 49    ,68.2  }}} ,
{["zone_name"] = "Southern Barrens"          ,[ "zoneID" ] =199  ,["name"]="Grantor"                         ,["maxlevel"]=60  ,["minlevel"]=32  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33803 ,["id"]=44354  ,["react"]={-   1,1  }	,[ "coords"]= {{ 40.8  ,69.6  }}} ,
{["zone_name"] = "Twilight Highlands"        ,[ "zoneID" ] =241  ,["name"]="Matthew Churchill"               ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=36986 ,["id"]=49600  ,["react"]={    1,-1 }	,[ "coords"]= {{ 43.6  ,57.4  }}} ,
{["zone_name"] = "Twilight Highlands"        ,[ "zoneID" ] =241  ,["name"]="Zay'hana"                        ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=37003 ,["id"]=49755  ,["react"]={-   1,1  }	,[ "coords"]= {{ 45.2  ,76.4  }}} ,
{["zone_name"] = "Howling Fjord"             ,[ "zoneID" ] =117  ,["name"]="Horatio the Stable Boy"          ,["maxlevel"]=10  ,["minlevel"]=10  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=338   ,["id"]=23733  ,["react"]={    1,nil}	,[ "coords"]= {{ 58.6  ,63    }}} ,
{["zone_name"] = "Howling Fjord"             ,[ "zoneID" ] =117  ,["name"]="Mary Darrow"                     ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22165 ,["id"]=24154  ,["react"]={nil,1    }	,[ "coords"]= {{ 52    ,66.6  }}} ,
{["zone_name"] = "Howling Fjord"             ,[ "zoneID" ] =117  ,["name"]="Mahana Frosthoof"                ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22052 ,["id"]=24067  ,["react"]={nil,1    }	,[ "coords"]= {{ 49.4  ,11    }}} ,
{["zone_name"] = "Howling Fjord"             ,[ "zoneID" ] =117  ,["name"]="Robert Clarke"                   ,["maxlevel"]=80  ,["minlevel"]=58  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=22333 ,["id"]=24350  ,["react"]={nil,1    }	,[ "coords"]= {{ 79    ,30.8  }}} ,
{["zone_name"] = "Uldum"                     ,[ "zoneID" ] =249  ,["name"]="Farah Tamina"                    ,["maxlevel"]=90  ,["minlevel"]=83  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=36486 ,["id"]=49408  ,["react"]={    1,1  }	,[ "coords"]= {{ 26.8  ,7.4   }}} ,
{["zone_name"] = "Deepholm"                  ,[ "zoneID" ] =207  ,["name"]="Mule Driver Ironshod"            ,["maxlevel"]=90  ,["minlevel"]=82  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=34393 ,["id"]=45298  ,["react"]={    1,-1 }	,[ "coords"]= {{ 47.4  ,51.4  }}} ,
{["zone_name"] = "Searing Gorge"             ,[ "zoneID" ] =32   ,["name"]="Karn Cragcare"                   ,["maxlevel"]=50  ,["minlevel"]=50  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=35913 ,["id"]=47934  ,["react"]={    1,1  }	,[ "coords"]= {{ 40.6  ,68.4  }}} ,
{["zone_name"] = "Abyssal Depths"            ,[ "zoneID" ] =204  ,["name"]="Shurrak"                         ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33247 ,["id"]=43151  ,["react"]={-   1,1  }	,[ "coords"]= {{ 53    ,59.2  }}} ,
{["zone_name"] = "The Cape of Stranglethorn" ,[ "zoneID" ] =210  ,["name"]="Grimestack"                      ,["maxlevel"]=46  ,["minlevel"]=46  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=9284  ,["id"]=10060  ,["react"]={    1,1  }	,[ "coords"]= {{ 41.4  ,73.4  }}} ,
{["zone_name"] = "The Cape of Stranglethorn" ,[ "zoneID" ] =210  ,["name"]="Finzy Watchwoozle"               ,["maxlevel"]=35  ,["minlevel"]=35  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33714 ,["id"]=44191  ,["react"]={-   1,1  }	,[ "coords"]= {{ 34.8  ,27.4  }}} ,
{["zone_name"] = "The Jade Forest"           ,[ "zoneID" ] =371  ,["name"]="Hong the Kindly"                 ,["maxlevel"]=90  ,["minlevel"]=84  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44904 ,["id"]=66241  ,["react"]={    1,1  }	,[ "coords"]= {{ 46.4  ,43.8  }}} ,
{["zone_name"] = "The Jade Forest"           ,[ "zoneID" ] =371  ,["name"]="Cheung"                          ,["maxlevel"]=90  ,["minlevel"]=81  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44959 ,["id"]=66266  ,["react"]={    1,nil}	,[ "coords"]= {{ 44.6  ,84.8  }}} ,
{["zone_name"] = "The Jade Forest"           ,[ "zoneID" ] =371  ,["name"]="Su Mi"                           ,["maxlevel"]=90  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44886 ,["id"]=66230  ,["react"]={-   1,1  }	,[ "coords"]= {{ 28.6  ,13    }}} ,
{["zone_name"] = "Valley of the Four Winds"  ,[ "zoneID" ] =376  ,["name"]="Little Tib"                      ,["maxlevel"]=90  ,["minlevel"]=85  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=43256 ,["id"]=66242  ,["react"]={    1,1  }	,[ "coords"]= {{ 83.8  ,21.8  }}} ,
{["zone_name"] = "Valley of the Four Winds"  ,[ "zoneID" ] =376  ,["name"]="Su the Tamer"                    ,["maxlevel"]=90  ,["minlevel"]=84  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44906 ,["id"]=66244  ,["react"]={    1,1  }	,[ "coords"]= {{ 55.2  ,49.4  }}} ,
{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =1530  ,["name"]="Tracker Lang"                    ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=43410 ,["id"]=63986  ,["react"]={-   1,1  }	,[ "coords"]= {{ 60.4  ,22.6  }}} ,
{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =1530  ,["name"]="Jaul Hsu"                        ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44171 ,["id"]=63988  ,["react"]={    1,-1 }	,[ "coords"]= {{ 84.6  ,63.2  }}} ,
{["zone_name"] = "Vale of Eternal Blossoms"  ,[ "zoneID" ] =1530  ,["name"]="Mount-Haver Nik Nik"             ,["maxlevel"]=90  ,["minlevel"]=85  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44907 ,["id"]=66245  ,["react"]={    1,1  }	,[ "coords"]= {{ 36    ,75.2  }}} ,
{["zone_name"] = "Kun-Lai Summit"            ,[ "zoneID" ] =379  ,["name"]="Herder Muskfree"                 ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=40834 ,["id"]=59509  ,["react"]={    1,1  }	,[ "coords"]= {{ 65.4  ,61.4  }}} ,
{["zone_name"] = "Townlong Steppes"          ,[ "zoneID" ] =388  ,["name"]="Tigermaster Liu-Do"              ,["maxlevel"]=90  ,["minlevel"]=85  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44908 ,["id"]=66247  ,["react"]={    1,1  }	,[ "coords"]= {{ 74.8  ,81.2  }}} ,
{["zone_name"] = "Townlong Steppes"          ,[ "zoneID" ] =388  ,["name"]="Tigermistress Min-To"            ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44909 ,["id"]=66248  ,["react"]={    1,1  }	,[ "coords"]= {{ 50    ,71.4  }}} ,
{["zone_name"] = "Townlong Steppes"          ,[ "zoneID" ] =388  ,["name"]="Tigermaster Gai-Lin"             ,["maxlevel"]=90  ,["minlevel"]=89  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44908 ,["id"]=66246  ,["react"]={    1,1  }	,[ "coords"]= {{ 71.4  ,57.4  }}} ,
{["zone_name"] = "The Veiled Stair"          ,[ "zoneID" ] =433  ,["name"]="Kama the Beast Tamer"            ,["maxlevel"]=90  ,["minlevel"]=82  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=42795 ,["id"]=62935  ,["react"]={    1,1  }	,[ "coords"]= {{ 55.8  ,75.2  }}} ,
{["zone_name"] = "Dread Wastes"              ,[ "zoneID" ] =422  ,["name"]="Handler Kla'vik"                 ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=44911 ,["id"]=66250  ,["react"]={    1,1  }	,[ "coords"]= {{ 53.6  ,32.4  }}} ,
{["zone_name"] = "Mount Hyjal"               ,[ "zoneID" ] =198  ,["name"]="Aili Greenwillow"                ,["maxlevel"]=90  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33357 ,["id"]=43408  ,["react"]={    1,1  }	,[ "coords"]= {{ 63.2  ,23    }}} ,
{["zone_name"] = "Mount Hyjal"               ,[ "zoneID" ] =198  ,["name"]="Limiah Whitebranch"              ,["maxlevel"]=82  ,["minlevel"]=82  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33336 ,["id"]=53780  ,["react"]={    1,1  }	,[ "coords"]= {{ 19.4  ,36.2  }}} ,
{["zone_name"] = "Mount Hyjal"               ,[ "zoneID" ] =198  ,["name"]="Oltarin Graycloud"               ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=33387 ,["id"]=50069  ,["react"]={    1,1  }	,[ "coords"]= {{ 41.8  ,45    }}} ,
{["zone_name"] = "Winterspring"              ,[ "zoneID" ] =83   ,["name"]="Azzleby"                         ,["maxlevel"]=60  ,["minlevel"]=47  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=10656 ,["id"]=11119  ,["react"]={    1,1  }	,[ "coords"]= {{ 58.6  ,50.2  }}} ,
{["zone_name"] = "Dragonblight"              ,[ "zoneID" ] =115  ,["name"]="Garmin Herzog"                   ,["maxlevel"]=80  ,["minlevel"]=73  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=25079 ,["id"]=28057  ,["react"]={nil,1    }	,[ "coords"]= {{ 76.8  ,62.6  }}} ,
{["zone_name"] = "Dragonblight"              ,[ "zoneID" ] =115  ,["name"]="Sentinel Sweetspring"            ,["maxlevel"]=80  ,["minlevel"]=65  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=24261 ,["id"]=27056  ,["react"]={    1,-1 }	,[ "coords"]= {{ 28.8  ,56    }}} ,
{["zone_name"] = "Dragonblight"              ,[ "zoneID" ] =115  ,["name"]="Soar Hawkfury"                   ,["maxlevel"]=80  ,["minlevel"]=62  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=23874 ,["id"]=26504  ,["react"]={-   1,1  }	,[ "coords"]= {{ 37    ,48.4  }}} ,
{["zone_name"] = "zul'drak"                  ,[ "zoneID" ] =121  ,["name"]="Fala Softhoof"                   ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=25687 ,["id"]=28790  ,["react"]={    1,1  }	,[ "coords"]= {{ 40.2  ,65.2  }}} ,
{["zone_name"] = "zul'drak"                  ,[ "zoneID" ] =121  ,["name"]="Asgari"                          ,["maxlevel"]=80  ,["minlevel"]=75  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26697 ,["id"]=30039  ,["react"]={    1,1  }	,[ "coords"]= {{ 59    ,57.6  }}} ,
{["zone_name"] = "Talador"                   ,[ "zoneID" ] =535  ,["name"]="Beastmaster Tagh"                ,["maxlevel"]=100 ,["minlevel"]=95  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=56081 ,["id"]=80833  ,["react"]={-   1,1  }	,[ "coords"]= {{ 70.8  ,29.6  }}} ,
{["zone_name"] = "Talador"                   ,[ "zoneID" ] =535  ,["name"]="Patrick Messer"                  ,["maxlevel"]=100 ,["minlevel"]=94  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=56083 ,["id"]=80854  ,["react"]={    1,nil}	,[ "coords"]= {{ 69.4  ,21.2  }}} ,
{["zone_name"] = "The Storm Peaks"           ,[ "zoneID" ] =120  ,["name"]="Andurg Slatechest"               ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26091 ,["id"]=29959  ,["react"]={    1,1  }	,[ "coords"]= {{ 30.6  ,36.8  }}} ,
{["zone_name"] = "The Storm Peaks"           ,[ "zoneID" ] =120  ,["name"]="Heksi"                           ,["maxlevel"]=80  ,["minlevel"]=78  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26631 ,["id"]=29906  ,["react"]={    1,1  }	,[ "coords"]= {{ 40.8  ,86    }}} ,
{["zone_name"] = "The Storm Peaks"           ,[ "zoneID" ] =120  ,["name"]="Boarmaster Bragh"                ,["maxlevel"]=80  ,["minlevel"]=80  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=26686 ,["id"]=29948  ,["react"]={    1,-1 }	,[ "coords"]= {{ 28.6  ,74.4  }}} ,
{["zone_name"] = "Shadowmoon Valley"         ,[ "zoneID" ] =539  ,["name"]="Ertai"                           ,["maxlevel"]=100 ,["minlevel"]=92  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=58472 ,["id"]=84730  ,["react"]={    1,nil}	,[ "coords"]= {{ 59.2  ,26.6  }}} ,
{["zone_name"] = "Frostfire Ridge"           ,[ "zoneID" ] =525  ,["name"]="Wolfhandler Ang'cha"             ,["maxlevel"]=100 ,["minlevel"]=100 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=55801 ,["id"]=77461  ,["react"]={nil,1    }	,[ "coords"]= {{ 22    ,56.2  }}} ,
{["zone_name"] = "Frostfire Ridge"           ,[ "zoneID" ] =525  ,["name"]="Grimble the Pupmaster"           ,["maxlevel"]=100 ,["minlevel"]=99  ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=20545 ,["id"]=77455  ,["react"]={-   1,1  }	,[ "coords"]= {{ 38.8  ,52    }}} ,
{["zone_name"] = "Frostfire Ridge"           ,[ "zoneID" ] =525  ,["name"]="Ko'ari"                          ,["maxlevel"]=100 ,["minlevel"]=100 ,["info"] = "" ,["class"]=CLASS_STABLE_MASTER ,["family"]={0, "Stable Master"} ,["familySkills"] = {} ,["displayID"]=54642 ,["id"]=78698  ,["react"]={nil,1    }	,[ "coords"]= {{ 52.4  ,40.2  }}} ,
{["zone_name"] = "Gorgrond"                  ,[ "zoneID" ] =543  ,["name"]="Ribchewer"                       ,["maxlevel"]=100	,["minlevel"]=93  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=56923	,["id"]=82731  ,["react"]={-   1,1  }	,[ "coords"]= {{ 45.8  ,69.8  }}} ,
{["zone_name"] = "Tanaan Jungle"             ,[ "zoneID" ] =534  ,["name"]="Dal Palesmoke"                   ,["maxlevel"]=100	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=7364  ,["id"]=90992  ,["react"]={-   1,1  }	,[ "coords"]= {{ 59.8  ,45.6  }}} ,
{["zone_name"] = "Timeless Isle"             ,[ "zoneID" ] =554  ,["name"]="Cowardly Zue"                    ,["maxlevel"]=85  ,["minlevel"]=85  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=41898	,["id"]=73632  ,["react"]={    1,1  }	,[ "coords"]= {{ 37.2  ,46.8  }}} ,
{["zone_name"] = "Frostwall"                 ,[ "zoneID" ] =590  ,["name"]="Drokil"                          ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=56564	,["id"]=79816  ,["react"]={nil,1    }	,[ "coords"]= {{ 52    ,58.2  }}} ,
{["zone_name"] = "Frostwall"                 ,[ "zoneID" ] =590  ,["name"]="Zagara"                          ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=56564	,["id"]=79860  ,["react"]={nil,1    }	,[ "coords"]= {{ 61.4  ,52.2  }}} ,
{["zone_name"] = "Lunarfall"                 ,[ "zoneID" ] =582  ,["name"]="Raven"                           ,["maxlevel"]=90  ,["minlevel"]=90  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=60992	,["id"]=77381  ,["react"]={    1,nil}	,[ "coords"]= {{ 45.4  ,40.2  }}} ,
{["zone_name"] = "Stormshield"               ,[ "zoneID" ] =622  ,["name"]="Orville Manfred"                 ,["maxlevel"]=100	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=59249	,["id"]=85963  ,["react"]={    1,-1 }	,[ "coords"]= {{ 33.4  ,65.6  }}} ,
{["zone_name"] = "Warspear"                  ,[ "zoneID" ] =624  ,["name"]="Ujia"                            ,["maxlevel"]=100	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=59325	,["id"]=86052  ,["react"]={-   1,1  }	,[ "coords"]= {{ 77.2  ,58.4  }}} ,
{["zone_name"] = "Dalaran"                   ,[ "zoneID" ] =625  ,["name"]="Tassia Whisperglen"              ,["maxlevel"]=105	,["minlevel"]=105 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=25607	,["id"]=96507  ,["react"]={    1,1  }	,[ "coords"]= {{ 59    ,37.8  }}} ,
{["zone_name"] = "Highmountain"              ,[ "zoneID" ] =650  ,["name"]="Haren Stonepath"                 ,["maxlevel"]=110	,["minlevel"]=107 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=65471	,["id"]=97874  ,["react"]={    1,1  }	,[ "coords"]= {{ 53.2  ,64    }}} ,
{["zone_name"] = "Highmountain"              ,[ "zoneID" ] =650  ,["name"]="Parek Splitfeather"              ,["maxlevel"]=110	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=65473	,["id"]=97862  ,["react"]={    1,1  }	,[ "coords"]= {{ 52.8  ,45.2  }}} ,
{["zone_name"] = "Broken Shore"              ,[ "zoneID" ] =646  ,["name"]="Pan the Kind Hand"               ,["maxlevel"]=110	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=44905	,["id"]=117813	,["react"]={    1,1  }	,[ "coords"]= {{ 43.4  ,63    }}} ,
{["zone_name"] = "Thunder Totem"             ,[ "zoneID" ] =750  ,["name"]="Liza Galestride"                 ,["maxlevel"]=110	,["minlevel"]=98  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=65468	,["id"]=97854  ,["react"]={    1,1  }	,[ "coords"]= {{ 53.6  ,45.4  }}} ,
{["zone_name"] = "Trueshot Lodge"            ,[ "zoneID" ] =739  ,["name"]="Pan the Kind Hand"               ,["maxlevel"]=100	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=44905	,["id"]=100661	,["react"]={    1,1  }	,[ "coords"]= {{ 58.8  ,32.6  }}} ,
{["zone_name"] = "Swamp of Sorrows"          ,[ "zoneID" ] =51   ,["name"]="Joran"                           ,["maxlevel"]=65  ,["minlevel"]=65  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=35563	,["id"]=47368  ,["react"]={    1,-1 }	,[ "coords"]= {{ 28.6  ,33.2  }}} ,
{["zone_name"] = "Swamp of Sorrows"          ,[ "zoneID" ] =51   ,["name"]="Hekkru"                          ,["maxlevel"]=65  ,["minlevel"]=65  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=9268  ,["id"]=10049  ,["react"]={-   1,1  }	,[ "coords"]= {{ 47.2  ,55.2  }}} ,
{["zone_name"] = "Swamp of Sorrows"          ,[ "zoneID" ] =51   ,["name"]="Shecky Shrimpshoot"              ,["maxlevel"]=60  ,["minlevel"]=57  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=35554	,["id"]=47337  ,["react"]={    1,1  }	,[ "coords"]= {{ 72    ,14.8  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Habradu"                         ,["maxlevel"]=120	,["minlevel"]=112 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=79535	,["id"]=137333	,["react"]={-   1,1  }	,[ "coords"]= {{ 51.2  ,50.2  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Beast Handler Kooley"            ,["maxlevel"]=120	,["minlevel"]=113 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=82065	,["id"]=124455	,["react"]={nil,1    }	,[ "coords"]= {{ 76.8  ,16.4  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Birgita"                         ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=86024	,["id"]=138850	,["react"]={    1,-1 }	,[ "coords"]= {{ 77.4  ,54.8  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Johnathan Ebrills"               ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84527	,["id"]=136004	,["react"]={    1,-1 }	,[ "coords"]= {{ 44.4  ,36.6  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Tailmaster Tacklesnatz"          ,["maxlevel"]=120	,["minlevel"]=112 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=89906	,["id"]=148168	,["react"]={-   1,1  }	,[ "coords"]= {{ 53.4  ,57.2  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Mitzi Pawsprinkle"               ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=86563	,["id"]=140057	,["react"]={    1,-1 }	,[ "coords"]= {{ 64.4  ,47.2  }}} ,
{["zone_name"] = "Zuldazar"                  ,[ "zoneID" ] =862  ,["name"]="Saranklei"                       ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84569	,["id"]=136082	,["react"]={    1,-1 }	,[ "coords"]= {{ 55.6  ,25    }}} ,
{["zone_name"] = "Tirisfal Glades"           ,[ "zoneID" ] =18   ,["name"]="Morganus"                        ,["maxlevel"]=60  ,["minlevel"]=60  ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=9274  ,["id"]=10055  ,["react"]={-   1,1  }	,[ "coords"]= {{ 61.8  ,52    }}} ,
{["zone_name"] = "Nazmir"                    ,[ "zoneID" ] =863  ,["name"]="Yash"                            ,["maxlevel"]=120	,["minlevel"]=113 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=77687	,["id"]=131993	,["react"]={    1,1  }	,[ "coords"]= {{ 66.8  ,42    }}} ,
{["zone_name"] = "Nazmir"                    ,[ "zoneID" ] =863  ,["name"]="Beastmaster Veayeka"             ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84381	,["id"]=135750	,["react"]={-   1,1  }	,[ "coords"]= {{ 39.4  ,79.6  }}} ,
{["zone_name"] = "Vol'dun"                   ,[ "zoneID" ] =864  ,["name"]="Orville Manfred"                 ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=59249	,["id"]=144121	,["react"]={    1,-1 }	,[ "coords"]= {{ 38.4  ,34.4  }}} ,
{["zone_name"] = "Vol'dun"                   ,[ "zoneID" ] =864  ,["name"]="Teego"                           ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=85953	,["id"]=138701	,["react"]={    1,1  }	,[ "coords"]= {{ 57.2  ,49.2  }}} ,
{["zone_name"] = "Vol'dun"                   ,[ "zoneID" ] =864  ,["name"]="Vithur"                          ,["maxlevel"]=120	,["minlevel"]=112 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=80668	,["id"]=139827	,["react"]={    1,1  }	,[ "coords"]= {{ 27    ,51    }}} ,
{["zone_name"] = "Tiragarde Sound"           ,[ "zoneID" ] =895  ,["name"]="Dolan Northfield"                ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=78467	,["id"]=125035	,["react"]={    1,-1 }	,[ "coords"]= {{ 51.4  ,26    }}} ,
{["zone_name"] = "Tiragarde Sound"           ,[ "zoneID" ] =895  ,["name"]="Tallelah Clearpath"              ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=85745	,["id"]=138160	,["react"]={-   1,1  }	,[ "coords"]= {{ 87.4  ,50.2  }}} ,
{["zone_name"] = "Boralus"                   ,[ "zoneID" ] =1161	,["name"]="Leila Stafford"                  ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=87599	,["id"]=142073	,["react"]={    1,-1 }	,[ "coords"]= {{ 69.62 ,13.13 }}} ,
{["zone_name"] = "Krokuun"                   ,[ "zoneID" ] =830  ,["name"]="Lead Rider Jerek"                ,["maxlevel"]=110	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=75163	,["id"]=126160	,["react"]={    1,1  }	,[ "coords"]= {{ 64.4  ,62.6  }}} ,
{["zone_name"] = "Krokuun"                   ,[ "zoneID" ] =830  ,["name"]="Raelaara the Kind"               ,["maxlevel"]=110	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=77962	,["id"]=127752	,["react"]={    1,1  }	,[ "coords"]= {{ 62.6  ,47.4  }}} ,
{["zone_name"] = "Dazar'alor"                ,[ "zoneID" ] =1165	,["name"]="Beast Handler Sujani"            ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=82207	,["id"]=132066	,["react"]={-   1,1  }	,[ "coords"]= {{ 47.8  ,89    }}} ,
{["zone_name"] = "Dazar'alor"                ,[ "zoneID" ] =1165	,["name"]="Beast Handler Kalatak"           ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=79372	,["id"]=122696	,["react"]={-   1,1  }	,[ "coords"]= {{ 45.8  ,36.2  }}} ,
{["zone_name"] = "Dazar'alor"                ,[ "zoneID" ] =1165	,["name"]="Beast Handler Tahno"             ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=82208	,["id"]=132067	,["react"]={-   1,1  }	,[ "coords"]= {{ 59.8  ,4.4   }}} ,
{["zone_name"] = "Dazar'alor"                ,[ "zoneID" ] =1165	,["name"]="Beast Handler Sonaba"            ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=82800	,["id"]=133253	,["react"]={-   1,1  }	,[ "coords"]= {{ 55    ,14.8  }}} ,
{["zone_name"] = "Drustvar"                  ,[ "zoneID" ] =896  ,["name"]="Klause Fairwind"                 ,["maxlevel"]=120	,["minlevel"]=118 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84609	,["id"]=136142	,["react"]={    0,0  }	,[ "coords"]= {{ 19.4  ,43.6  }}} ,
{["zone_name"] = "Drustvar"                  ,[ "zoneID" ] =896  ,["name"]="Willow Tempest"                  ,["maxlevel"]=120	,["minlevel"]=114 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=85015	,["id"]=137010	,["react"]={    1,-1 }	,[ "coords"]= {{ 38.6  ,52.4  }}} ,
{["zone_name"] = "Stormsong Valley"          ,[ "zoneID" ] =942  ,["name"]="Calik the Skinny"                ,["maxlevel"]=120	,["minlevel"]=113 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=84243	,["id"]=135386	,["react"]={    1,nil}	,[ "coords"]= {{ 43.2  ,54.6  }}} ,
{["zone_name"] = "Stormsong Valley"          ,[ "zoneID" ] =942  ,["name"]="Crabmaster Daijo"                ,["maxlevel"]=120	,["minlevel"]=111 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=77687	,["id"]=138451	,["react"]={    1,1  }	,[ "coords"]= {{ 40.4  ,36.4  }}} ,
{["zone_name"] = "Stormsong Valley"          ,[ "zoneID" ] =942  ,["name"]="Beast Handler Khajuku"           ,["maxlevel"]=120	,["minlevel"]=120 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=85733	,["id"]=138108	,["react"]={-   1,1  }	,[ "coords"]= {{ 50.8  ,33    }}} ,
{["zone_name"] = "Stormsong Valley"          ,[ "zoneID" ] =942  ,["name"]="Hayworth"                        ,["maxlevel"]=120	,["minlevel"]=110 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=87217	,["id"]=141349	,["react"]={    1,-1 }	,[ "coords"]= {{ 58.4  ,70.6  }}} ,
{["zone_name"] = "Oribos"          ,[ "zoneID" ] =1670  ,["name"]="Keeper Ta'saran"                        ,["maxlevel"]=120	,["minlevel"]=100 ,["info"] = ""	,["class"]=CLASS_STABLE_MASTER	,["family"]={0, "Stable Master"}	,["familySkills"] = {}	,["displayID"]=93595	,["id"]=156791	,["react"]={    1, 1 }	,[ "coords"]= {{ 59.0  ,75.0  }}} ,


} 
  

AOTH.tamablePets = {
30,43,113,118,119,154,157,199,217,299,330,345,428,442,454,462,471,521,524,525,547,574,582,616,628,681,682,683,684,685,686,687,688,689,690,698,700,704,705,708,728,729,730,731,736,758,772,819,822,830,831,833,834,858,922,930,976,977,995,1016,1019,1085,1088,1109,1111,1112,1125,1130,1132,1140,1150,1152,1186,1189,1195,1196,1201,1216,1225,1504,1505,1508,1509,1511,1512,1513,1516,1547,1548,1549,1550,1551,1552,1553,1554,1555,1557,1558,1559,1688,1689,1693,1713,1765,1766,1778,1780,1781,1797,1810,1811,1815,1817,1819,1820,1822,1824,1922,1961,1979,1980,1984,1985,1986,1994,1995,1996,1997,1998,1999,2000,2001,2031,2032,2033,2034,2042,2043,2052,2070,2071,2164,2165,2172,2175,2233,2237,2321,2347,2349,2350,2354,2356,2385,2408,2476,2505,2521,2522,2544,2559,2560,2561,2563,2565,2578,2579,2580,2635,2658,2680,2681,2707,2728,2729,2730,2731,2732,2734,2753,2829,2830,2831,2850,2923,2924,2925,2926,2931,2955,2956,2957,2958,2959,2960,2966,2969,2970,2971,2972,2973,2974,3035,3056,3058,3068,3098,3099,3100,3106,3107,3108,3110,3122,3123,3124,3125,3126,3127,3234,3235,3236,3237,3240,3241,3242,3243,3244,3245,3246,3248,3252,3253,3254,3255,3256,3281,3398,3415,3416,3425,3426,3460,3461,3462,3466,3474,3475,3566,3581,3619,3630,3631,3632,3633,3634,3636,3637,3652,3653,3680,3721,3722,3809,3810,3812,3814,3816,3817,3818,3819,3820,3821,3823,3824,3825,3826,3864,3866,3868,4005,4006,4007,4008,4011,4012,4013,4014,4015,4018,4019,4040,4041,4044,4067,4107,4109,4110,4117,4118,4127,4132,4166,4250,4316,4341,4343,4344,4345,4346,4347,4348,4351,4352,4356,4357,4374,4376,4378,4379,4380,4397,4412,4414,4415,4482,4660,4688,4689,4690,4691,4692,4693,4694,4695,4696,4697,4699,4700,4701,4702,4724,4725,4726,4727,4728,4729,4841,4861,4862,4863,4950,5048,5053,5056,5225,5244,5245,5246,5247,5260,5264,5268,5286,5288,5291,5300,5304,5305,5306,5307,5326,5347,5349,5350,5352,5356,5419,5420,5426,5427,5429,5430,5431,5441,5443,5450,5451,5452,5453,5454,5455,5457,5458,5459,5460,5555,5596,5689,5755,5756,5762,5807,5823,5827,5828,5829,5831,5832,5833,5834,5842,5856,5857,5858,5865,5928,5935,5937,5983,5985,5986,5987,5989,5990,5992,6215,6352,6375,6377,6498,6499,6500,6501,6502,6503,6504,6505,6506,6507,6508,6513,6514,6516,6551,6552,6553,6554,6555,6581,6582,6583,6584,6585,6648,7022,7055,7078,7094,7095,7096,7097,7099,7268,7269,7273,7319,7376,7377,7378,7405,7430,7431,7432,7433,7434,7443,7444,7446,7448,7455,7456,7803,7977,8095,8120,8138,8149,8204,8205,8207,8208,8211,8213,8277,8299,8300,8301,8302,8303,
8336,8596,8597,8598,8599,8600,8601,8602,8660,8760,8761,8764,8886,8921,8922,8925,8926,8927,8928,8932,8933,8956,8958,8959,8960,9042,9162,9163,9164,9166,9167,9318,9416,9498,9622,9683,9684,9690,9691,9696,9697,10041,10077,10177,10200,10220,10221,10268,10356,10357,10359,10375,10376,10596,10644,10699,10737,10741,10806,10807,10925,10981,10990,11497,11671,11672,11673,11698,11710,11721,11722,11723,11724,11725,11726,11727,11728,11729,11730,11731,11732,11733,11734,11735,11736,11737,11738,11739,11740,11741,11785,11786,11787,11788,11789,11836,11885,11897,11982,12037,12054,12207,12296,12297,12347,12418,12431,12433,12676,12940,13036,13136,13323,13596,13599,13676,13837,14020,14123,14222,14223,14227,14228,14232,14233,14234,14237,14266,14268,14279,14280,14283,14339,14343,14344,14370,14406,14430,14472,14473,14474,14475,14476,14477,14491,14566,14661,15107,15168,15196,15229,15230,15233,15235,15236,15240,15274,15300,15316,15317,15318,15319,15320,15323,15325,15327,15336,15348,15366,15369,15370,15372,15421,15422,15461,15462,15509,15510,15511,15521,15543,15544,15546,15621,15622,15630,15649,15650,15651,15652,15653,15718,15934,15962,15966,15974,15975,15976,16041,16117,16170,16173,16175,16176,16177,16178,16180,16181,16310,16347,16348,16349,16350,16351,16352,16353,16354,16355,16371,16448,16491,16492,16520,16698,16863,16872,16874,16875,16879,16880,16931,16932,16933,16934,16972,16973,16992,17034,17035,17039,17053,17128,17129,17130,17131,17132,17133,17144,17198,17199,17200,17201,17202,17203,17216,17217,17221,17280,17345,17347,17348,17349,17350,17372,17373,17374,17411,17447,17522,17523,17525,17526,17527,17560,17561,17562,17563,17620,17661,17668,17683,17724,17731,17736,17882,17952,18033,18105,18128,18129,18130,18131,18132,18133,18134,18135,18155,18205,18213,18214,18220,18226,18241,18257,18258,18259,18280,18281,18283,18285,18286,18289,18290,18334,18398,18437,18438,18461,18463,18464,18465,18466,18467,18468,18469,18470,18476,18477,18647,18648,18650,18651,18670,18680,18706,18707,18739,18851,18854,18878,18880,18883,18884,18964,18982,18983,19055,19183,19189,19207,19306,19349,19350,19423,19428,19429,19458,19459,19461,19632,19706,19729,19730,19770,19771,19784,19785,19921,20038,20058,20196,20197,20198,20279,20280,20283,20324,20330,20387,20412,20502,20517,20607,20610,20611,20618,20634,20671,20673,20681,20682,20714,20728,20729,20734,20748,20749,20751,20752,20754,20773,20775,20777,20783,20797,20906,20924,20925,20931,20932,20987,20998,20999,21012,21013,21014,21015,21016,21017,21022,21033,21042,21102,21108,21123,21124,21128,21195,21250,21306,21372,21373,21381,21408,21423,21462,21515,21723,21802,21804,21816,21839,21854,21864,21878,21879,21891,21897,21900,21901,21904,21922,21956,22044,22052,22056,22100,22105,22123,22132,22180,22191,22193,22256,22265,22287,22299,22353,22394,22807,22884,22885,22979,23013,23014,23020,23026,23035,23163,23219,23232,23326,23501,23507,23527,23528,23529,23530,23531,23584,23598,23690,23691,23693,23740,23747,23772,23834,23873,23929,
23930,23939,23945,23958,23959,23994,24026,24043,24047,24049,24064,24076,24128,24138,24172,24217,24287,24338,24475,24478,24479,24514,24516,24517,24530,24547,24614,24615,24616,24633,24673,24677,24681,24731,24732,24747,24761,24787,24791,24793,24794,24863,24901,24917,25113,25355,25362,25447,25454,25464,25481,25482,25487,25488,25489,25498,25667,25675,25680,25711,25718,25721,25743,25748,25750,25791,25817,25862,25867,25963,25988,25989,26174,26271,26272,26273,26281,26293,26322,26358,26359,26363,26369,26418,26426,26446,26472,26482,26483,26521,26592,26615,26616,26622,26625,26628,26641,26643,26644,26672,26706,26711,26730,26806,26824,26838,27131,27214,27230,27244,27249,27294,27329,27408,27421,27483,27523,27578,27626,27642,27740,27902,27911,27912,28001,28002,28003,28004,28009,28011,28085,28086,28096,28097,28098,28129,28145,28203,28213,28221,28233,28278,28288,28297,28325,28342,28358,28379,28380,28404,28477,28605,28606,28607,28614,28737,28851,28899,28900,28903,29044,29319,29327,29334,29358,29390,29402,29444,29452,29469,29479,29486,29487,29605,29630,29693,29698,29713,29735,29741,29748,29838,29889,29931,29958,30093,30148,30164,30187,30206,30260,30291,30422,30423,30430,30445,30447,30448,30455,30456,30573,30574,30613,30664,30952,30963,31010,31045,31233,31236,31404,31528,31636,31747,31809,31871,32163,32361,32392,32400,32475,32481,32485,32517,32935,32976,32997,33009,33024,33127,33311,33710,33711,33712,33713,33776,33905,33978,34034,34178,34262,34263,34302,34318,34369,34417,34500,34543,34640,34647,34699,34829,34865,34886,34894,34982,35096,35189,35231,35245,35285,35409,35412,35434,35750,35811,35812,35904,35905,36094,36113,36147,36197,36304,36362,36512,36540,36555,36560,36623,36696,36732,36740,36741,36813,36882,37045,37078,37082,37083,37084,37085,37086,37088,37089,37090,37091,37206,37207,37208,37492,37555,37556,37557,37559,37718,37785,37786,37956,37961,38046,38141,38154,38187,38206,38305,38346,38357,38371,38373,38453,38593,38765,38844,38845,38881,39004,39049,39149,39183,39185,39186,39224,39337,39348,39385,39418,39439,39440,39443,39444,39452,39588,39658,39850,39851,39943,40064,40193,40194,40238,40239,40276,40280,40310,40337,40338,40403,40458,40527,40581,40650,40656,40657,40685,40717,40764,40798,40819,40889,41084,41166,41185,41212,41295,41342,41343,41374,41400,41401,41419,41420,41478,41520,41539,41561,41595,41604,41609,41645,41917,41919,41922,42002,42104,42170,42171,42193,42235,42242,42286,42290,42336,42337,42338,42357,42373,42504,42523,42543,42556,42657,42658,42659,42660,42663,42664,42710,42712,42713,42714,42715,42717,42718,42719,42720,42721,42722,42766,42845,42859,42879,42925,43007,43038,43050,43064,43083,43084,43181,43182,43296,43339,43340,43417,43438,43498,43658,43704,43917,43981,44014,44016,44020,44089,44108,44109,44113,44116,44130,44138,44164,44165,44166,44167,44184,44188,44257,44258,44259,44284,44390,44425,44427,44428,44429,44473,44474,44475,44476,44480,44482,44546,44551,44568,44587,44594,44595,44599,44620,44626,44627,44628,44635,44638,44639,44832,44836,44906,45087,
45096,45121,45142,45202,45204,45227,45302,45321,45335,45353,45367,45380,45402,45433,45434,45450,45453,45517,45582,45613,45807,45825,45859,45896,45906,45950,46123,46126,46127,46128,46129,46146,46150,46152,46153,46155,46156,46158,46159,46160,46161,46162,46278,46280,46281,46317,46369,46393,46507,46508,46517,46536,46570,46575,46580,46606,46751,46910,46970,47053,47056,47071,47072,47079,47115,47117,47190,47202,47204,47205,47263,47283,47327,47386,47387,47388,47389,47390,47485,47544,47591,47666,47676,47680,47687,47720,47726,47740,47769,47801,47803,48038,48111,48128,48130,48131,48132,48137,48138,48146,48151,48155,48177,48178,48179,48180,48184,48248,48249,48268,48278,48325,48440,48441,48442,48447,48448,48449,48450,48451,48455,48456,48479,48511,48532,48635,48639,48724,48765,48918,48920,48945,49159,49249,49251,49346,49347,49486,49565,49815,49816,49822,49871,50044,50051,50058,50060,50138,50154,50159,50249,50302,50313,50317,50320,50328,50329,50330,50337,50342,50343,50345,50346,50348,50353,50357,50361,50362,50370,50724,50725,50726,50727,50728,50730,50731,50735,50737,50738,50741,50742,50743,50744,50745,50746,50747,50748,50752,50759,50763,50764,50765,50770,50775,50777,50778,50779,50784,50785,50786,50788,50790,50792,50797,50803,50804,50807,50809,50810,50812,50813,50814,50815,50818,50819,50825,50833,50837,50838,50839,50842,50843,50846,50850,50854,50855,50856,50858,50859,50862,50864,50865,50866,50873,50874,50875,50876,50882,50884,50885,50886,50891,50892,50895,50897,50901,50903,50905,50906,50908,50915,50916,50918,50922,50925,50926,50929,50930,50931,50937,50940,50942,50944,50945,50946,50947,50948,50949,50952,50955,50957,50959,50960,50964,50967,50981,50986,50990,50993,50995,50997,50998,51000,51001,51002,51004,51007,51008,51010,51013,51014,51017,51018,51021,51022,51025,51026,51027,51028,51029,51031,51037,51040,51042,51044,51045,51046,51048,51052,51053,51057,51058,51061,51062,51063,51066,51067,51069,51076,51077,51107,51193,51194,51197,51198,51199,51259,51368,51369,51401,51402,51403,51404,51442,51589,51661,51662,51663,51671,51673,51674,51675,51676,51712,51713,51714,51726,51760,51761,51947,51961,51962,51972,51983,51987,52085,52146,52173,52174,52224,52345,52373,52375,52376,52377,52379,52402,52413,52418,52441,52442,52622,52648,52686,52795,52839,52981,53240,53414,53523,53614,53704,53753,54132,54318,54319,54320,54321,54322,54323,54324,54338,54510,54533,54557,54558,54559,54688,54699,54700,54896,54897,54988,55015,55095,55118,55236,55238,55272,55273,55317,55493,55565,55602,55603,55604,55607,55664,55715,55786,55874,55946,56034,56070,56106,56132,56171,56172,56183,56198,56199,56200,56201,56239,56253,56254,56255,56256,56272,56274,56283,56329,56357,56396,56404,56447,56523,56524,56532,56543,56650,56652,56653,56654,56655,56683,56703,56752,56753,56754,56833,56877,57215,57216,57232,57237,57239,57273,57299,57421,57422,57442,57797,57851,58067,58070,58111,58112,58116,58213,58214,58217,58218,58219,58221,58229,58231,58411,58415,58419,58424,58427,58431,58432,58435,58448,58449,58450,58455,58456,
58457,58459,58474,58475,58489,58490,58548,58552,58553,58554,58575,58581,58582,58588,58641,58645,58674,58678,58694,58724,58741,58755,58766,58804,58808,58809,58811,58876,58880,58881,58883,58884,58885,58887,58888,58889,58890,58892,58893,58895,58896,58910,58940,58941,58950,59002,59037,59084,59102,59104,59105,59112,59116,59139,59149,59157,59158,59196,59197,59235,59239,59251,59295,59309,59319,59339,59351,59367,59384,59431,59523,59528,59534,59603,59641,59658,59665,59670,59672,59675,59680,59700,59742,59743,59744,59745,59747,59753,59754,59756,59757,59763,59768,59769,59772,59773,59774,59780,59782,59785,59786,59787,59970,59971,59975,59984,60131,60134,60196,60198,60200,60201,60202,60203,60223,60242,60282,60294,60373,60401,60410,60411,60437,60493,60511,60573,60616,60623,60668,60748,60783,60800,60804,60833,60860,60866,60875,60932,61091,61159,61177,61294,61299,61306,61307,61387,61410,61415,61446,61509,61556,61565,61618,61619,61747,61748,61843,61848,61911,61945,61971,61981,62000,62008,62023,62029,62131,62160,62164,62254,62267,62269,62309,62324,62372,62442,62448,62533,62597,62598,62599,62654,62760,62763,62945,63007,63025,63026,63116,63172,63201,63282,63297,63347,63403,63404,63503,63509,63510,63537,63538,63543,63584,63586,63588,63600,63605,63625,63637,63638,63667,63696,63697,63722,63723,63725,63726,63728,63729,63739,63755,63765,63767,63796,63827,63833,63870,63895,63920,63950,63956,63981,64018,64046,64186,64211,64309,64321,64323,64403,64436,64485,64551,64554,64638,64669,64670,64671,64717,64724,64725,64726,64745,64832,64834,64849,64937,64965,64982,65115,65118,65122,65188,65229,65231,65236,65237,65238,65239,65240,65241,65339,65428,65450,65520,65526,65559,65582,65612,65616,65622,65627,65629,65632,65650,65653,65672,65673,65674,65679,65723,65724,65773,65799,65802,65816,65819,65820,65821,65823,65839,65878,66096,66099,66164,66184,66187,66188,66208,66213,66319,66421,66431,66448,66462,66463,66464,66472,66476,66514,66549,66587,66605,66617,66622,66633,66668,66670,66748,66772,66783,66849,66880,66881,66882,66891,66892,66895,66898,67033,67036,67071,67084,67085,67099,67128,67162,67475,67576,67703,67759,67763,67770,67774,67820,67895,67896,68079,68080,68081,68250,68476,68584,68961,69099,69148,69161,69162,69177,69180,69207,69218,69239,69246,69277,69306,69349,69358,69384,69523,69562,69580,69679,69712,69795,69812,69943,69946,69947,69983,69991,69992,69993,69998,70004,70005,70006,70007,70008,70009,70010,70011,70012,70013,70014,70015,70016,70017,70018,70019,70020,70021,70120,70149,70172,70226,70327,70422,70448,70493,70494,70558,70589,70595,70858,71297,71425,71491,71500,71529,71578,71721,71728,71786,71921,71923,72162,72244,72247,72251,72273,72275,72287,72288,72329,72452,72606,72650,72753,72761,72762,72764,72765,72766,72775,72777,72805,72807,72808,72841,72843,72844,72849,72876,72881,72927,72934,72991,73013,73158,73160,73161,73163,73166,73167,73223,73234,73449,73476,73619,73679,73686,73960,74032,74169,74206,74311,74424,74446,74453,74508,74509,74513,74566,74567,74583,74584,74597,74620,74630,
74712,74714,74722,74748,74909,74921,74933,74935,74957,74962,74981,74995,75009,75014,75037,75113,75115,75151,75206,75241,75247,75280,75298,75312,75348,75416,75420,75466,75467,75468,75482,75483,75484,75487,75519,75527,75558,75588,75590,75605,75674,75678,75680,75737,75771,75954,76143,76150,76178,76181,76253,76255,76326,76337,76389,76438,76442,76473,76477,76497,76576,76593,76597,76624,76668,76685,76687,76705,76707,76710,76711,76786,76819,76857,76874,76891,76914,76916,76919,76920,76945,76946,76954,76956,76967,77065,77067,77070,77091,77093,77110,77112,77115,77122,77124,77129,77140,77141,77142,77145,77146,77155,77157,77177,77212,77298,77306,77307,77314,77328,77430,77431,77441,77442,77443,77478,77492,77513,77516,77519,77609,77626,77627,77634,77655,77715,77719,77741,77742,77785,77845,77881,77886,77927,77994,78141,78183,78213,78273,78275,78276,78277,78278,78279,78291,78314,78329,78331,78332,78364,78371,78385,78387,78390,78400,78404,78459,78460,78462,78508,78514,78521,78528,78547,78550,78570,78571,78572,78574,78575,78576,78671,78673,78712,78856,78872,78918,78919,78920,78931,78972,79019,79020,79034,79035,79061,79148,79149,79214,79250,79285,79332,79334,79384,79398,79411,79413,79420,79481,79483,79486,79524,79577,79587,79595,79642,79643,79645,79646,79660,79662,79703,79721,79726,79745,79746,79752,79755,79756,79779,79851,79854,79895,79909,79910,79920,79959,80034,80081,80082,80098,80122,80136,80164,80174,80175,80211,80212,80224,80226,80227,80228,80241,80242,80261,80263,80321,80354,80370,80372,80398,80401,80403,80404,80405,80420,80445,80453,80471,80541,80542,80543,80558,80559,80560,80589,80687,80694,80715,80782,80832,80836,80838,80839,80841,80842,80844,80845,80846,80848,80849,80915,80997,81000,81001,81083,81084,81085,81138,81168,81198,81306,81307,81333,81537,81538,81548,81557,81561,81583,81598,81718,81745,81774,81828,81898,81902,81966,81968,81979,81980,81982,82031,82037,82050,82116,82119,82172,82173,82174,82175,82205,82209,82257,82258,82306,82307,82308,82310,82312,82323,82354,82411,82452,82513,82514,82520,82535,82616,82617,82632,82646,82726,82758,82778,82828,82829,82884,82905,82908,82912,82933,82976,83048,83321,83322,83323,83324,83388,83389,83393,83405,83436,83444,83447,83448,83455,83470,83483,83517,83520,83522,83553,83591,83664,83681,83704,83720,83740,83746,83804,83815,83840,83841,83843,83881,83897,83932,83976,83982,83984,84002,84019,84020,84044,84045,84058,84083,84108,84151,84231,84233,84341,84639,84640,84643,84644,84793,84798,84799,84805,84852,84856,84858,84865,84866,84867,84893,84909,84912,84919,84927,84935,84943,84955,85030,85031,85180,85184,85316,85357,85403,85417,85429,85453,85473,85516,85526,85532,85537,85562,85564,85565,85693,85694,85695,85742,85743,85753,85756,85762,85779,85807,85852,85856,85888,85907,85970,86000,86134,86150,86151,86153,86263,86264,86265,86266,86286,86294,86373,86414,86423,86425,86455,86520,86549,86727,86728,86729,86730,86731,86732,86741,86742,86743,86747,86748,86750,86755,86756,86757,86772,86773,86774,86780,86801,86810,86833,86834,86835,
86846,86847,86848,86850,86851,86852,86931,86932,87007,87008,87009,87010,87011,87013,87020,87021,87039,87051,87083,87084,87085,87086,87088,87089,87107,87241,87250,87251,87268,87283,87343,87362,87409,87425,87439,87649,87651,87652,87660,87665,87666,87671,87698,87699,87700,87796,88075,88076,88208,88295,88460,88481,88489,88495,88508,88523,88524,88578,88579,88586,88587,88589,88592,88630,88643,88669,88674,88677,88708,88710,88844,88922,88926,88951,88956,88957,88962,89014,89031,89132,89216,89243,89244,89377,89379,89384,89385,89386,89388,89391,89393,89652,89653,89688,89689,89696,89697,89718,89741,89742,89744,89749,89755,89756,89757,89788,89789,89791,89828,89837,89891,90057,90124,90134,90245,90246,90313,90427,90480,90502,90816,90901,90947,91050,91128,91171,91250,91253,91265,91269,91308,91314,91386,91423,91539,91569,91715,91717,91824,91916,91936,92040,92117,92205,92298,92301,92429,92521,92532,92599,92600,92606,92627,92694,92707,92735,92876,92887,92906,92912,92979,93002,93003,93010,93058,93095,93124,93226,93236,93313,93314,93318,93327,93328,93330,93333,93349,93647,93669,93718,93856,93903,93952,94149,94151,94196,94198,94386,94452,94459,94463,94495,94687,94694,94708,94718,94986,95043,95053,95268,95270,95305,95327,95328,95615,95762,95908,95951,96021,96146,96165,96166,96167,96265,96266,96267,96268,96287,96410,96608,96611,96878,97030,97091,97122,97124,97129,97214,97220,97247,97248,97345,97348,97434,97449,97454,97494,97504,97516,97677,97681,97752,97755,97787,97789,97810,97820,97828,97895,97928,97957,97976,97991,98021,98382,98468,98512,98653,98743,98759,98808,98884,98890,98957,99055,99119,99481,99504,99598,99633,99636,99647,99675,99720,99744,99749,99759,99779,99785,99793,99794,100100,100243,100328,100329,100333,100334,100409,100411,100496,100723,100841,100846,100890,101062,101068,101069,101077,101110,101145,101169,101170,101171,101172,101173,101315,101515,101541,101554,101575,101580,101581,101596,101619,101624,101756,101785,101982,102091,102093,102106,102132,102229,102263,102361,102385,102415,102434,102515,102516,102556,102741,102819,102863,102918,102960,103046,103079,103217,103224,103225,103326,103480,103497,103514,103527,103540,103549,103563,103592,103616,103639,103681,103785,103786,103787,103805,103808,103841,104147,104219,104224,104226,104310,104364,104404,104481,104815,104827,104882,104895,105014,105049,105104,105141,105397,105398,105547,105613,105644,105657,105662,105838,105876,105884,106039,106192,106309,106311,106467,106630,106665,106804,106837,106920,106993,107098,107103,107398,107440,107459,107487,107503,107595,107596,107617,107663,107667,107669,107741,107749,107753,107755,107758,107778,107803,107805,107808,107811,107846,107852,107914,107928,107957,107965,108014,108048,108163,108181,108185,108313,108322,108359,108360,108361,108499,108529,108535,108538,108542,108552,108624,108626,108702,108890,108891,108927,109023,109124,109180,109320,109324,109349,109351,109521,109594,109613,109627,109628,109702,109779,109803,109807,109809,109819,109867,109934,110042,110043,110050,110066,110253,110340,110350,110422,110501,110502,110503,110562,110675,110703,110824,110838,110846,110966,111197,111206,111273,111383,111387,111456,111463,111487,111570,111571,111633,111643,111647,111721,111784,
111933,111980,112008,112010,112039,112068,112328,112331,112334,112336,112370,112444,112461,112497,112498,112533,112636,112637,112644,112661,112691,112692,112732,112742,112802,112825,112827,112859,112861,112905,112909,112910,112948,113040,113041,113110,113122,113123,113125,113126,113127,113150,113184,113185,113189,113190,113198,113201,113205,113408,113493,113626,113694,113700,113739,113756,113757,113758,113759,113761,114113,114323,114575,114576,114577,114835,115091,115093,115097,115119,115553,115663,115664,115665,115666,115667,115668,115669,115670,115671,115672,115673,115674,115675,115676,115677,115678,115795,116571,116921,116975,117101,117206,117243,117354,117509,117663,117672,117749,117851,118244,118252,118275,118471,118706,118721,118725,119139,119181,119287,119326,119337,119339,119709,119721,119747,119748,119874,119884,119968,119969,119990,120016,120071,120226,120386,120477,120570,120587,120588,120589,120592,120593,120666,120667,121112,121178,121440,121441,121442,121444,121446,121447,121448,121449,121457,121461,121502,121562,121565,121567,121571,121610,121620,121623,121624,121625,121629,121661,121673,121896,121898,121927,122002,122004,122010,122022,122023,122060,122111,122113,122114,122153,122154,122157,122165,122176,122223,122224,122242,122362,122363,122365,122399,122407,122408,122410,122504,122516,122517,122518,122548,122560,122570,122678,122749,122790,122957,122961,122986,123076,123090,123093,123095,123096,123098,123135,123210,123212,123306,123308,123309,123310,123312,123313,123316,123352,123423,123425,123427,123455,123463,123487,123502,123508,123511,123512,123519,123527,123571,123604,123620,123636,123647,123651,123653,123655,123702,123712,123714,123727,123731,123809,123810,123813,123814,123815,123868,123871,123901,123937,124016,124019,124029,124039,124084,124170,124172,124179,124182,124187,124212,124217,124225,124226,124265,124269,124271,124278,124279,124287,124300,124301,124303,124316,124375,124382,124397,124399,124439,124486,124522,124523,124524,124526,124527,124528,124529,124530,124536,124548,124567,124631,124654,124681,124700,124709,124716,124761,124783,124791,124800,124807,124814,124845,124853,124877,124885,124890,124921,125003,125081,125090,125098,125100,125101,125130,125205,125206,125207,125211,125212,125214,125250,125276,125278,125299,125308,125347,125386,125401,125411,125452,125453,125464,125477,125547,125875,125882,126111,126133,126142,126198,126217,126219,126237,126243,126313,126353,126356,126387,126419,126433,126443,126452,126455,126463,126502,126505,126508,126562,126618,126626,126627,126637,126642,126643,126644,126645,126653,126672,126695,126702,126703,126708,126709,126722,126723,126725,126726,126732,126771,126831,126885,126898,126909,126926,126929,126939,126945,126953,126966,126967,126973,126984,126991,127000,127010,127060,127132,127140,127169,127201,127203,127259,127267,127279,127290,127294,127333,127381,127477,127479,127482,127493,127494,127514,127526,127530,127542,127543,127547,127553,127569,127572,127580,127600,127602,127611,127615,127626,127630,127636,127651,127699,127702,127745,127746,127758,127765,127776,127780,127800,127805,127806,127807,127822,127824,127847,127854,127864,127869,127873,127874,127876,127925,127939,127959,128005,128051,128065,128066,128067,128093,128099,128115,128116,128188,128189,128344,128361,128384,128385,128389,128390,128397,128404,128434,128435,128441,128476,128478,128547,128551,128612,128616,128620,128622,128623,128625,128658,128667,128669,128670,128699,128710,128729,128774,128780,128799,
128809,128821,128837,128838,128848,128849,128852,128912,128922,128937,127667,128942,128950,128959,128966,128968,128974,128996,129001,129002,129005,129027,129070,129110,129124,129126,129128,129139,129259,129283,129284,129288,129289,129301,129318,129323,129337,129345,129346,129347,129476,129495,129496,129500,129501,129505,129554,129558,129576,129626,129638,129644,129742,129760,129761,129764,129805,129810,129833,129835,129857,129863,129868,129869,129913,129935,129950,129954,130018,130019,130020,130022,130042,130070,130085,130110,130130,130138,130147,130160,130164,130229,130232,130233,130235,130244,130248,130256,130257,130314,130316,130321,130350,130359,130370,130401,130403,130405,130406,130413,130415,130428,130439,130443,130486,130489,130508,130543,130545,130557,130572,130575,130577,130598,130668,130705,130712,130713,130722,130727,130741,130743,130751,130752,130753,130754,130756,130757,130770,130772,130774,130776,130812,130814,130817,130832,130835,130846,130889,130902,130903,130935,130937,130943,130948,130953,130954,131013,131069,131072,131074,131076,131136,131188,131190,131191,131221,131229,131233,131252,131262,131283,131284,131332,131365,131377,131380,131384,131387,131520,131554,131558,131560,131598,131600,131603,131608,131609,131614,131624,131626,131628,131632,131672,131675,131687,131693,131695,131697,131718,131766,131780,131817,131890,131892,131893,131895,131897,131951,132022,132030,132031,132068,132102,132127,132136,132194,132195,132211,132244,132275,132311,132317,132319,132341,132409,132410,132526,132578,132580,132584,132644,132650,132653,132674,132754,132758,132760,132799,132835,132987,133158,133163,133173,133285,133321,133356,133357,133384,133527,133539,133562,133587,133603,133618,133619,133689,133812,133815,133822,133835,133842,133843,133853,133857,133862,133888,133896,133901,133928,133980,133988,133996,133999,134001,134005,134019,134048,134108,134147,134167,134181,134206,134207,134264,134296,134307,134316,134349,134377,134390,134433,134434,134436,134453,134519,134557,134562,134675,134686,134690,134699,134717,134718,134744,134774,134780,134782,134825,134896,134906,134907,135005,135048,135049,135052,135062,135175,135197,135234,135291,135293,135304,135306,135322,135450,135467,135483,135490,135494,135500,135508,135510,135543,135574,135582,135632,135674,135726,135728,135745,135773,135789,135790,135846,135850,135852,136149,136183,136204,136280,136311,136334,136335,136336,136341,136354,136381,136393,136396,136400,136416,136417,136426,136469,136553,136591,136593,136653,136663,136664,136667,136690,136697,136796,136901,136908,136914,136939,136993,137000,137025,137098,137140,137181,137182,137183,137209,137211,137217,137254,137255,137257,137329,137332,137336,137338,137340,137342,137349,137353,137356,137450,137457,137461,137494,137495,137640,137681,137713,137714,137716,137720,137724,137739,137763,137824,137825,137829,137835,137836,137840,137873,137885,138086,138139,138179,138181,138186,138258,138316,138342,138491,138540,138596,138675,138727,138794,138812,138963,138971,138972,139071,139072,139080,139145,139161,139194,139233,139235,139278,139280,139285,139290,139298,139365,139385,139435,139456,139483,139484,139486,139493,139521,139534,139537,139538,139539,139703,139706,139790,139793,139796,139988,140034,140038,140275,140276,140433,140501,140585,140591,140594,140604,140664,140690,140691,140692,140693,140694,140695,140696,140697,140699,140735,140738,140756,140938,141021,141029,141034,141049,141051,141118,141239,141313,141599,141641,141643,141696,141720,
141729,141832,141872,141877,141911,141935,141940,141977,141988,142088,142183,142195,142198,142199,142301,142312,142333,142334,142335,142337,142338,142339,142340,142341,142342,142347,142361,142400,142403,142435,142437,142438,142440,142449,142455,142475,142497,142500,142577,142579,142610,142711,142713,142717,142755,142780,142935,143391,143392,143393,143416,143510,143700,143718,143740,143741,143898,143928,143929,144052,144122,144329,144342,144460,144462,144477,144496,144837,144839,144842,144993,145172,145204,145337,145338,145340,145343,145457,145528,145529,145736,145740,145967,145970,146282,146321,146396,147222,147322,147453,147499,147500,147853,147864,148293,148296,148454,148480,148787,149134,149138,149147,149262,149644,149651,149654,149663,149680,149707,149836,149851,150154,150275,150373,150376,150467,150569,150581,150645,150649,150696,150802,150857,151096,151133,151144,151145,151147,151148,151149,151354,151639,151809,151811,151883,151945,151948,151993,151994,151998,152001,152092,152114,152136,152148,152290,152291,152296,152319,152356,152357,152358,152359,152360,152361,152362,152363,152383,152426,152444,152448,152461,152462,152463,152464,152465,152541,152542,152543,152544,152545,152546,152547,152548,152551,152552,152553,152555,152556,152642,152657,152708,152768,152795,152796,152797,152798,152799,152800,152801,152836,152989,153026,153032,153096,153208,153266,153268,153278,153350,153447,153448,153462,153531,153532,153549,153575,153585,153587,153588,153589,153592,153593,153596,153598,153609,153611,153612,153613,153614,153629,153654,153655,153656,153657,153658,153659,153660,153661,153663,153664,153691,153699,153719,153731,153733,153764,153801,153804,153812,153814,153818,153892,153902,153959,153966,153992,154030,154090,154107,154115,154155,154173,154181,154182,154268,154307,154308,154316,154331,154339,154353,154367,154505,154506,154576,154604,154616,154659,154752,154753,154754,154755,154756,154761,154868,154872,154905,154935,155073,155141,155238,155455,155483,155489,155570,155583,155703,155731,155779,155795,155855,155914,156046,156065,156077,156081,156091,156097,156098,156099,156100,156101,156201,156247,156267,156284,156314,156315,156316,156317,156345,156375,156376,156389,156395,156416,156509,156514,156527,156571,156595,156596,156636,156716,156736,156741,156744,156745,156751,156756,156757,156759,156760,156765,156778,156780,156808,156912,156917,156920,156921,156924,156927,156931,157083,157109,157121,157143,157149,157162,157274,157277,157279,157290,157332,157341,157438,157465,157466,157477,157482,157565,157589,157606,157619,157662,157665,157670,157684,157695,157697,157725,157728,157761,157828,157829,157937,157938,157973,157974,158054,158081,158110,158153,158226,158234,158235,158237,158239,158248,158249,158250,158251,158252,158253,158254,158256,158258,158260,158291,158292,158295,158344,158364,158384,158387,158409,158429,158448,158460,158465,158497,158520,158530,158590,158638,158646,158698,158702,158722,158752,158767,158771,158772,158797,158945,158948,158952,158954,158976,158978,158979,159016,159029,159030,159071,159072,159073,159077,159078,159079,159123,159176,159177,159178,159192,159194,159195,159196,159197,159218,159221,159222,159223,159265,159298,159323,159331,159420,159441,159460,159610,159612,159637,159666,159667,159693,159708,159737,159746,159747,159753,159816,159843,159844,159856,159886,159895,159916,159925,159926,160050,160051,160052,160074,160075,160076,160079,160080,160189,160255,160267,160269,160307,160308,160309,160310,160311,160319,
160320,160321,160341,160348,160350,160394,160395,160401,160402,160413,160425,160531,160547,160548,160549,160552,160553,160554,160555,160556,160557,160558,160559,160560,160565,160566,160569,160570,160581,160584,160585,160586,160587,160588,160590,160591,160592,160599,160606,160611,160612,160615,160616,160617,160618,160619,160620,160629,160632,160634,160685,160691,160715,160784,160785,160786,160787,160788,160852,160853,160872,160917,160970,160975,161069,161130,161131,161133,161149,161172,161206,161210,161211,161218,161227,161249,161294,161309,161382,161452,161453,161454,161466,161471,161524,161527,161528,161529,161530,161541,161567,161672,161763,161828,161882,161889,161917,161960,162011,162043,162045,162054,162055,162104,162140,162142,162147,162155,162156,162157,162173,162258,162259,162276,162278,162300,162334,162335,162336,162360,162361,162363,162364,162368,162373,162374,162375,162378,162380,162381,162382,162399,162437,162449,162477,162478,162536,162586,162588,162589,162593,162608,162617,162624,162625,162626,162627,162628,162681,162701,162705,162707,162747,162765,162767,162894,162909,162964,162990,162995,163025,163042,163047,163072,163077,163091,163093,163154,163157,163166,163170,163185,163186,163188,163216,163236,163238,163239,163240,163241,163251,163259,163265,163268,163316,163322,163370,163386,163432,163433,163439,163454,163455,163456,163466,163468,163473,163480,163492,163500,163503,163506,163507,163525,163526,163529,163530,163531,163546,163549,163552,163556,163566,163568,163616,163660,163884,163893,163899,163953,163956,163975,163991,163992,163994,163997,164036,164037,164038,164046,164110,164118,164186,164197,164198,164208,164234,164238,164312,164379,164385,164391,164424,164433,164479,164528,164563,164582,164587,164598,164642,164690,164788,164789,164790,164792,164813,164819,164826,164827,164829,164847,164862,164863,164873,164874,164875,162428,164878,164895,164915,164922,164990,164995,165025,165055,165068,165077,165079,165081,165085,165086,165087,165092,165093,165094,165106,165125,165189,165190,165223,165224,165225,165251,165336,165345,165349,165365,165368,165398,165400,165401,165404,165427,165449,165450,165451,165473,165566,165634,165685,165727,165730,165780,165784,165790,165800,165801,165905,165907,165908,165912,165914,165937,165942,165957,165973,165974,165989,166019,166022,166024,166073,166075,166099,166179,166182,166187,166290,166301,166304,166322,166354,166370,166421,166423,166433,166434,166456,166475,166499,166517,166559,166592,166671,166676,166679,166735,166895,166930,166933,166934,166951,166966,166967,166972,167065,167066,167068,167069,167070,167071,167111,167113,167114,167116,167129,167139,167328,167335,167342,167343,167344,167345,167346,167347,167348,167349,167350,167351,167352,167375,167376,167418,167433,167448,167461,167480,167494,167497,167629,167719,167721,167848,167851,167856,167947,167960,168008,168013,168036,168084,168085,168086,168090,168132,168135,168149,168153,168192,168196,168216,168239,168240,168255,168258,168268,168269,168298,168302,168303,168306,168309,168310,168314,168315,168319,168321,168333,168338,168342,168359,168361,168383,168387,168388,168395,168402,168407,168424,168428,168434,168436,168438,168442,168457,168464,168469,168470,168475,168502,168533,168552,168584,168591,168613,168617,168620,168634,168638,168644,168659,168673,168676,168677,168678,168679,168690,168712,168722,168724,168731,168735,168737,168763,168788,168789,168792,168804,168806,168855,168857,168862,168873,168887,168890,168897,168910,168919,168943,
168946,168965,169049,169050,169051,169052,169061,169099,169104,169114,169118,169119,169123,169124,169129,169160,169163,169167,169174,169190,169191,169193,169195,169228,169234,169240,169241,169243,169247,169249,169252,169263,169303,169308,169313,169332,169333,169334,169335,169336,169337,169390,169471,169489,169503,169504,169509,169512,169513,169515,169532,169555,169570,169577,169579,169618,169673,169675,169692,169702,169704,169732,169737,169741,169742,169747,169750,169755,169757,169758,169762,169768,169771,169795,169798,169823,169825,169826,169829,169840,169856,169857,169858,169864,169872,169911,169914,169915,169921,169963,169972,169973,169974,169975,169976,169977,169983,170005,170007,170008,170009,170014,170015,170047,170067,170068,170070,170093,170112,170122,170144,170145,170159,170183,170184,170194,170205,170206,170232,170241,170244,170247,170248,170268,170307,170325,170326,170328,170330,170331,170332,170333,170334,170335,170336,170371,170383,170386,170387,170390,170392,170393,170395,170397,170439,170451,170456,170460,170488,170516,170521,170526,170548,170577,170604,170605,170609,170642,170659,170674,170695,170698,170699,170701,170715,170730,170733,170766,170767,170768,170769,170780,170781,170785,170790,170822,170823,170829,170847,170852,170853,170856,170859,170860,170876,170893,170910,170923,170932,170933,170968,170969,170995,171017,171074,171081,171093,171181,171202,171203,171204,171207,171209,171212,171245,171328,171341,172058,171342,171343,171365,171366,171367,171383,171450,171452,171455,171511,171591,171633,171651,171663,171776,171827,171837,171862,171870,171997,171999,172000,172017,172028,172029,172045,172060,172061,172067,172069,172070,172071,172072,172073,172082,172083,172092,172108,172124,172179,172200,172206,172286,172312,172319,172329,172388,172390,172401,172426,172492,172518,172524,172628,172635,172703,172704,172722,172785,172846,172847,172871,172876,172888,172934,172943,172945,172947,172950,172966,172970,172979,172983,173007,173024,173045,173046,173075,173114,173133,173160,173202,173211,173216,173379,173393,173409,173411,173522,173524,173560,173582,173611,173619,173625,173635,173640,173687,173688,173716,173720,173727,173776,173777,173782,173794,173818,173834,173855,173940,174024,174201,174203,174212,174247,174248,174281,174356,174391,174392,174396,174412,174431,174455,174551,174552,174592,174657,174713,174761,174855,174990,174994,175141,175162,175237,175245,175254,175255,175265,175350,175396,175454,175465,175478,175543,175544,175626,175627,175651,175653,175654,158427,
}


--[[

AOTH.normalPets = {
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Stonetusk Boar",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 503 ,["id"] = 113  ,["coords"] = {{31.4,85.2},{32,84},{32.2,85.4},{32.2,85.6},{32.2,86.6},{33,86.6},{33.2,85.2},{33.2,85.6},{33.6,85.4},{34.8,80.2},{37.6,70.4},{38.4,74.2},{38.4,75},{38.6,77},{39,78.6},{39.2,74},{40.2,78.2},{40.4,70.4},{40.6,70.6},{40.6,75.4},{40.6,77.2},{41,76.2},{41,85.4},{41,85.6},{41,86.6},{41.2,69.4},{41.2,69.6},{41.2,88},{41.6,72},{41.6,85.4},{41.8,69},{41.8,69.8},{41.8,88},{42,77.6},{42,86.4},{42,86.6},{42.2,74.8},{42.4,73},{42.4,73.6},{42.6,71.6},{42.6,72.8},{42.8,70.6},{42.8,86.4},{42.8,86.6},{43.4,70},{43.6,71.8},{43.8,69.6},{44.6,71.2} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Young Goretusk",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 8871 ,["id"] = 454  ,["coords"] = {{42.4,24},{46,18.8},{46.2,28.2},{46.6,19.4},{46.6,27.6},{46.8,27.4},{47,31.2},{47.2,24.6},{47.2,28.8},{47.4,21.4},{47.4,21.6},{47.4,23.4},{47.4,24},{47.4,31.6},{47.6,23.4},{47.6,23.6},{47.8,22.2},{47.8,28.2},{47.8,30.4},{47.8,31.2},{49.4,16.8},{49.4,21.8},{49.4,23.4},{49.4,23.6},{49.4,25.4},{49.6,16.8},{49.6,23.4},{49.6,23.6},{49.6,24.6},{50.2,22},{50.4,20.4},{50.4,20.8},{50.6,21.6},{51,20.4},{51,20.6},{51.2,23.2},{51.2,24},{51.4,24.6},{51.6,19.4},{51.6,22.4},{51.6,23.6},{51.8,20.4},{51.8,21},{51.8,24.8},{52.4,18.4},{52.4,23},{52.6,22.2},{53,17.8},{53.4,25},{53.4,25.6},{53.8,24.4},{53.8,24.8},{53.8,25.6},{54.2,20.8},{54.4,20.4},{54.6,20.6},{54.8,24.8},{54.8,26},{55,19.6},{55,24.4},{55.2,19.4},{55.4,16},{55.4,16.6},{55.6,16},{55.8,17.4},{55.8,17.6},{56.2,20.4},{56.2,20.8},{56.8,22},{57,16.6},{57,22.8},{57.2,16.4},{57.8,31.6},{58,11.4},{58,12.2},{58,15.6},{58.2,12.6},{58.2,15.4},{58.2,33.8},{58.4,13.6},{58.4,31.2},{58.6,16},{58.6,32.2},{58.8,13.4},{58.8,13.6},{58.8,34.4},{59.2,30.2},{59.4,16.6},{59.4,29.4},{59.4,34.8},{59.6,16.4},{59.6,17.8},{59.6,33.6},{59.8,17.2},{60.4,27.6},{60.4,32},{60.6,27.6},{60.6,28.8},{61,32.4},{61.8,22.2},{62.6,27.6} } },
  {["zone_name"] = "Duskwood", [ "zoneID" ] = 47, [ "name" ] = "Black Ravager",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Duskwood.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 741 ,["id"] = 628  ,["coords"] = {{22.6,74.8},{22.6,77},{22.8,63.2},{22.8,64.2},{23,76.2},{23.6,63.4},{23.6,76.6},{23.8,62.2},{24.6,75.8},{25,78.2},{25.2,78.8},{25.4,72.8},{26.2,68.8},{26.4,64.8},{26.4,65.6},{26.4,68.2},{26.6,75.4},{26.6,77.4},{27,63},{27.2,68.2},{27.2,72.2},{27.4,65.4},{27.4,79},{27.6,61.8},{27.6,71.6},{27.8,71},{27.8,75},{28.6,68.4},{29,73.8},{29.2,69.6},{30.2,62.2},{30.4,62.6},{30.6,61.2},{30.6,64.6},{31.8,62.4},{32.4,62.6},{33,62.2},{35.2,63.8},{36.4,64.4},{36.6,64},{37.2,63},{37.6,62.2},{37.6,65.2},{38.8,59.6},{39.2,58.2},{39.2,67},{39.4,59},{39.6,58.4},{39.6,59},{39.6,65.4},{39.8,67.2},{40.2,61.4},{40.6,61.4},{41.2,61.6},{41.6,61.4},{41.6,63.2},{41.8,65.4},{41.8,77.8},{42,61.6},{42.2,66.2},{42.8,66.8},{42.8,78.4},{42.8,78.6},{43,65.4},{43,65.6},{43.2,76},{43.2,77.2},{43.8,76.8},{43.8,79.2},{44.2,74.8},{44.6,75},{44.6,76.4},{44.6,77},{49.2,62.6},{49.4,62.2},{50.2,61.4},{50.4,62},{50.8,60.8},{50.8,61.8},{51,59.4},{51.4,59.8},{51.6,60.6},{51.8,62},{52,60},{52.4,65.8},{52.6,59.2},{52.8,60.8},{52.8,63.2},{53.4,60.4},{53.6,64.6},{53.8,60},{53.8,65.6},{54,57.4},{54,57.6},{54,60.6},{55,58},{55.2,57},{55.4,59},{55.6,60.2},{55.8,57.2},{55.8,58.8},{55.8,60.6},{56.6,59},{57,60.8},{57.2,62.2},{57.4,56.4},{57.6,57},{58,59},{58.6,56.8},{59.4,57.8},{59.6,58},{59.6,59},{59.8,59.8},{59.8,61},{60.6,59.2} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Young Stranglethorn Tiger",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 598 ,["id"] = 681  ,["coords"] = {{36.2,17.6},{36.4,17.4},{37.2,18.8},{37.6,19.4},{37.8,20},{38.2,20.8},{39,21.8},{39.4,20.4},{39.4,20.6},{39.4,22.6},{39.6,20.4},{39.8,21},{39.8,23.2},{40.4,22},{40.4,24.2},{40.4,24.6},{40.6,22.2},{40.6,24.2},{41.2,25.4},{41.2,25.6},{41.4,23.4},{41.6,23.4},{41.6,26},{42.2,24.4},{42.2,24.6},{42.2,26.6},{42.2,32.6},{42.4,32.4},{42.6,29.2},{42.8,27.4},{42.8,27.8},{42.8,31.4},{42.8,31.6},{43,29.6},{43.2,25.4},{43.2,25.6},{43.4,24.4},{43.6,23.4},{44.2,22.2},{44.2,24.4},{44.2,24.6},{44.2,25.8},{44.4,32},{44.6,25.8},{45,26.8},{45,31.6},{45.2,24.6},{45.4,24},{45.4,31.4},{45.4,33.8},{45.6,24.2},{45.6,31.6},{45.6,33.6},{46,22.4},{46,23},{46.2,30},{46.2,32.8},{46.4,25.2},{46.4,30.6},{46.6,23.6},{46.6,34.6},{46.8,26.2},{46.8,31.4},{46.8,31.6},{46.8,34},{47,25.4},{47.4,32.6},{47.6,30.6},{47.6,32.8},{48,29.4},{48,30},{48.4,33.8},{48.6,31.8},{48.6,34},{49.2,30.4},{49.2,30.8},{49.2,32.8} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Shadowmaw Panther",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 633 ,["id"] = 684  ,["coords"] = {{44.4,58.4},{44.4,58.6},{44.6,58.4},{44.6,58.6},{45.4,59.6},{47,57.2},{47,57.6},{47.4,59.2},{47.8,59.4},{48.4,56.2},{48.6,56.4},{49.4,57.4},{49.4,57.6},{49.6,57.4},{49.6,57.6},{50,59.8},{50.2,56},{50.4,58.6},{50.6,56},{50.6,58.4},{50.6,58.8},{50.8,64.8},{51,54.4},{51,55},{52,59.4},{52,61.4},{52.2,62.2},{52.4,54.4},{52.4,54.6},{52.4,59.6},{52.6,54.4},{52.6,54.8},{52.6,69.6},{52.8,59.4},{52.8,59.6},{53,67.2},{54.4,64.4},{54.4,64.8},{54.6,64.8},{55.2,64.4},{58.2,46.6},{58.4,46.4},{58.6,46.4},{59,45.2},{59.2,47.2},{59.2,47.6},{59.8,48.6},{60,48.4},{60.2,46.4},{60.2,46.6},{60.4,50.4},{60.4,50.6},{60.6,47.2},{60.6,50},{60.8,40.2},{60.8,47.6},{61.4,49},{61.4,51.4},{61.4,51.6},{61.6,49},{61.6,51.4},{61.6,51.6},{62.4,42.8},{62.4,47.4},{62.4,47.6},{62.4,50.4},{62.6,42.8},{62.6,47.4},{62.8,42},{63,48.4},{63,48.6},{63.2,36.4},{63.2,36.6},{64,37.4},{64,37.6},{64.2,50.4},{64.8,36.4},{65,36.8},{65.4,38},{65.4,45.2},{65.4,45.6},{65.6,38.2},{65.6,45.4},{65.6,45.6},{66,42.8},{66.4,38.8},{66.4,41.2},{66.4,41.6},{66.4,43.8},{66.6,39},{66.6,41.4},{66.6,41.6},{66.6,44.2},{67.2,37.4},{67.2,37.6} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Forest Spider",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 366 ,["id"] = 30  ,["coords"] = {{28,66.2},{28,67},{32.2,56.8},{32.2,68.2},{32.4,57.6},{32.6,57.4},{32.8,57.6},{33.4,73.6},{35.4,62.4},{35.4,69.2},{35.4,69.8},{35.6,69.4},{35.6,69.6},{35.8,62.6},{36,62.4},{36.2,55.4},{36.2,55.8},{36.2,56.8},{36.4,60.8},{36.6,55.4},{36.6,56},{36.8,61.8},{37,77.6},{37.2,77},{37.8,78.2},{38,62.4},{38,70.2},{38.2,75.6},{38.4,62.6},{38.4,73.6},{38.4,74.8},{38.4,77.2},{38.4,79.4},{38.6,62.2},{38.6,62.8},{38.6,74.4},{38.6,75.4},{38.6,76.4},{38.6,77.6},{39,68.4},{39.2,72.8},{39.8,76.2},{40,77.4},{40.2,69.4},{40.2,69.6},{40.2,74},{40.4,70.6},{40.4,73.4},{40.4,75.4},{40.6,70.8},{40.6,74.2},{40.8,70.2},{41,75},{41,76},{41,80.6},{41.2,73},{41.2,76.8},{41.4,72.2},{41.4,78},{41.4,78.8},{41.6,70.2},{41.6,72},{41.6,76.2},{41.8,78.4},{42,74.6},{42.4,70.8},{42.4,73},{42.4,73.6},{42.6,71},{42.6,72},{42.8,70.4},{43,60},{43.2,59.4},{43.4,72.6},{43.4,77.4},{43.6,59.4},{43.6,59.6},{43.6,71.2},{44,70},{44,71.6},{44,76.4},{44.6,71.2} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Stranglethorn Raptor",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 788 ,["id"] = 685  ,["coords"] = {{25,29.4},{25.4,29.8},{26,30.6},{26.4,30},{27,30.6},{27.2,29.4},{27.4,29.8},{28.2,30.4},{28.2,30.6},{28.6,31.6},{28.8,29.2},{29.2,30.4},{29.2,30.6},{29.8,31},{30,29.6},{30,32.8},{30.2,29.2},{30.4,31.6},{30.6,30.2},{30.6,31.4},{30.8,28.6},{30.8,31.6},{31,27.4},{31,27.6},{31.4,32.6},{31.6,27.4},{31.6,27.6},{31.6,31.2},{31.6,31.6},{31.6,32.6},{32.2,28.8},{32.2,30},{32.6,28.4},{32.6,29} } },
  {["zone_name"] = "Darkshore", [ "zoneID" ] = 62, [ "name" ] = "Moonstalker Runt",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Darkshore. Already controlled.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 11449 ,["id"] = 2070  ,["coords"] = {{38.2,92.8},{38.8,90.4},{39,67.2},{39.2,69.8},{39.4,65.6},{39.6,69},{39.6,90.8},{39.8,67.2},{39.8,68.2},{40,66},{40,86.6},{40.2,63.6},{40.2,70.8},{40.6,88.6},{40.8,71.6},{41,64.4},{41.2,65.4},{41.4,65.6},{41.4,87.2},{41.6,65.6},{41.8,63.4},{41.8,63.6},{42,65.2},{42,86.8},{42.6,87.2},{42.8,61.8},{42.8,64.2},{43.2,63.2},{44.8,62.6},{45,61.2},{45.4,62},{46.4,89.6} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Parched Buzzard",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 1105 ,["id"] = 2830  ,["coords"] = {{35.8,60.4},{43.4,36.8},{43.8,37.6},{44,35.4},{45,27},{45.4,12.6},{46.4,13.6},{46.6,13.8},{47.4,51.2},{49.4,58.6},{52.6,43.2},{52.8,51.6},{54.8,50.2},{55,41.8},{56,38.4},{56.4,42} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Konda",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Spirit Den, The Cape of Stranglethorn. Spawns as the second gorilla during the quest Stranglethorn Fever, at a cave at the north end of Mistvale Valley.", ["class" ] = CLASS_NORMAL, ["family"] = {  9  , "Gorilla"          } , ["familySkills" ] = GORILLA_SKILLS          ,["displayID"] = 839 ,["id"] = 1516  ,["coords"] = {{53.2,48.4},{53.6,47.6},{54,46.4},{54,46.6} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Stone Maw Basilisk",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  130  , "Basilisk"          } , ["familySkills" ] = BASILISK_SKILLS          ,["displayID"] = 45450 ,["id"] = 688  ,["coords"] = {{35.8,11.8},{36,11.4},{36.2,9.4},{40,16},{40.8,15.8},{41,15.4},{41.4,16.8},{42.4,16.2},{42.4,16.6},{42.8,16.4},{42.8,16.6},{44,14.8},{44,16.2},{45.4,18.4},{45.4,18.6},{45.6,18.6},{45.8,17.8} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Starving Buzzard",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 10824 ,["id"] = 2829  ,["coords"] = {{76.8,29.8},{77.8,29},{78.6,32.2},{78.8,31.4},{79,32.6},{80.4,30.8},{81,30.4},{81.4,30.6},{81.6,30.6} } },
  {["zone_name"] = "Dun Morogh", [ "zoneID" ] = 27, [ "name" ] = "Snow Leopard",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Dun Morogh. Only found in North Gate Pass. Left overs.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 954 ,["id"] = 1201  ,["coords"] = {{86.2,36},{86.4,33.6},{86.4,35},{86.8,34.8},{87.4,33.6},{87.8,34},{89.2,36},{89.8,36.4} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Enraged Silverback Gorilla",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Spirit Den, The Cape of Stranglethorn. Spawns as the first gorilla during the quest Stranglethorn Fever, at a cave at the north end of Mistvale Valley.", ["class" ] = CLASS_NORMAL, ["family"] = {  9  , "Gorilla"          } , ["familySkills" ] = GORILLA_SKILLS          ,["displayID"] = 837 ,["id"] = 1511  ,["coords"] = {{53.4,47.8},{53.6,47.6},{54,46.4},{54,46.6} } },
  {["zone_name"] = "The Hinterlands", [ "zoneID" ] = 26, [ "name" ] = "Vilebranch Raiding Wolf",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Hinterlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 782 ,["id"] = 2681  ,["coords"] = {{58.4,64.4},{58.6,64.4},{58.6,64.8},{58.6,65.6} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Giant Buzzard",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 1106 ,["id"] = 2831  ,["coords"] = {{13,58.4},{13.8,54.6},{14.8,52},{15.4,52.8},{15.8,53.8},{15.8,55},{16.2,57.2},{16.2,59.2},{17.2,54.6},{18.2,54.4},{18.4,56},{18.6,52.4},{19,55},{19.6,54},{20.2,52.8},{20.8,56.2},{21.8,58} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Stranglethorn Tiger",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 320 ,["id"] = 682  ,["coords"] = {{50.8,20.4},{50.8,20.6},{51,21.6},{54.8,30},{55.2,28.8},{55.6,27.4},{56,27.8},{56.4,28.8},{56.6,27.6},{56.6,29},{56.6,29.6},{57,26.4},{57,26.8},{58.2,27},{58.2,29.2},{58.4,27.6},{58.6,27.2},{58.6,28.8},{59,28},{59.4,21.2},{59.6,21.2},{59.8,29.2},{60,31.4},{60.2,29.6},{60.2,32.2},{60.4,28},{60.6,28.2},{60.6,32.6},{60.8,25.4},{60.8,25.8},{60.8,32.4},{61,30},{61.4,29},{61.4,31.4},{61.4,34},{61.6,29},{61.6,29.6},{61.6,31.4},{61.6,31.6},{61.6,33.4},{61.6,34} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Bloodscalp Tiger",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn. Already controlled.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 320 ,["id"] = 698  ,["coords"] = {{23.4,18.4},{23.4,18.6},{23.6,18.8},{23.8,23.2},{27.4,20},{27.4,22},{27.6,22},{27.6,22.8},{27.8,19.4},{27.8,19.6},{29.2,23.2},{29.6,27},{31.2,23.2},{31.4,23.6},{32,23} } },
  {["zone_name"] = "Redridge Mountains", [ "zoneID" ] = 49, [ "name" ] = "Bellygrub",["maxlevel" ] =30, [ "minlevel" ] =7, ["info" ] ="Located in Redridge Mountains. Bellygrub may be found by the far western tip of the lake.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 703 ,["id"] = 345  ,["coords"] = {{17.4,44.4},{17.4,45},{17.4,45.6},{17.6,44.8},{17.8,44.2} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Feral Crag Coyote",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 557 ,["id"] = 2728  ,["coords"] = {{60.8,51.4},{68.4,29},{68.6,28.4},{69,29.4},{69,29.6},{69.6,30.2},{70.2,28.8},{70.2,30.6},{70.2,31.6},{70.6,31.4},{71,30.4},{71,32.2},{71.2,28.6},{71.4,21.6},{71.4,32.8},{71.8,36},{72,22.2},{72.4,32.8},{76.4,27},{76.6,27.2},{77,30.6},{77,40.2},{77.6,28.8},{77.8,36.4},{78.4,34.2},{79.6,31.6},{80.2,32.8},{89.2,38.2},{90,39} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Mangy Wolf",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 903 ,["id"] = 525  ,["coords"] = {{21.4,73.8},{22.6,75.4},{22.6,75.6},{23.4,76.6},{23.6,76.8},{23.6,77.6},{23.8,76.4},{26.2,75.6},{26.4,75.2},{26.6,75.2},{27.4,70.6},{27.4,74},{27.8,74},{29.2,72},{29.2,72.6},{29.6,72.6},{30.4,72},{30.6,72},{31.4,56.6},{32,55.2},{32,55.8},{33.2,57.4},{33.2,57.6},{33.2,75.6},{33.4,75.4},{34,59.2},{34.2,72.4},{34.8,62},{35,63.6},{35,67.2},{35,67.6},{35,70.6},{35,74.4},{35,74.6},{35.2,70.2},{35.2,72.4},{35.2,72.6},{35.6,69.4},{37,60.8},{37.8,65},{38.2,62.6},{38.2,63.8},{42.4,55.6},{42.4,62.8},{42.6,62.2},{42.6,62.6},{42.8,61},{43.6,59.8},{44.4,57.2},{44.6,58},{45.8,55.4},{45.8,68.6},{47.2,68.2},{49.4,60.6},{49.6,60.4},{49.6,60.6},{51,62.2},{51.4,69.2},{52,63.2},{52,64},{52.2,62.4},{54.2,60.2},{54.6,69.6},{56.2,61.6},{56.8,59.4},{56.8,60.8},{57.6,60.2} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Ridge Stalker",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 632 ,["id"] = 2731  ,["coords"] = {{68.4,29},{68.6,29},{68.8,29.6},{69.8,30.4},{69.8,30.8},{70.4,31.6},{70.8,29.4},{70.8,29.6},{71,32.4},{71.2,32.8},{77,40.2},{77.8,36.2},{79.6,32},{90,39.2} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Longsnout",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 381 ,["id"] = 119  ,["coords"] = {{24.4,83.4},{24.4,84.2},{24.6,83.4},{24.6,83.6},{24.8,86.8},{24.8,87.6},{25,85.2},{25.2,78.4},{25.2,86.2},{25.4,79.4},{25.4,79.6},{25.4,82},{25.6,79.4},{25.6,79.6},{25.6,82},{25.6,82.6},{25.6,84.2},{25.6,85.2},{25.8,86} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Young Thistle Boar",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 8869 ,["id"] = 1984  ,["coords"] = {{32,72.6},{32.2,70.8},{33.2,68},{36,76.2},{36.4,74.2},{36.4,75.4},{36.8,71.6},{36.8,73.8},{36.8,74.6},{36.8,75.6},{37.6,75},{37.8,76.4},{38,76.6},{38.8,75.2},{39.4,62.2},{39.8,63.4},{39.8,75},{42.4,73.4},{42.4,73.8},{42.4,75.2},{42.6,73.8},{42.6,75.6},{42.8,72.4},{42.8,74.8},{43.4,72.8},{43.8,74},{44.2,73.2},{44.4,76},{44.6,73.4},{45.2,76.6},{45.2,78.4},{45.4,79},{45.4,79.6},{45.6,77.2},{45.8,78},{46,79.2},{46.4,80},{46.8,78.4},{46.8,78.6},{46.8,79.8},{47.6,76.6},{52,78.8},{52.2,77.8},{52.6,79},{53,69.2},{53,76.8},{53,77.6},{53.4,68.2},{53.4,76.4},{55.2,66.4},{55.8,66.2},{55.8,67.6},{56.2,63},{56.2,71.8},{56.4,61.2},{56.4,73.6},{56.6,66.2},{57.2,66.6},{57.8,71},{58.2,68.6},{58.6,66.8},{58.6,67.8} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Cold Eye Basilisk",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  130  , "Basilisk"          } , ["familySkills" ] = BASILISK_SKILLS          ,["displayID"] = 8797 ,["id"] = 690  ,["coords"] = {{42,15.4},{42,17.2},{42,17.6},{42.8,16.6},{43,12.6},{43,16.4},{43.4,14},{43.4,14.6},{43.6,11},{43.6,11.6},{43.6,14.8},{44.4,10},{44.6,10.4},{45.8,9.4},{47,8.8},{47.4,8.4},{48,9} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Prowler",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11415 ,["id"] = 118  ,["coords"] = {{72.4,65},{72.4,65.6},{72.6,65.4},{73,65.8},{75.4,73.8},{75.4,74.6},{75.4,76.4},{75.6,74.2},{75.6,76.4},{75.8,75.4},{76,63.4},{76.4,63.6},{76.6,63.4},{76.6,63.6},{76.8,61},{76.8,61.8},{76.8,78.6},{77,76.4},{77.4,77.2},{78.2,63.4},{78.4,63.8},{78.4,79},{78.4,80.4},{78.6,75.4},{78.8,63.6},{78.8,80.2},{79.2,62.4},{79.2,76.2},{79.2,82.8},{79.4,60.4},{79.4,60.6},{79.4,62.6},{79.4,81.2},{80,61},{80.2,60},{80.4,80.4},{80.4,80.6},{80.6,60.2},{80.6,80.4},{80.6,81},{81.2,77.6},{81.4,61},{81.6,60.2},{81.8,77.2},{82,61},{82.4,84},{82.6,84},{82.8,60.2},{83.2,61},{83.4,59.2},{83.8,60.4},{83.8,71.2},{84,61.6},{84.2,61.4},{84.6,61.2},{85.6,63.8},{85.6,83},{85.8,61},{86,65.2},{86.2,66.4},{86.4,69.4},{87,66.6},{87,69.4},{87,70},{87,71},{87.4,82},{87.8,72},{87.8,77.8},{90.2,78.8} } },
  {["zone_name"] = "Tirisfal Glades", [ "zoneID" ] = 18, [ "name" ] = "Ragged Scavenger",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Tirisfal Glades.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 604 ,["id"] = 1509  ,["coords"] = {{58.8,27},{58.8,45.8},{59,29.4},{59.2,22.4},{59.4,25.4},{59.4,28},{59.4,30.4},{59.8,21.6},{59.8,23.6},{60,20.8},{60,23.2},{60,27},{60.2,39.6},{60.4,25.4},{60.4,26.2},{60.4,27.8},{60.4,29.4},{60.4,30.4},{60.6,25.2},{60.8,19.2},{61,26.8},{61,28.4},{61,30.8},{61,41.8},{61.2,26.2},{61.2,41},{61.2,46},{61.4,20},{61.4,20.6},{61.4,28.6},{61.4,30.4},{61.6,19.4},{61.6,27.2},{61.6,28.2},{61.6,29.2},{61.6,30},{61.6,30.6},{61.8,25.8},{62,42.6},{62,45.8},{62.2,20.2},{62.2,23.4},{62.2,42.4},{62.4,25.2},{62.6,19.2},{62.6,23.4},{62.6,25.8},{62.6,41.8},{62.8,20.6},{62.8,24},{62.8,25.2},{62.8,26.8},{62.8,45.8},{63,22.4},{63,27.8},{63,30.2},{63.4,28.6},{63.6,23.8},{63.8,23},{63.8,24.8},{63.8,25.6},{63.8,28.4},{63.8,31.6},{64.2,21.8},{64.8,22.4},{64.8,26.6},{65,25},{65.4,28.2},{65.6,21.2},{65.6,24},{65.6,24.6},{66,17.8},{66.6,21.6},{66.6,36.8},{67,23},{67,27.6},{67,29.8},{67.2,21.4},{67.4,32.8},{67.6,22.6},{67.8,25.2},{68.2,21.4},{69.4,37.4},{69.4,37.6},{69.8,36.2},{69.8,36.6},{70.4,35},{70.6,35.4},{70.6,37.8},{70.8,22.4},{71,20},{72,28.4},{72.4,21},{72.8,29.4},{72.8,36.4},{73,27.6},{73.4,27.2},{74.4,45.4},{75.2,46.2} } },
  {["zone_name"] = "Tirisfal Glades", [ "zoneID" ] = 18, [ "name" ] = "Mangy Duskbat",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Tirisfal Glades.", ["class" ] = CLASS_NORMAL, ["family"] = {  24  , "Bat"          } , ["familySkills" ] = BAT_SKILLS          ,["displayID"] = 47211 ,["id"] = 1513  ,["coords"] = {{56,21.8},{57.4,38.6},{57.8,20.8},{58.2,22.6},{58.2,39.4},{58.4,21.6},{58.6,40.6},{58.8,32.8},{58.8,53.2},{59,21.8},{59,32},{59,38.2},{59.2,23},{59.4,29.6},{59.4,31},{59.6,27.6},{59.6,31.6},{59.8,23},{59.8,23.6},{59.8,27.4},{59.8,39.4},{60,30.4},{60.2,31.2},{60.4,33.8},{60.6,31.4},{60.6,33.4},{60.8,28.6},{60.8,30.4},{61.2,41},{61.6,20.6},{61.6,28.6},{61.6,31.4},{62.6,43.4},{62.8,23},{62.8,25.6},{63,30.6},{63.4,39.8},{63.6,20.4},{63.6,26},{63.6,28.2},{63.6,31.6},{63.6,40},{63.6,40.6},{64.2,21},{64.2,25.2},{64.2,44.4},{64.6,21.8},{64.6,25.8},{64.8,20.4},{64.8,27.4},{65,38.8},{65.2,18.8},{65.4,28.6},{65.4,46},{65.6,44.2},{65.6,45.8},{65.8,40.6},{66,25},{66,26.6},{66,39.8},{66.2,21.2},{66.2,25.6},{66.4,35.6},{66.6,24.4},{66.8,44.8},{67.6,38.8},{70,25.2},{70.4,25.6},{70.8,38.6},{71.2,40.4},{72.2,27},{73,31.4},{74.2,24.6} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Goretusk",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 3027 ,["id"] = 157  ,["coords"] = {{45,30.4},{50.8,36},{51,32},{51,32.8},{51.2,31.4},{51.2,33.8},{51.4,34.8},{51.6,31},{51.6,34.4},{51.6,34.8},{51.8,35.6},{52,29.4},{52,29.8},{52.4,32.4},{52.4,33.2},{52.6,30.2},{52.6,32.4},{52.6,33.4},{52.6,35.6},{52.8,35},{53.4,34.4},{53.6,34.6},{53.8,34.4},{54.8,28},{54.8,28.8},{55.4,27.4},{55.6,27.4},{56.4,28},{56.4,31.8},{56.6,28.4},{56.8,29.2},{57,26.8},{57,30},{57,31.4},{57,32.2},{57,32.8},{57.2,26.4} } },
  {["zone_name"] = "Mulgore", [ "zoneID" ] = 7, [ "name" ] = "Plainstrider",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Mulgore.", ["class" ] = CLASS_NORMAL, ["family"] = {  12  , "Tallstrider"          } , ["familySkills" ] = TALLSTRIDER_SKILLS          ,["displayID"] = 1042 ,["id"] = 2955  ,["coords"] = {{19.4,26.6},{19.6,26.6},{19.8,42.2},{20,26.4},{20.6,42},{20.6,44.6},{23.8,28.8},{24,48.6},{24.2,49.6},{24.4,47.8},{24.4,51.2},{25.6,34.4},{28.2,23.6},{28.4,50.8},{28.6,58.2},{28.8,61.8},{29,50.6},{29,64},{29.2,23.4},{29.2,36.2},{29.2,40.6},{29.6,57.8},{31,50.4},{31,53.6},{31.2,52.2},{31.2,55.2},{31.4,52.6},{31.8,53.2},{32,54},{32.4,28.2},{32.4,55},{32.4,59},{32.6,27.4},{32.6,57.2},{32.8,58.4},{33.2,59.6},{33.6,56.8},{34,50.8},{34.2,52.4},{34.8,43.6},{35.2,43.2},{35.4,26.6},{36.4,38.8},{36.4,40.4},{37,40.2},{37.6,39.2},{38.2,34},{38.4,32.6},{39.2,35} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Greater Fleshripper",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 1105 ,["id"] = 154  ,["coords"] = {{25.6,47.2},{26.4,42.4},{26.4,42.6},{26.4,44},{26.6,42.4},{26.6,43.8},{26.8,43.4},{26.8,45.2},{27.6,42},{27.6,43.2},{32.2,62.4},{32.2,63.2},{33,62},{33.4,61.2},{33.4,63},{34.2,60.8},{34.8,72.2},{35,73.2},{35.4,65},{36.2,59.6},{36.4,69},{36.8,69.4},{37,59.8},{37.2,70},{37.4,66.8},{37.6,67.2},{37.6,69.2},{38.4,66},{39,67},{39.2,66.4},{39.2,68},{39.4,69.2},{39.6,66.2},{39.8,57.6},{39.8,59},{39.8,68.2},{40,67.2},{40.2,69.4},{40.4,65},{40.6,66.2},{40.6,69},{41,61.6},{41.4,58.8},{42.2,63.4},{57.8,65},{58.2,59.2},{58.2,61},{58.2,65.6},{58.4,56.2},{58.4,58.2},{58.6,58.6},{58.6,63.4},{58.8,63.8},{59,58},{59.2,59.6},{59.2,60.6},{59.2,62},{59.6,54.8},{59.6,65},{60,51.2},{60,52.4},{60,52.8},{60,63.8},{60.4,63},{60.6,62},{60.8,63.2},{60.8,63.6},{61,58.6},{61,61.2},{61.6,48},{61.8,62},{62,49},{62,51.2},{62,59.2},{62.2,50},{62.2,57.8},{62.6,58.2},{62.8,49.4},{62.8,50.4},{63,55.8},{63.4,57},{63.4,61.8},{63.6,56},{63.6,59.2},{63.6,60.6},{64,59.8},{64.2,57.4},{64.2,62.4},{64.8,57},{65,62},{65.2,63} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Mine Spider",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 368 ,["id"] = 43  ,["coords"] = {{60,48},{60,49},{60.4,47.2},{60.8,47},{61.4,47.8},{61.6,47.4},{61.8,47.6} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Giant Webwood Spider",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 336 ,["id"] = 2001  ,["coords"] = {{39.2,22.2},{40,24.4},{40,24.8},{40,25.6},{40.2,22.2},{40.4,23.4},{40.6,21.8},{40.6,23.2},{40.6,23.6},{40.8,24.8},{40.8,25.6},{41.8,23.4},{42.2,23.8},{42.4,24.6},{42.4,25.8},{42.8,23.8},{43,25.4},{43.6,24.8},{47,24.4},{47.2,25.2},{47.2,25.6},{47.8,22.4},{48,23.6},{48.4,22.6},{48.6,22.6} } },
  {["zone_name"] = "Darkshore", [ "zoneID" ] = 62, [ "name" ] = "Moonstalker Matriarch",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Darkshore.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 3031 ,["id"] = 2071  ,["coords"] = {{38.2,92.8},{39,67.2},{39,90.6},{39.2,70},{39.4,70.6},{39.8,65.2},{39.8,67.2},{40,66},{40,69.2},{40,86.6},{40.2,63.6},{40.4,70.6},{40.8,71.6},{40.8,89},{41.4,63.4},{41.4,63.8},{41.4,65.4},{41.4,65.8},{41.4,67.4},{41.4,87.2},{41.6,65.8},{41.8,63.4},{41.8,63.6},{41.8,65.4},{42,86.8},{42.4,88.4},{42.6,87.2},{42.8,64.2},{43,62.4},{43,63},{44.8,62.6},{45,61.2},{45,62.2},{46.8,89.4} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Young Wolf",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest. Had a diseased skin during WotLK. Changed to a healthy skin, and lost the 'Diseased' part of their name, during Cataclysm.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 18156 ,["id"] = 299  ,["coords"] = {{41.2,58.4},{41.4,57.4},{42,64},{42.2,55.8},{42.4,60.4},{42.4,60.8},{42.4,62.2},{42.4,62.6},{42.6,55.4},{42.6,62.4},{42.6,62.6},{42.8,53.6},{42.8,61},{43.6,59.6},{43.8,59.4},{44.4,57.2},{44.4,58.4},{44.6,57.4},{44.6,57.6},{45.4,55.4},{45.4,55.6},{45.8,55.4},{45.8,55.6} } },
  {["zone_name"] = "Hillsbrad Foothills", [ "zoneID" ] = 25, [ "name" ] = "Elder Gray Bear",["maxlevel" ] =30, [ "minlevel" ] =7, ["info" ] ="Located in Hillsbrad Foothills.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 3201 ,["id"] = 2356  ,["coords"] = {{30.4,47.8},{31,49.8},{31.8,52.4},{32.8,61.8},{33.2,58.4},{33.4,60.6},{33.4,63},{33.4,64},{33.6,51.4},{33.6,60.2},{33.6,63},{33.6,63.6},{33.8,55.4},{33.8,58},{33.8,62.4},{34.6,53.8},{35,52.6},{35.6,27.4},{35.8,27.6},{36,31.8},{36.2,32.8},{36.2,33.8},{36.6,47.2},{36.8,38},{37,26},{37,37.2},{37,41.8},{37,51.2},{37.2,25.4},{37.2,40},{37.2,52.2},{37.2,52.6},{37.2,72.2},{37.6,52.4},{37.6,71.6},{37.8,68.4},{38,73},{38.4,75.2},{38.4,76},{38.6,72.4},{38.6,75.4},{38.8,67.8},{38.8,71},{39,70.2},{39.6,72.6},{39.6,73.8},{39.6,74.8},{40,65.8},{40.4,70},{40.6,69.6},{40.6,72},{40.6,76.2},{41.2,66},{41.4,71},{47.4,13.6},{47.8,12.4},{47.8,13.6},{49,12.6},{50.8,13.4},{52.6,16},{53,15} } },
  {["zone_name"] = "Wetlands", [ "zoneID" ] = 56, [ "name" ] = "Highland Lashtail",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Wetlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 2571 ,["id"] = 1016  ,["coords"] = {{65.8,33.8},{67.2,30.6},{67.4,28.4},{67.4,33.4},{67.4,33.6},{67.6,32.2},{67.6,33.6},{67.8,30.4},{68,32.6},{68.4,27.6},{68.8,28},{68.8,31.2},{68.8,32.8},{69.2,31.8},{69.2,35.2},{69.6,30.6},{70,32.2},{70.4,29.4},{70.6,29.6},{70.8,30.6} } },
  {["zone_name"] = "Redridge Mountains", [ "zoneID" ] = 49, [ "name" ] = "Great Goretusk",["maxlevel" ] =30, [ "minlevel" ] =7, ["info" ] ="Located in Redridge Mountains.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 3035 ,["id"] = 547  ,["coords"] = {{12.4,68.2},{13,70},{13.2,71},{13.4,68.6},{14.2,69},{14.4,70.2},{17,64.2},{17.6,63.4},{18.2,63.6},{18.6,63.4},{18.6,63.6},{22.2,61.2},{22.4,60},{22.4,62},{22.6,59.8},{22.6,61.8},{23,61.2},{24.8,69.6},{25,69.4},{25.6,71.2},{27.2,59.4},{27.2,71.2},{27.4,60},{27.4,71.6},{27.6,59.8},{27.6,71.2},{27.8,72},{28.2,69.6},{29,57},{29.4,56.4},{29.4,57.6},{29.4,70.2},{29.4,70.6},{29.6,55.2},{29.6,56.6},{29.6,69.2},{29.8,55.8},{29.8,70.2},{29.8,71.2},{30,64.4},{30,65},{30.2,63.4},{31,64.4},{31.4,55.4},{31.4,55.6},{31.4,57.6},{31.4,70.6},{31.6,55.8},{31.8,57.8},{31.8,63.8},{32,55},{32.4,54.4},{32.4,63.2},{33,55.6},{34.6,62.4},{34.8,64},{34.8,64.6},{36.4,66.6},{36.6,66.6},{37.4,66},{37.6,66},{41.8,21.2},{42,21.6},{42.4,12},{42.6,16.8},{42.8,11.2},{42.8,11.6},{43,12.6},{43,14.8},{43,15.6} } },
  {["zone_name"] = "Arathi Highlands", [ "zoneID" ] = 14, [ "name" ] = "Young Mesa Buzzard",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Arathi Highlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 10824 ,["id"] = 2578  ,["coords"] = {{13.8,39},{18.8,36.4},{19.2,36.6},{20.2,38.2},{21.4,35.2},{21.6,35.4},{24,38},{24.6,41.2},{35.4,62.6},{35.6,64.6},{36.8,65.6},{38,65.8},{43.8,41.4},{46,47.6},{48.2,47.8},{49,48},{49.2,47.4},{50.8,46},{52.6,46.6},{52.8,46},{54.4,41.6},{55,43.2},{57.6,39.4},{58,41},{58.8,30.8},{59,42.8},{60.2,40},{61,40.2},{61.6,41.8},{62.2,58},{62.4,50.4},{63.4,49.4},{64,50.2} } },
  {["zone_name"] = "Wetlands", [ "zoneID" ] = 56, [ "name" ] = "Elder Razormaw",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Wetlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 788 ,["id"] = 1019  ,["coords"] = {{67.2,31.2},{67.4,28.2},{67.4,28.8},{67.8,30.4},{67.8,31},{67.8,32.2},{68,32.6},{68.4,27.6},{68.8,28},{68.8,31.2},{68.8,32.8},{69.2,31.8},{69.2,35.2},{70,32.2},{70.4,29.4},{70.4,31.2},{70.6,29.2},{70.6,29.6},{70.6,31.2} } },
  {["zone_name"] = "Mulgore", [ "zoneID" ] = 7, [ "name" ] = "Kodo Calf",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Mulgore.", ["class" ] = CLASS_NORMAL, ["family"] = {  156  , "Scalehide"          } , ["familySkills" ] = SCALEHIDE_SKILLS          ,["displayID"] = 1451 ,["id"] = 2972  ,["coords"] = {{38.2,54.8},{41,55.4},{41,60.2},{41.2,54.4},{41.8,56.8},{42.2,52.6},{42.6,50.6},{47.8,49.2},{49,47.8},{49.8,32},{51.2,24.6},{51.6,46.2},{52.8,23},{53,24.8},{53,46},{53.2,45.2},{53.4,26.4},{53.8,23.8},{56.2,28},{58.4,55.4},{58.6,64.2},{60,60.2},{60.4,58.6},{61.8,65.2},{62.6,64.8},{63.4,65.6} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Rockhide Boar",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 389 ,["id"] = 524  ,["coords"] = {{41.4,77.8},{42.4,77},{43,77.6},{43,81.4},{43.4,77.4},{43.4,79.8},{43.4,81.8},{44,80.2},{44,81},{44.2,79},{44.2,83.2},{44.2,83.8},{44.4,76.4},{44.4,78.4},{44.4,85.8},{44.4,89.4},{44.4,90.8},{44.6,79},{44.6,83.4},{44.6,84},{44.6,89.6},{44.8,77.8},{44.8,89.2},{45,85.6},{45,87.2},{45.4,88},{45.6,79.8},{45.8,83},{45.8,87.8},{46,82.4},{46,85.2},{46.2,77.2},{46.4,77.6},{46.4,81.4},{46.6,80.2},{46.6,83},{46.6,83.6},{47,80.8},{47.2,79},{47.4,76.2},{47.4,76.6},{47.4,78.4},{47.6,77.4},{47.8,79},{48,80.8},{48.2,75.4},{48.2,76.2},{48.2,78.2},{48.6,81.6},{48.8,75.6},{49,81.2},{49.2,73.4},{49.4,74.2},{49.4,75.2},{49.4,76.8},{49.6,75.2},{49.6,75.6},{49.8,73.6},{49.8,79.2},{49.8,80.2},{49.8,80.6},{50.2,78.4},{51.6,74.2},{52.2,78.4},{52.2,78.8},{52.2,83.4},{52.4,75.2},{52.4,81},{52.4,83.6},{52.6,75},{52.6,83.6},{53,79},{53,82.6},{53.2,74},{53.2,79.8},{53.2,82.4},{53.4,76.2},{53.6,85.2},{54.2,77.6},{54.2,83.6},{54.4,75.4},{54.4,80.8},{54.8,79.8},{55,72.8},{55.4,73.6},{56.2,75.4},{56.4,83.6},{56.6,73.4},{56.8,74},{56.8,74.6},{57.2,76},{58,72.6},{58,75},{58.2,72.4},{58.8,76.2},{59.4,74.4},{59.8,72.8},{60,75.2},{60.2,78.2},{60.4,77},{60.4,79.8},{60.4,80.8},{60.6,73},{60.8,76.8},{60.8,79.2},{61.4,74},{61.6,78},{61.8,75.4},{63,76.4},{63,76.6},{63,79.6},{64,75.6},{64,78.2},{64.4,75.2},{64.4,79.2},{64.6,76.6},{64.6,79.2},{64.6,79.6},{65.6,75.2},{65.8,78},{65.8,78.6},{66.8,76.6},{66.8,79.8},{66.8,82.2},{67.8,75.6},{68.2,75.2},{69,76.2},{69.4,72.4},{69.4,75.4},{69.6,72.2},{69.6,73},{69.6,75.4},{69.6,75.8},{70.4,83},{70.6,73.4},{70.6,75.6},{70.6,82.4},{71,73.6},{71,82.6},{71.4,75.4},{71.6,75},{71.8,84.4},{72.2,79},{72.4,76.4},{72.4,76.8},{72.6,74.8},{72.6,76.4},{72.6,79.6},{72.8,76.8},{72.8,79.2},{72.8,82.4},{73.4,78.4},{73.4,80.6},{73.4,83.4},{73.6,77.4},{73.6,78.2},{73.8,78.6},{74,83.8},{74.2,82},{74.4,80},{74.6,79.8} } },
  {["zone_name"] = "Darkshore", [ "zoneID" ] = 62, [ "name" ] = "Encrusted Tide Crawler",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Darkshore.", ["class" ] = CLASS_NORMAL, ["family"] = {  8  , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 979 ,["id"] = 2233  ,["coords"] = {{34,86},{34.4,82.4},{34.4,82.8},{34.6,82.4},{34.6,82.6},{35.2,80.6},{35.8,71.4},{35.8,71.6},{35.8,73},{35.8,84.6},{36,84.2},{36.2,83.2},{36.2,87.4},{36.4,80},{36.4,86},{36.6,71.6},{36.6,82.6},{36.6,86},{37,71.4},{37,73.6},{37.2,64.4},{37.2,64.6},{37.2,69},{37.2,69.6},{37.2,81.4},{37.2,82},{37.4,67},{37.4,73.4},{37.4,78.4},{37.4,80.4},{37.6,66},{37.6,68.4},{37.8,69},{38,78.4},{38,79.2},{38,80.6},{38.2,65.2},{38.2,79.6},{38.4,74.2},{38.4,76.4},{38.4,76.6},{38.6,76},{38.6,76.6},{38.6,77.8},{38.6,79.2},{39.2,74.2} } },
  {["zone_name"] = "Mulgore", [ "zoneID" ] = 7, [ "name" ] = "Swoop",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Mulgore. Swoop & Wiry Swoop switched levels.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 1229 ,["id"] = 2970  ,["coords"] = {{36,49.4},{36,77.8},{36.4,52},{36.4,55.2},{36.6,51.8},{36.8,49.4},{36.8,49.8},{37,48.2},{37,51.4},{37,53},{37,57},{37.2,56.2},{37.4,54.6},{37.4,68.6},{37.6,56.6},{37.6,59.4},{37.6,63.4},{37.8,56},{37.8,59.6},{37.8,69.2},{38,61.4},{38.2,55.4},{38.2,57.6},{39,68.2},{39.4,51.4},{39.4,51.6},{39.4,55.4},{39.6,51.4},{39.6,51.6},{39.6,55.2},{39.8,48},{39.8,55.6},{40,49.6},{40.2,47.2},{40.4,53.4},{40.4,53.6},{40.6,51},{40.6,53.2},{40.6,53.6},{40.8,47.4},{40.8,56.2},{40.8,59},{40.8,61.2},{42,57.8},{42.4,66.4},{42.6,66.4},{42.8,50.4},{42.8,51},{43.2,52.4},{43.2,64.8},{43.4,52.6},{43.6,52},{43.6,54.6},{43.8,54.2},{44.6,53.2},{44.6,53.6},{49.8,68.6},{50,68},{50.4,67.2},{50.8,67.4},{50.8,67.6},{51.4,64},{51.4,64.6},{51.4,66.4},{51.6,64.4},{51.6,64.6},{51.6,66.4},{51.6,66.6},{51.6,68.4},{52.2,69},{53,62.4},{53,63},{53.2,67.4},{53.2,67.6},{53.4,61.2},{53.6,61.2},{53.8,61.8},{54.2,63.2},{54.4,67.4},{54.4,67.6},{54.6,63.4},{54.6,67.4},{54.6,67.6},{54.8,63.6},{55.2,68.8},{55.6,63.8},{56,63},{57.4,66.4},{57.8,65.6},{57.8,67},{57.8,68.2},{57.8,68.6},{58.4,64.2},{58.4,64.6},{58.6,64.2},{58.6,64.6},{58.8,68.4},{58.8,68.6},{59.6,64.4},{59.6,64.6},{60.6,68.6},{60.8,65.2},{60.8,68.4},{61.2,65.6},{61.4,67},{62,64.8},{62.4,66.4},{63.2,66.2},{63.4,66.8},{64.4,67.2},{65,66} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Coyote Packleader",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 161 ,["id"] = 833  ,["coords"] = {{31.8,38.8},{32.4,40},{40.2,18.4},{40.4,25},{40.6,17},{41,23},{41.2,27},{41.8,26.2},{42,27.4},{50.2,29.2},{51.4,34},{51.6,34.6},{53,37.6},{53.2,37},{53.4,28},{53.8,28.2},{54.2,29.4},{55.2,29.4},{55.2,29.8},{55.4,30.6},{55.6,25.8},{55.6,29.6},{55.8,31.2},{56.4,27},{56.4,27.8},{59,29.6},{61.4,19.2},{61.4,22.2},{62,22},{63.4,54.4},{68,68.4},{68.2,70.4} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Princess",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in The Stonefield Farm, Elwynn Forest. Princess roams the fields of the Stonefield Farm.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 22320 ,["id"] = 330  ,["coords"] = {{32.2,85.2},{32.4,84.4},{32.4,85.6},{32.4,86.6},{32.6,86.6},{32.8,84.4},{33,85},{33.4,85.8},{33.6,85.4},{33.6,85.6} } },
  {["zone_name"] = "Darkshore", [ "zoneID" ] = 62, [ "name" ] = "Foreststrider Fledgling",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Darkshore. Follows the Strider Clutchmother.", ["class" ] = CLASS_NORMAL, ["family"] = {  12  , "Tallstrider"          } , ["familySkills" ] = TALLSTRIDER_SKILLS          ,["displayID"] = 1042 ,["id"] = 2321  ,["coords"] = {{40.8,48.4},{40.8,48.6} } },
  {["zone_name"] = "Swamp of Sorrows", [ "zoneID" ] = 51, [ "name" ] = "Monstrous Crawler",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Swamp of Sorrows.", ["class" ] = CLASS_NORMAL, ["family"] = {  8  , "Crab"} , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 699 ,["id"] = 1088  ,["coords"] = {{72.2,8.6},{72.6,6.4},{73.2,6.8},{73.2,8.2},{73.2,9.4},{76.6,9.4},{78,11.8},{78.4,10.6},{78.4,90.8},{78.6,10.4},{78.6,11.2},{78.6,11.8},{79,90.4},{79.2,90.6},{80.2,86},{80.2,86.6},{80.6,86.4},{81.2,85.4},{81.4,86.6},{81.6,84},{81.6,85.4},{81.6,88.2},{82.4,14.6},{82.6,15},{82.8,14},{82.8,80.2},{83,84.6},{83.2,15.8},{83.6,15.8},{83.8,82.4},{83.8,84},{84,85},{84.6,79},{85,79.6},{85.2,80.6},{85.4,76.8},{85.6,77.6},{86,11.2},{86.2,76.8},{90.2,62.4},{90.4,37.2},{90.6,39.2},{90.6,62},{90.8,38.2},{91.2,35},{91.4,42.6},{98,49.6}}},
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Gray Forest Wolf",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 380 ,["id"] = 1922  ,["coords"] = {{59.8,65.4},{59.8,65.6},{60.2,60},{60.4,63.6},{60.6,63.8},{61,63.4},{61.6,70.2},{62,61.4},{62,62.6},{65.2,63.8},{66,64.2},{66.2,58.4},{66.2,58.6},{66.4,63},{66.6,64},{67.4,62.4},{69.2,63},{70.4,61.4},{70.4,61.6},{70.6,61.4},{70.6,61.6},{71.6,60.4},{71.6,60.6},{73,62.4},{73.2,63.2},{73.2,67.4},{73.4,63.6},{73.6,68.2},{73.8,63.8},{74.2,66.6},{74.2,69.2},{74.4,63},{74.4,65.2},{74.4,65.6},{74.6,65.4},{74.6,65.6} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Stranglethorn Tigress",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 614 ,["id"] = 772  ,["coords"] = {{37,30.6},{38,31.8},{38.2,31.4},{39.4,29.4},{39.4,29.6},{39.4,31.4},{39.6,29.2},{39.6,31.6},{40.2,28.2},{40.2,30.6},{40.4,27.4},{40.4,30.2},{41.2,29.4},{41.2,30.2},{41.4,26.4},{41.4,26.6},{41.4,28},{41.8,19},{41.8,25.6},{41.8,28},{42,25.4},{42,27.4},{42,30.4},{42.2,30.6},{42.6,31.4},{43,19.2},{43,21},{43,24},{43,24.8},{43.2,19.6},{43.2,21.6},{43.4,23},{43.6,23},{43.8,20.6},{43.8,22.4},{44,20.4},{44.4,19.4},{44.6,19.2},{45.4,19.8},{45.4,20.6},{45.6,19.8},{46,19},{46.4,16.4},{46.4,16.6},{46.6,16.6},{47,19},{47.2,17.8},{47.8,14.2},{47.8,18.8},{48,14.6},{48,16},{48.2,16.8},{48.4,13},{48.6,9.6},{48.6,14},{48.8,15.2},{49.2,11.4},{50,14.2},{50,15.6},{50.2,12.4},{51.4,11.8},{51.4,12.6},{51.6,12.4},{52,10.6},{52.2,10.2} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Webwood Silkspinner",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 759 ,["id"] = 2000  ,["coords"] = {{36,28.4},{36.4,28.6},{36.8,28.6},{38.4,28.8},{38.8,29.4},{42.6,35.2},{42.8,33.4},{43.8,40.8},{44.4,37.6},{45,39.4},{45,39.8},{45,41.4},{47,37.6} } },
  {["zone_name"] = "Swamp of Sorrows", [ "zoneID" ] = 51, [ "name" ] = "Silt Crawler",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Swamp of Sorrows.", ["class" ] = CLASS_NORMAL, ["family"] = {  8  , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 342 ,["id"] = 922  ,["coords"] = {{74.8,4.8},{75,8.4},{75.4,5.6},{75.4,9},{75.4,9.6},{75.6,6.8},{75.8,1.4},{75.8,9.2},{75.8,9.6},{76,2.8},{76,4.4},{76,5.2},{76.2,2.4},{76.2,6.4},{76.2,7.8},{76.4,12.6},{76.6,2.4},{76.6,3.2},{76.6,8.8},{76.8,4.4},{76.8,5},{77,1.4},{77,5.6},{77.2,12},{77.4,7.4},{77.4,8},{77.4,11.4},{77.6,7.6},{77.6,11.8},{78,7.4},{78,8.6},{78.2,6.4},{78.4,3.2},{78.4,4.4},{78.4,4.6},{78.6,4.4},{78.6,4.6},{78.6,5.8},{78.6,7},{78.6,8},{78.8,3},{79.2,13.4},{79.4,14.2},{79.4,14.6},{79.6,4.4},{79.6,4.8},{79.6,5.6},{79.6,13.2},{79.6,14},{80,17.8},{80.4,2.8},{80.4,15.4},{80.4,15.6},{80.4,16.8},{80.6,6.6},{80.6,16},{80.6,19},{80.8,2.4},{80.8,15.4},{81,3},{81,3.6},{81,12.4},{81.2,13.4},{81.2,16.8},{81.4,13.8},{81.4,17.8},{81.6,2.8},{81.6,12.2},{81.6,13},{81.6,13.8},{81.6,17.2},{81.6,17.8},{81.6,19.2},{81.8,5.4},{82.4,6.4},{82.4,7.4},{82.4,8.2},{82.4,8.8},{82.4,14.8},{82.4,19.8},{82.6,7.6},{82.6,17.2},{82.6,18},{82.8,19.2},{82.8,19.8},{83.4,6.4},{83.4,7.2},{83.6,4.6},{83.8,6.4},{83.8,7},{83.8,7.6},{83.8,20},{84,19.4},{84.4,21},{84.6,21},{84.8,20},{85,6.6},{85.2,21.6},{85.8,14},{85.8,22.8},{86.4,14.6},{87,14.6},{87.4,27.2},{87.6,27.2},{87.8,23.4},{88,27.6},{88.2,28.6},{88.6,27.6},{88.8,27.4},{89.4,22},{90.8,7.4} } },
  {["zone_name"] = "Mulgore", [ "zoneID" ] = 7, [ "name" ] = "Prairie Wolf",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Mulgore.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 1100 ,["id"] = 2958  ,["coords"] = {{33.2,48.8},{34.2,49.4},{34.4,49.6},{34.4,65},{35,51},{35.2,54.8},{35.2,56.8},{35.4,49.4},{35.4,49.6},{35.4,52},{35.6,50.2},{35.8,56},{35.8,58.4},{36,49},{36,59.4},{36,59.6},{36,64.2},{36,65.2},{36,73.4},{36.2,50.8},{36.4,56.6},{36.8,64.6},{37.2,66.6},{38,53},{38.2,47.6},{38.2,49.6},{38.2,52.4},{38.2,60},{38.4,48.8},{38.4,50.6},{38.4,60.6},{38.6,50.4},{38.6,50.6},{38.6,53.6},{39,48},{39,49},{39,52.4},{39.2,61},{39.2,62.2},{39.4,47.4},{39.4,62.6},{39.6,47.4},{39.8,46.4},{40.2,48.8},{40.6,49.4},{41,49.8},{41.4,48},{41.4,52.4},{41.4,52.6},{41.6,52.4},{41.6,52.6},{42,48.6},{42,50},{42,55.2},{42,72},{42.2,53.6},{42.2,56.2},{42.8,55.6},{43.4,71.4},{44.4,66},{44.4,69.4},{44.4,69.8},{44.6,69.6},{45,65.4},{45,65.8},{45,68.8},{46.8,70},{47.4,68},{47.4,68.6},{47.8,68.6},{48.2,66.4},{48.2,66.6},{48.2,67.8},{49.2,67.6},{49.4,66.2},{49.4,66.6},{49.4,69.8},{49.6,66.8},{49.8,65},{49.8,69.8},{50.2,64.4},{50.4,66},{50.4,69},{50.6,64.4},{50.6,65.6},{50.8,65},{51,68.2},{51,69.4},{51,69.6},{51.2,61.8},{51.2,63},{52,60.8},{52,62},{52,63.4},{52,63.6},{52.4,57.4},{52.4,57.6},{52.6,57.4},{52.6,57.6},{52.6,60.8},{52.6,62.2},{53.4,58.6},{53.6,57.2},{53.6,58.4},{53.6,58.6},{54.4,61.6},{54.6,61.6},{54.8,61.4},{54.8,65},{54.8,66.6},{55.2,63.8},{55.4,66.4},{55.4,69},{55.6,65.2},{55.6,66.6},{55.8,69.2},{56,61.8},{56.2,61.4},{56.2,71},{56.4,63.4},{56.4,64.2},{56.4,66.4},{56.4,69.8},{56.6,64.2},{56.6,68},{56.6,70.2},{56.6,70.6},{56.8,71.6},{57,62.6},{57.2,68.8},{57.6,64},{57.8,62},{57.8,62.8},{58.2,69.4},{58.8,65.4},{58.8,67.8},{59,67},{59.4,66.4},{59.6,65.4},{59.6,66.2},{59.8,66.6},{60.2,69.2},{62.8,63.4},{63.2,64.8},{63.2,67},{63.4,67.6},{63.6,62.8},{63.6,64.8},{67.6,62.4} } },
  {["zone_name"] = "Arathi Highlands", [ "zoneID" ] = 14, [ "name" ] = "Highland Thrasher",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Arathi Highlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 180 ,["id"] = 2560  ,["coords"] = {{10.8,48.8},{11,49.6},{11.8,50.4},{12,49},{12.2,47.6},{12.2,50.6},{12.2,59.4},{12.4,56.6},{12.6,58.6},{13,51.8},{13.2,46.8},{13.2,57},{13.4,46},{13.4,49.8},{13.6,49.4},{13.8,49.6},{13.8,50.6},{14.2,45.8},{14.2,57.8},{14.4,52},{14.6,47.6},{14.6,48.8},{15,54.6},{15.2,52},{15.4,51},{15.6,57},{15.8,50},{16,49.4},{16,50.8},{16.8,50.6},{27.4,63.4},{27.4,63.8},{27.6,63},{27.8,69.4},{28,65.2},{28.2,62.4},{28.2,65.8},{28.4,63.6},{28.6,63.6},{28.6,68.8},{28.8,64.6},{29,67.4},{29,67.6},{29.8,68.2},{29.8,69.2},{29.8,69.6},{30,67},{30.4,65},{30.6,63.6},{30.6,68.8},{31,66},{31,67},{31,68},{31,69.6},{31,72.2},{31.2,65.2},{31.6,66},{31.6,70.8},{32,67.8},{32,70},{32.4,67.4},{32.4,69},{32.6,69.6},{33,66.6},{33,70.6},{33.2,65.4},{33.2,68.4},{33.2,72.4},{33.4,66.2},{33.4,69},{33.6,66},{33.6,68.4},{33.6,72.8},{33.8,70.8},{34,68.6},{34.2,67.2},{34.2,70.2},{34.4,72.2},{34.6,66.2},{34.6,67},{34.6,73},{34.8,67.8},{34.8,71.4},{35.2,72.2},{35.6,71},{35.8,67},{47.6,62.6},{48,59.8},{48.4,59.4},{48.4,62.2},{48.6,58.8},{48.6,59.8},{48.6,61.2},{48.6,62},{48.8,58.4},{50.2,70.2},{50.2,71},{50.6,68.4},{50.6,70.2},{50.6,71.2},{51.6,70},{53,68.8},{53.2,70},{53.8,69.2},{54.6,69.4},{56.2,67.6},{56.4,65.2},{57,66.2},{57.2,67.8},{57.4,67.2},{57.6,67.2},{58,69.4} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Nightsaber Stalker",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 14318 ,["id"] = 2043  ,["coords"] = {{40.4,48.8},{40.4,49.6},{40.4,50.6},{40.6,50.4},{40.6,50.8},{42.2,48.4},{42.2,48.8},{42.2,52.6},{42.4,50.2},{42.4,52.2},{42.6,50.4},{42.6,50.6},{42.6,52.2},{42.8,55.2},{42.8,56},{43,56.8},{43.8,58.6} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Thrashtail Basilisk",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  130  , "Basilisk"          } , ["familySkills" ] = BASILISK_SKILLS          ,["displayID"] = 45449 ,["id"] = 1550  ,["coords"] = {{57.4,28.2},{57.8,28.4},{58,29},{58.4,29.6},{58.6,29.4},{58.8,30},{59.6,21},{60,28.4},{60.2,30.4},{60.4,25.2},{60.4,28.6},{60.4,30.6},{60.4,32.4},{60.4,32.8},{60.6,25.2},{60.6,28.4},{60.6,28.8},{60.6,30.4},{60.6,30.6},{60.6,32.4},{60.6,33},{62.2,27.4},{62.2,30.4},{62.2,30.6},{62.4,28},{62.4,32.4},{62.4,32.6},{62.6,27.6},{62.6,32.6},{63,29.2},{63,31.6},{63.2,29.6},{63.2,31.4},{63.6,29.2},{63.8,30.4},{63.8,30.6} } },
  {["zone_name"] = "Loch Modan", [ "zoneID" ] = 48, [ "name" ] = "Forest Lurker",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Loch Modan.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 909 ,["id"] = 1195  ,["coords"] = {{25.4,17.4},{25.4,17.8},{25.6,17.4},{25.6,17.8},{25.6,38.2},{25.6,38.8},{25.8,37},{27,16.6},{27.2,15.4},{27.2,16.2},{27.4,13.2},{27.4,32.6},{27.4,34.4},{27.6,16.6},{27.8,11.2},{27.8,11.6},{27.8,15.6},{27.8,17.8},{27.8,32.4},{28,33.4},{28,33.6},{28,48.8},{28.6,49.6},{28.8,33},{28.8,33.8},{29,48.4},{29,49.4},{29.2,46},{29.2,50.8},{29.4,44.4},{29.4,44.6},{29.6,44.6},{29.8,44.4},{29.8,45.8},{29.8,46.8},{29.8,50.2},{30.2,43},{30.2,47.6},{30.2,51.4},{30.2,51.6},{30.2,53.4},{30.2,53.6},{30.2,54.6},{30.4,41.4},{30.4,42},{30.6,41.8},{30.6,47.4},{30.6,47.6},{30.6,51.6},{30.6,52.8},{30.6,53.8},{30.8,42.8},{30.8,51.4},{31,41.2},{31.2,29.4},{31.2,29.6},{31.4,37.2},{31.6,30.2},{31.8,29.2},{32,37},{32.2,30.8},{32.2,35},{32.2,36.2},{32.4,31.6},{32.6,31.6},{32.6,36.4},{32.6,37},{32.8,29.8},{32.8,31},{33,38},{33,54.6},{33.4,33},{33.4,34},{33.4,39.2},{33.4,54.4},{33.4,55.6},{33.6,30.4},{33.6,32},{33.6,33.4},{33.6,33.8},{33.6,54},{33.6,54.6},{33.8,31},{33.8,53.2},{34,57.6},{34.2,41.2},{34.4,39.4},{34.4,40.2},{34.6,41},{34.6,52},{34.8,39.4},{34.8,39.6},{35.2,32.2},{35.4,29.4},{35.4,30.2},{35.6,30.4},{35.6,30.8},{35.6,31.8},{36.2,52.4},{36.8,28.2},{37,52.6},{37.2,51.6},{37.4,51.4},{37.4,53.6},{37.6,11.4},{37.6,52.6},{37.8,52},{38,40.6},{38,51.4},{38.4,28.6},{38.4,39.2},{38.4,40},{38.6,40.4},{38.8,11.6},{38.8,28.4},{38.8,40.6},{39,26.6},{39,47},{39,50.2},{39.4,21.8},{39.4,23.2},{39.4,28.8},{39.4,47.6},{39.4,48.8},{39.4,53.4},{39.4,53.6},{39.6,27.6},{39.6,29.2},{39.6,53.4},{39.6,54.6},{39.8,54.2},{40,18.4},{40,34.2},{40,36.2},{40.2,22.4},{40.2,22.6},{40.2,35.2},{40.4,51},{40.4,51.8},{40.4,56.8},{40.6,22.6},{40.6,51.4},{40.6,58.6},{40.8,35},{40.8,56.4},{40.8,57},{41,52.2},{41,53},{41.2,57.6},{41.4,18.8},{42.4,55.2},{42.6,55.6},{42.8,56.6},{43,55.4},{43.2,61},{43.4,62.6},{43.8,54.6},{43.8,62.4},{43.8,62.6},{43.8,66.2},{44.2,66.6},{44.6,62.6},{45,66.4},{46.4,68.4},{47,68.2} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Strigid Hunter",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  26  , "Bird of Prey"          } , ["familySkills" ] = BIRD_OF_PREY_SKILLS          ,["displayID"] = 10830 ,["id"] = 1997  ,["coords"] = {{39.2,27.6},{39.4,25.4},{39.4,27.4},{39.6,24.8},{39.6,27.8},{40,33.2},{40,34.8},{40.2,34.4},{40.2,42.2},{40.4,28.6},{40.4,40.2},{40.8,28.2},{40.8,33.4},{40.8,40.4},{40.8,40.6},{40.8,41.8},{41,26.2},{41,27.4},{41.6,40},{41.8,28.4},{42,33},{42.4,39.4},{42.6,39.2},{43.2,26},{43.4,38.2},{45.4,34.8},{45.6,34.6},{46.8,28},{47.2,35.6},{47.4,34.8} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Southern Sand Crawler",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  8  , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 9573 ,["id"] = 2544  ,["coords"] = {{38.6,86.8},{39.8,84.2},{40.2,85.2},{40.6,84.8},{41.2,84.2},{41.6,84},{41.8,86.8},{42.2,87.8},{43.6,81.6},{43.6,90.2},{43.8,91},{44,81.2},{44.8,83},{45.2,81.2},{45.2,90.6},{45.4,80},{45.4,90.4},{45.6,82},{45.6,83},{46,90.2},{46.4,81.2},{46.6,81.4},{46.8,79.6},{48,78.8},{48.2,78.2},{48.8,81},{49,74.8},{49,75.6},{49,77.2},{49.2,77.6},{49.2,80.4},{49.2,81.6},{49.6,80.4},{49.6,81},{50,74.8},{50.4,71},{50.4,76},{50.6,70},{50.6,71.4},{51,72},{51.6,70},{51.6,70.6},{51.6,72.4},{51.8,87.6},{52,73.2},{52.4,68.2},{52.6,67.2},{52.6,68.4},{53.6,90.4},{54.4,65},{54.8,64.6},{55,62.6},{55.2,64},{55.4,62.4},{56.4,59.8},{56.6,58.6},{56.8,54.6},{56.8,58.2},{56.8,60},{57,54.4} } },
  {["zone_name"] = "Mulgore", [ "zoneID" ] = 7, [ "name" ] = "Adult Plainstrider",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Mulgore.", ["class" ] = CLASS_NORMAL, ["family"] = {  12  , "Tallstrider"          } , ["familySkills" ] = TALLSTRIDER_SKILLS          ,["displayID"] = 1220 ,["id"] = 2956  ,["coords"] = {{34.6,31.4},{35,49.4},{36,52.6},{36.6,34.2},{37.8,51.8},{39.2,54.2},{40,50.2},{40,52.8},{40.4,48},{41.2,69},{41.4,55.4},{42,50},{42,52},{42,68.2},{42.4,44.8},{42.6,52},{42.6,57},{42.8,55.4},{42.8,67},{43.4,53},{43.8,54.8},{44,52.4},{44.4,54.2},{44.6,53.8},{44.6,68.6},{44.8,54.8},{45.2,52.2},{45.2,53},{45.6,47.2},{45.6,68.6},{46.2,44.6},{46.2,48.8},{46.4,65.6},{46.6,50},{46.8,50.8},{47,42.6},{47,65.2},{47.4,63.4},{47.4,64},{47.4,67.4},{47.4,67.8},{47.6,67.8},{47.6,70},{47.8,69},{48.4,48},{48.4,67.2},{48.6,48.2},{48.6,66.6},{48.8,66.4},{50,45.6},{50.4,68.2},{50.4,68.6},{50.6,68},{51,64.4},{51,64.6},{51.6,68.4},{51.6,68.6},{51.8,57.4},{51.8,57.6},{52,61.2},{52.2,67.2},{52.6,61},{52.8,61.6},{52.8,63.2},{52.8,63.6},{53,58.2},{54,58.2},{54,61},{54,61.8},{54,63.2},{54.2,56},{54.2,63.6},{54.4,58.8},{54.4,69},{54.6,68},{55.4,63},{55.4,69.6},{55.6,51},{56.2,58.4},{56.8,61.8},{57.4,53.8},{57.4,69.8},{57.8,50.2},{58,49.2},{58.4,65.2},{58.6,65.2},{59.6,68.6},{59.8,64.2},{60.2,53.2},{62,68.6},{62.4,65},{63,62.8},{63.6,62.2},{63.8,66},{66.2,59.2} } },
  {["zone_name"] = "Loch Modan", [ "zoneID" ] = 48, [ "name" ] = "Loch Crocolisk",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Loch Modan.", ["class" ] = CLASS_NORMAL, ["family"] = {  6  , "Crocolisk"          } , ["familySkills" ] = CROCOLISK_SKILLS          ,["displayID"] = 1080 ,["id"] = 1693  ,["coords"] = {{47.2,64},{47.8,62.8},{48,59.8},{48.2,61.4},{48.2,61.8},{48.2,65},{48.4,64.4},{48.6,61.4},{48.6,61.6},{48.6,63.8},{48.8,64.6},{49,62.6},{49.6,61.6},{49.8,58.2},{49.8,63},{50.2,60.2},{50.2,60.6},{50.2,63.6},{50.2,65.4},{50.2,66},{50.2,66.6},{50.4,59.2},{50.6,59.4},{50.6,60},{50.6,65.8},{50.6,66.6},{51.2,61.2},{51.2,62.2},{51.2,63.4},{51.2,63.6},{51.2,65.4},{51.8,63.4},{51.8,63.6},{52.4,55.4},{52.4,55.8},{52.4,57.2},{52.4,60.4},{52.4,60.8},{52.4,65},{52.4,66.4},{52.4,66.6},{52.6,63.2},{52.6,63.6},{52.6,66.6},{52.8,55.4},{52.8,55.6},{52.8,60.8},{52.8,61.6},{52.8,66.4},{53,60.4},{53.2,65.2},{53.4,56.6},{53.4,58.4},{53.4,58.6},{53.6,58.6},{53.6,61.6},{53.8,56.6},{53.8,58.4},{53.8,60.2},{53.8,63},{53.8,63.6},{53.8,65.6},{54,61.4},{54.4,49.4},{54.4,49.6},{54.4,53.8},{54.4,55.4},{54.4,55.6},{54.6,49.8},{54.6,50.6},{54.6,55.4},{54.6,55.6},{54.6,62},{54.8,49.4},{54.8,60.4},{55,52.8},{55,53.6},{55,56.6},{55,58},{55,59.4},{55,60.6},{55.2,52.4},{55.6,60.6},{56,49.4},{56,49.6},{56,57.4},{56,57.8},{56,59.2},{56,59.6},{56.2,65.8},{56.6,49.2},{56.6,49.6},{57.2,55.8},{57.2,56.6},{57.4,54.2},{57.4,54.6},{57.6,50.4},{57.6,50.6},{57.6,54.4},{57.6,54.6},{58.2,57.4},{58.2,57.6},{58.4,48.4},{58.4,48.6},{58.6,48.2},{58.6,49},{58.6,57},{59.2,54},{59.2,55},{59.4,50.2},{59.4,51},{59.8,54.6},{60,50.4},{60,50.8},{60,53.4},{60,53.8},{60.6,50.2},{60.8,46.8},{61.2,46.4},{62.2,48.4},{62.2,48.6} } },
  {["zone_name"] = "Western Plaguelands", [ "zoneID" ] = 22, [ "name" ] = "Plague Lurker",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Western Plaguelands.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 1088 ,["id"] = 1824  ,["coords"] = {{42.4,53.4},{42.4,54.2},{42.8,56.4},{43.2,54.4},{43.4,54.8},{43.6,55},{44,56.4},{44,56.6},{44.4,59.2},{44.6,58.4},{44.8,59.4},{44.8,59.8},{46.2,59.4},{46.2,59.6},{48.2,58.8},{48.8,60.8},{49,58.4},{49,59},{49.4,59.6},{49.4,61.8},{49.6,59.4},{49.6,61.4},{49.6,61.8},{49.8,59.6},{50.2,58},{50.2,63.2},{50.2,63.6},{50.6,59.6},{50.6,63.2},{51.2,57.4},{51.2,57.6},{51.4,60.6},{51.6,61.6},{51.8,60.8},{52.2,60.4},{52.4,58.4},{52.4,58.6},{52.6,58.4},{52.6,58.6},{52.8,61},{52.8,61.6},{53.4,59.8},{53.8,60.2},{54,61.2},{54.2,61.6},{54.4,62.6},{54.8,62.2},{55,62.6},{55.4,60.2},{55.8,63.4},{55.8,63.6},{56,58.2},{56,58.6},{56,60.6},{56.4,57.4},{56.4,60.2},{56.4,61.6},{56.6,57.4},{56.6,57.6},{56.6,58.6},{56.8,59.8},{57,61.4},{57,61.6},{57,63.4},{57.2,64.8},{57.4,64.4},{57.6,61.6},{57.6,64.4},{57.6,64.6},{58,60.6},{58.2,60.4},{58.4,58.2},{58.4,59},{58.4,62.8},{58.6,57.4},{58.6,57.8},{58.6,60.6},{58.6,62.6},{58.8,61.6},{59.2,59.4},{59.4,60},{59.6,59.4},{59.6,59.6},{59.8,61.2} } },
  {["zone_name"] = "Western Plaguelands", [ "zoneID" ] = 22, [ "name" ] = "Diseased Black Bear",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Western Plaguelands.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 1082 ,["id"] = 1815  ,["coords"] = {{29.8,65.4},{29.8,65.6},{30,61},{30.6,60.4},{30.8,60.8},{31.4,55},{31.6,62.4},{31.6,63},{31.8,54.4},{31.8,54.6},{31.8,55.6},{31.8,61.4},{32.2,64},{32.6,55.6},{32.8,64.2},{33,66.8},{33.2,57.4},{33.2,57.8},{33.2,62.6},{33.4,65},{33.6,57.8},{33.6,65.4},{33.6,65.6},{33.6,67.2},{33.8,52.6},{34,52.4},{34,54.2},{34,56.4},{34,56.6},{34.4,63.4},{34.4,63.6},{34.6,63.4},{34.6,64.4},{34.6,64.6},{34.6,66},{34.8,66.8},{35.4,67.8},{35.6,68.2},{36.2,63.4},{36.2,64},{36.6,66.4},{36.8,65.4} } },
  {["zone_name"] = "Arathi Highlands", [ "zoneID" ] = 14, [ "name" ] = "Mesa Buzzard",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Arathi Highlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 1105 ,["id"] = 2579  ,["coords"] = {{25.2,56.6},{26.4,61.2},{28.2,64.8},{30,67.6},{30.4,36.2},{31,64},{32.4,70.2},{32.6,31},{32.6,69.6},{33.2,30},{36.4,31.6},{36.6,31.4},{36.6,32},{36.6,32.6},{43.2,68.8},{43.4,66},{43.6,66.8},{43.6,69.4},{43.8,71.2},{44.2,65.8},{44.2,72.4},{44.4,73.8},{44.8,71.6},{45.6,67.2},{46.2,69.8},{48.2,67},{48.2,67.6},{48.4,66.2},{48.6,66.2},{49.2,67},{49.6,68.8},{50,62.6},{50.8,64},{53,64},{53,65},{55.4,73.2},{57.4,69.6},{57.6,69.4} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "King Mukla",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Jaguero Isle, The Cape of Stranglethorn. Found on the south-east side of the isle. Watch out for his interrupting Barrel Bash.", ["class" ] = CLASS_NORMAL, ["family"] = {  9  , "Gorilla"          } , ["familySkills" ] = GORILLA_SKILLS          ,["displayID"] = 792 ,["id"] = 1559  ,["coords"] = {{62.4,82.2},{62.4,83},{62.4,83.6},{62.6,82.2},{63,83.4},{63,83.6},{63.6,82.8},{63.6,83.8} } },
  {["zone_name"] = "Arathi Highlands", [ "zoneID" ] = 14, [ "name" ] = "Elder Mesa Buzzard",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Arathi Highlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 388 ,["id"] = 2580  ,["coords"] = {{9.6,70.2},{14.6,76},{16.8,72},{19.8,70.4},{25,70.8},{41,79},{41.8,83},{42,84.2},{42,84.8} } },
  {["zone_name"] = "Hillsbrad Foothills", [ "zoneID" ] = 25, [ "name" ] = "Foothill Stalker",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Hillsbrad Foothills; Old Hillsbrad Foothills (Dungeon).", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 2031 ,["id"] = 2385  ,["coords"] = {{41,55.4},{42.4,56.8},{43,57.6},{43.4,57.4},{43.6,58.2},{44.4,58.6},{45.2,58.8},{45.4,57.8},{45.8,58.6},{46,58.4},{47.2,55.4},{47.2,57.4},{47.8,54.2},{47.8,54.6},{47.8,56.8},{48,56.2},{49.2,54.2},{49.2,54.6},{49.4,55.8},{49.4,56.6},{49.6,55.4},{50.2,55.8},{50.4,53.4},{50.4,54.4},{50.6,53.4},{50.8,54},{51,54.6} } },
  {["zone_name"] = "Darkshore", [ "zoneID" ] = 62, [ "name" ] = "Moonstalker Sire",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Darkshore.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 11450 ,["id"] = 2237  ,["coords"] = {{38.2,93.8},{38.4,91.2},{38.4,92.8},{38.6,91.2},{39.2,65.2},{39.2,89.8},{39.4,94},{39.6,70.2},{39.6,94},{39.8,88.4},{39.8,88.6},{40,91.2},{40.4,66.2},{40.4,89.6},{40.6,93.2},{40.8,66.8},{41,69.4},{41.2,88.2},{41.4,65.8},{41.4,70.4},{41.4,70.6},{41.4,86.4},{41.4,89.2},{41.6,70.4},{41.6,70.6},{41.6,86.6},{41.8,63.4},{41.8,63.6},{41.8,65},{41.8,65.6},{41.8,69},{41.8,86.4},{41.8,92},{42.4,61.6},{42.6,61.6},{42.6,63.2},{43,90.6},{43.2,64.4},{43.2,64.6},{43.2,90.4},{43.8,62.4},{43.8,62.6},{44.4,61},{44.6,61.2},{44.6,62.4},{45,88.8},{45.2,88.4},{45.8,88.8},{45.8,90.4},{46,90.6},{46.4,91.6},{46.6,90},{46.6,91.6},{46.8,91} } },
  {["zone_name"] = "The Hinterlands", [ "zoneID" ] = 26, [ "name" ] = "Mangy Silvermane",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Hinterlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11413 ,["id"] = 2923  ,["coords"] = {{14.4,54},{14.6,54.2},{14.6,54.8},{15.4,51},{15.6,54},{15.8,51},{15.8,51.6},{16.4,49.4},{16.4,49.8},{16.4,55},{16.6,50},{16.6,55},{17.2,51.6},{17.4,48.4},{17.4,48.6},{17.4,51.4},{17.4,53.4},{17.4,53.8},{17.4,56},{17.6,48.4},{17.6,48.6},{17.6,51.4},{17.6,53.6},{17.6,56.2},{18.2,55},{18.4,47.4},{18.4,49.8},{18.6,47.4},{18.6,50.2},{19,51.2},{19.2,48.4},{19.2,49},{19.4,51.6},{19.6,48.8},{19.8,49.8},{20,52.2},{20.4,50.8},{20.4,55},{20.6,55},{20.8,51},{21.4,47.6},{21.8,47.4},{21.8,47.8},{21.8,52.4},{21.8,55.8},{22.4,51.2},{22.6,51.2} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Young Panther",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 2437 ,["id"] = 683  ,["coords"] = {{44.4,29.2},{44.4,29.6},{44.6,29.4},{44.6,29.6},{46,18},{46,27.4},{46.2,27.6},{46.8,28.4},{46.8,28.6},{47.2,25.8},{47.8,25.4},{47.8,26.2},{48.4,27},{48.4,29.2},{48.6,26.4},{48.6,27},{48.6,29.2},{48.6,29.6},{49.2,27.8},{49.4,15.4},{49.4,16},{49.4,16.6},{49.4,18},{49.6,15.4},{49.6,16.4},{49.6,16.6},{49.6,18},{51,18.4},{51,18.6},{51.2,23},{51.2,23.6},{51.6,21.8},{52.4,18.4},{52.4,18.6},{52.4,20.4},{52.4,20.6},{52.4,25.8},{52.6,18.4},{52.6,18.6},{52.6,20.4},{52.6,20.6},{52.8,22.8},{52.8,25.4},{53.2,24.4},{53.4,21.6},{53.4,26.2},{53.4,26.6},{53.6,22},{53.6,24.4},{53.6,26.6},{54,22.8},{54.2,25.4},{54.2,25.6},{54.4,20},{54.4,20.6},{54.6,20.4},{54.6,20.6},{54.6,22.6},{54.8,26.4},{54.8,26.6},{55,21.8},{55,24.4},{55,24.6} } },
  {["zone_name"] = "Dun Morogh", [ "zoneID" ] = 27, [ "name" ] = "Mangeclaw",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Dun Morogh.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 913 ,["id"] = 1961  ,["coords"] = {{87.4,49.4},{87.4,49.6},{87.6,50} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Jaguero Stalker",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 613 ,["id"] = 2522  ,["coords"] = {{56.2,84.8},{56.4,77.2},{56.4,77.6},{56.4,79.4},{56.4,79.6},{56.4,82.2},{56.4,82.6},{56.4,84.2},{56.6,77.2},{56.6,79.6},{56.6,82.8},{56.6,87.2},{57.2,78.4},{57.4,75.4},{57.4,76.2},{57.4,78.6},{57.4,81.2},{57.4,81.6},{57.4,83.6},{57.6,81.2},{57.6,81.6},{58,83.2},{58,84.4},{58,84.6},{58.2,75.4},{58.2,77.4},{58.2,78.6},{58.2,80.2},{58.4,75.8},{58.4,78.2},{58.4,86.4},{58.4,86.8},{58.6,75.4},{58.6,75.8},{58.6,80.6},{58.6,82.4},{58.6,83.8},{58.6,87},{58.8,79.8},{58.8,83.4},{59.4,77.4},{59.4,78.2},{59.4,79.2},{59.6,74.6},{59.6,77.4},{59.6,77.6},{59.6,82.8},{59.8,74.4} } },
  {["zone_name"] = "Redridge Mountains", [ "zoneID" ] = 49, [ "name" ] = "Dire Condor",["maxlevel" ] =30, [ "minlevel" ] =7, ["info" ] ="Located in Redridge Mountains. Used to be a Red Vulture.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 23482 ,["id"] = 428  ,["coords"] = {{11.8,67.2},{13.2,64.2},{13.4,62},{13.8,62},{14.4,65.6},{16,71.4},{16.4,57.8},{16.6,62},{16.8,60.6},{16.8,63.8},{17,55.8},{17,57.8},{17.2,63.2},{18.8,65.6},{19,63.6},{19.2,63.4},{19.8,65},{19.8,66.2},{20.2,63.4},{20.2,64.4},{20.2,66.6},{20.8,65.4},{22,67},{22.8,59.8} } },
  {["zone_name"] = "The Hinterlands", [ "zoneID" ] = 26, [ "name" ] = "Razorbeak Gryphon",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Hinterlands. Friendly to Alliance.", ["class" ] = CLASS_NORMAL, ["family"] = {  160  , "Feathermane"          } , ["familySkills" ] = FEATHERMANE_SKILLS          ,["displayID"] = 935 ,["id"] = 2658  ,["coords"] = {{26.2,59.4},{26.2,59.6},{26.4,57.2},{26.4,57.6},{26.4,60.6},{26.6,60.6},{27,56.8},{27.4,61.8},{27.8,62.6},{30.2,64.6},{35,54.2},{36.6,53},{38.6,47.4},{39.2,45.4},{39.4,45.6},{40.4,62.6},{40.6,48.8},{41.2,63},{41.4,47.6},{42.6,46.2},{43.2,53.6},{44.8,50.8},{45.4,51.8},{45.6,51.6},{46.8,48.8},{46.8,58.8},{48,59},{48.8,57.6},{51.2,55.6} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "River Crocolisk",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  6  , "Crocolisk"          } , ["familySkills" ] = CROCOLISK_SKILLS          ,["displayID"] = 1039 ,["id"] = 1150  ,["coords"] = {{38.2,18.2},{38.4,17.4},{39,19.4},{39,19.6},{41.2,19.4},{41.2,19.6},{41.4,20.8},{41.6,20.6},{42,18.6},{42.2,18.2},{42.4,21.8},{42.6,21.8},{43.4,19.4},{43.4,19.6},{43.6,19.6},{43.8,18.4},{43.8,18.6},{43.8,20.6},{45.4,20.8},{45.4,21.8},{45.8,21.6},{46.2,20.4},{46.2,20.6},{48.4,23},{48.6,23},{50.4,23.4},{50.4,23.8},{50.4,28.2},{50.6,23.4},{50.6,27.8},{51,27},{51.2,25},{51.2,26.4},{51.4,24.4},{52,27.2} } },
  {["zone_name"] = "Hillsbrad Foothills", [ "zoneID" ] = 25, [ "name" ] = "Domesticated Creeper",["maxlevel" ] =30, [ "minlevel" ] =7, ["info" ] ="Located in Hillsbrad Foothills.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 520 ,["id"] = 2349  ,["coords"] = {{28.4,68},{29.4,68.4},{29.4,68.6},{29.6,68.4},{29.6,68.6},{30.6,68.6},{31.2,70.8},{31.4,70.2},{31.6,70.4},{31.6,70.6},{32,67},{32,68.4},{32.2,68.6},{32.8,66.8},{32.8,68.8},{33.4,68.4},{33.6,67.4},{34.8,67},{34.8,69.4},{35.2,67.8},{35.2,76.4},{35.2,76.6},{35.6,70},{36,69.4},{36.2,70.8} } },
  {["zone_name"] = "Mulgore", [ "zoneID" ] = 7, [ "name" ] = "Young Battleboar",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Mulgore.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 8869 ,["id"] = 2966  ,["coords"] = {{41,57.4},{42.2,55.2},{42.2,56.4},{42.2,57.8},{42.6,58.6},{43.2,54.2},{43.2,55.4},{44.4,56.4},{45.8,48.4},{46.2,45.8},{46.2,47},{46.6,46.4},{46.8,47},{47,45.2},{47.2,48.6},{47.2,51.2},{47.4,49.8},{47.8,44.8},{47.8,46.6},{48.4,46},{48.6,46.6},{48.6,52.8},{49.2,48.8},{49.2,52},{50,51.2},{50.2,48},{50.2,48.6},{50.4,37},{50.4,41.4},{50.6,41.4},{50.8,36.6},{50.8,46},{51.2,39.6},{51.2,41.8},{51.4,23.8},{51.4,32},{51.6,28.4},{52.4,23.4},{52.6,43.8},{52.8,24.6},{53.2,35.2},{53.2,41.4},{53.4,34.2},{53.6,47.6},{55,27.8},{55,28.8},{55.4,40.4},{56.2,33.8},{56.2,46},{57,46.8},{57.8,32.8},{57.8,45.2},{58,34.6},{60.2,42},{62.4,49.4} } },
  {["zone_name"] = "Arathi Highlands", [ "zoneID" ] = 14, [ "name" ] = "Giant Plains Creeper",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Arathi Highlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 1104 ,["id"] = 2565  ,["coords"] = {{29.8,25.6},{30.4,27.2},{30.8,27},{31,25},{31.2,26.2},{31.8,24.2},{31.8,27.4},{32.2,28.6},{32.2,30},{33.2,28.6},{33.4,26.4},{33.4,30},{34.2,29.6},{34.4,28},{34.4,29.2},{34.6,29.6},{34.8,28.8},{39.8,76.8},{40.2,76},{40.4,37.4},{40.6,37.4},{40.8,81.6},{42,79.6},{42.2,79.4},{42.6,79.4},{46.2,62},{46.2,62.8},{46.8,63},{46.8,66.4},{46.8,67},{47,58},{47.4,68},{47.4,70.8},{47.6,60.2},{47.6,68.6},{47.8,58.6},{47.8,67.6},{48.2,56.4},{48.2,57},{48.2,57.6},{48.2,67},{48.4,55.2},{48.6,67.6},{48.8,57.6},{48.8,59.2},{48.8,61},{49,59.8},{49.4,57.2},{49.8,60},{49.8,61},{50,57.6},{50.2,59.4},{50.2,62.4},{50.4,55.6},{50.4,57},{50.6,55.4},{50.6,59.6},{50.6,68.4},{51,57.8},{51,59.2},{51,61.4},{51,63.4},{51,64.8},{51,69.2},{51.2,70.2},{51.4,71.4},{51.4,71.6},{51.6,70},{52.2,70.8},{52.4,67.6},{52.4,68.8},{52.4,71.6},{52.6,71.4},{52.8,66.6},{53,66.4},{53.2,65},{53.6,67.6},{53.6,70.4},{54,66},{54,71.2},{54.2,67},{54.6,68.4},{54.8,66},{54.8,69.6},{55.2,66.8},{55.8,67},{55.8,67.6},{56,69.4},{56,70.4},{56.2,71.4},{56.2,71.6},{57.2,71},{57.6,69.8} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Kurzen War Panther",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 599 ,["id"] = 977  ,["coords"] = {{59.2,21.4},{59.2,21.6},{59.4,20.4},{59.6,20.2},{59.6,21} } },
  {["zone_name"] = "Arathi Highlands", [ "zoneID" ] = 14, [ "name" ] = "Highland Fleshstalker",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Arathi Highlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 961 ,["id"] = 2561  ,["coords"] = {{39.8,82},{40.2,79.8},{40.2,82.6},{40.4,78},{40.4,79},{40.6,79.2},{40.8,80.4},{40.8,80.6},{41,76.6},{41,77.8},{41,83.2},{41,83.6},{41.2,74.6},{41.4,76.4},{41.4,82.2},{41.6,82},{41.8,75.2},{41.8,76.6},{41.8,84.4},{41.8,84.6},{42,76.2},{42,77.6},{42.4,82.8},{42.8,83.2},{42.8,83.6},{43,76.6},{43.4,70.4},{43.4,71.2},{43.8,71},{44,72.8},{44.2,72.2},{44.4,70.4},{44.6,72.2},{44.6,72.6},{44.8,69.4},{45.4,70.4},{45.4,70.8},{45.6,70.4},{45.6,72},{45.8,70.6},{46.2,66.4},{46.4,69.2},{46.6,69.4},{46.6,69.6},{46.8,67.8},{47.4,66.6},{47.4,70.6},{47.6,70.4},{47.6,70.6},{47.8,68.2},{48.2,65.2},{48.2,69.2},{48.4,66.2},{48.4,67.4},{48.6,69},{48.6,69.6},{48.8,66.4},{48.8,66.8},{49.2,67.6},{49.6,67.4},{49.6,67.8} } },
  {["zone_name"] = "The Hinterlands", [ "zoneID" ] = 26, [ "name" ] = "Saltwater Snapjaw",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Hinterlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  21  , "Turtle"          } , ["familySkills" ] = TURTLE_SKILLS          ,["displayID"] = 5027 ,["id"] = 2505  ,["coords"] = {{74.8,68.4},{74.8,68.6},{75.4,67},{75.4,70},{75.6,66.6},{75.6,69.4},{75.6,69.8},{75.6,71.8},{76.2,65.8},{76.2,71},{76.2,84},{76.4,65.4},{76.4,68.2},{76.4,73.4},{76.4,73.6},{76.4,83.4},{76.6,65.4},{76.6,65.6},{76.6,68.2},{76.6,70.6},{76.6,73.4},{76.6,73.6},{76.6,83.4},{76.6,83.6},{77.2,61.4},{77.2,61.8},{77.2,69.4},{77.2,69.8},{77.4,64.4},{77.4,66.8},{77.6,62.2},{77.6,66.8},{78,60.6},{78,62.8},{78,63.8},{78,65.2},{78,65.6},{78,70.4},{78,70.6},{78.2,60.2},{78.2,68.4},{78.2,68.6},{78.6,69.2},{78.6,69.6},{79,59},{79.2,61.4},{79.2,61.6},{79.4,58.4},{79.4,60.4},{79.6,58},{79.6,60.4},{79.6,60.6},{79.6,73.8},{80,57.4},{80,72.6},{80.2,75.8},{80.4,62.2},{80.4,70.8},{80.6,61.4},{81.2,58.8},{81.2,70.2},{81.4,44.4},{81.4,44.8},{81.4,50.4},{81.4,52.4},{81.4,53},{81.4,55.4},{81.4,55.6},{81.6,44.4},{81.6,44.6},{81.6,53},{81.6,55.2},{81.6,55.6},{81.8,49.4},{81.8,50.4},{82.2,51.4},{82.2,51.6},{82.2,54.2},{82.6,59},{83,49.8},{83,52.6},{83.2,52.4},{83.4,42} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Jungle Stalker",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 11317 ,["id"] = 687  ,["coords"] = {{51.2,52.4},{51.2,52.6},{51.8,46.6},{51.8,51},{51.8,51.6},{52,46},{52,49},{52.4,45.4},{52.4,49.8},{52.8,45.2},{52.8,49.8},{53.4,44},{53.4,45.8},{53.4,48.4},{53.4,49},{53.4,53.6},{53.4,56.4},{53.6,46},{53.6,48.4},{53.6,48.6},{53.6,55.8},{54,50},{54,55},{54.2,45.2},{54.2,47.2},{54.2,53.2},{54.2,53.8},{54.8,53.8},{55,53.4},{55.2,46.4},{55.2,46.6},{55.2,48.4},{55.4,49},{55.6,49.4},{55.8,49.8},{56.4,46.4},{56.4,46.6},{56.6,46.4},{56.6,46.6},{56.8,56},{57.4,50.2},{57.4,64},{57.6,50.2},{57.6,62},{57.6,64.2},{57.8,47.2},{58.2,51},{58.2,61.2},{58.4,48.6},{59,60},{59.2,59.4},{59.2,62.4},{59.8,51},{59.8,59},{59.8,63.4},{60.2,57},{60.6,57.2},{60.6,59.4},{60.6,62.2},{61.2,61.2},{62.2,64.4},{63.2,58.6},{64.6,63.4} } },
  {["zone_name"] = "Loch Modan", [ "zoneID" ] = 48, [ "name" ] = "Black Bear",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Loch Modan.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 707 ,["id"] = 1186  ,["coords"] = {{24.4,14.8},{24.6,14.8},{24.8,13.2},{25,14.4},{26,15.4},{27.4,14.4},{27.4,14.6},{27.6,14.6},{27.6,50.2},{27.8,14},{27.8,20.4},{27.8,20.6},{28,45},{28,51.6},{28.2,46.2},{28.4,21.8},{28.4,31.4},{28.4,32},{28.4,33},{28.4,50.8},{28.6,32},{28.8,46.8},{28.8,50.4},{28.8,51},{28.8,51.8},{29,34.6},{29.2,22.2},{29.2,22.6},{29.2,31.2},{29.2,34.2},{29.2,46},{29.4,24.4},{29.6,25.2},{29.6,51},{29.8,25.6},{30,27.4},{30,28},{30.2,20.4},{30.2,55.4},{30.2,55.8},{30.2,56.8},{30.4,20.6},{30.6,20},{30.6,56.6},{31.2,24.4},{31.2,28.4},{31.4,34.6},{31.6,20.4},{31.8,35.6},{32,32.8},{32,34.2},{32,34.8},{32.2,28.2},{32.2,28.6},{32.4,30.2},{32.6,28.4},{32.6,29.2},{33.2,34.8},{33.4,36},{33.8,35.2},{34,36.6},{34.2,36},{34.2,37.6},{34.4,29},{34.4,30},{34.4,33.4},{34.4,33.6},{34.6,36.6},{34.8,28.2},{34.8,33.2},{35,28.6},{35,32.4},{35,33.6},{35,35},{35.2,29.8},{35.6,32.6},{35.8,30.4},{36,37.6},{36.2,38.6},{36.4,29},{36.4,37},{36.4,40.4},{36.6,29.6},{36.6,35.4},{36.6,40.6},{36.8,36.6},{37,29},{37,30.8},{37,36.4},{37,37.8},{37,39.6},{37.4,33.2},{37.4,33.8},{37.4,39},{37.4,55.8},{37.6,11.4},{37.6,33.4},{37.6,33.6},{37.6,36.2},{37.6,56},{37.8,29},{37.8,38.4},{37.8,38.6},{37.8,40},{37.8,55.2},{38.2,31.4},{38.2,31.6},{38.4,50.2},{38.8,32.2},{39,25.4},{39,31.2},{39,50.4},{39,51.6},{39.2,49.4},{39.2,51.2},{39.4,33.2},{39.4,33.6},{39.6,15.6},{39.6,32},{39.6,33},{39.6,51.8},{39.6,55.8},{39.8,25.6},{39.8,29.8},{39.8,33.6},{39.8,50.8},{40,22.4},{40,25},{40,27.6},{40,31},{40,50},{40.2,27},{40.2,49.2},{40.6,10.4},{40.8,57},{41,16.8},{41.2,53.4},{41.4,54},{41.4,54.6},{41.6,48},{41.6,54.4},{41.6,58.4},{41.8,54.6},{41.8,61},{42,66},{42.2,64},{42.2,65},{42.4,59.4},{42.4,60.2},{42.6,59.4},{42.6,60},{43,60.6},{44.8,68.2},{45.2,68.6},{45.8,64.8},{46.4,65.6},{46.6,64.4},{46.6,65.2},{47.2,65.6} } },
  {["zone_name"] = "Silverpine Forest", [ "zoneID" ] = 21, [ "name" ] = "Giant Rabid Bear",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Silverpine Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 1082 ,["id"] = 1797  ,["coords"] = {{34.8,14.4},{35.2,14.8},{36,8.8},{36.2,17},{36.8,18.2},{37,25.8},{38,14.8},{38.6,21.2},{39.2,23.4},{39.2,23.6},{40,23.6},{40.4,23.2},{40.6,23.4},{40.8,16.8},{40.8,19},{41,26},{41.2,25.4},{41.4,18.2},{41.6,22},{41.6,30.4},{42.2,28.8},{42.4,17.6},{42.4,19},{42.4,19.8},{42.4,23},{42.8,17.2},{42.8,23.2},{43,19.8},{43.2,22.4},{43.8,17},{45.8,27},{46,17.6},{46.4,19},{46.4,45.4},{46.4,45.6},{46.6,23},{46.6,45.8} } },
  {["zone_name"] = "Swamp of Sorrows", [ "zoneID" ] = 51, [ "name" ] = "Sorrow Spinner",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Swamp of Sorrows.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 2543 ,["id"] = 858  ,["coords"] = {{21.8,43.4},{28,50.6},{28.6,50.6},{29,51.8},{29.2,49.2},{29.2,49.8},{29.6,50.2},{29.8,50.6},{30.6,49},{30.8,46.4},{31.2,47.6},{31.4,46.6},{31.4,53.2},{31.4,54},{31.6,52.8},{31.6,53.8},{32.4,46.2},{32.4,47.2},{32.6,55},{34.4,53.2},{35.4,37.6},{35.6,35.8},{35.6,38.2},{35.8,50},{35.8,53.2},{36,37.4},{36.2,45.2},{36.6,38.6},{36.6,46.4},{36.8,37.2},{36.8,45},{38.4,40.8},{39,48.2},{39.4,48.6},{39.6,33.6},{40.4,47.4},{40.6,48.8},{40.8,39.8},{40.8,46.2},{41.2,39.4},{41.2,40.8},{41.8,46.6},{42.2,48.4},{42.8,43.6},{44.8,45.6},{45.2,42.8},{47.2,44.2},{60.4,58},{60.6,58},{66.4,71.2},{68,67.2},{68.2,70.2},{68.4,65.4},{68.4,65.8},{68.8,65.4},{68.8,65.6},{69.8,66.6},{69.8,68} } },
  {["zone_name"] = "Wetlands", [ "zoneID" ] = 56, [ "name" ] = "Leech Stalker",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Wetlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 711 ,["id"] = 1111  ,["coords"] = {{53.2,63.8},{53.2,65.4},{53.4,63.2},{53.4,65.6},{53.8,64},{53.8,65},{54,66.2},{54.2,66.6},{54.4,63.2},{54.6,63.2},{54.6,65.4},{54.8,65.6},{55.2,63.8},{55.2,67.8},{55.4,62},{55.4,66.8},{55.6,61.6},{55.6,64.2},{55.6,66.8},{56,61.4},{56.2,62.6},{56.2,65.4},{56.2,65.6},{56.2,68.2},{56.2,68.6},{56.6,61},{56.6,65.8},{56.8,62},{56.8,65},{57,62.6},{57,64.4},{57,66.8},{57.6,65.4},{57.6,65.8},{57.6,68} } },
  {["zone_name"] = "Tirisfal Glades", [ "zoneID" ] = 18, [ "name" ] = "Ravenous Darkhound",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Tirisfal Glades.", ["class" ] = CLASS_NORMAL, ["family"] = {  52  , "Hound"          } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 3916 ,["id"] = 1549  ,["coords"] = {{79.8,49},{80.4,42.2},{80.8,43},{81,44.6},{81.4,46.6},{81.6,45.4},{81.6,47},{81.6,51.4},{82.2,44},{82.2,48.6},{82.2,50.4},{82.6,47},{82.8,44},{82.8,48.2},{82.8,49.6},{82.8,51},{83,40.4},{83.2,40.8},{83.2,46.4},{83.4,45.4},{83.6,44},{83.8,43.4},{84,41.2},{84,41.8},{85,41.2},{85.2,41.6},{85.2,43.6},{85.2,46.4},{85.4,40.4},{85.6,43.8},{85.8,40.6},{86,38.2},{86,40.2},{86,45.2},{86,46.2},{86.4,46.8},{86.8,46.2},{87.4,43.2},{87.4,47.2},{87.8,47.8},{88,46.2},{88,49},{88.2,41.8},{88.2,43.8},{88.2,49.6},{88.6,47.2},{89,45.4},{89.4,43.8},{89.6,43.6} } },
  {["zone_name"] = "Loch Modan", [ "zoneID" ] = 48, [ "name" ] = "Ol' Sooty",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Loch Modan.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 21735 ,["id"] = 1225  ,["coords"] = {{79,51.4},{79.2,51.6},{80,52} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Ridge Huntress",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 1055 ,["id"] = 2732  ,["coords"] = {{35,34.2},{35,61},{35.4,60},{36,58.6},{36,60.4},{36.6,58.8},{37,34},{37.2,60},{38,60},{38.4,58.8},{38.6,58.4},{39,61.8},{39.4,34.2},{39.4,59.2},{40,34.4},{40.4,62.2},{40.6,34},{40.6,60.4},{40.8,59.2},{40.8,62.4},{41,63.4},{41.2,58.2},{41.2,61.2},{41.4,57},{42.2,58.4},{42.6,58.8},{43.4,32},{43.6,31.4},{43.6,33.6},{43.8,32.8},{43.8,35.4},{44.4,35.8},{44.6,36.6},{44.8,34.4},{45.2,33.4},{45.4,12.4},{45.8,50.4},{46,7.4},{46,11},{46.2,8.4},{46.6,8.6},{46.8,56.4},{47,12},{47,20.6},{47,50.4},{47,56.8},{47.2,12.8},{47.2,50.6},{47.2,51.6},{47.2,53.2},{47.4,24.6},{47.4,47},{47.4,47.6},{47.6,47.4},{47.8,25.8},{47.8,49.6},{47.8,53.6},{48,14.2},{48,21.2},{48,52.6},{48.2,17.2},{48.2,24.2},{48.2,51.4},{48.2,51.6},{48.4,24.6},{48.6,24.4},{48.6,24.8},{48.6,51.8},{48.8,50.8},{49.2,22.4},{49.4,23},{49.6,19},{50,20.4},{50.2,23.2},{50.6,19},{51.4,43},{52.2,43.2},{52.2,44.8},{52.2,47},{52.2,51.4},{52.4,43.6},{52.6,49.4},{52.8,43.6},{53,42.4},{53,42.8},{53,54.6},{53.2,46},{53.2,46.8},{53.4,41},{53.4,45},{53.6,44.4},{53.6,45.2},{53.6,58.4},{53.8,42.4},{53.8,47},{53.8,48.2},{53.8,48.6},{53.8,55},{53.8,57.4},{54,43},{54.2,46.4},{54.2,53.2},{54.4,49.6},{54.4,51.2},{54.6,46.6},{54.6,50},{54.6,56.2},{54.8,42.8},{54.8,56.6},{55,52.6},{55.2,38.2},{55.2,51.4},{55.2,51.6},{55.4,55.4},{55.6,49.6},{55.8,44.2},{56,34.8},{56,35.6},{56,36.6},{56,38.6},{56.2,49.4},{56.4,33},{56.4,33.8},{56.4,52.6},{56.6,32.4},{56.8,29},{56.8,31},{56.8,33.2},{57,30.2},{57,34},{57.6,60},{57.8,28.6},{57.8,30.8} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Silverback Patriarch",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  9  , "Gorilla"          } , ["familySkills" ] = GORILLA_SKILLS          ,["displayID"] = 844 ,["id"] = 1558  ,["coords"] = {{52.8,53.2},{53.4,50.6},{54.4,50.8},{54.4,52.4},{54.8,51.4},{54.8,51.8},{55.8,52.6},{56,50.4},{56,50.6},{56,52.2},{56.4,49.4},{56.6,49.8},{57,54.4},{57.2,49.4},{57.6,50.6},{57.8,49.4},{57.8,49.6},{58,46.2},{58,47.2},{58.6,44.2},{58.8,46} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Nightsaber",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 6805 ,["id"] = 2042  ,["coords"] = {{50,45.4},{50,45.8},{50.2,48.4},{50.2,48.6},{51.4,50},{51.8,52},{52.2,52.8},{53,50.6},{53.2,48.4},{53.4,48.8},{53.6,48.4},{53.6,48.8},{54.8,56.8},{57.2,48},{58,50.4},{58,50.8},{58.4,53.8},{58.6,50.4},{58.6,53.4},{58.6,53.6},{58.8,54.8},{60.4,51.2},{60.4,52.2},{60.6,51},{60.8,51.8},{61,52.6},{61.6,52},{61.6,52.8},{63.2,48.2},{63.2,48.6},{64.4,45},{64.4,46.8},{64.6,45},{65.2,47.4},{65.2,47.6},{65.8,46.8},{66,47.8} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Webwood Venomfang",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 759 ,["id"] = 1999  ,["coords"] = {{40.6,54},{40.8,41.6},{41,51.8},{41.2,53.2},{42,54.8},{42.2,53.4},{42.4,42.6},{42.4,53.6},{42.6,53.8},{42.8,42.4},{42.8,42.6},{44.8,47.2},{45.6,61} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Elder Nightsaber",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 3030 ,["id"] = 2033  ,["coords"] = {{41.2,36.6},{41.4,30.6},{41.4,39.2},{42.2,40},{46.4,37},{46.6,36.6},{47,36} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Bhag'thera",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn. Wanders a path north to south through the middle of Bambala, then roughly south-west, ending to the west of Mosh'Ogg Ogre Mound.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 613 ,["id"] = 728  ,["coords"] = {{61.4,51.2},{61.8,50.4},{61.8,50.6},{62.8,48.2},{64,36.4},{64.4,36.8},{64.4,37.6},{64.6,36.2},{64.6,37},{64.8,37.6},{65.4,43},{65.8,42.2},{65.8,43.2},{65.8,43.6},{65.8,44.6} } },
  {["zone_name"] = "Western Plaguelands", [ "zoneID" ] = 22, [ "name" ] = "Venom Mist Lurker",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Western Plaguelands.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 759 ,["id"] = 1822  ,["coords"] = {{42.4,54.2},{42.8,56.4},{43.2,54.4},{43.4,55},{43.6,55.2},{44,56.4},{44,56.6},{45,59.4},{45,59.6},{46.2,59.6},{47,59},{48.4,58.2},{48.8,58.4},{48.8,60.8},{49,59.4},{49.4,59.6},{49.4,61.8},{49.6,59.4},{49.6,59.6},{49.6,61.8},{49.8,61.2},{50.2,63.2},{50.2,63.6},{50.4,58.4},{51,62.6},{51.2,57.4},{51.2,57.8},{51.2,59.4},{51.2,60.2},{51.4,60.6},{51.6,60.4},{51.8,60.8},{52.4,58.4},{52.4,58.6},{52.6,58.4},{52.6,58.6},{52.8,61},{52.8,61.6},{53.4,59.8},{53.8,60.2},{54,61},{54.2,61.6},{54.4,63},{54.8,62.2},{55,62.6},{55.4,57.6},{55.8,63.4},{56,58.4},{56,58.6},{56,60.6},{56,63.6},{56.2,60.4},{56.2,61.6},{56.4,57.4},{56.6,57.4},{56.6,57.8},{56.6,59.4},{56.6,59.8},{56.6,62.6},{56.8,61.4},{57,61.6},{57.2,64.8},{57.4,64.4},{57.6,64.4},{57.6,64.6},{58,62.4},{58.2,60.4},{58.4,58},{58.4,59.2},{58.4,60.8},{58.4,62.8},{58.6,60.6},{58.6,62.6},{58.8,57.4},{58.8,57.8},{59,62},{59.2,59.6},{59.4,59.4},{59.6,59.4},{59.6,59.6},{60.2,60.6} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Sin'Dall",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn. Roams a rocky mound just south-west of Tkshi Ruins, further south-west of Nesingwary's Expedition.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 471 ,["id"] = 729  ,["coords"] = {{38.2,32.6},{38.4,32.4},{38.6,32.4},{38.6,32.6} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Sea Crawler",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  8  , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 979 ,["id"] = 831  ,["coords"] = {{25.2,50.8},{25.4,52.8},{25.4,62.2},{26.2,57},{26.4,47},{26.4,56.4},{26.8,42.6},{26.8,43.8},{26.8,51.2},{27,52.2},{27.2,46.4},{27.8,44.4},{27.8,45},{27.8,49.8},{28.4,45.8},{28.6,40.6},{28.8,55.8},{28.8,78.4},{29.2,41.6},{29.8,42},{30,83.6},{30.2,24.2},{30.8,84.4},{30.8,84.6},{31.2,27.8},{32.4,23.2},{32.8,84.8},{33,84.2},{34.6,23.6},{35.4,87.8},{35.6,18.4},{35.6,88.4},{35.8,15.2},{36,89.2},{36.2,16.6},{36.6,17.6},{36.6,18.8},{36.8,89.2},{39.6,9},{45.4,4.6},{53.6,9},{54,8.2},{55.2,8.8},{55.4,7},{55.4,7.6},{55.8,6.8},{56,8.4} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Feral Nightsaber",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 3030 ,["id"] = 2034  ,["coords"] = {{39.4,22},{39.6,21.4},{39.6,25.4},{40,25.6},{40.4,21.6},{40.4,23.4},{40.4,23.8},{40.6,22.2},{40.6,23.4},{40.6,23.8},{40.6,25},{40.8,25.8},{41.8,22.6},{42,22.4},{42,24.8},{42.2,24},{42.6,22.6},{42.6,24.2},{42.6,24.8},{42.8,22.4},{47.2,25.6},{47.4,24.2},{48,22.4} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Webwood Spider",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 709 ,["id"] = 1986  ,["coords"] = {{55.2,24.6},{55.4,22.4},{55.4,24.2},{55.6,23.8},{56,22.2},{56,23.4},{56,26.4},{56.2,27},{56.4,25.2},{56.4,27.6},{56.8,25.8},{57,24.4},{57.2,22.8},{57.2,24.8} } },
  {["zone_name"] = "Dun Morogh", [ "zoneID" ] = 27, [ "name" ] = "Ice Claw Bear",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Dun Morogh.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 8840 ,["id"] = 1196  ,["coords"] = {{64.4,57},{65,57},{66,54.8},{66.2,55.6},{66.2,58.4},{66.2,60},{66.4,58.6},{66.6,58.4},{66.8,54.4},{66.8,55.8},{67,56.6},{67.2,55},{67.6,57.4},{67.6,59},{68.4,54.2},{68.4,54.6},{68.4,58.2},{69.2,54.4},{69.2,54.6},{69.2,56.2},{69.4,56.8},{69.6,56.6},{69.8,53.4},{69.8,54.2},{70.4,51.6},{70.4,54.8},{70.4,56.4},{70.4,58},{70.6,52},{70.6,54.4},{70.6,54.6},{70.6,58.4},{71.2,52.8},{72,58.4},{72.8,49.4},{73,49.6} } },
  {["zone_name"] = "Duskwood", [ "zoneID" ] = 47, [ "name" ] = "Black Widow Hatchling",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Duskwood.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 368 ,["id"] = 930  ,["coords"] = {{72.4,58.6},{72.4,62.2},{72.4,63.2},{72.8,62.4},{72.8,62.6},{73,59.8},{73.4,59.4},{73.4,63.6},{73.4,65.4},{73.6,60.6},{73.6,63.2},{73.8,57.8},{73.8,59.4},{73.8,60.4},{74,56.4},{74.2,63.8},{74.2,64.8},{74.4,61.6},{74.8,63.2},{75,59.8},{75.2,60.8},{75.2,62},{75.4,64.2},{75.6,61},{75.6,64.4},{75.8,61.6},{75.8,63.4},{76,58.8},{76.4,58.4},{76.4,59.8},{76.6,59.8},{76.6,61.6},{76.6,62.6},{76.6,64},{76.6,64.6},{76.8,58.4},{76.8,60.8},{77,59.2},{77.6,61.6},{78,54.8},{78,56},{78,57.2},{78.4,63.2},{78.6,55.8},{78.8,54.8},{78.8,60.2},{79,53.4},{79,53.6},{79,56.6},{79.6,55},{79.8,51.2},{79.8,57.4},{79.8,57.6},{80,52},{80,52.6},{80.2,53.8},{80.4,56.2},{80.4,61.2},{81.4,51.8},{81.4,53.4},{81.4,53.6},{81.4,57},{81.6,55.2},{81.8,51.6},{81.8,53.8},{82,46.6},{82,52.8},{82,56.4},{82.4,51.2},{82.6,51.2},{82.6,52.8},{82.8,56.4},{83.8,52.2},{83.8,55.8},{84.2,55.4},{84.4,56.6},{84.6,56.8},{84.8,56},{85.2,51.4},{85.6,52},{85.8,49.2},{86,50},{86,54.6},{86.2,52.6},{86.2,54.4},{86.6,49},{86.6,49.8},{86.6,50.6} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Shore Crawler",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  8  , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 32790 ,["id"] = 1216  ,["coords"] = {{25.8,62.8},{26,64.8},{26.2,66.6},{28.6,77.2},{28.8,74.8},{29.2,76.4},{29.2,78},{29.4,78.6},{29.4,79.8},{29.6,79.6},{30.2,80.6},{30.6,82.2},{30.8,82.8},{31.6,82.2},{31.8,83.4},{31.8,83.6},{32.6,82.4},{35.8,87.6},{36.2,87.4} } },
  {["zone_name"] = "The Hinterlands", [ "zoneID" ] = 26, [ "name" ] = "Silvermane Wolf",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Hinterlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11419 ,["id"] = 2924  ,["coords"] = {{23.4,51.8},{23.6,50},{24.6,51},{24.6,52.8},{24.6,65.4},{25,52.2},{25,65.8},{25.4,66.6},{25.6,66.4},{25.8,66.6},{26,54.2},{26,68},{26.2,53.4},{26.4,55},{27.4,53.2},{27.8,53},{28.4,63.4},{29,63.6},{29.6,62.8},{30,65},{30.2,62.4},{31,61.2},{31,65.6},{31.4,63.2},{31.4,63.8},{31.4,64.8},{31.6,64},{32.2,58},{32.2,62.6},{32.8,61},{32.8,64},{33,62},{33.6,50.2},{33.6,51.6},{33.6,64},{33.8,61.8},{34.2,63},{34.4,49},{34.4,51.4},{34.6,51.2},{34.6,51.6},{34.8,49},{34.8,62.4},{35,46.6},{35.2,42.8},{35.2,44.4},{35.2,48.2},{35.2,53.6},{35.4,45},{35.4,46.2},{35.4,50.2},{35.6,42},{35.6,47.8},{35.8,46.6},{35.8,51.2},{35.8,52.2},{36,42.6},{36,43.6},{36,49.6},{36,53.2},{36,53.8},{36.2,45.8},{36.2,48.6},{36.4,45.4},{36.6,43.4},{36.6,51.2},{36.6,51.6},{36.8,46},{36.8,47.4},{36.8,50.2},{37,44},{37.2,53.6},{37.4,44.6},{37.4,47.8},{37.4,49.2},{37.4,53},{37.6,44.2},{37.6,47.6},{37.8,47.2},{38,45.2},{38.4,50} } },
  {["zone_name"] = "Tirisfal Glades", [ "zoneID" ] = 18, [ "name" ] = "Vicious Night Web Spider",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Tirisfal Glades.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 368 ,["id"] = 1555  ,["coords"] = {{82.4,54.2},{82.4,55},{82.4,56.4},{82.6,54.4},{83,56.2},{83.2,53.4},{83.4,55.4},{83.6,52.4},{83.6,52.8},{83.6,55},{83.6,56.4},{84.2,50.2},{84.2,54.2},{84.4,47},{84.4,47.6},{84.4,51.4},{84.6,53.6},{84.8,51.8},{85,47.6},{85,50.6},{85,52.8},{85,54.6},{85.2,50.4},{85.4,49.2},{85.4,57.4},{85.6,51.4},{85.6,52},{85.8,49.4},{85.8,57.4},{85.8,57.6},{86.4,48.4},{86.4,50.2},{86.4,53.2},{86.4,53.8},{86.6,53},{86.6,53.8},{86.6,57.2},{86.8,48.2},{86.8,50},{86.8,50.8},{87.2,49.4},{87.2,51.6},{87.4,55.8},{87.6,53.6},{87.8,50},{87.8,50.6},{88,49},{88,52.8},{88,54.8},{88.6,51.6},{88.6,53.6},{88.8,49.4},{88.8,49.6},{89.4,50.6},{89.4,52.8},{90,49.6},{90.2,49.4} } },
  {["zone_name"] = "Tirisfal Glades", [ "zoneID" ] = 18, [ "name" ] = "Vampiric Duskbat",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Tirisfal Glades.", ["class" ] = CLASS_NORMAL, ["family"] = {  24  , "Bat"          } , ["familySkills" ] = BAT_SKILLS          ,["displayID"] = 47213 ,["id"] = 1554  ,["coords"] = {{42,63.6},{42.4,60},{43.4,58.6},{44.4,59.2},{44.4,64.4},{44.6,59.2},{45.2,63.6},{45.2,66.8},{45.6,66.2},{45.8,63.6},{46,60},{46,62},{46.2,58.8},{47.8,61.2},{48,62},{48.6,68.2},{48.6,68.6},{49.2,59.8},{49.2,63.8},{49.4,63.2},{50.4,61.4},{50.6,61.8},{51,61.4},{51.8,60.8},{52,62.8},{52.6,60.4},{52.6,63.4},{53,63.8},{53.2,65.4},{53.4,62.4},{53.6,61.8},{53.6,63.2},{54,61.2},{55.4,60.4},{55.4,61},{55.6,60.2},{65,34.6},{65.4,34.4},{67.4,59},{67.6,59.2},{67.8,33.6},{69.6,58.2},{69.6,58.6},{69.8,60.4},{70.2,54},{70.4,61.4},{70.4,62},{70.6,61},{71,55},{71.2,52.8},{71.2,55.6},{71.6,59.6},{71.8,49.4},{72,34},{72,44.8},{72.2,58.4},{72.4,37.4},{72.4,65},{72.6,65.4},{72.6,65.6},{73.4,42.4},{73.4,42.6},{73.4,47.2},{73.4,59.6},{73.4,63.4},{73.6,54.8},{73.6,59.6},{74,58.2},{74,59.2},{74.2,67.2},{74.4,66.2},{74.8,44.4},{74.8,63.8},{74.8,65.8},{74.8,66.8},{75,53.2},{75.2,47.6},{75.2,71.6},{75.4,69.2},{75.8,69.2},{76,34.2},{76,63.8},{76,65.8},{76,66.6},{76.2,46.2},{76.4,71.6},{76.6,72.4},{76.8,32.2},{76.8,71.4},{77,30.8},{77,32.6},{77.4,30},{77.4,68.6},{77.6,66.8},{77.8,66.4},{77.8,72.2},{78,70.4},{78.4,62.2},{78.4,63.4},{78.4,64.6},{78.4,69.2},{78.4,71.2},{78.4,73.4},{78.6,64.8},{78.6,69.4},{78.6,69.6},{78.6,71.8},{79,44},{79,59.2},{79,68.4},{79.2,62.8},{79.2,66.6},{79.2,71.4},{79.4,58.4},{79.6,68.4},{79.6,70.8},{79.6,72.4},{79.6,72.6},{79.8,45},{79.8,61.4},{80,58},{80,59.2},{80,62.4},{80,62.6},{80,64.8},{80.4,59.6},{80.4,66.2},{80.4,70.4},{80.6,59.2},{80.6,66.2},{80.6,68.6},{80.6,70.4},{80.8,59.6},{80.8,64.4},{80.8,68.4},{81.2,49},{81.2,67.2},{81.4,71},{81.6,49},{81.6,67.2},{81.6,67.6},{81.8,41},{81.8,73.8},{81.8,75.2},{82,63.8},{82.2,53},{82.2,64.6},{82.2,65.8},{82.6,41.6},{83,44.6},{83,65},{83,66.2},{83.4,66.6},{83.6,51.2},{83.6,65.8},{84.4,40.6},{84.4,42.4},{84.4,42.6},{84.6,42.6},{85,39},{87,38.6},{88.4,42.8} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Elder Shadowmaw Panther",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 11452 ,["id"] = 1713  ,["coords"] = {{37.8,31.8},{39.4,29.2},{39.4,29.6},{39.4,31.4},{39.4,31.6},{39.6,29.2},{39.6,31.6},{40.2,30.2},{40.2,30.6},{40.4,27.4},{40.4,27.8},{40.6,27.6},{41,29.2},{41.2,29.6},{41.4,26.4},{41.4,26.6},{41.8,27.8},{41.8,30.6},{42,25.4},{42,25.6},{42,27.4},{42,30.4},{42.8,19},{42.8,21.4},{43,21.6},{43,23.8},{43.4,20.2},{43.4,23},{43.6,22.8},{43.8,17.8},{43.8,20.4},{43.8,20.6},{43.8,22.4},{44.4,19.2},{44.6,19.2},{45.4,19.8},{45.4,20.6},{45.4,40.8},{45.4,43},{45.6,19.8},{45.6,40.4},{45.6,40.8},{46,42.4},{46,43},{46.2,16.8},{46.2,19},{46.2,43.6},{46.4,16.4},{46.6,16.4},{47.2,17.4},{47.2,17.8},{47.4,43.4},{47.4,43.6},{47.6,16.4},{47.6,16.6},{47.6,43.4},{47.8,18.8},{47.8,43.6},{48,14},{48,18.4},{48,44.6},{48.4,9.8},{48.4,12.4},{48.4,13},{48.6,9.8},{48.6,12.6},{48.6,43.6},{48.8,15.2},{48.8,43.4},{49.4,11.2},{49.4,13.8},{49.4,42.2},{49.6,11.2},{49.6,13.6},{49.6,42.2},{49.6,43.2},{50,14.8},{50,16.6},{50.2,12.4},{50.4,12.6},{51,13.8},{51.4,11.8},{51.6,12.2},{51.6,12.6},{54.4,38.4},{54.4,38.6},{54.6,38.8},{54.8,39.6},{54.8,40.6},{55.2,42},{55.4,38.2},{56.2,36},{56.4,37.2},{56.4,38.2},{56.4,38.6},{56.6,38.4},{56.6,38.8} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Elder Stranglethorn Tiger",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 698 ,["id"] = 1085  ,["coords"] = {{35.4,31.6},{35.6,31.4},{36.4,32.4},{36.4,32.6},{37.2,31.4},{37.2,31.6},{37.2,34},{37.4,30.4},{37.4,32.8},{37.4,35.4},{37.4,36.4},{37.4,36.6},{37.6,33.2},{37.6,34.2},{37.8,30.6},{38,30.2},{38,38.6},{38.2,28.4},{38.2,35.2},{38.4,28.8},{38.4,36.4},{38.4,36.6},{38.4,37.6},{38.6,28},{38.6,29.6},{38.6,34.6},{38.6,36.4},{38.6,36.6},{38.8,29.2},{38.8,37.6},{39,34.2},{39.4,33.4},{39.6,28.8},{39.6,33.4},{39.8,30.2},{40,32.4},{40,33.8},{40,34.8},{42.4,35.6},{42.8,34},{43,35.4},{43,35.6},{43.4,37.2},{43.4,37.8},{43.6,34.2},{43.6,35.6},{43.6,36.6},{44.4,34.8},{44.4,58.4},{44.6,34.8},{44.6,58.8},{45,34},{45.4,59.6},{46,59},{47,57},{47,57.6},{47.2,59.2},{47.4,59.6},{47.6,59.6},{47.6,62},{47.8,59.4},{48.2,58},{48.4,56.2},{48.8,56.4},{48.8,57.2},{49.2,57.6},{49.6,57.2},{50,55.8},{50,59.8},{50.4,55.2},{50.4,58.4},{50.4,58.8},{50.6,56.2},{50.6,58.4},{50.6,58.8},{51,55},{51.2,54.2},{52,55.4},{52,61.4},{52,62.4},{52,62.6},{52.2,54},{52.4,59.6},{52.6,54.4},{52.6,54.6},{52.8,59.4},{52.8,59.6},{52.8,69.2},{54.4,64.6},{54.6,64.8} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Strigid Owl",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  26  , "Bird of Prey"          } , ["familySkills" ] = BIRD_OF_PREY_SKILLS          ,["displayID"] = 10832 ,["id"] = 1995  ,["coords"] = {{52.8,49.6},{53.2,48},{57,49.2},{57.4,53.2},{58,49.4},{58,49.6},{58.2,52.6},{58.4,52.2},{60.2,44},{60.8,44.8},{61.2,54.4},{61.2,54.6},{61.6,55.8},{62,45.2},{62,46.4},{62,47},{62.6,47.4},{62.6,56.2},{62.8,47.6},{63.2,53.4},{63.2,53.6},{63.4,45.4},{63.8,45.8},{63.8,47.4},{63.8,47.6},{65.6,47},{65.6,53.4} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Ironjaw Basilisk",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  130  , "Basilisk"          } , ["familySkills" ] = BASILISK_SKILLS          ,["displayID"] = 45446 ,["id"] = 1551  ,["coords"] = {{64.4,29.8},{64.8,26},{64.8,29.6},{65,25.4},{65.4,29.2},{65.6,23.8},{65.8,28.4},{65.8,28.6},{66.2,27.2},{66.4,22.8},{67,28.2},{67.2,24.4},{67.4,22.8},{67.4,24.6},{67.4,26.4},{67.4,26.6},{67.6,23.2},{67.6,23.8},{67.8,24.6},{67.8,27},{67.8,28.2},{68.4,26},{68.6,26} } },
  {["zone_name"] = "Dun Morogh", [ "zoneID" ] = 27, [ "name" ] = "Crag Boar",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Dun Morogh.", ["class" ] = CLASS_NORMAL, ["family"] = {  5  , "Boar"          } , ["familySkills" ] = BOAR_SKILLS          ,["displayID"] = 607 ,["id"] = 1125  ,["coords"] = {{46.4,58.2},{46.4,62},{46.6,58},{48.4,57.8},{48.8,58.4},{48.8,63.2},{49.4,55},{49.6,55},{50.4,54.2},{50.8,53.8},{51,51.6},{51,53.4},{51.2,50.4},{51.2,57},{51.4,43.4},{51.4,44},{51.4,50.8},{51.4,56},{51.6,43.4},{51.6,43.8},{51.6,51.2},{51.8,44.6},{51.8,54.6},{51.8,55.6},{52,53.8},{52.2,38.4},{52.2,38.6},{52.2,41.4},{52.2,41.6},{52.4,63.4},{52.6,41.4},{52.8,42.8},{52.8,44.8},{52.8,62.6},{53,44.2},{53.2,39.4},{53.2,39.8},{53.2,42.4},{53.2,57.4},{53.2,58},{53.2,60.2},{53.4,55},{53.6,54.8},{54.4,41.8},{54.6,42},{54.8,53.4},{54.8,62.4},{55,47.2},{55,53.8},{55.2,47.6},{55.2,48.8},{55.2,57},{55.2,58.4},{55.4,55.8},{55.6,48.4},{55.6,48.6},{55.6,56},{56,53.2},{56,57},{56.6,49},{56.6,52.6},{57,52.2},{57.2,49.6},{57.4,44.4},{57.8,49.6},{57.8,50.8},{58.2,47.2},{58.2,49.4},{58.4,43.8},{58.4,57.6},{58.6,57.4},{58.6,57.6},{58.8,41.4},{62.2,42.8} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Tethis",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn. Wanders a broad area south of Mosh'Ogg Ogre Mound and west to the eastern side of Ziata'jai Ruins (west of Fort Livingston).", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 8472 ,["id"] = 730  ,["coords"] = {{58.4,59.8},{58.8,61.2},{59,59.8},{59.2,58.2},{59.2,59.2},{59.2,62.4},{59.4,62.6},{59.6,59.2},{59.8,62.2},{59.8,62.6},{60,60.2},{60,61.2},{60,63.6},{60.8,62.8},{61.6,60.2},{62,61.2},{62.2,63.2},{62.4,61.8},{62.6,60.4},{62.8,62.6},{63,62.4},{63.2,59},{63.4,61.4},{63.8,61.4},{64,62.4},{64.4,58.4},{64.8,56.2},{64.8,57.6},{65,57.4},{65.2,58.6} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Fleshripper",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 2305 ,["id"] = 1109  ,["coords"] = {{30.6,35.8},{33,35.8},{33.2,37.4},{33.2,40.4},{35.2,29.2},{35.4,30.2},{35.6,30.2},{36,28.4},{36.2,42.4},{39.8,24.4},{42.4,50.8},{42.6,24.8},{43,44.2},{43.4,43.4},{43.6,42.2},{43.6,46.4},{43.8,44.2},{44.8,54.2},{45.4,46.2},{45.6,46.6},{46,26},{46.2,26.8},{46.4,28},{47.2,55.8},{47.4,55.4},{48.4,56.2},{48.4,56.6},{48.6,55.6},{49.2,57},{49.4,31},{50,58.6},{50.4,30.4},{50.4,30.6},{50.4,32},{50.6,30.4},{50.6,32},{50.6,32.6},{50.8,31.2},{52.4,24.4},{52.4,24.6},{52.4,35.6},{53,25.6},{53.2,24.4},{53.2,25.2},{53.2,35.4},{53.4,22.6},{53.4,35.6},{53.4,37.2},{53.6,36.8},{54,23.2},{54,35.2},{54.2,26.8},{54.4,24.2},{54.4,25.4},{54.4,25.6},{54.4,35.6},{54.6,23},{54.6,25.4},{54.6,25.6},{54.6,36.4},{54.8,26.6},{54.8,60.6},{55.2,23.8},{55.4,60.4},{55.6,60.4},{55.6,60.6},{56.4,33.4},{56.4,34},{56.4,35},{56.4,35.8},{56.6,33.2},{56.6,33.6},{57,35.6},{57.4,34.6},{58.2,34.2},{63.4,44.6} } },
  {["zone_name"] = "Silverpine Forest", [ "zoneID" ] = 21, [ "name" ] = "Worg",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Silverpine Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11421 ,["id"] = 1765  ,["coords"] = {{55.4,21.8},{55.6,24.4},{56.2,16.4},{56.2,18.4},{56.2,18.6},{56.4,17.2},{56.4,19.8},{56.4,21.4},{56.4,21.6},{56.6,19.8},{57,17},{57.8,17.4},{58.2,17.6},{58.4,15.8},{58.6,15.2},{58.6,16},{58.6,16.6},{58.8,11},{59,14},{59.4,8.8},{59.4,10.4},{59.6,9.6},{59.6,10.8},{60,8},{60.2,9.2},{60.2,16.4},{60.2,16.6},{60.4,7.2},{60.4,12.4},{60.4,13},{60.6,9.4},{60.6,13},{60.6,15.6},{60.8,14.8},{61,7},{61,7.6},{61,9.8},{61,14},{61.8,8.2},{61.8,8.6},{63.2,11.2},{63.8,11},{64,5.4},{64,7.4},{64,7.6},{64.2,5.8},{64.6,6.4},{64.8,6.6},{65,12.4},{65.6,10},{66.2,9},{67,8.4},{67,8.6} } },
  {["zone_name"] = "Tirisfal Glades", [ "zoneID" ] = 18, [ "name" ] = "Cursed Darkhound",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Tirisfal Glades.", ["class" ] = CLASS_NORMAL, ["family"] = {  52  , "Hound"          } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 9020 ,["id"] = 1548  ,["coords"] = {{42,47.2},{43.4,44.6},{43.6,44},{44,41.2},{44,58.4},{44.2,58.6},{44.4,48},{44.8,44.8},{45.2,61.2},{45.2,61.6},{45.4,47.4},{45.4,51},{45.6,59.4},{46,46.2},{46,48},{46,51.4},{46.2,51.6},{47.2,49.4},{47.6,48.2},{47.6,59.4},{47.8,49},{47.8,52},{48.2,50.4},{48.6,51.2},{48.6,64.8},{49.4,63.2},{49.6,65},{49.8,60.4},{49.8,64.4},{50.6,63.6},{50.8,60},{51.2,69.8},{51.6,62},{52.6,65.8},{52.6,71.2},{52.8,65.4},{53.2,72.8},{53.8,63.4},{54.2,63.6},{54.2,65.4},{54.2,65.6},{54.2,66.6},{54.2,71},{54.4,61.4},{54.6,71.8},{54.8,61.4},{54.8,62.6},{55,62.4},{55.4,65.6},{55.4,73.8},{55.6,61.4},{55.6,61.6},{55.6,65.8},{55.8,65.4},{56.2,60.2},{56.4,59.4},{56.4,63.8},{56.6,64.2},{56.8,58.4},{57,59.4},{57,59.6},{57.4,61.4},{57.4,61.6},{57.4,62.6},{57.6,61.8},{57.6,62.6},{57.8,61.2},{58.2,59.4},{58.4,58.2},{58.4,59.6},{58.6,58.2},{58.6,59.2},{59.2,30.8},{59.2,59.8},{59.2,62.4},{59.2,62.6},{59.6,62.6},{60,61.6},{60.2,61.4},{60.6,62},{63.4,35.4},{65,32.4},{77,34.4} } },
  {["zone_name"] = "Darkshore", [ "zoneID" ] = 62, [ "name" ] = "Grizzled Thistle Bear",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Darkshore.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 14316 ,["id"] = 2165  ,["coords"] = {{39.2,78.6},{39.4,80.8},{40.2,74.2},{40.2,77.4},{40.2,77.6},{40.4,79.4},{40.4,79.6},{40.4,81.6},{40.6,76.8},{40.6,79},{40.6,81.8},{40.8,76.4},{40.8,79.8},{41,74.8},{42.2,79},{43.4,80.8},{43.4,87.8},{43.4,88.6},{43.6,87.8},{43.8,77.4},{43.8,80.4},{43.8,80.6},{44,77.8},{45.8,76.4},{46,76.6},{46.4,80} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Young Fleshripper",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 410 ,["id"] = 199  ,["coords"] = {{36,28},{37.2,27},{39,20.6},{40.6,17},{41.4,35.4},{41.4,39},{41.6,35},{41.8,35.6},{42,34},{42,37.4},{42,38.4},{42.4,16.2},{42.4,24.2},{42.4,38.6},{42.6,17.8},{42.6,37.8},{42.8,38.8},{43.4,24},{43.4,25},{43.6,25.4},{44.4,19.2},{44.4,20.4},{44.4,20.6},{44.4,26},{44.8,18.4},{44.8,19},{44.8,19.8},{45.2,25.4},{45.4,26},{45.4,31},{45.8,25.4},{45.8,26},{46,26.6},{46,30.2},{46,30.6},{46.2,29.2},{46.6,26.2},{47.4,33.6},{47.6,17.2},{47.8,17.8},{47.8,25.4},{47.8,28.2},{48,19.2},{48.2,27.4},{48.4,25.6},{48.4,29.4},{48.4,30.2},{48.4,31.4},{48.4,31.8},{48.6,30.4},{48.8,18.2},{48.8,25},{48.8,31},{49,24.4},{49,25.6},{49,27.4},{49,31.6},{49.2,15.2},{49.2,27.6},{49.4,28.6},{49.6,19.6},{49.6,27.6},{49.6,31.2},{49.8,15},{49.8,16},{49.8,18.8},{49.8,26.4},{49.8,27},{50,32.2},{50.2,16.6},{50.2,17.8},{50.2,21.8},{50.2,22.8},{50.4,20.8},{50.8,19.6},{50.8,24.4},{51,18.4},{51,19.2},{51.4,24.8},{51.6,24.8},{52,18.4},{52.2,29.6},{52.4,19},{52.4,19.6},{52.4,22.4},{52.4,22.6},{52.4,28.4},{52.4,29.2},{52.4,35},{52.4,36.2},{52.4,36.6},{52.6,18.4},{52.6,19.4},{52.6,19.6},{52.6,22.4},{52.6,22.8},{52.6,28.4},{52.6,29},{52.6,30.2},{52.6,35.4},{52.6,36.2},{52.6,36.6},{52.8,30.6},{54.2,29.2},{54.4,17.6},{55,19.8},{55.2,24.8},{55.4,19.4},{55.4,23.8},{55.6,18.4},{55.8,19.2},{55.8,20.4},{56,23.4},{56,23.8},{57.6,18},{59.2,32.4},{59.4,33.4},{59.4,33.6},{59.6,12.4},{59.6,33.4},{59.6,33.6},{59.8,14.2},{60,25},{60.2,13.4},{60.2,24.4},{60.2,27.4},{60.2,27.6},{60.6,23.4},{60.6,28},{60.8,26.6},{61,30.4},{61,30.6},{61,31.6},{62.4,27.8},{62.6,27.8},{62.8,27.4} } },
  {["zone_name"] = "Badlands", [ "zoneID" ] = 15, [ "name" ] = "Rabid Crag Coyote",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Badlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 161 ,["id"] = 2730  ,["coords"] = {{9.8,52},{10.4,51},{10.6,52.2},{11,52.6},{11.4,49.6},{11.4,50.6},{11.6,49.4},{11.6,49.6},{11.8,52.8},{12.4,52},{12.6,52.4},{12.8,50.4},{12.8,53},{13.6,53},{14,52.2},{14.2,57.8},{14.2,58.8},{14.6,59.4},{14.8,50.2},{15.2,58.4},{15.4,52},{15.8,56.6},{16.4,52.2},{16.4,58.4},{16.6,58.4},{17,53.8},{17,55.4},{17.4,53},{17.4,56.4},{17.4,57.4},{17.6,56.6},{18,53.2},{18,53.6},{18,56},{18.2,54.8},{18.4,52.4},{18.8,54.2},{19,51.8},{19,52.6},{19,54.8},{19.2,55.6},{19.4,51.4},{19.8,54.6},{20,53.8},{20.2,51.8},{20.4,53},{20.6,56},{21,52.6},{21.2,65},{22,64.8},{22.2,64.2},{23,63.8},{23.2,66.4},{23.4,65.2},{23.8,62},{24.6,62.2},{24.8,63.2},{25.8,63},{26,62.4} } },
  {["zone_name"] = "Tirisfal Glades", [ "zoneID" ] = 18, [ "name" ] = "Decrepit Darkhound",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Tirisfal Glades.", ["class" ] = CLASS_NORMAL, ["family"] = {  52  , "Hound"          } , ["familySkills" ] = DOGS_SKILLS          ,["displayID"] = 9021 ,["id"] = 1547  ,["coords"] = {{36,45.4},{36,45.6},{36.6,46.2},{37.8,45.2},{38,39.2},{38.2,42.4},{38.4,47.2},{38.4,47.6},{38.6,47},{39,52},{39.4,44.6},{39.4,51.4},{39.6,40.6},{39.6,51.4},{39.6,51.6},{40,44.2},{40,45.6},{40.4,39.2},{40.4,47},{40.4,56},{40.6,39.2},{40.6,52.6},{40.6,55.6},{41,47.4},{41.4,48.8},{41.8,56.8},{42.4,40.8},{42.4,50.4},{42.4,53.4},{42.4,53.6},{42.6,50.4},{42.6,53.4},{42.6,53.6},{42.8,51},{44.4,56.8},{46.2,56.8},{46.6,57},{47.6,58.2},{49.2,58.4},{50,46.8},{50.2,48.6},{51.6,52.2},{55.2,53.2},{55.4,53.6},{56.4,53},{56.6,53.4},{56.8,53.6},{57.6,52.4},{57.8,52.8},{58.4,53.6},{58.6,53.8},{59,54.8},{59.4,55.6},{59.4,56.6},{59.8,55.4},{60,55.6},{60.4,40.8},{60.8,44.8},{61,44.2},{61,55.4},{61.2,43.4},{61.2,55.6},{61.4,40.4},{61.8,45.4},{62,45.8},{62.2,47},{62.4,48.8},{62.4,55},{62.6,37.6},{62.6,48.8},{62.6,55.2},{62.8,49.6},{63,54.4},{63.2,45.4},{63.4,50.8},{63.8,41},{64,44.4},{64,55.2},{64.2,56.4},{64.2,56.6},{64.2,58.6},{64.4,42.8},{64.4,48.4},{64.6,48.4},{64.8,52.8},{65,37.2},{65.2,51.6},{65.4,49.4},{65.4,49.6},{66,50.4},{66,50.6},{66,56},{66,57.4},{67.4,52.4},{67.4,52.6},{67.6,52.4},{67.8,55.4},{67.8,56.6},{69.6,63.6},{70.4,64.8},{70.6,64.2} } },
  {["zone_name"] = "Silverpine Forest", [ "zoneID" ] = 21, [ "name" ] = "Rabid Worg",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Silverpine Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 4124 ,["id"] = 1766  ,["coords"] = {{34.8,15.8},{35.2,17.8},{35.4,11.8},{36,8.8},{36.8,25.6},{37,17.8},{38.4,23},{38.4,24.2},{39.6,18.4},{40.4,23},{40.6,23.4},{41.4,18},{41.4,20.4},{41.4,20.6},{41.4,22},{41.6,20.4},{41.6,22},{42,17.2},{42.2,18.4},{42.2,21.4},{42.4,19},{42.6,21.2},{42.6,21.6},{43,19.8},{43,31.2},{44.4,27.8},{44.6,27.6},{44.8,17},{44.8,27.4},{46,17.4},{46.2,19.4},{46.4,45.4},{47.2,18.4},{48.4,23.2},{49,24.4},{49,25.8},{49.2,24.6},{50,18.4},{52,17.8},{54.2,26.6} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Sand Crawler",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Azshara; Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  8  , "Crab"          } , ["familySkills" ] = CRAB_SKILLS          ,["displayID"] = 342 ,["id"] = 830  ,["coords"] = {{37,17.8},{39.2,12.2},{39.2,17.2},{39.4,14},{39.4,16.2},{39.4,17.6},{39.6,16.8},{39.8,16.2},{40,10},{40,10.8},{40.2,12},{41,11.4},{41,11.6},{42,11.6},{42.6,11.6},{43.4,10.8},{46.2,9.8},{46.4,11},{46.8,11.6},{47.4,11},{47.6,11.6},{48,11.2},{48.2,10.4},{48.6,10.8},{48.8,10},{49.6,11.2},{49.6,13.4},{49.8,14},{50.2,11.8},{50.6,11.2},{50.6,11.6},{51.2,10.4},{51.4,9.2},{51.6,9.4},{52,10.2},{52,10.6},{53,9.4},{53.2,9.6},{53.4,11},{54,12.4},{54.2,9.4},{54.2,12.8},{54.4,10.4},{54.4,10.6},{54.4,14.2},{54.4,15.8},{54.6,9.4},{54.6,13.4},{54.8,10},{54.8,14.2},{55,14.8},{55.2,11.4},{55.4,8.4},{55.4,11.6},{55.6,9.4},{55.8,11} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Elder Mistvale Gorilla",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  9  , "Gorilla"          } , ["familySkills" ] = GORILLA_SKILLS          ,["displayID"] = 838 ,["id"] = 1557  ,["coords"] = {{47.2,45.4},{47.2,46},{47.4,54.2},{47.4,54.6},{47.4,56.2},{47.6,54.2},{47.8,54.6},{48,46.6},{48.2,46.4},{48.2,58.6},{48.4,56.4},{48.4,57.2},{48.4,57.6},{48.6,57.2},{48.6,57.6},{48.8,56.4},{49,45.8},{49.2,59},{49.2,60},{49.4,44.4},{49.4,44.6},{49.4,55.4},{49.6,43.4},{49.6,44.6},{49.6,55.6},{49.6,58.8},{49.8,44.2},{50,47.4},{50,47.8},{50,57.2},{50.2,48.6},{50.2,50.4},{50.2,57.6},{50.4,51},{50.4,54.4},{50.4,54.8},{50.6,54.8},{50.6,57.8},{50.8,51},{50.8,53.4},{50.8,53.6},{50.8,55.6},{51,51.6},{51.2,57.2},{51.4,48.8},{51.4,49.8},{51.6,50},{51.6,51.4},{51.6,57},{51.6,57.6},{52,52},{52,53},{52.2,56.2},{52.4,53.6},{52.4,54.6},{52.6,56.4},{52.6,56.6},{52.8,50.2},{52.8,50.6},{52.8,54.4},{52.8,54.6},{53,49.4},{53.4,53},{53.6,53},{54.6,52.4} } },
  {["zone_name"] = "The Hinterlands", [ "zoneID" ] = 26, [ "name" ] = "Silvermane Stalker",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Hinterlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 32926 ,["id"] = 2926  ,["coords"] = {{65,57.2},{65.2,56},{65.6,60.2},{65.8,56.4},{66,56.6},{66.6,60.6},{66.8,57},{66.8,58},{66.8,60.2},{67.4,59.2},{67.8,56.4},{67.8,57.6},{67.8,59},{68,53.4},{68,53.6},{68.2,60.8},{68.4,56.8},{68.4,60},{68.8,58.4},{68.8,60.2},{68.8,60.8},{69,55.2},{69.2,56.8},{69.4,54},{69.4,56.2},{69.4,59},{69.6,53.8},{69.6,56.2},{69.8,58},{69.8,61.6},{70,60.4},{70.2,58.6},{70.2,60.6},{70.4,55.4},{70.4,57.4},{70.6,55.4},{70.6,57.6},{71,56.2},{71,56.6},{71,61.8},{71,62.8},{71.2,59.4},{71.4,60},{71.4,61.4},{71.6,59.4},{71.8,60.4},{71.8,60.6},{72,57.2},{72.4,58.4},{72.6,59.2},{73,56.6},{73.2,56.2},{73.4,50.4},{73.4,50.6},{73.4,55.4},{73.4,57.6},{73.6,50.4},{73.6,55.4},{73.6,55.6},{73.6,57.4},{73.6,57.8},{73.8,50.6},{74.4,53},{74.4,54},{74.6,48.6},{74.6,53.8},{74.8,50.8},{75.2,50},{75.2,52.2},{75.2,52.6},{75.4,55},{75.6,49.6},{75.6,55},{76,49.2},{76.2,53.4},{76.2,53.6},{76.4,51.2},{76.6,51.4},{77,50.2},{77.4,52.4},{77.6,52.2},{77.8,49.4},{78.2,48},{78.2,51} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Panther",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 599 ,["id"] = 736  ,["coords"] = {{31.6,20.6},{32.2,24.4},{32.2,31.2},{32.2,31.6},{32.4,19.4},{32.4,19.8},{32.4,21.8},{32.4,24.8},{32.4,25.6},{32.4,27},{32.4,27.8},{32.6,19.4},{32.6,19.6},{32.6,22},{32.6,24.4},{32.6,27},{32.6,31.2},{32.8,23.2},{32.8,25.4},{32.8,25.8},{33.2,28.4},{33.2,28.6},{33.4,20.8},{33.4,30.2},{33.6,29.2},{33.6,30.4},{33.8,26.4},{33.8,26.6},{33.8,28.4},{33.8,30.6},{34,19.4},{34,19.6},{34,21.4},{34,21.8},{34.4,23},{34.8,17.4},{34.8,17.8},{34.8,18.8},{34.8,22.8},{34.8,30.2},{34.8,30.6},{35,21},{35.2,28},{35.4,19.8},{35.4,21.8},{35.4,26.4},{35.4,26.8},{35.4,29.4},{35.6,25.6},{35.6,27},{35.8,19.2},{35.8,19.8},{35.8,22.2},{35.8,25.4},{35.8,29.4},{36.2,20.8},{36.2,30.2},{36.4,23.2},{36.4,23.6},{36.4,28.4},{36.4,30.6},{36.6,23.2},{36.6,23.6},{36.6,28},{36.6,28.6},{36.6,30.4},{36.6,30.6},{36.6,31.6},{37,27.4},{38.4,28.2},{59.2,21.6},{59.4,21.2},{59.6,21.2},{59.8,21.6} } },
  {["zone_name"] = "Silverpine Forest", [ "zoneID" ] = 21, [ "name" ] = "Skitterweb Striker",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Silverpine Forest. Found at the Skittering Dark cave in the northwest of Silverpine.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 34167 ,["id"] = 1780  ,["coords"] = {{34.4,8.4},{34.4,8.6},{34.4,10},{34.6,7.8},{34.6,10.2},{35.2,11.4},{35.2,11.6},{35.4,9.4},{35.4,13},{35.6,13.4},{35.6,13.6},{35.8,16},{36.4,14.8},{36.4,19},{37.4,15.4},{37.6,16.8},{37.8,17.6},{38.4,15},{39.4,16},{39.4,17.2} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Elder Snapjaw Crocolisk",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  6  , "Crocolisk"          } , ["familySkills" ] = CROCOLISK_SKILLS          ,["displayID"] = 815 ,["id"] = 2635  ,["coords"] = {{14,11} }},
  {["zone_name"] = "Silverpine Forest", [ "zoneID" ] = 21, [ "name" ] = "Skitterweb Lurker",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Silverpine Forest. Found at the Skittering Dark cave in the northwest of Silverpine.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 26773 ,["id"] = 1781  ,["coords"] = {{34.2,9.4},{34.4,8.4},{34.4,10},{34.6,8},{34.8,15.8},{35,14},{35.2,11.4},{35.2,11.6},{35.2,14.8},{35.2,17.8},{35.4,9.4},{35.4,10.4},{35.4,13},{35.6,8.6},{35.6,13.4},{35.6,13.6},{35.8,16.2},{35.8,17.2},{36,15},{36.6,15},{36.6,18.4},{37,16.6},{37.4,13.8},{37.6,15},{38,16.6},{38.2,16},{38.4,14.2},{39.2,15.2},{39.4,17.2},{39.6,17} } },
  {["zone_name"] = "Westfall", [ "zoneID" ] = 52, [ "name" ] = "Coyote",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Westfall.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 643 ,["id"] = 834  ,["coords"] = {{40.4,17},{40.4,18.2},{40.6,17},{40.6,18.2},{40.8,18.6},{46.2,18.8},{47.4,26.4},{47.8,14.2},{47.8,26.4},{48.4,22.2},{48.4,22.6},{48.6,22.4},{48.6,22.6},{49.4,19.2},{49.4,23.6},{49.6,19.6},{49.8,18.8},{49.8,23.4},{50,23.6},{50.2,21.4},{50.2,22},{50.2,30.6},{50.4,17.2},{50.4,18.4},{50.4,25.4},{50.4,25.6},{50.6,23.6},{50.6,30.6},{50.8,20},{51,18.6},{51.2,17},{51.2,18.2},{51.2,25.4},{51.2,25.6},{51.4,21},{51.4,22.4},{51.4,22.6},{51.4,34},{51.4,34.6},{51.6,21},{51.6,23.4},{51.6,23.6},{51.6,25.8},{51.6,34},{51.6,35.2},{52,35.8},{52.4,22.4},{52.4,24.6},{52.6,22.4},{52.6,22.6},{52.6,24.4},{52.6,24.6},{54,28},{54,28.6},{54.2,18.2},{54.2,18.6},{55,21.2},{55.2,29.4},{55.2,29.8},{55.4,27.4},{55.4,28.2},{55.4,30.6},{55.6,27.4},{55.6,29.4},{55.6,30},{55.8,27.8},{56,31.2},{59,15.4},{59.4,12.4},{59.4,12.6},{59.6,12.4},{62.2,24} } },
  {["zone_name"] = "The Hinterlands", [ "zoneID" ] = 26, [ "name" ] = "Silvermane Howler",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Hinterlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 11417 ,["id"] = 2925  ,["coords"] = {{37.2,61},{37.6,61},{37.8,42.6},{37.8,58},{38.2,46.4},{38.2,49.2},{38.2,52.2},{38.4,45.2},{38.4,51},{38.4,58.8},{38.6,45.6},{38.6,47.4},{38.8,43.6},{38.8,57},{39,50.2},{39,54.8},{39,57.6},{39.2,45},{39.2,62.2},{39.4,52.2},{39.4,63.4},{39.6,45},{39.8,43.8},{40,46.2},{40,46.6},{40,48.2},{40,50.2},{40,64},{40.4,51},{40.4,54.4},{40.4,63.2},{40.6,54.4},{40.8,51},{40.8,55},{40.8,62.8},{41,44.2},{41,46.6},{41,53},{41.2,44.6},{41.2,45.6},{41.8,42.4},{41.8,49.6},{41.8,64.6},{42,47.6},{42.2,62.6},{42.4,44.4},{42.4,47},{42.6,46.4},{43,44.6},{43.2,47.4},{43.2,61.6},{43.4,44.2},{43.4,54},{43.4,55.2},{43.4,59},{43.8,59.2},{43.8,62},{44,45.4},{44.2,52},{44.2,53.6},{44.4,44.4},{44.4,45.6},{44.8,55.6},{45.2,52.2},{45.4,49.8},{45.4,52.8},{45.4,54.2},{45.6,49.6},{45.6,52},{45.8,50.8},{46,61.6},{46.2,57.6},{46.2,60.4},{46.4,48.4},{46.4,59.2},{46.4,60.8},{47,51.4},{47,57.4},{47.2,49.2},{47.4,47.2},{47.4,59.2},{47.6,40.8},{47.6,47.4},{47.8,57.8},{48.2,51.6},{48.4,59},{48.4,59.8},{49.4,42.2},{49.4,60.4},{49.4,62},{49.6,42.2},{50,39.4},{50,46.2},{50.4,45.4},{50.8,41.2},{50.8,42.6},{51,45.6},{51.2,42},{51.2,46.8},{51.4,47.8},{51.6,47.2},{51.6,47.6} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "King Bangalash",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 616 ,["id"] = 731  ,["coords"] = {{47.4,59.4},{47.6,59.6},{47.8,59.2} } },
  {["zone_name"] = "Tirisfal Glades", [ "zoneID" ] = 18, [ "name" ] = "Greater Duskbat",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Tirisfal Glades.", ["class" ] = CLASS_NORMAL, ["family"] = {  24  , "Bat"          } , ["familySkills" ] = BAT_SKILLS          ,["displayID"] = 47211 ,["id"] = 1553  ,["coords"] = {{36.4,47},{37.8,47.4},{39,49.4},{40,51.4},{41,47.4},{41.4,54},{41.6,54},{41.8,49.2},{41.8,52.2},{42,49.8},{42,50.8},{42,57},{42.8,52.4},{45.2,57.2},{45.4,55.2},{45.6,49.6},{45.8,52.6},{46.8,48.4},{47.2,56},{48.6,59},{51.4,50},{51.6,48.8},{53.6,64.8},{54,62.2},{54.4,60.6},{54.6,60.8},{55.6,60.8},{56.4,55.6},{56.4,58.2},{57.2,53.4},{58,56},{58.4,54.6},{58.6,55.8},{58.6,57},{59.4,61.4},{60,56.4},{60,56.6},{60.2,61},{60.6,57.4},{60.6,57.8},{62.4,46},{62.4,57.4},{62.4,57.6},{62.8,36},{63,39},{63,49.6},{63.4,55.4},{63.6,53},{63.6,55.2},{63.6,56},{63.8,53.8},{64,43.6},{64,51.6},{64.2,57.4},{64.2,57.6},{64.6,50.4},{64.8,54},{65,52.2},{65,56.4},{65,56.6},{65,58.2},{65.4,59},{65.6,58.8},{65.8,53.2},{65.8,54.4},{65.8,54.8},{66.2,52},{66.8,54.2},{66.8,57},{67.2,55.8},{67.8,53.8},{68.8,54},{68.8,56.2},{69.2,62.6},{69.8,54.8},{69.8,56.2},{71,63.8} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Crystal Spine Basilisk",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  130  , "Basilisk"          } , ["familySkills" ] = BASILISK_SKILLS          ,["displayID"] = 46056 ,["id"] = 689  ,["coords"] = {{23.8,35.4},{24.4,33},{24.8,32},{25,33.8},{25.8,33.2},{26.4,32.2},{26.4,34.2},{26.4,34.6},{26.6,31.8},{26.8,34.4},{27.4,33.2},{27.4,34.8},{28.4,34.2},{28.6,34},{28.6,35.2},{28.8,31.6},{30.4,34.8},{30.6,34.4},{30.6,34.6},{31.8,34.6},{59,17},{59.4,19.6},{59.4,22.4},{59.8,19.2},{60,16.4},{60,22.4},{60.4,17.6},{60.4,20.4},{60.4,20.6},{60.4,23.2},{60.4,23.6},{60.6,20.4},{60.6,23.6},{60.8,17.4},{60.8,17.6},{60.8,22},{61,18.6},{61.2,23.2},{61.4,21},{61.6,21.2},{61.6,23.6},{61.8,18.4},{61.8,18.6},{62,22.4},{62.2,19.8},{62.4,22.8},{62.4,25.4},{62.4,25.6},{62.6,25.2},{62.8,18.8},{62.8,20.8},{63,15.8},{63,22.4},{63,22.6},{63,24},{63.2,18.4},{63.2,26.4},{63.2,26.6},{63.2,29},{63.2,29.6},{63.2,31.8},{63.4,28},{63.4,30.8},{63.6,25.4},{63.6,28},{63.6,29.6},{63.6,30.8},{63.8,19.2},{63.8,26.8},{64,19.6},{64,21.4},{64,21.6},{64.2,26.4},{64.2,29.4},{64.6,28.6},{64.8,20.4},{64.8,20.8} } },
  {["zone_name"] = "Arathi Highlands", [ "zoneID" ] = 14, [ "name" ] = "Highland Strider",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Arathi Highlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 11316 ,["id"] = 2559  ,["coords"] = {{20.4,21},{20.8,20.4},{20.8,20.6},{21.4,19.2},{21.6,19.2},{40.4,56.4},{41.6,54},{42.2,36.6},{48.8,49.8},{53.4,42.2},{53.6,42.4},{53.6,42.6},{54.6,38.4},{58,43.6},{58.2,46.4},{58.8,45.4},{59.2,47.4},{60,46},{60.2,37.6},{60.2,43.4},{60.8,40.8},{60.8,44.6},{61,36.4},{61,36.6},{62,37.4},{62.8,39.8},{63.8,37.6},{64,40.6},{64.8,41.8},{65.6,53.8},{69.2,48.8} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Snapjaw Crocolisk",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  6  , "Crocolisk"          } , ["familySkills" ] = CROCOLISK_SKILLS          ,["displayID"] = 833 ,["id"] = 1152  ,["coords"] = {{48.2,54.4},{49.8,50},{50,32.6},{50,38.4},{50,38.8},{50,39.6},{50.2,30.8},{50.2,32.4},{50.4,30.2},{50.4,50.6},{50.6,30.2},{50.6,32.8},{51,35.4},{51,35.8},{51,41},{51.4,29.2},{51.4,40.4},{51.8,28.4},{52,33.2},{52,39.8},{52.4,29.2},{52.4,29.6},{52.4,35.2},{52.4,35.6},{52.4,37.4},{52.4,37.6},{52.4,39.4},{52.6,35.2},{52.6,35.6},{52.6,37.4},{52.6,37.6},{52.8,29.4},{52.8,29.6},{52.8,39.2},{53.2,32.6},{53.4,30.6},{53.4,32.4},{53.6,32.6},{53.8,30.4},{54.2,31.2},{54.2,38.4},{54.2,38.6},{54.4,31.6},{54.6,31.2},{54.6,31.6} } },
  {["zone_name"] = "Redridge Mountains", [ "zoneID" ] = 49, [ "name" ] = "Tarantula",["maxlevel" ] =30, [ "minlevel" ] =7, ["info" ] ="Located in Redridge Mountains.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 366 ,["id"] = 442  ,["coords"] = {{11.2,67.2},{11.4,75.8},{11.6,71.8},{11.6,76.6},{11.8,76},{12.2,68.2},{12.2,69},{12.2,82},{12.6,68},{12.6,71},{12.8,69},{13,73.2},{13.2,64.2},{13.4,65.8},{13.4,67.2},{13.6,65.2},{13.6,69.4},{13.8,64},{14,65.8},{14,66.8},{14,68.4},{14.2,74.6},{14.4,69.8},{14.4,70.8},{14.4,73.6},{14.6,67.6},{14.6,71.6},{14.6,73.2},{14.8,80.2},{15.4,70.2},{15.8,70.2},{16,66.4},{16.2,64.4},{17,62.6},{17.2,63.6},{17.4,64.8},{17.6,64.6},{17.8,63.6},{18,62.4},{18.2,63.4},{18.8,63},{19.2,65.6},{19.4,60.4},{19.4,64.4},{19.4,65.2},{19.6,64.4},{19.6,64.6},{20.4,59.2},{20.4,59.8},{20.6,59.2},{20.6,59.6},{20.6,61},{20.6,65.8},{22,60.6},{22.2,64},{22.4,59.8},{22.6,59.8},{22.6,61.6},{23,67.4},{23.2,67.8},{24.2,71},{24.4,69.2},{24.6,71},{24.8,69.4},{24.8,69.6},{25.6,69.4},{26.8,68} } },
  {["zone_name"] = "Mulgore", [ "zoneID" ] = 7, [ "name" ] = "Wiry Swoop",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Mulgore. Swoop & Wiry Swoop switched levels.", ["class" ] = CLASS_NORMAL, ["family"] = {  7  , "Carrion Bird"          } , ["familySkills" ] = CARRION_BIRD_SKILLS          ,["displayID"] = 1228 ,["id"] = 2969  ,["coords"] = {{37.4,45.4},{37.6,45.4},{37.6,45.6},{38.2,42.4},{38.2,42.6},{43,46.2},{43.2,46.6},{43.6,45.6},{44.4,36.4},{44.4,36.6},{46.2,33.2},{47.2,42.4},{47.4,42.6},{47.6,42.4},{47.6,42.6},{48,34.2},{48,38.2},{48,50},{49,41.2},{49.4,41.6},{49.6,42},{49.8,35.4},{49.8,46.4},{49.8,46.6},{50,38.8},{51,42.4},{51,42.8},{51.6,45.6},{51.8,45.4},{52.2,37.2},{52.4,35.2},{53.4,44.8},{53.6,44.4},{53.6,44.6},{54.2,39.6},{55.2,57.2},{55.2,57.6},{55.4,41.4},{55.4,41.6},{55.6,57},{56.6,45.2},{56.6,45.6},{57,48.8},{57.2,48.4},{57.2,54.4},{57.2,54.6},{57.8,52.4},{57.8,52.8},{58.8,59.2},{59,59.6},{59.4,54.4},{59.4,54.6},{59.6,54.4},{59.6,54.6},{60.4,62},{61,61.4},{61.4,59},{63,57.4},{63.8,60.6},{64,60.4},{65.2,58.2},{65.6,58.8} } },
  {["zone_name"] = "Silverpine Forest", [ "zoneID" ] = 21, [ "name" ] = "Ferocious Grizzled Bear",["maxlevel" ] =30, [ "minlevel" ] =5, ["info" ] ="Located in Silverpine Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 982 ,["id"] = 1778  ,["coords"] = {{54.2,20.8},{55.6,23},{56.2,16.8},{56.2,18.4},{56.2,18.6},{56.4,19.6},{56.6,17.8},{56.8,23},{57.2,17},{57.4,15.2},{57.4,15.6},{57.6,15.4},{57.6,15.8},{58,17.2},{58.8,14},{59,14.6},{59.2,17.2},{59.4,8.4},{59.4,8.8},{59.4,17.6},{59.6,17},{59.8,7.4},{59.8,9.6},{60.4,8.4},{60.4,8.6},{60.4,16.4},{60.6,8.2},{60.6,16},{60.8,14.8},{61,14},{61.4,11.6},{61.4,12.8},{61.6,12.8},{61.8,8.2},{61.8,12.4},{62,8.6},{63.2,8.6},{63.4,8.4},{63.6,8.2},{63.8,11},{64,7.4},{65,12.4},{65.4,10},{65.6,9.2},{65.6,10.2},{66.6,9.4} } },
  {["zone_name"] = "Hillsbrad Foothills", [ "zoneID" ] = 25, [ "name" ] = "Snapjaw",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Hillsbrad Foothills; Old Hillsbrad Foothills (Dungeon).", ["class" ] = CLASS_NORMAL, ["family"] = {  21  , "Turtle"          } , ["familySkills" ] = TURTLE_SKILLS          ,["displayID"] = 1244 ,["id"] = 2408  ,["coords"] = {{52.8,68.8},{52.8,70.8},{53.4,66.4},{53.4,66.6},{55.2,63},{56.6,61.2},{56.8,61.6},{58,59.4},{58,59.6},{59.6,58.4},{60.6,54.6},{60.6,56.6},{60.8,46},{61,44.6},{61.4,42.6},{63.6,38.6},{68.2,33.2},{69.2,30.4} } },
  {["zone_name"] = "Elwynn Forest", [ "zoneID" ] = 37, [ "name" ] = "Young Forest Bear",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Elwynn Forest.", ["class" ] = CLASS_NORMAL, ["family"] = {  4  , "Bear"          } , ["familySkills" ] = BEAR_SKILLS          ,["displayID"] = 1006 ,["id"] = 822  ,["coords"] = {{22.6,75.4},{22.6,75.6},{25,83},{25.4,89.2},{25.4,89.8},{25.4,91},{25.8,89.8},{26,89.4},{38.6,89.6},{42.4,89.2},{42.8,89.2},{43,81.4},{43,89.6},{44,76.6},{44.8,77},{46.2,75.8},{46.2,76.6},{46.2,80.8},{47.4,80.2},{47.6,77.4},{47.6,77.6},{49.6,75.4},{53.2,84},{63.2,65.4},{64.4,63.8},{65.8,78.2},{69,63.8},{71.6,60.6},{73.4,80.8},{74.6,67.8},{74.8,67},{76.8,75.6},{76.8,77.2},{76.8,77.6},{78,62.2},{78.4,61.2},{78.4,78.6},{78.4,79.8},{79,61.4},{79.2,83.8},{81,77.4},{81,77.6},{82,59.2},{82.2,59.6},{83,84.4},{86.4,77.2},{86.6,63.6},{86.6,64.6},{86.6,67.4},{87.2,68.8},{87.2,69.6},{87.2,82},{87.6,65.2},{88.4,77},{88.6,77.8} } },
  {["zone_name"] = "Hillsbrad Foothills", [ "zoneID" ] = 25, [ "name" ] = "Forest Creeper",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Hillsbrad Foothills; Old Hillsbrad Foothills (Dungeon).", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 759 ,["id"] = 2350  ,["coords"] = {{33.6,61.6},{34.4,29.2},{35.2,30.6},{36,31.6},{36.4,38.6},{37,26},{37.4,25.2},{37.6,37.6},{38.4,23.4},{38.4,23.6},{39.4,42.2},{44.4,12},{44.4,14.4},{44.4,14.6},{44.6,14.6},{45.2,14.2},{48.2,11},{48.8,12.8},{49.8,13.2},{53.8,17},{54.2,34.4},{54.4,34.6},{54.8,33.4},{55.6,32.6},{55.8,32.4},{56.2,15.8},{56.8,18.8} } },
  {["zone_name"] = "The Cape of Stranglethorn", [ "zoneID" ] = 210, [ "name" ] = "Skymane Gorilla",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Cape of Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  9  , "Gorilla"          } , ["familySkills" ] = GORILLA_SKILLS          ,["displayID"] = 809 ,["id"] = 2521  ,["coords"] = {{59,89.2},{59,89.8},{59.4,78},{59.4,79},{60,76.6},{60.2,78.4},{60.2,78.8},{60.2,88.4},{60.4,76.2},{60.6,76.4},{60.6,76.6},{60.6,78.8},{60.8,79.8},{61,89.4},{61.4,78.4},{61.6,79.6},{61.8,83.6},{62,78.6},{62,82.8},{62.2,73.2},{62.2,73.6},{62.2,77.4},{62.2,77.6},{62.4,80.6},{62.4,81.6},{62.6,73.6},{62.6,78.4},{62.6,79},{62.6,84},{62.6,84.8},{62.8,77.2},{62.8,81.6},{63,81},{63,83.4},{63.2,80.4},{63.4,75.4},{63.4,76},{63.6,75.6},{63.8,80.4},{63.8,81.6},{64,75.4},{64,80.6},{64.2,86.6},{64.4,77.4},{64.4,77.8},{64.4,79.4},{64.4,82.8},{64.4,85.4},{64.4,86.4},{64.6,74.8},{64.6,79.8},{64.6,85.6},{64.8,77},{64.8,77.6},{64.8,82},{64.8,82.6},{64.8,84.4},{64.8,84.6} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Lashtail Raptor",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  11  , "Raptor"          } , ["familySkills" ] = RAPTOR_SKILLS          ,["displayID"] = 788 ,["id"] = 686  ,["coords"] = {{35.4,40.4},{35.4,43.4},{35.4,43.6},{35.6,40.4},{35.6,43.6},{36,42.8},{36.2,41.4},{36.2,41.6},{37,42.6},{37.2,39},{37.2,39.6},{37.2,42.4},{37.8,40},{38,38.2},{38.2,40.6},{38.4,38.6},{38.4,42.2},{38.4,42.8},{38.4,44},{38.6,41.2},{38.6,41.8},{38.6,43.6},{38.8,38.4},{38.8,38.6},{39.4,42.8},{39.6,42.4},{39.6,42.6},{40.4,44},{40.6,44.4},{41.2,45.2},{41.2,45.6},{42.4,45.4},{42.4,45.6},{42.6,45.4},{42.8,47},{43,47.6},{43.4,46.2},{43.8,46.2},{44.4,45.4},{44.4,47.4},{44.6,47.2},{45.4,44},{45.6,43.8},{46,42.4},{46,42.6},{46,44.8},{46.6,42},{46.8,41.4},{47,38.8},{47,48.4},{47,48.6},{47.8,35.4},{47.8,37.4},{47.8,37.8},{48,44.8},{48.4,44.2},{48.6,44},{48.6,46},{48.8,39},{49,45.4},{49.4,35.4},{49.4,40},{49.6,40},{49.8,35.2},{49.8,35.6} } },
  {["zone_name"] = "Western Plaguelands", [ "zoneID" ] = 22, [ "name" ] = "Diseased Wolf",["maxlevel" ] =30, [ "minlevel" ] =15, ["info" ] ="Located in Western Plaguelands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 4124 ,["id"] = 1817  ,["coords"] = {{42.6,48.4},{43.2,46.4},{43.2,48.6},{43.8,49.4},{44.4,46},{44.4,47.2},{44.4,50},{44.6,45.4},{44.6,46},{44.6,49.2},{44.6,50.2},{44.8,46.6},{45.4,48},{45.6,48},{45.8,45.4},{45.8,45.8},{46.2,47.2},{46.6,46.8},{46.8,48.2},{46.8,48.8},{47,45.2},{47.2,46.2},{47.6,46.8},{47.8,47.6},{51,50.4},{51.2,47.2},{51.2,51},{51.4,47.8},{51.6,48},{51.6,48.8},{52.2,51.4},{52.2,54},{52.4,51.6},{52.6,53.2},{52.8,51.8},{53.2,50},{53.2,50.6},{53.6,50.4},{53.6,50.6},{53.8,53.6},{54.2,48.2},{54.4,47.4},{54.4,48.8},{55.2,51},{55.8,51.8},{56,49.4},{56,49.6},{56.2,51.4},{56.2,53},{56.6,53},{57.4,52.4},{57.6,53},{57.8,50.4},{58,51},{58.6,51.6},{58.8,54.2},{60.4,52},{61.2,51.2},{61.4,48.8},{62.4,50.6},{62.6,50.6},{62.8,46.2},{63.4,45.4},{64.6,48.8},{64.8,48},{65.4,53.8},{66.4,54.6},{67.4,53.2},{68.6,44.6} } },
  {["zone_name"] = "Northern Stranglethorn", [ "zoneID" ] = 50, [ "name" ] = "Kurzen War Tiger",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in Northern Stranglethorn.", ["class" ] = CLASS_NORMAL, ["family"] = {  2  , "Cat"          } , ["familySkills" ] = CAT_SKILLS          ,["displayID"] = 320 ,["id"] = 976  ,["coords"] = {{58.8,22.8},{59,22},{59.2,21.4},{59.4,20.4},{59.6,20.4},{59.6,21} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Webwood Lurker",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  3  , "Spider"          } , ["familySkills" ] = SPIDER_SKILLS          ,["displayID"] = 759 ,["id"] = 1998  ,["coords"] = {{51.4,46.6},{51.6,46.6},{52.2,51.4},{52.4,48.8},{53,58.4},{53.4,53.8},{53.6,53.8},{54.2,56},{57.6,49.2},{57.6,49.6},{58.8,52},{59,50.8},{59.2,52.6},{59.4,47.6},{59.4,49.2},{59.4,50},{59.6,50.6},{59.6,52.4},{59.8,48.4},{59.8,48.6},{59.8,50},{60,53.4},{60.4,47.4},{60.6,47.6},{61.8,55.4},{62,55.8},{62.4,53.4},{62.4,53.6},{63,54} } },
  {["zone_name"] = "The Hinterlands", [ "zoneID" ] = 26, [ "name" ] = "Vilebranch Wolf Pup",["maxlevel" ] =30, [ "minlevel" ] =10, ["info" ] ="Located in The Hinterlands.", ["class" ] = CLASS_NORMAL, ["family"] = {  1  , "Wolf"          } , ["familySkills" ] = WOLF_SKILLS          ,["displayID"] = 781 ,["id"] = 2680  ,["coords"] = {{46.2,69.4},{46.6,66.2},{46.8,70},{47.4,65.2},{47.6,70.2},{48,65.8},{48.4,65},{48.6,65.2},{50.4,65.8},{63.4,70},{63.6,70.2},{63.8,69},{64,66.4},{64,66.6},{64.2,67.6},{64.2,71},{64.8,71.4},{65,71.8},{65.2,69.2},{65.4,70.2},{65.4,73},{65.6,70.2},{65.8,68.4},{66,72.2},{66.2,69},{66.2,73.2},{66.6,68.4},{66.6,73},{67,69.2},{67.2,70},{67.4,70.6},{67.6,68.2},{67.8,72},{68.4,69},{68.4,70.4},{68.4,70.6},{68.6,69} } },
  {["zone_name"] = "Teldrassil", [ "zoneID" ] = 57, [ "name" ] = "Strigid Screecher",["maxlevel" ] =30, [ "minlevel" ] =1, ["info" ] ="Located in Teldrassil.", ["class" ] = CLASS_NORMAL, ["family"] = {  26  , "Bird of Prey"          } , ["familySkills" ] = BIRD_OF_PREY_SKILLS          ,["displayID"] = 4877 ,["id"] = 1996  ,["coords"] = {{40,48.4},{40,49.6},{40.2,44.4},{40.2,44.6},{40.2,48.8},{40.8,46.8},{40.8,55},{41,49},{41,54},{41.2,44.4},{41.2,57},{41.4,45},{41.4,45.8},{41.6,46.4},{41.6,47.4},{41.6,57.4},{42,44.6},{42,47.8},{42.4,43.4},{42.6,46.2},{42.6,50.4},{42.8,43.2},{42.8,43.6},{42.8,59.8},{43,59.4},{43.4,58.4},{43.6,45.8},{43.6,58.2},{43.8,43},{43.8,43.6},{44,59},{44.4,45},{44.4,60.6},{44.6,60.6},{45,44.4},{45.2,44.6},{46.8,66},{47,66.8},{52,67.2},{53.8,66.8},{54,66.4},{54.8,66},{56.8,66.4},{57.2,65.4},{57.6,64.8},{62.8,59},{63,60.4},{63.4,58},{63.8,58} } },

}
]]

